﻿var VisualCron = VisualCron || {};

$.extend(VisualCron, {

    ConnectionController: function () {
        var _serverStateUri = $("#serverStateUri").val();

        this.onManageConnections_Click = function (eventArg) {
            console.log("#debug");
            var oWnd = $("#ConnectionsWindow").data("kendoWindow");
            oWnd.center().open();
        };

        this.onConnect_Click = function(eventArg) {
            console.log("#debug");

            var combobox = $("#ConnectionsList").data("kendoComboBox");
            //get selected server
            var item = combobox.dataItem();

            showLoadingPopup(false);

            if (item.Connected === true) {

                window.visualCron.server.disconnect(item.ConnectionId)
                    .done(
                        function(result) {
                            console.log("#debug");
                            if (!result) {
                                showLoadingPopup(true);
                            }
                        })
                    .fail(
                        function() {
                            console.log("#debug");
                            alert("Error on disconnecting");
                            showLoadingPopup(true);
                        });
            } else {

                if (item.Password === "" && item.PromptPassword) {
                    // in case connection password is empty and this is not a local connection
                    // we ask user to supplay another credentials
                    VisualCron.PromptPasswordController.show(item);

                } else {
                    window.visualCron.server.connect(item.ConnectionId, "", "");
                }
            }

        };

        this.onGridFilterVisible_Toggled = function (eventArg) {
            if (eventArg.checked == false) {
                $("#toolBarPanel").css("display", "none");
            } else {
                $("#toolBarPanel").css("display", "block");
            }
        };

        this.onDeleteJob_Click = function(eventArg) {
            console.log("#debug");

            var obj = getData();

            if (confirm("delete job?")) {
                window.visualCron.server.removeJob(obj.serverId, obj.jobId);
            }
        }

        this.onRunJob_Click = function (eventArg) {
            console.log("#debug");

            var obj = getData();
            window.visualCron.server.runJob(obj.serverId, obj.jobId, "");
        }

        this.onClearFilter_Click = function (eventArg) {
            console.log("#debug");
            $("#FilterByJob").val("");
            $("#FilterByTask").val("");
            GridDataSourceController.Filter();
            var filter = $("#ConnectionsListFilter").data("kendoComboBox");
            var len = filter.dataSource.data().length;
            filter.select(len - 1);
        };

        this.onCloseFilter_Click = function(eventArg) {
            $("#toolBarPanel").css("display", "none");
            $("#btnGridFilter").removeClass("k-state-active");
        };

        this.onSelectedServer = function (eventArg) {
            console.log("#debug");
            $(eventArg.sender.element).data("kendoComboBox").close();
        };


        this.connnectionsList_OnClientSelectedIndexChanged = function (eventArgs) {
            console.log("#debug");

            var selectedItem = $("#ConnectionsList").data("kendoComboBox").dataItem();

            if (!selectedItem) {
                $("#ConnectionsList").data("kendoComboBox").select(0);
                return;
            }

            var userServerId = "";

            if (selectedItem.Connected) {
                userServerId = selectedItem.UserServerId;
            }

            updateServerTab(selectedItem.Connected);

            var btnText;
            var btnImage;
            if (selectedItem.Connected == true) {
                btnText = "Disconnect";
                btnImage = "/Content/images/ServerConnectedfalse.png";
            } else {
                btnText = "Connect";
                btnImage = "/Content/images/ServerConnectedtrue.png";
            }
            //we rename Ribbon tab of the server
            $("#tabServer").html("<a href=\"#\" class=\"rrbTabLabel\" accesskey=\"\"><span id=\"currentServerId\" class=\"rrbTabText\" data-currentServerId=\"" + userServerId + "\">Server [" + selectedItem.Host + "]</span></a>");
            $("#btnConnect").html(btnText);
            $("#btnConnect").kendoButton({
                imageUrl: btnImage
            });

            showLoadingPopup(true);

            if (selectedItem.Connected) {
                ServerTreeController.loadServerTree(selectedItem.Host, userServerId);
            }
        };

        var getData = function() {
            console.log("#debug");
            var data = new Object();
            $("[id^=jobsGrid]").each(function() {
                console.log("#debug");
                var grid = $(this).data("kendoGrid");
                if (grid) {
                    var row = $("tr.k-master-row.SelectFlag");
                    if (row.length > 0) {

                        row = $(row[0]);
                        var jobIds = $(row.find(".ids"));
                        var serverIds = $(row.find(".serverIds"));

                        data.serverId = serverIds.text();
                        data.jobId = jobIds.text();
                    }
                }
            });
            return data;
        };

        var showLoadingPopup = function (enabled) {
            console.log("#debug");

            if (!enabled) {
                $("#loading_popub").css("display", "block");
            } else {
                $("#loading_popub").css("display", "none");
            }
        };

        var updateServerTab = function (connected) {
            if (connected) {
                $(".rrbButtonOut:data(onlyconnected=true)").each(function (e) { $(this).removeClass("rrbDisabled"); });
            } else {
                $(".rrbButtonOut:data(onlyconnected=true)").each(function (e) { $(this).addClass("rrbDisabled"); });
            }
        };

        this.setServerButtonState = function(status) {
            console.log("#debug");
            var cbButton = $("#tglbtnServerState");

            var textElement = $(cbButton.find(".rrbTextContent"));
            var imgElement = $(cbButton.find(".rrbButtonImage"));

            if (status === true) {
                if (cbButton.hasClass("rrbToggled") == false) {
                    cbButton.addClass("rrbToggled");
                    textElement.text("Server On");
                    imgElement.attr("src", "/Content/images/icons/system_on.png");
                }
            } else {
                if (cbButton.hasClass("rrbToggled") == true) {
                    cbButton.removeClass("rrbToggled");
                    textElement.text("Server Off");
                    imgElement.attr("src", "/Content/images/icons/system_off.png");
                }
            }
        };

        this.connnectionsListFilter_OnClientSelectedIndexChanged = function (eventArgs) {
            console.log("#debug");
            var selected = $("#ConnectionsListFilter").data("kendoComboBox").dataItem();
            if (selected && selected.ConnectionId != "All") {
                $("[id^=ServerTree]").each(function (e) {
                    console.log("#debug");
                    if (!$(this).data("kendoTreeView")) {
                        return;
                    }
                    var id = $(this).attr("id");
                    if (id == "ServerTree" + selected.UserServerId) {
                        ServerTreeController.loadServerTree(selected.Host, selected.UserServerId, true);
                    }
                    else {
                        $(this).hide();
                    }
                });
            } else {
                var combobox = $("#ConnectionsList").data("kendoComboBox").dataSource.data();
                for (var i = 0; i < combobox.length; i++) {
                    if (combobox[i].Connected) {
                        ServerTreeController.loadServerTree(combobox[i].Host, combobox[i].UserServerId, true);
                    }
                }
            }
        };

        // makes combobox "readonly" by opening it on each mousedown
        this.InitializeComboBox = function (_id) {
            $(_id).prev().parent().on("mousedown", function (eventArg) {
                console.log("#debug");
                $(_id).data("kendoComboBox").open();
            });

            var filter = $(_id).data("kendoComboBox");
            if (filter) {
                filter.bind("select", ConnectionController.onSelectedServer);
                //
                filter.select(0);
                filter.readonly(true);
            }
        };

        this.OnHistoryStatusFilterChange = function (eventArg) {
            console.log("#debug");
            var selected = $("#statusFilter").data("kendoComboBox").dataItem();
            var filter;
            if (selected && selected.text != "All") {
                filter = selected.text;
            } else {
                filter = "";
            }
            var grid = $("#jobHistoryGrid").data("kendoGrid");
            grid.dataSource.filter({ field: "Result", operator: "contains", value: filter });
            grid.refresh();
        };
    }
});