﻿var VisualCron = VisualCron || {};

$.extend(VisualCron, {
    ConnectionsWindowController: function() {
        var defaultPort = $("#defaultUri").val();
        var _this = this;
        console.log("on: ConnectionsWindowController");

        $(function () {
          $(document).on('dblclick', '#ConnectionGrid tbody > tr', _this.EditConnection_OnClientClicked);
        });

        //methods
        var _addConnection_Clicked = function() {
            console.log("on: _addConnection_Clicked");
            var host = $(".hostText").val();
            var user = $(".usernameText").val();
            var pass = $(".passwordText").val();
            var connectionId = $("#hdnCurrentConnectionId").val();
            var port = $(".portText").val();
            var isLocal = $("#btnIsLocal").prop("checked");
            var useAD = $("#btnUseAD").prop("checked");
            var promptPassword = $("#btnPromptPassword").prop("checked");

            window.visualCron.server.addUpdateConnection(connectionId, host, user, pass, port, isLocal, false, useAD, promptPassword)
                .done(function(dataset) {
                    _updateConnectionGrid(dataset);
                    _clearConnectionWindow();
                    _hideConnectionWindow();
                });
        };

        this.AddConnection_OnClientClicked = function() {
            console.log("on: AddConnection_OnClientClicked");
            _clearConnectionWindow();
            _showConnectionWindow();
        };

        this.EditConnection_OnClientClicked = function() {
            console.log("on: EditConnection_OnClientClicked");
            var connectionTable = $("#ConnectionGrid").data("kendoGrid");
            var selectedItem = connectionTable.select();
            var item = connectionTable.dataItem(selectedItem);
            if (!item) {
                return;
            }
            $("#HostText").val(item.Host);
            $("#Username").val(item.Username);
            $("#Password").val(item.Password);
            $("#btnPromptPassword").prop("checked", item.PromptPassword);
            
            if (item.IsLocalServer == true) {
                item.Port = "IPC";
            }
            $("#PortText").val(item.Port);
            $("#btnIsLocal").prop("checked", item.IsLocalServer);
            $("#btnUseAD").prop("checked", item.UseAD);
            //$('#btnIsLocal').set_checked(items[i].getDataKeyValue("IsLocalServer"));
            $("#hdnCurrentConnectionId").val(item.ConnectionId);
            _showConnectionWindow();
        };

        this.DeleteConnection_OnClientClicked = function() {
            console.log("on: DeleteConnection_OnClientClicked");
            var connectionTable = $("#ConnectionGrid").data("kendoGrid");
            var selectedItem = connectionTable.select();
            var item = connectionTable.dataItem(selectedItem);
            if (!item) {
                return;
            }
            window.visualCron.server.removeConnection(item.ConnectionId).done(function(dataset) {
                _updateConnectionGrid(dataset);
            });
        };

        this.AcceptConnectionChanges_OnClientClicked = function() {
            console.log("on: AcceptConnectionChanges_OnClientClicked");
            _addConnection_Clicked();
            _hideConnectionWindow();
        };

        this.DeclineConnectionChanges_OnClientClicked = function() {
            console.log("on: DeclineConnectionChanges_OnClientClicked");
            _clearConnectionWindow();
            _hideConnectionWindow();
        };

        var _updateConnectionGrid = function(dataset) {
            console.log("on: updateConnectionGrid");
            if (dataset) {
                for (var i = 0; i < dataset.length; i++) {
                    if (dataset[i].IsLocalServer === false) {
                        dataset[i].PortStr = dataset[i].Port;
                    }
                }
                var connectionTable = $("#ConnectionGrid").data("kendoGrid");
                connectionTable.dataSource.data(dataset);
            } else {
                alert("Update Error. Please try again.");
            }
        };

        var _showConnectionWindow = function() {
            console.log("on: showConnectionWindow");
            var oWnd = $("#EditConnectionWindow").data("kendoWindow");
            oWnd.center().open();
        };

        var _hideConnectionWindow = function() {
            console.log("on: hideConnectionWindow");
            var oWnd = $("#EditConnectionWindow").data("kendoWindow");
            oWnd.close();
        };

        var _clearConnectionWindow = function() {
            console.log("on: clearConnectionWindow");
            $("#HostText").val("localhost");
            $("#Username").val("admin");
            $("#Password").val("");
            var defport = defaultPort;
            $("#PortText").val(defport);
            $("#hdnCurrentConnectionId").val("");
            $("#btnIsLocal").prop("checked", true);
            $("#btnUseAD").prop("checked", false);
            $("#btnPromptPassword").prop("checked", false);
        };
    }
});