﻿var VisualCron = VisualCron || {};

$.extend(VisualCron, {
    ContextMenuController: function () {
        console.log("on: ContextMenuController");

        this.JobsContextMenu_OnOpen = function (sender) {
            //if tasks ConextMenu was opened it needs to be closed prior to opening this one
            $("[id^=TasksContextMenu]").each(function () {
                var cm = $(this).data("kendoContextMenu");
                if (cm) {
                    cm.close();
                }
            });

            // as we need to search through several tables simultaneously
            // we can switch menu on first one, then switch off on second etc
            // so we use flag to prevent this
            var stopProcessing = false;

            $("[id^=jobsGrid]").each(function () {
                var grid = $(this).data("kendoGrid");
                if (!grid) {
                    return;
                }

                if (stopProcessing) {
                    //in case there is a multiple seletion - don't need to iterate further
                    //return - exits from .each(function), not from "TasksContextMenu_OnOpen"
                    return;
                }

                var selectedRows = grid.select();
                var cMenu = $(sender.item).data("kendoContextMenu");
                if (selectedRows.length > 1) {
                    stopProcessing = true;
                    cMenu.enable("#jsRun", true);
                    cMenu.enable("#jsStop", true);
                    cMenu.enable("#jsDelete", true);
                    cMenu.enable("#jsActivate", true);
                    cMenu.enable("#jsDeactivate", true);
                } else {
                    cMenu.enable("#jsDeactivate", false);
                    cMenu.enable("#jsActivate", false);
                    cMenu.enable("#jsDelete", false);
                    cMenu.enable("#jsStop", false);
                    cMenu.enable("#jsRun", false);
                }
            });
        };

        var openLogWindow = function (serverId, jobId) {
            $("#JobLogHistory").data("serverId", serverId);
            $("#JobLogHistory").data("jobId", jobId);
            window.setDefaultHistory();
            //load history for current day
            HistoryWindowController.OnGetButton_Click();
            var oWnd = $("#JobLogHistory").data("kendoWindow");

            var firstJobCell = $(".k-master-row>td:data(type=jobId):getJobById(" + jobId + ")");
            var columns = firstJobCell.nextAll("td");

            var jobNameColumn = $(columns).filter(":data(type=jobName)");
            
            oWnd.title("Job history - " + jobNameColumn.html());
            oWnd.center().open();
        }

        this.JobsContextMenu_OnClicked = function (sender) {
            console.log("on: JobsContextMenu_OnClicked");
            var row = $("tr.k-master-row.SelectFlag");
            if (row.length > 0) {
                row = $(row[0]);
                //get selected row and it's values
                var jids = $(row.find(".ids"));
                var sids = $(row.find(".serverIds"));
                var serverId = sids.text();
                var jobId = jids.text();

                var type = sender.item.id;
                //if single action is selected then we leave handler after it's finished
                switch (type) {
                    case "jActivate":
                        window.visualCron.server.activateJob(serverId, jobId);
                        return;
                    case "jDeactivate":
                        window.visualCron.server.deactivateJob(serverId, jobId);
                        return;
                    case "jDelete":
                        if (confirm("Delete job?")) {
                            window.visualCron.server.removeJob(serverId, jobId);
                        }
                        return;
                    case "jRun":
                        window.visualCron.server.runJob(serverId, jobId, "");
                        return;
                    case "jStop":
                        window.visualCron.server.stopJob(serverId, jobId);
                        return;
                    case "jLog":
                        openLogWindow(serverId, jobId);
                        return;
                }

                if (type === "jsDelete") {
                    if (!confirm("Delete selected jobs?")) {
                        return;
                    }
                }

                //if multiple actions are required we iterate through list
                $("[id^=jobsGrid]").each(function () {
                    var grid = $(this).data("kendoGrid");
                    if (!grid) {
                        return;
                    }
                    var selectedRows = grid.select();
                    for (var i = 0; i < selectedRows.length; i++) {
                        var selectedRow = $(selectedRows[i]);
                        jids = $(selectedRow.find(".ids"));
                        sids = $(selectedRow.find(".serverIds"));
                        serverId = sids.text();
                        jobId = jids.text();

                        switch (type) {
                            //selected
                            case "jsActivate":
                                window.visualCron.server.activateJob(serverId, jobId);
                                break;
                            case "jsDeactivate":
                                window.visualCron.server.deactivateJob(serverId, jobId);
                                break;
                            case "jsDelete":
                                window.visualCron.server.removeJob(serverId, jobId);
                                break;
                            case
                                "jsRun":
                                window.visualCron.server.runJob(serverId, jobId, "");
                                break;
                            case
                                "jsStop":
                                window.visualCron.server.stopJob(serverId, jobId);
                                break;
                        }
                    }
                });
            }
        };

        this.JobsContextMenu_OnClose = function (sender) {
            //stub
        };

        this.TasksContextMenu_OnOpen = function (sender) {
            var openedMenu = $("#JobsContextMenu");
            if (openedMenu.length > 0) {
                var cm = $(openedMenu).data("kendoContextMenu");
                if (cm) {
                    cm.close();
                }
            }
            var taskGrids = $(".tasksGrid");

            // as we need to search through several tables simultaneously
            // we can switch menu on first one, then switch off on second etc
            // so we use flag to prevent this
            var stopProcessing = false;

            taskGrids.each(function () {
                var grid = $(this).data("kendoGrid");
                if (!grid) {
                    return;
                }
                if (stopProcessing) {
                    //in case there is a multiple secletion - don't need to iterate further
                    //return - exits from .each(function), not from "TasksContextMenu_OnOpen"
                    return;
                }
                var selectedRows = grid.select();
                var cMenu = $(sender.item).data("kendoContextMenu");
                if (selectedRows.length > 1) {
                    stopProcessing = true;
                    cMenu.enable("#tsRun", true);
                    cMenu.enable("#tsStop", true);
                    cMenu.enable("#tsDelete", true);
                    cMenu.enable("#tsActivate", true);
                    cMenu.enable("#tsDeactivate", true);
                } else {
                    cMenu.enable("#tsDeactivate", false);
                    cMenu.enable("#tsActivate", false);
                    cMenu.enable("#tsDelete", false);
                    cMenu.enable("#tsStop", false);
                    cMenu.enable("#tsRun", false);
                }
            });
        };

        this.TasksContextMenu_OnClicked = function (sender) {
            console.log("on: JobsContextMenu_OnClicked");
            var row = $("tr.SelectFlag.TaskFlag");
            if (row.length > 0) {
                var data = $($(row[0]).find(".taskIds"));
                var serverId = data.data("serverid");
                var jobId = $(row[0]).parents(".tasksGrid").data("jobId");
                var taskId = data.html();

                var type = sender.item.id;
                var oWnd;
                switch (type) {
                    case "tActivate":
                        window.visualCron.server.activateTask(serverId, jobId, taskId);
                        break;
                    case "tDeactivate":
                        window.visualCron.server.deactivateTask(serverId, jobId, taskId);
                        break;
                    case "tRun":
                        window.visualCron.server.runTask(serverId, jobId, taskId);
                        break;
                    case "tStop":
                        window.visualCron.server.stopTask(serverId, jobId, taskId);
                        break;
                    case "tjRun":
                        window.visualCron.server.runJob(serverId, jobId, taskId);
                        break;
                    case "tDelete":
                        if (confirm("delete task?")) {
                            window.visualCron.server.removeTask(serverId, jobId, taskId);
                        }
                        break;
                    case "tLog":
                        openLogWindow(serverId, jobId);
                        break;
                    case "tOutput":
                        OutputWindowController.loadOutputText(serverId, jobId, taskId, 1, false);
                        oWnd = $("#OutputWindow").data("kendoWindow");
                        oWnd.center().open();
                        break;
                    case "tOutputErr":
                        OutputWindowController.loadOutputText(serverId, jobId, taskId, 0, false);
                        oWnd = $("#OutputWindow").data("kendoWindow");
                        oWnd.center().open();
                        break;
                }

                if (type === "tsDelete") {
                    if (!confirm("Delete selected tasks?")) {
                        return;
                    }
                }

                //in case this is a mupltiple elements command, then iterate through them and do selected action
                $(".tasksGrid").each(function () {
                    var dGrid = $(this).data("kendoGrid");
                    if (!dGrid) {
                        return;
                    }
                    var selectedRows = dGrid.select();
                    for (var i = 0; i < selectedRows.length; i++) {
                        var _data = dGrid.dataItem(selectedRows[i]);
                        var _parentDetailRow = $(this).parents("tr.k-detail-row");
                        var _masterRow = $(_parentDetailRow).prev(".k-master-row");
                        var _serverIdRow = $(_masterRow).children("td.serverIds");
                        var _serverId = $(_serverIdRow).html();
                        var _jobId = _data.JobId;
                        var _taskId = _data.TaskId;

                        switch (type) {
                            //selected
                            case "tsActivate":
                                window.visualCron.server.activateTask(_serverId, _jobId, _taskId);
                                break;
                            case "tsDeactivate":
                                window.visualCron.server.deactivateTask(_serverId, _jobId, _taskId);
                                break;
                            case "tsRun":
                                window.visualCron.server.runTask(_serverId, _jobId, _taskId);
                                break;
                            case "tsStop":
                                window.visualCron.server.stopTask(_serverId, _jobId, _taskId);
                                break;
                            case "tsDelete":
                                window.visualCron.server.removeTask(_serverId, _jobId, _taskId);
                                break;
                        }
                    }
                });
            }
        };
    }
});
