﻿var VisualCron = VisualCron || {};


$.extend(VisualCron, {
    GridDataSourceController: function (gridType) {
        console.log("on: VisualCron.GridDataSourceController");

        //initialize internal dataSource
        //eventHandle - is recieved from event handlers, null otherwise
        this.InitializeDataSource = function (eventHandle) {
            console.log("on: VisualCron.GridDataSourceController.InitializeDataSource");

            //Search all grid as current type
            $("[id^=" + _gridType + "]").each(function () {
                var grid = $(this).data("kendoGrid");
                if (!grid) {
                    //if not grid
                    return;
                }
                //get dataSource for current id
                var dataSource = _dataSource[$(this).attr("id")];
                var currentFilter = null;
                if (dataSource) {
                    //remember filter if exist
                    currentFilter = dataSource.filter();
                }

                //load context menu gridNameContextMenu
                $("#" + _gridType + "ContextMenu").load(_contextMenuUri);
                var ds = grid.dataSource.data();
                //copy grid.dataSource to new dataSource
                //bug: replace this - data() to data(source)
                //cannot use data() here as it causes table to refresh and tasks to collapse, so we need to iterate and add
                _dataSource[$(this).attr("id")] = new kendo.data.DataSource.create();
                for (var i = 0; i < ds.length; i++) {
                    _dataSource[$(this).attr("id")].add(ds[i]);
                }
                _dataSource[$(this).attr("id")].filter(currentFilter);
                filter();
                //finding tasks in job
                _checkTask(grid);
                _setColumnHide(grid);
                _setColumnSize(grid);
                _setColumnOrder(grid);
                VisualCron.GridController.fixPagesizeDropdown(grid);
                // _fixPagesizeDropdown(grid);
            });
        };

        this.InitializeTaskGrid = function (eventArg) {
            $(".tasksGrid").each(function () {
                var grid = $(this).data("kendoGrid");
                if (!grid) {
                    //if not grid
                    return;
                }
                _setColumnHide(grid);
                _setColumnSize(grid);
                _setColumnOrder(grid);
            });
        };

        var _checkTask = function (grid) {
            console.log("#debug");
            var dataGroups = grid.dataSource.view();
            if (dataGroups.length == 0) {
                return;
            }
            for (var d = 0; d < dataGroups.length; d++) {
                var data = dataGroups[d].items;
                var sendData = [];
                for (var i = 0; i < data.length; i++) {
                    var obj = {
                        serverId: data[i].ServerId,
                        jobId: data[i].Id
                    };
                    sendData.push(obj);
                }

                window.visualCron.server.checkTaskExist(sendData).done(function (s) {
                    for (var j = 0; j < s.length; j++) {
                        var currentReq = s[j];
                        var jobId = currentReq.Id;
                        var element = $(".ids:contains('" + jobId + "')");

                        var prev = $(element).prev();
                        var children = prev.children();
                        if (!currentReq.Exist) {
                            $(children).hide();
                        } else {
                            $(children).css("display", "block");
                        }
                    }
                });
            }
        };

        this.AddItemToSource = function (serverId, item) {
            console.log("on: AddItemToSource");
            var dataSource = _dataSource[_gridType + serverId];
            dataSource.add(item);
        };

        //if user sort null, set default server sort
        this.SortingDataSource = function (serverId, sortType) {
            console.log("on: SortingDataSource");
            if (sortType) {
                _dataSource[_gridType + serverId].sort(sortType);
            } else {
                _dataSource[_gridType + serverId].sort({ dir: "asc", field: "JobName" });
            }
        };

        this.GetItemPosition = function (serverId, job) {
            console.log("on: GetItemPosition");
            //sorted items saved in _view
            var items = _dataSource[_gridType + serverId]._view;
            for (var i = 0; i < items.length; i++) {
                if (items[i].Id == job.Id) {
                    //get new item position
                    return _dataSource[_gridType + serverId]._view.indexOf(items[i]);
                }
            }
            return -1;
        };

        this.InsertNewRow = function (serverId, position, jobId, uidClass) {
            var isFirst = false;
            console.log("on: InsertNewRow");
            //get tr to clone (first row)
            var trSource = $($("#" + _gridType + serverId).find("tbody")).find("tr.k-master-row")[0];
            if (!trSource) {
                isFirst = true;
                $("#" + _gridType + serverId).data("kendoGrid").dataSource.add();
                trSource = $($("#" + _gridType + serverId).find("tbody")).find("tr.k-master-row")[0];
            }
            if (position > 0) {
                position = position - 1;
            }
            //get element to insert before
            var insertBeforeItem = $($($("#" + _gridType + serverId).find("tbody")).find("tr.k-master-row")[position]);
            var copyobj = $(trSource).clone();
            if (isFirst) {
                copyobj = $(trSource);
            }
            //set new id to clone
            $(copyobj.find(uidClass)).html(jobId);
            var uid = $(copyobj.find(".newRow"));
            if (uid) {
                uid.html("true");
            }
            $(copyobj.find(".k-hierarchy-cell")).children().removeClass("k-minus").addClass("k-plus");
            insertBeforeItem.before(copyobj);
        };

        this.RemoveDataSourceItem = function (serverId, jobId) {
            console.log("on: RemoveDataSourceItem");
            var items = _dataSource[_gridType + serverId].data();
            for (var g = 0; g < items.length; g++) {
                if (items[g].Id == jobId) {
                    _dataSource[_gridType + serverId].remove(items[g]);
                }
            }
        };

        this.DeleteItemRowAndDetalRow = function (serverId, jobId) {
            console.log("on: DeleteItemRowAndDetalRow");
            //get item id
            var items = $("#" + _gridType + serverId).find(".ids");
            for (var i = 0; i < items.length; i++) {
                var item = $(items[i]);
                var id = item.html();
                if (id == jobId) {
                    //get detalGrid if expanded
                    var parentTable = item.parent();
                    var detGrid = parentTable.next();
                    var detTable = $(detGrid.find(".tasksGrid"));
                    if (detTable.length > 0) {
                        detGrid.remove();
                    }
                    parentTable.remove();
                }
            }
        };

        this.UpdateJob = function (serverId, job) {
            console.log("on: UpdateJob");

            var firstJobCell = $("#ServerPartials .k-master-row>td:data(type=jobId):getJobById(" + job.Id + ")");
            var columns = firstJobCell.nextAll("td");

            var currentColumn = $(columns).filter(":data(type=conditions)");
            currentColumn.html(job.ConditionsIcon);

            currentColumn = $(columns).filter(":data(type=active)");
            currentColumn.html("<img alt='icon' class='k-image' src='/Content/images/Activity" + job.Active + ".gif'>");

            currentColumn = $(columns).filter(":data(type=jobName)");
            currentColumn.html(job.JobName);

            currentColumn = $(columns).filter(":data(type=description)");
            currentColumn.html(job.Description);

            currentColumn = $(columns).filter(":data(type=result)");
            currentColumn.html("<img alt='icon' class='k-image' src='/Content/images/result/res_" + job.Result + ".png'>");

            currentColumn = $(columns).filter(":data(type=nextRunStr)");
            currentColumn.html(job.NextRunStr);

            currentColumn = $(columns).filter(":data(type=lastRunStr)");
            currentColumn.html(job.LastRunStr);

            currentColumn = $(columns).filter(":data(type=status)");
            currentColumn.html(job.Status);

            currentColumn = $(columns).filter(":data(type=created)");
            currentColumn.html(job.DateCreatedStr);

            currentColumn = $(columns).filter(":data(type=createdBy)");
            currentColumn.html(job.CreatedByStr);

            currentColumn = $(columns).filter(":data(type=modified)");
            currentColumn.html(job.ModifiedStr);

            currentColumn = $(columns).filter(":data(type=modifiedBy)");
            currentColumn.html(job.ModifiedByStr);

            currentColumn = $(columns).filter(":data(type=executionTime)");
            currentColumn.html(job.ExecutionTime);

            currentColumn = $(columns).filter(":data(type=tasksGroup)");

            var group = $(".k-grouping-row:getGroup(" + job.Group + ")");
            var currentRowGroup = currentColumn.text();
            if (group.length <= 0) {
                group = $(".k-grouping-row:getGroup(" + currentRowGroup + ")");
                var template = "<a class=\"k-icon k-i-collapse\" href=\"#\" tabindex=\"-1\"></a>Group: ";
                var value = template + job.Group;
                group.find("p").html(value);
            }
            if (group.length > 0) {
                var groupRow = currentColumn.parent().prevAll(".k-grouping-row")[0];
                var text = $(groupRow).find("p").text();
                if ("Group: " + job.Group != text) {
                    var currentJobRow = firstJobCell.parent();
                    //get detail grid if availebed
                    var detail = currentJobRow.next("tr.k-detail-row");

                    group.after(currentJobRow);
                    currentJobRow.after(detail);
                    VisualCron.GridController.removeGroupRowIfEmplty(currentRowGroup);
                }
            }
            currentColumn.text(job.Group);

            var filterByJobElement = $("#FilterByJob");
            if (filterByJobElement) {
                var cFilter = filterByJobElement[0].value;
                if (cFilter.length > 0) {
                    filter();
                }
            }
            var grid = $("#" + _gridType + serverId).data("kendoGrid");
            if (grid) {
                _checkTask(grid);
            }
        };

        this.GetGrid = function (serverId) {
            console.log("on: GetTaskGrid");
            return $("#" + _gridType + serverId).data("kendoGrid");
        };

        this.GetTaskGrid = function (serverId, jobId) {
            console.log("on: GetTaskGrid");
            var gridObj = $("#" + jobId);
            return gridObj.data("kendoGrid");
        };

        this.AddTaskToGrid = function (serverId, jobId, grid, task) {
            console.log("on: AddTaskToGrid");
            task.Active = "<img alt='icon' class='k-image' src='/Content/images/Activity" + task.Active + ".gif'>";
            task.ConditionsIcon = "<img alt='icon' class='k-image' src='/Content/images/icons/conditions.gif'>";
            task.Active = "<img alt='icon' class='k-image' src='/Content/images/Activity" + task.Active + ".gif'>";
            task.Result = "<img alt='icon' class='k-image' src='/Content/images/result/res_" + task.Result + ".png'>";
            task.TaskType = "<img alt='icon' class='k-image' src='" + $("#taskTypeIconUri").val() + "?taskType=" + task.TaskType + "'>";
            task.serverId = serverId;
            task.jobId = jobId;
            grid.dataSource.add(task);
            _checkTask(grid);
        };

        this.RemoveTask = function (grid, taskId) {
            console.log("on: RemoveTask");
            var tasks = grid.dataSource.data();
            for (var i = 0; i < tasks.length; i++) {
                if (tasks[i].TaskId == taskId) {
                    grid.dataSource.remove(tasks[i]);
                }
            }
        };

        this.UpdateTask = function (serverId, jobId, grid, task) {
            console.log("on: UpdateTask");
            var tasks = grid.dataSource.data();
            for (var i = 0; i < tasks.length; i++) {
                if (tasks[i].TaskId == task.TaskId) {
                    tasks[i] = task;
                    tasks[i].serverId = serverId;
                    tasks[i].jobId = jobId;
                    tasks[i].Active = "<img alt='icon' class='k-image' src='/Content/images/Activity" + tasks[i].Active + ".gif'>";
                    tasks[i].Result = "<img alt='icon' class='k-image' src='/Content/images/result/res_" + tasks[i].Result + ".png'>";
                    tasks[i].TaskType = "<img alt='icon' class='k-image' src='" + $("#taskTypeIconUri").val() + "?taskType=" + task.TaskType + "'>";
                    //                    tasks[i].ConditionsIcon = "<img alt='icon' class='k-image' src='/Content/images/icons/conditions.gif'>";
                }
            }
            grid.dataSource.data(tasks);
        };

        this.Filter = function (e) {
            var filterElement = $("#FilterByJob");
            var _filter = "";
            var _filterTaskName = "";
            var _filterTaskType = "";
            if (filterElement) {
                _filter = filterElement[0].value;
            }
            var filterElementTask = $("#FilterByTask");
            if (filterElementTask) {
                var tempVal = filterElementTask[0].value;
                var selectedFilter = $("#cbFilterByTask").data("kendoDropDownList");
                var selectedValue = selectedFilter.value();
                if (selectedValue === "Name") {
                    _filterTaskName = tempVal;
                }
                else if (selectedValue === "Type") {
                    _filterTaskType = tempVal;
                }
            }
            var _filterJobActivity = "";
            if (e && e.sender) {
                var cb = $(e.sender.element).attr("id");
                if (cb !== "cbActiveTask") {
                    var val = e.item.text();
                    if (val !== "All") {
                        _filterJobActivity = "/Activity" + val;
                    }
                }
            } else {
                var cbEl = $("#cbActiveJob").data("kendoDropDownList");
                var valEl = cbEl.text();
                if (valEl !== "All") {
                    _filterJobActivity = "/Activity" + valEl;
                }
            }

            $("[id^=" + _gridType + "]").each(function () {
                console.log("#debug");
                var dataSource = _dataSource[$(this).attr("id")];
                var grid = $(this).data("kendoGrid");
                if (!grid) {
                    return;
                }
                var currentFilter = null;
                if (dataSource) {
                    currentFilter = dataSource.filter();
                }
                var f = grid.dataSource.filter();

                if (currentFilter && f) {
                    if (_filter === currentFilter.filters[0].value &&
                        _filterTaskName === currentFilter.filters[1].value &&
                        _filterTaskType === currentFilter.filters[2].value &&
                        _filterJobActivity === currentFilter.filters[3].value) {
                        return;
                    }
                }

                var ds = _dataSource[$(this).attr("id")];
                if (ds) {
                    ds.filter([
                        { field: "JobName", operator: "contains", value: _filter },
                        { field: "TasksTags", operator: "contains", value: _filterTaskName },
                        { field: "TasksTypeTags", operator: "contains", value: _filterTaskType },
                        { field: "Active", operator: "contains", value: _filterJobActivity }
                    ]);
                    grid.dataSource.filter(ds.filter());
                    grid.refresh();
                }
            });
        };

        this.FilterTask = function (e) {
            $(".tasksGrid").each(function () {
                console.log("#debug");
                //we highlight row on mouse click
                var data = $(this).data("kendoGrid");
                if (data && data.tbody) {

                    var filterElementTask = $("#FilterByTask");
                    var _filterTaskName = "";
                    var _filterTaskType = "";
                    if (filterElementTask) {
                        var tempVal = filterElementTask[0].value;
                        var selectedFilter = $("#cbFilterByTask").data("kendoDropDownList");
                        var selectedValue = selectedFilter.value();
                        if (selectedValue === "Name") {
                            _filterTaskName = tempVal;
                        }
                        else if (selectedValue === "Type") {
                            _filterTaskType = tempVal;
                        }
                    }
                    var _filterJobActivity = "";
                    if (e && e.sender) {
                        var val = e.item.text();
                        if (val !== "All") {
                            _filterJobActivity = "/Activity" + val;
                        }
                    } else {
                        var cbEl = $("#cbActiveJob").data("kendoDropDownList");
                        var valEl = cbEl.text();
                        if (valEl !== "All") {
                            _filterJobActivity = "/Activity" + valEl;
                        }
                    }

                    var currentFilter = data.dataSource.filter();
                    if (currentFilter) {
                        if (_filterTaskName === currentFilter.filters[0].value &&
                            _filterTaskType === currentFilter.filters[1].value) {
                            return;
                        }
                    }

                    var f = [
                        { field: "TaskName", operator: "contains", value: _filterTaskName },
                        { field: "TaskType", operator: "contains", value: _filterTaskType },
                        { field: "Active", operator: "contains", value: _filterJobActivity }
                    ];
                    data.dataSource.filter(f);
                    data.refresh();
                }
            });
        };


        var _setColumnHide = function (grid) {
            var gridT = _getGridType(grid.element);
            window.visualCron.server.getColumnSetting(gridT).done(
                    function (result) {
                        if (!result) {
                            return;
                        }
                        //set column visibility according to settings
                        for (var i = 0; i < result.length; i++) {
                            if (!result[i]) {
                                continue;
                            }
                            if (result[i].Visibility == null) {
                                continue;
                            }
                            if (result[i].Visibility == false) {
                                grid.hideColumn(result[i].Name);
                            } else if (result[i].Visibility == true) {
                                grid.showColumn(result[i].Name);
                            }
                        }
                    })
                .fail(
                    function () {
                        console.error("#fail");
                    });
        };

        var _setColumnSize = function (grid) {
            // get the place where column widths are stored
            var content = $(grid.element).find("table");
            var columnsWidthControllers = $(content).find("colgroup col:not(.k-hierarchy-col)");
            // get the table type
            var gridT = _getGridType(grid.element);
            window.visualCron.server.getColumnSetting(gridT)
                .done(
                    function (result) {
                        if (!result) {
                            return;
                        }
                        //grid has a lot of columns, but we only need those that are visible
                        var visibleColumnsWidth = [];
                        for (var j = 0; j < grid.columns.length; j++) {
                            if (grid.columns[j].hidden) {
                                continue;
                            }
                            if (!result[j]) {
                                continue;
                            }
                            if (result[j].Width == null) {
                                continue;
                            }
                            visibleColumnsWidth.push(result[j].Width);
                        }

                        for (var i = 0; i < visibleColumnsWidth.length; i++) {
                            //in visibleColumnsWidth the order is same as in columnsWidthControllers, 
                            //we only need to iterate through it and set widths if supplied
                            if (visibleColumnsWidth[i]) {
                                columnsWidthControllers.eq(i).css({ width: visibleColumnsWidth[i] });
                            }
                        }
                    });
        };

        var _setColumnOrder = function (grid) {
            var gridT = _getGridType(grid.element);
            //get column settings
            window.visualCron.server.getColumnSetting(gridT)
                .done(
                    function (result) {
                        if (!result) {
                            return;
                        }
                        // iterate through recieved columns, find them in grid and put to saved position
                        for (var i = 0; i < result.length; i++) {
                            if (!result[i]) {
                                continue;
                            }
                            if (result[i].Index) {
                                for (var x = 0; x < grid.columns.length; x++) {
                                    if (grid.columns[x].field === result[i].Name) {
                                        grid.reorderColumn(result[i].Index, grid.columns[x]);
                                    }
                                }
                            }
                        }
                    });
        };

        var _fixPagesizeDropdown = function (grid) {
            $('.k-dropdown, select', grid.element).off();
            var pager = grid.pager;
            pager
//            var el = $(".k-pager-sizes.k-label").find(".k-dropdown-wrap");
//            var element = $("k-pager-sizes>.k-dropdown, select");
//            setInterval(function () {
//                console.log("CLICK");
//                var dropdown = element.data("kendoDropDownList");
//                dropdown.open();
//
//                dropdown.toggle();
//            }, 2000);
//
////            debugger;
////            element1.unbind("open");
////            el.unbind("open");
        }

        this.onColumn_Reorder = function (eventArg) {
            // this event fires before column got to their places
            // we need to call our handler after that, so do it on timer with small timeout
            setTimeout(function () {
                reorderEventHandler(eventArg);
            }, 5);
        };

        var reorderEventHandler = function (eventArg) {
            //get grid type
            var gridT = _getGridType(eventArg.sender.element);
            var grid = eventArg.sender;
            //get header (which contains columns)
            var headers = $($(grid.element).find(".k-grid-header"));
            //iterate through columns and store their positions
            for (var j = 0; j < grid.columns.length; j++) {
                var column = grid.columns[j];
                var headerElements = headers.find("th.k-header.k-with-icon");
                for (var i = 0; i < headerElements.length; i++) {
                    //data-field is kendo's system field for column
                    if ($(headerElements[i]).data("field") == column.field) {
                        window.visualCron.server.saveGridOrderColumns(gridT, column.field, i);
                    }
                }
            }

            //update all the grids with new positions
            if (gridT == 0) {
                $("[id^=" + _gridType + "]").each(function () {
                    var ngrid = $(this).data("kendoGrid");
                    if (ngrid) {
                        _setColumnOrder(ngrid);
                    }
                });
            } else {
                $(".tasksGrid").each(function () {
                    var ngrid = $(this).data("kendoGrid");
                    if (ngrid) {
                        _setColumnOrder(ngrid);
                    }
                });
            }
        };

        this.onColumn_Resize = function (eventArg) {
            //translate gridT = это не одно и тоже что и _gridType
            var gridT = _getGridType(eventArg.sender.element);
            window.visualCron.server.saveGridSizeColumns(gridT, eventArg.column.field, eventArg.newWidth)
                .done(function (result) {
                    //update all the grids with new positions
                    if (gridT === 0) {
                        $("[id^=" + _gridType + "]").each(function () {
                            var grid = $(this).data("kendoGrid");
                            if (grid) {
                                _setColumnSize(grid);
                            }
                        });
                    } else {
                        $(".tasksGrid").each(function () {
                            var grid = $(this).data("kendoGrid");
                            if (grid) {
                                _setColumnSize(grid);
                            }
                        });
                    }
                });
        };

        this.onColumn_HideChange = function (eventArg) {
            //translate gridT = это не одно и тоже что и _gridType
            var gridT = _getGridType(eventArg.sender.element);

            //event args has "hidden" variable which needs to be converted to "visibility"
            var visibility = true;
            if (eventArg.column.hidden) {
                visibility = false;
            }
            window.visualCron.server.saveGridHideColumns(gridT, eventArg.column.field, visibility)
                .done(function (result) {
                    //update all the grids with new positions
                    if (gridT == 0) {
                        $("[id^=" + _gridType + "]").each(function () {
                            var grid = $(this).data("kendoGrid");
                            if (grid) {
                                _setColumnHide(grid);
                            }
                        });
                    } else {
                        $(".tasksGrid").each(function () {
                            var grid = $(this).data("kendoGrid");
                            if (grid) {
                                _setColumnHide(grid);
                            }
                        });
                    }
                });
        };

        this.getGridType = function (element) {
            var gridT = 0;
            //child table has class tasksGrid, which contains gridT, constant of class GridType
            if ($(element).hasClass("tasksGrid")) {
                gridT = 1;
            }
            return gridT;
        };

        this.dataSource = function (bar) {
            console.log("#debug");
            if (arguments.length)
                _dataSource = bar;
            else
                return _dataSource;
            return null;
        };

        this.gridType = function (bar) {
            console.log("#debug");
            if (arguments.length)
                _gridType = bar;
            else
                return _gridType;
            return null;
        };

        var _dataSource = { "ServerId": null };
        var _contextMenuUri = $("#contextMenuUri").val();
        //id  = gridName + Id

        //todo внести ясность в _gridType _getGridType gridT и т.д. - назвать как-то правильно и добавить комментарии.
        var _gridType = gridType;
        var filter = this.Filter;
        var filterTask = this.FilterTask;

        var _getGridType = this.getGridType;
    }
});

//
VisualCron.HistoryDSController = {
    //initialize new constructor
    Init: function (gridType) {
        console.log("#debug");
        //call base class constructor
        var baseClass = new VisualCron.GridDataSourceController(gridType);
        //we extend base class with private function
        var extended = $.extend({}, baseClass, {
            _checkTask: function (grid) {
                console.log("#debug");

                var data = grid.dataSource.view();
                if (data.length == 0) {
                    return;
                }
                var sendData = [];
                for (var i = 0; i < data.length; i++) {
                    var obj = {
                        serverId: data[i].ServerId,
                        guid: data[i].ExecutionId,
                        //store current position, so that we can insert fast when response is recieved
                        position: i
                    };
                    sendData.push(obj);
                }
                var jsonSData = JSON.stringify({ jobsData: sendData });

                $.ajax({
                    type: "Post",
                    dataType: "json",
                    url: $("#checkTaskHistoryUri").val(),
                    data: jsonSData,
                    contentType: "application/json; charset=utf-8",
                    async: true,
                    success: function (s) {
                        for (var j = 0; j < s.length; j++) {
                            var currentReq = s[j];
                            //console.log('#debug');
                            $(".hids").each(function () {
                                //console.log('#debug');
                                if ($(this).text() == data[currentReq.pos].ExecutionId) {
                                    var prev = $(this).prev();
                                    var children = prev.children();
                                    if (!currentReq.exist) {
                                        $(children).hide();
                                    } else {
                                        $(children).css("display", "block");
                                    }
                                }
                            });
                        }
                    }
                });
            }
        });

        //extend new class with public methods
        return $.extend({}, extended, {
            //eventHandle - is recieved from event handlers, null otherwise
            InitializeDataSource: function (eventHandle, serverId) {
                console.log("on: HistoryDSController.InitializeDataSource");
                var grid = $("#jobHistoryGrid").data("kendoGrid");
                //get ds for current id
                var lnk = extended.gridType() + serverId;
                var dataSource = extended.dataSource()[lnk];
                var currentFilter = null;
                if (dataSource) {
                    //remember filter if exist
                    currentFilter = dataSource.filter();
                }

                var ds = grid.dataSource.data();
                //cannot use data() here as it causes table to refresh and tasks to collapse, so we need to iterate and add
                extended.dataSource()[lnk] = new kendo.data.DataSource.create();
                for (var i = 0; i < ds.length; i++) {
                    extended.dataSource()[lnk].add(ds[i]);
                }
                extended.dataSource()[lnk].filter(currentFilter);
                extended._checkTask(grid);
            },

            UpdateJob: function (job, uId) {
                console.log("on: HS.UpdateJob");

                var jobIdColumn = $("#" + extended.gridType()).find(":getJobById(" + uId + ")");
                var jobColumns = jobIdColumn.nextAll("td");

                var currentColumn = $(jobColumns).filter(":data(type=executionId)");
                currentColumn.html(job.ExecutionId);

                currentColumn = $(jobColumns).filter(":data(type=serverId)");
                currentColumn.html(job.ServerId);

                currentColumn = $(jobColumns).filter(":data(type=jobId)");
                currentColumn.html(job.Id);

                currentColumn = $(jobColumns).filter(":data(type=started)");
                currentColumn.html(job.Started);

                currentColumn = $(jobColumns).filter(":data(type=result)");
                currentColumn.html("<img alt='icon' class='k-image' src='/Content/images/result/res_" + job.Result + ".png'>");

                currentColumn = $(jobColumns).filter(":data(type=exitCode)");
                currentColumn.html(job.ExitCode);

                currentColumn = $(jobColumns).filter(":data(type=executionTime)");
                currentColumn.html(job.ExecutionTime);
            },

            UpdateTask: function (serverId, jobId, grid, task) {
                console.log("on: HS.UpdateTask");
                var tasks = grid.dataSource.data();
                var found = false;
                for (var i = 0; i < tasks.length; i++) {
                    if (tasks[i].TaskId == task.TaskId) {
                        found = true;
                        tasks[i] = task;
                        tasks[i].serverId = serverId;
                        tasks[i].jobId = jobId;
                        tasks[i].TaskType = "<img alt='icon' class='k-image' src='/Content/images/Activity" + tasks[i].TaskType + ".gif'>";
                        tasks[i].Result = "<img alt='icon' class='k-image' src='/Content/images/result/res_" + tasks[i].Result + ".png'>";
                    }
                }
                if (!found) {
                    //if there were no such task we add it
                    console.log("on: AddTaskToGrid");
                    task.TaskType = "<img alt='icon' class='k-image' src='/Content/images/Activity" + task.TaskType + ".gif'>";
                    task.Result = "<img alt='icon' class='k-image' src='/Content/images/result/res_" + task.Result + ".png'>";
                    task.serverId = serverId;
                    task.jobId = jobId;
                    grid.dataSource.add(task);
                    return;
                }
                grid.dataSource.data(tasks);
                _checkTask(grid);
            }
        });
    }
};

//
VisualCron.HistoryTaskDSController = {
    //initialize new constructor
    Init: function (gridType) {
        console.log("#debug");
        //call base class constructor
        var baseClass = new VisualCron.GridDataSourceController(gridType, "", "");
        //extend base class with private function
        return $.extend({}, baseClass, {

            InitializeDataSource: function (uid) {
                console.log("on: HistoryTaskDSController.InitializeDataSource");
                //get ds for current id
                var lnk = baseClass.gridType() + uid;
                var dataSource = baseClass.dataSource()[lnk];
                if (dataSource) {
                    return;
                }

                //var ds = grid.dataSource.data();
                //cannot use data() here as it causes table to refresh and collapse
                baseClass.dataSource()[lnk] = new kendo.data.DataSource.create();
            },

            AddTaskToGrid: function (uid, task) {
                console.log("#debug");
                var lnk = baseClass.gridType() + uid;
                var dataSource = baseClass.dataSource()[lnk];
                if (!dataSource) {
                    return;
                }
                dataSource.add(task);
            },

            UpdateTaskInGrid: function (uid, grid, task) {
                console.log("#debug");
                var lnk = baseClass.gridType() + uid;
                var dataSource = baseClass.dataSource()[lnk];
                if (!dataSource) {
                    return;
                }
                var tasks = dataSource.data();
                for (var i = 0; i < tasks.length; i++) {
                    if (tasks[i].TaskId == task.TaskId) {
                        tasks[i] = task;
                    }
                }
                dataSource.data(tasks);
                if (grid) {
                    grid.dataSource.data(tasks);
                }
            },

            FillGrid: function (uid, grid) {
                console.log("#debug");
                var lnk = baseClass.gridType() + uid;
                var dataSource = baseClass.dataSource()[lnk];
                if (!dataSource || !grid) {
                    return;
                }
                grid.dataSource.data(dataSource.data());
            }
        });
    }
};