﻿// #HUB
$(function () {
    console.log("#debug");
    var visualCron = $.connection.visualCron;

    $.connection.hub.start(function () {
        console.log("hub.start");

        var currentTime = new Date();
        var currentTimezone = currentTime.getTimezoneOffset();
        currentTimezone = (currentTimezone / 60) * -1;

        visualCron.server.start($("#session").val(), currentTimezone).done(function (result) {
            if (!result) {
                alert("Session error, reload page");
                return;
            }
            window.visualCron = visualCron;
            window.KeepAlive();
            var clientSettings = new VisualCron.ClientSettingsController($("#windowObjectsUri").val());
            clientSettings.loadSettings();
        });
    });


    visualCron.client.serverConnected = function (diff) {
        console.log("serverConnected");
    };

    visualCron.client.serverDisconnected = function (serverId) {
        console.log("serverDisconnected");
        //when server is disconnected - remove it
        $("#" + serverId).remove();
        $("" + serverId);
    };

    visualCron.client.serverStateChange = function (serverId, state) {
        console.log("serverStateChange:" + state);
        var combobox = $("#ConnectionsList").data("kendoComboBox").dataItem();
        var cbButton = $("#tglbtnServerState");

        var textElement = $(cbButton.find(".rrbTextContent"));
        var imgElement = $(cbButton.find(".rrbButtonImage"));

        if (combobox.UserServerId === serverId) {
            if (state) {
                if (cbButton.hasClass("rrbToggled") == false) {
                    cbButton.addClass("rrbToggled");
                    textElement.text("Server On");
                    imgElement.attr("src", "/Content/images/icons/system_on.png");
                }
            } else {
                if (cbButton.hasClass("rrbToggled") == true) {
                    cbButton.removeClass("rrbToggled");
                    textElement.text("Server Off");
                    imgElement.attr("src", "/Content/images/icons/system_off.png");
                }
            }
        }
    };

    visualCron.client.connectionError = function (connectionId, isLoginError, message) {
        window.alert(message);
        if (isLoginError) {
//            var comboBox = $("#ConnectionsList").data("kendoComboBox");
//            comboBox.dataSource.filter({ field: "ConnectionId", operator: "eq", value: connectionId })
//            var item = comboBox.dataSource.at(0);
            VisualCron.PromptPasswordController.show();
        }
        console.log(message);
        $("#loading_popub").css("display", "none");
    };

    ///jobs

    visualCron.client.jobsUpdated = function (serverId, jobs) {
        //TODO does this method fire?
        console.log("jobsUpdated");
        for (var i = 0; i < jobs.length; i++) {
            GridDataSourceController.UpdateJob(serverId, jobs[i]);
        }
    };

    visualCron.client.jobAdded = function (serverId, job) {
        console.log("jobAdded");
        var grid = $("#jobsGrid" + serverId).data("kendoGrid");
        if (!grid) {
            return;
        }

        GridDataSourceController.InitializeDataSource(serverId);
        GridDataSourceController.AddItemToSource(serverId, job);
        var sortType = grid.dataSource.sort();
        GridDataSourceController.SortingDataSource(serverId, sortType);
        var position = GridDataSourceController.GetItemPosition(serverId, job);
        //BUG: check current page here
        if (position < grid.dataSource.pageSize()) {
            GridDataSourceController.InsertNewRow(serverId, position, job.Id, ".ids");

            var group = $(".k-grouping-row:getGroup(" + job.Group + ")");
            if (group.length <= 0) {
                var element = $($(".k-grouping-row")[0]);
                group = element.clone();
                var template = "<a class=\"k-icon k-i-collapse\" href=\"#\" tabindex=\"-1\"></a>Group: ";
                var value = template + job.Group;
                group.find("p").html(value);
                element.before(group);
            }
            //update new row data
            GridDataSourceController.UpdateJob(serverId, job);
        }
    };

    visualCron.client.jobRemoved = function (serverId, job) {
        console.log("jobRemoved");
        GridDataSourceController.InitializeDataSource(serverId);
        GridDataSourceController.RemoveDataSourceItem(serverId, job.Id);
        GridDataSourceController.DeleteItemRowAndDetalRow(serverId, job.Id);

        VisualCron.GridController.removeGroupRowIfEmplty(job.Group);
    };

    visualCron.client.jobUpdated = function (serverId, job) {
        console.log("jobUpdated");
        GridDataSourceController.UpdateJob(serverId, job);
    };

    //eof jobs

    //tasks

    visualCron.client.taskAdded = function (serverId, jobId, task) {
        console.log("taskAdded");
        var grid = GridDataSourceController.GetTaskGrid(serverId, jobId);
        if (grid) {
            GridDataSourceController.AddTaskToGrid(serverId, jobId, grid, task);
        }
        var element = $(".ids:contains('" + jobId + "')");
        var prev = $(element).prev();
        var children = prev.children();
        $(children).css('display', 'block');
    };

    visualCron.client.taskRemoved = function (serverId, jobId, task) {
        console.log("taskRemoved");
        var grid = GridDataSourceController.GetTaskGrid(serverId, jobId);
        if (grid) {
            GridDataSourceController.RemoveTask(grid, task.TaskId);
        }
    };

    visualCron.client.taskUpdated = function (serverId, jobId, task) {
        console.log("taskUpdated");
        var grid = GridDataSourceController.GetTaskGrid(serverId, jobId);
        if (grid) {
            GridDataSourceController.UpdateTask(serverId, jobId, grid, task);
        }
    };

    //history
    visualCron.client.jobStarted = function (serverId, job) {
        console.log("jobStarted");
        JobHistoryAdd(serverId, job);
    };

    visualCron.client.jobEnded = function (serverId, job) {
        console.log("jobEnded");
        HistoryDSController.UpdateJob(job, job.ExecutionId);
    };

    visualCron.client.taskStarted = function (serverId, task) {
        console.log("taskStarted");
        HistoryTaskDSController.InitializeDataSource(task.ExecutionId);
        HistoryTaskDSController.AddTaskToGrid(task.ExecutionId, task);
    };

    visualCron.client.taskEnded = function (serverId, task) {
        console.log("taskEnded");
        var grid = HistoryDSController.GetTaskGrid(serverId, task.ExecutionId);
        HistoryTaskDSController.UpdateTaskInGrid(task.ExecutionId, grid, task);
    };

    // eof history

    //server objects

    visualCron.client.serverObjectAdded = function (userServerId, serverObject, objectType) {
        var controllerUri = $("#windowObjectsUri").val();
        var soc = new VisualCron.ServerObjects.ServerObjectController(controllerUri, objectType);
        soc.onAdded(userServerId, serverObject);
    };

    visualCron.client.serverObjectRemoved = function (userServerId, serverObject, objectType) {
        var controllerUri = $("#windowObjectsUri").val();
        var soc = new VisualCron.ServerObjects.ServerObjectController(controllerUri, objectType);
        soc.onRemoved(userServerId, serverObject);
    };

    visualCron.client.serverObjectUpdated = function (userServerId, serverObject, objectType) {
        var controllerUri = $("#windowObjectsUri").val();
        var soc = new VisualCron.ServerObjects.ServerObjectController(controllerUri, objectType);
        soc.onUpdated(userServerId, serverObject);
    };

    visualCron.client.jobNotification = function (jobName, time, running) {
        var settings = VisualCron.ClientSettingsController.getSettings();
        if (running && settings.ShowJobStart) {
            VisualCron.NotificationController.showNotification({ Name: jobName, RunTime: "VisualCron - " + time }, "Job started");
        } else if (!running && settings.ShowJobEnd) {
            VisualCron.NotificationController.showNotification({ Name: jobName, RunTime: "VisualCron - " + time }, "Job completed");
        }
    };



    // eof server objects


    visualCron.client.popupRequest = function (userServerId, popupTask) {
        VisualCron.PopupTaskController.show(userServerId, popupTask);
    }


    visualCron.client.connectionStateChanged = function (listConnections) {
        console.log("connectionStateChanged");
        var comboBox = $("#ConnectionsList").data("kendoComboBox");

        if (!comboBox) {
            $("#ConnectionsList").width(300).kendoComboBox({
                dataTextField: "Name",
                dataValueField: "ConnectionId",
                template: "<span class='k-state-default'><img src='/Content/images/ServerConnected#=Connected#.png' />#=Name#</span>"
            });
            comboBox = $("#ConnectionsList").data("kendoComboBox");
            comboBox.readonly(true);
            comboBox.bind("select", ConnectionController.onSelectedServer);
            comboBox.bind("cascade", ConnectionController.connnectionsList_OnClientSelectedIndexChanged);
        }
        var dataSource = new kendo.data.DataSource({
            data: listConnections
        });
        comboBox.unbind("cascade", ConnectionController.connnectionsList_OnClientSelectedIndexChanged);
        var selectFirstItem = $("#ConnectionsList").data("kendoComboBox").dataItem();
        comboBox.setDataSource(dataSource);
        for (var i = 0; i < listConnections.length; i++) {
            if (listConnections[i].Connected) {
                visualCron.server.getServerState(listConnections[i].UserServerId)
                    .done(
                        function(result) {
                            console.log("#debug");
                            ConnectionController.setServerButtonState(result);
                        });
                ServerTreeController.loadServerTree(listConnections[i].Host, listConnections[i].UserServerId);
            }
        }
        comboBox.bind("cascade", ConnectionController.connnectionsList_OnClientSelectedIndexChanged);

        //select first element, if this "first load" event

        if (!selectFirstItem) {
            comboBox.select(0);
        } else {
            $("#ConnectionsList").data("kendoComboBox").select(function (dataItem) {
                return dataItem.ConnectionId === selectFirstItem.ConnectionId;
            });
            //not fire cascade event, bug?
            ConnectionController.connnectionsList_OnClientSelectedIndexChanged(null);
        }

        var ConnectionsListFilter = $("#ConnectionsListFilter").data("kendoComboBox");

        if (!ConnectionsListFilter) {
            $("#ConnectionsListFilter").kendoComboBox({
                dataTextField: "Name",
                dataValueField: "ConnectionId",
                template: "<span class='k-state-default'><img src='/Content/images/ServerConnected#=Connected#.png' />#=Name#</span>"
            });
            ConnectionsListFilter = $("#ConnectionsListFilter").data("kendoComboBox");
            ConnectionsListFilter.readonly(true);
            ConnectionsListFilter.bind("select", ConnectionController.onSelectedServer);
            ConnectionsListFilter.bind("cascade", ConnectionController.connnectionsListFilter_OnClientSelectedIndexChanged);
        }
        listConnections.push({ "Name": "All", "ConnectionId": "All", "Connected": "false" });
        var dataSourceFilter = new kendo.data.DataSource({
            data: listConnections
        });
        ConnectionsListFilter.setDataSource(dataSourceFilter);
        var selectFirstItemFilter = ConnectionsListFilter.dataItem();
        if (!selectFirstItemFilter) {
            ConnectionsListFilter.select(listConnections.length - 1);
        }


        $("#ConnectionsListFilter").prev().parent().on("mousedown", function (e) {
            console.log("#debug");
            var img = $("#ConnectionsListFilter-list").find("img");
            img.each(function (parameters) {
                console.log("#debug");
                if ($(this).parent().html() == "<img src=\"/Content/images/ServerConnectedfalse.png\">All") {
                    $(this).hide();
                }
            });
            $("#ConnectionsListFilter").data("kendoComboBox").open();
        });
        var item = $("#ConnectionsList").data("kendoComboBox").select();
        //we make all comboboxes readonly
        ConnectionController.InitializeComboBox("#ConnectionsList");
        $("#ConnectionsList").data("kendoComboBox").select(item);
        ConnectionController.InitializeComboBox("#cbFilterByJob");
        //        ConnectionController.InitializeComboBox("#cbFilterByTask");
        ConnectionController.InitializeComboBox("#statusFilter");
    };
});

JobHistoryAdd = function (serverId, job) {
    console.log("JobHistoryAdded");
    var grid = HistoryDSController.GetGrid("");
    if (!grid) {
        return;
    }
    HistoryDSController.InitializeDataSource("", serverId);
    HistoryDSController.AddItemToSource(serverId, job);
    var sortType = grid.dataSource.sort();
    HistoryDSController.SortingDataSource(serverId, sortType);
    var position = HistoryDSController.GetItemPosition(serverId, job);
    ///bug: fix getting current page
    if (position < grid.dataSource.pageSize()) {
        //jobId for History is always the same, so we need to pass something unique to distinguish that, and pass this value to new UpdateJob
        HistoryDSController.InsertNewRow("", position, job.ExecutionId, ".hids");
        //update new row data
        HistoryDSController.UpdateJob(job, job.ExecutionId);
    }
};