﻿var VisualCron = VisualCron || {};

$.extend(VisualCron, {
    OutputWindowController: function () {

        //we store output values in this variable so that we can easily convert it
        var _output;

        var getFormatingText = function (toggledBtnId) {
            var editor = $("#OutEditor").data("kendoEditor");
            switch (toggledBtnId) {
                case "getText":
                    editor.value(_output);
                    break;
                case "getHtml":
                    //We perform convertion to HTML by adding raw output to editor, 
                    //then taking it's encodedValue and setting it to editor again 
                    editor.value(_output);
                    editor.value(editor.encodedValue());
                    break;
                case "getXml":
                    //TODO: XML View Not implemented
                    //var xml = new XElement("output", window.output);
                    //editor.value('@xml.ToString()');*@
                    break;
            }
        };

        var OnLoadedOutput = function (response) {
            console.log("#debug");

            _output = response.Output;
            var btnFull = $("#btnFullOut");
            var templateForToolBar = $("#templateForToolBar");
            if (!templateForToolBar) {
                console.err("templateForToolBar - null");
                return;
            }
            var toolbar = templateForToolBar.data("kendoToolBar");
            if (!toolbar) {
                $("#templateForToolBar").kendoToolBar({
                    resizable: false,
                    items: [
                        {
                            type: "buttonGroup",
                            buttons: [
                                { spriteCssClass: "k-tool-icon k-justifyLeft", id: "getText", text: "Text", togglable: true, selected: true, group: "format", toggle: OutputWindowController.onFormatButton_Toggled },
                                { spriteCssClass: "k-tool-icon k-viewHtml", id: "getHtml", text: "HTML", togglable: true, group: "format", toggle: OutputWindowController.onFormatButton_Toggled }
                            ]
                        },
                        { type: "separator" },
                        { type: "button", id: "btnFullOut", text: "Get full output", click: onGetFullOutputButton_Click }
                    ]
                });
                toolbar = $("#templateForToolBar").data("kendoToolBar");
            }
            toolbar.enable(btnFull, response.IsEnabled);
            //format output to selected formatting
            var id = $(toolbar.getSelectedFromGroup("format")).attr("id");
            getFormatingText(id);
        };

        var saveData = function (sId, jId, tId, outType) {
            $("#OutEditor").data("serverId", sId);
            $("#OutEditor").data("jobId", jId);
            $("#OutEditor").data("taskId", tId);
            $("#OutEditor").data("outType", outType);
        };

        var getDataObject = function (fullOut) {
            return {
                serverId: $("#OutEditor").data("serverId"),
                jobId: $("#OutEditor").data("jobId"),
                taskId: $("#OutEditor").data("taskId"),
                type: $("#OutEditor").data("outType"),
                full: fullOut
            };
        };

        //toggledBtnId = id of selected formatting button

        this.loadOutputText = function (serverId, jobId, taskId, outType, fullOut) {
            console.log("#debug");

            if (!fullOut) {
                saveData(serverId, jobId, taskId, outType);
            } else {
                var obj = getDataObject(fullOut);
                serverId = obj.serverId;
                jobId = obj.jobId;
                taskId = obj.taskId;
                outType = obj.type;
            }
            window.visualCron.server.getOutputValue(serverId, jobId, taskId, outType, fullOut).done(OnLoadedOutput);
        };

        this.loadHistoryOutputText = function (serverId, taskId, guid, outType) {
            console.log("#debug");
            window.visualCron.server.getHistoryOutputValue(serverId, taskId, guid, outType).done(OnLoadedOutput);
        }

        this.onFormatButton_Toggled = function (eventArg) {
            var buttonId = $(eventArg.target).attr("id");
            getFormatingText(buttonId);
        }
    }
});
