﻿var VisualCron = VisualCron || {};

$.extend(VisualCron, {
    RibbonBarController: function () {

        this.onRibbonButtons_Click = function (sender, eventArg) {
            console.log("#debug");
            var btn = eventArg.get_button();
            var button = $(btn._element);
            var buttonType = button.attr("id");
            var serverId = $("#currentServerId").data("currentserverid");
            var controllerUri = $("#windowObjectsUri").val();
            //disabled="disabled" class="aspNetDisabled rrbButtonOut rrbMediumButton  rrbDisabled"
            switch (buttonType) {

                //File
                case "btnManageServers":
                    ConnectionController.onManageConnections_Click();
                    break; 
                case "btnClientSettings":
                    VisualCron.ClientSettingsController.safeConxtext.createWindow(serverId);
                    break; 

                    //Server
                case "btnRunningJobs":
                case "btnClientConnections":
                    //serobjects
                case "btnCertificates":
                case "btnConditions":
                case "btnConnections":
                case "btnCredentials":
                case "btnNetDrives":
                case "btnNotification":
                case "btnPgpKeyRings":
                case "btnVariables":
                    var serverObjectController = new VisualCron.ServerObjects.ServerObjectController(controllerUri, buttonType);
                    serverObjectController.createWindow(serverId);
                    break;

                    //Tools

                    //Logs 

                    //Help
                case "btnForum":
                    window.open("http://www.visualcron.com/Forum.aspx", "_blank");
                    break;
                case "btnContact":
                    window.open("http://www.visualcron.com/Contact.aspx", "_blank");
                    break;
                case "btnTutorials":
                    window.open("http://www.visualcron.com/Tutorials.aspx", "_blank");
                    break;

                    //Other
                default:
                    alert(buttonType + " - Not implemented");
            }
        };

        this.onRibbonToggleButtons_Toggled = function (sender, eventArg) {
            console.log("#debug");

            var btn = eventArg.get_button();
            var button = $(btn._element);
            var id = button.attr("id");
            var toggled = btn._toggled;
            var textElement = $(button.find(".rrbTextContent"));
            var imgElement = $(button.find(".rrbButtonImage"));
            var serverId = $("#currentServerId").data("currentserverid");
            var connected = false;
            if (serverId !== "") {
                connected = true;
            }

            switch (id) {
                //Server
                case "tglbtnServerState":
                    //if simple button.text("Whoa!Whoa!Whoa!") === missing icon :(
                    if (connected) {
                        window.visualCron.server.serverState(serverId, toggled);
                        if (toggled) {
                            textElement.text("Server On");
                            imgElement.attr("src", "/Content/images/icons/system_on.png");
                        } else {
                            textElement.text("Server Off");
                            imgElement.attr("src", "/Content/images/icons/system_off.png");
                        }
                    }
                    break;
                    //Interface
                case "tglbtnColumnSelector":
                    if (toggled) {
                        textElement.text("Hide column selectors");
                        //imgElement.attr("src", "/Content/images/icons/system_off.png");
                        $(".k-icon.k-i-arrowhead-s").css("display", "block");

                    } else {
                        textElement.text("Show column selectors");
                        //imgElement.attr("src", "/Content/images/icons/system_off.png");
                        $(".k-icon.k-i-arrowhead-s").hide();
                    }
                    break;

                case "tglbtnGroup":
                    if (toggled) {
                        //imgElement.attr("src", "/Content/images/icons/system_off.png");
                        $(".k-grouping-row").css("display", "table-row");

                    } else {
                        //imgElement.attr("src", "/Content/images/icons/system_off.png");
                        var grids = $(".k-grid[id^=jobsGrid]");
                        grids.each(function(i, e) {
                            var grid = $(e).data("kendoGrid");
                            if (grid) {
                                grid.expandGroup(".k-grouping-row");
                            }
                        });
                        $(".k-grouping-row").hide();
                    }
                    break;
                default:
                    alert(id + " - Not implemented");
            }
        };

        this.onRibbonClient_Load = function (sender, eventArg) {
            //console.log('#debug');
            //with add doubleclick handler on tabs, to mimic the way desktop app works
            var tabs = $($(".rrbTabs").find(".rrbTab"));
            tabs.each(function (counter) {
                $(this).on("dblclick", function (e) {
                    $(".rrbToggleHandle").click();
                });
            });
        };
    }
});