﻿var VisualCron = VisualCron || {};

$.extend(VisualCron, {
    ServerTreeController: function () {
        var _serverTreeUri = $("#TreeServerUri").val();

        this.loadServerTree = function(serverName, serverId, force) {
            console.log("#debug");
            //"force" is used to force grid reload, this fixes problem with grid updated twice
            var currentTree = $("#" + serverId);
            if (currentTree.length == 0 || force) {
                $("#ServerPartials").append("<div id=" + serverId + "></div>");
                if (force) {
                    currentTree.load(_serverTreeUri + "?server=" + serverName + "&serverId=" + serverId);
                }
            }
        };

        //this is made to fix the tree expansion visual style
        this.onServerTree_Expand = function(eventArg) {
            console.log("#debug");
            var treeIcon = getTreeIconElement(eventArg, "k-plus");
            $(treeIcon).removeClass("k-plus").addClass("k-minus");
        };

        //this is made to fix the tree collapsion visual style
        this.onServerTree_Collapse = function (eventArg) {
            console.log("#debug");
            var treeIcon = getTreeIconElement(eventArg, "k-minus");
            $(treeIcon).removeClass("k-minus").addClass("k-plus");
        };

        this.runServerTimer = function () {
            $("[id^=server-div-]").each(function (element) {

                var timeElement = $(this).find(".server-time");
                var serverId = $(this).parent().attr("id");

                window.visualCron.server.getCurrentServerTime(serverId)
                    .done(
                        function(result) {
                            if (result == "null") {
                                result = $(timeElement).text();
                            }
                            $(timeElement).text(result);
                        })
                    .fail(
                        function() {
                            console.log("#fail");
                            $(timeElement).text($(timeElement).text());
                        });
            });
            window.setTimeout(arguments.callee, 1000);
        };

        var getTreeIconElement = function(eventArg, findElement) {
            var senderElement = $(eventArg.sender.element);
            //we look for <span> element here, all <a> elements are branches of main tree already
            return senderElement.find("span." + findElement);
        };
    }
});
