﻿var VisualCron = VisualCron || {};

$.extend(VisualCron, {
    TasksGridController: function () {

        //This is called when tasks are closed
        //clears row from cache, so that next time it gets loaded again
        this.onGrid_Collapse =function (eventArg) {
            console.log("#debug");
            $(eventArg.detailRow).remove();
        }

        //happens when tasks list is expanded
        this.onGrid_Expand = function (eventArg) {
            console.log("#debug");

            VisualCron.TaskGridBaseController.readData(eventArg);

            $(".tasksGrid").each(function () {
                console.log("#debug");
                //we highlight row on mouse click
                var data = $(this).data("kendoGrid");
                if (data && data.tbody) {
                    data.tbody.on("mousedown", onMouse_Down);

                    var filterElementTask = $("#FilterByTask");
                    var _filterTask = "";
                    if (filterElementTask) {
                        _filterTask = filterElementTask[0].value;
                    }
                    var _filterJobActivity = "";
                    var cbEl = $("#cbActiveTask").data("kendoDropDownList");
                    var valEl = cbEl.text();
                    if (valEl !== "All") {
                        _filterJobActivity = "/Activity" + valEl;
                    }

                    var f = [
                        { field: "TaskName", operator: "contains", value: _filterTask },
                        { field: "Active", operator: "contains", value: _filterJobActivity }
                    ];
                    data.dataSource.filter(f);
                    data.refresh();
                    GridDataSourceController.FilterTask();
                }
                openOutputWindows(this);
            });

            $(".tasksHistoryGrid").each(function () {
                console.log("#debug");
                openOutputWindows(this);
            });
        }


        var openOutputWindows = function (element) {
            console.log("#debug");
            //on doubleclick we show output window
            $(element).data("kendoGrid").tbody.on("dblclick", function(e) {
                console.log("#debug");
                var isHistory = false;
                if ($(e.target).hasClass("outputs")) {
                    //var grids = $(e.currentTarget).parents('.k-grid');
                    var grid = $(e.currentTarget).parents("div");
                    var detailGrid = grid.data("kendoGrid");
                    var data = detailGrid.dataItem($(e.target).parent());
                    var detailRow = $(element).parents("tr.k-detail-row");
                    var masterRow = $(detailRow).prev(".k-master-row");
                    var serverIdContainer = $(masterRow).children("td.serverIds");
                    var serverId = $(serverIdContainer).html();

                    // when we click on a row which has serverId - we show "output"
                    // if there is no serverId - we show History
                    if (!serverId) {
                        serverId = data.ServerId;
                        isHistory = true;
                    }
                    var jobId = data.JobId;
                    var taskId = data.TaskId;
                    var guid = data.ExecutionId;
                    var type = $(e.target).data("type");
                    if (!isHistory) {
                        OutputWindowController.loadOutputText(serverId, jobId, taskId, type, false);
                    } else {
                        OutputWindowController.loadHistoryOutputText(serverId, taskId, guid, type);
                    }
                    var oWnd = $("#OutputWindow").data("kendoWindow");
                    oWnd.center().open();
                }
            });
        };

        var onMouse_Down = function(eventArg) {
            console.log("#debug");
            var grid = $(eventArg.target).parents("div.k-grid.tasksGrid");
            if (grid) {
                //var targetRowElement = $(eventArg.target).parents("tr.k-master-row");
                $("tr.SelectFlag.TaskFlag").removeClass("SelectFlag TaskFlag");
                var targetRowElement = $($(eventArg.target).parents("tr")[0]);
                if (!targetRowElement.hasClass("SelectFlag TaskFlag")) {
                    targetRowElement.addClass("SelectFlag TaskFlag");
                }
            }
        };
    }
});