/// <reference path="../typings/jquery/jquery.d.ts" />
/// <reference path="../kendo/typescript/kendo.all.d.ts" />
var VisualCron;
(function (VisualCron) {
    var ui = kendo.ui;
    var ServerObjectController = (function () {
        function ServerObjectController(url, objectType) {
            this.url = url;
            this.objectType = objectType;
        }
        ServerObjectController.prototype.createWindow = function (serverId) {
            var _this = this;
            var data = {
                serverId: serverId,
                objectType: this.objectType
            };
            this._addEventHandler();
            var target = this._createElement();
            target.load(this.url, data, function (resp, text, xreq) { return _this._onLoad(); });
        };
        ServerObjectController.prototype._addEventHandler = function () {
            var childElement = $("#win" + this.objectType);
            //if event handler was added, not add again
            if (childElement.length > 0) {
                return;
            }
            window.visualCron.server.addEventHandler(this.objectType);
        };
        ServerObjectController.prototype._onLoad = function () {
            var windowParams = this._createWindowsOptions();
            switch (this.objectType) {
                case "btnCertificates":
                    windowParams.title = "Manage certificates";
                    break;
                case "btnConditions":
                    windowParams.title = "Manage conditions";
                    break;
                case "btnConnections":
                    windowParams.title = "Manage connections";
                    break;
                case "btnCredentials":
                    windowParams.title = "Manage Credentials";
                    break;
                case "btnNetDrives":
                    windowParams.title = "Manage network drives";
                    break;
                case "btnNotification":
                    windowParams.title = "Manage notification";
                    break;
                case "btnPgpKeyRings":
                    windowParams.title = "Manage PGP Key Rings";
                    break;
                case "btnVariables":
                    windowParams.title = "Manage variables";
                    break;
            }
            this._createWindow(windowParams);
        };
        ServerObjectController.prototype._createWindowsOptions = function () {
            var wp = {
                draggable: true,
                modal: true,
                height: 500,
                width: 1000,
                resizable: true
            };
            return wp;
        };
        ServerObjectController.prototype._createWindow = function (windowParams) {
            var rootElement = $("#root" + this.objectType)[0];
            var win = new ui.Window(rootElement, windowParams);
            win.center();
        };
        ServerObjectController.prototype._createElement = function () {
            var root = $("#ServerObjectsRoot");
            var childElement = $("#win" + this.objectType);
            if (childElement.length <= 0) {
                var childHtml = "<div id='win" + this.objectType + "'></div>";
                root.append(childHtml);
                childElement = $("#win" + this.objectType);
            }
            return childElement;
        };
        return ServerObjectController;
    })();
    VisualCron.ServerObjectController = ServerObjectController;
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=ServerObjectController.js.map