var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var VisualCron;
(function (VisualCron) {
    var ClientSettingsController = (function (_super) {
        __extends(ClientSettingsController, _super);
        function ClientSettingsController(uri) {
            _super.call(this);
            this._currentSetting = null;
            this.url = uri;
            ClientSettingsController.safeConxtext = this;
        }
        Object.defineProperty(ClientSettingsController, "objectType", {
            get: function () { return "btnClientSettings"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ClientSettingsController.prototype, "objectType", {
            get: function () { return ClientSettingsController.objectType; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ClientSettingsController.prototype, "title", {
            get: function () { return "Client settings"; },
            enumerable: true,
            configurable: true
        });
        ClientSettingsController.prototype.loadSettings = function () {
            window.visualCron.server.getClientSettings().done(function (obj) {
                ClientSettingsController.safeConxtext._currentSetting = obj;
            });
        };
        ClientSettingsController.prototype._createWindowsOptions = function () {
            var _this = this;
            var wp = {
                draggable: true,
                modal: true,
                height: 350,
                width: 300,
                resizable: true,
                close: function (e) {
                    //anonymous function save 'this' context
                    _this._onWindowClose(_this, e);
                }
            };
            return wp;
        };
        ClientSettingsController.onClick = function (eventArg) {
            var id = eventArg.id;
            switch (id) {
                case "btnOk":
                    ClientSettingsController.safeConxtext._currentSetting = {
                        ShowJobStart: $("#cbkShowStart").prop("checked"),
                        ShowJobEnd: $("#cbkShowEnd").prop("checked")
                    };
                    window.visualCron.server.saveClientSettings(ClientSettingsController.safeConxtext._currentSetting).fail(function (f) { alert(f); });
                    ClientSettingsController._closeWindow();
                    break;
                case "btnCancel":
                    ClientSettingsController._closeWindow();
                    break;
                default:
                    throw new TypeError("type not found");
            }
        };
        ClientSettingsController.getSettings = function () {
            if (ClientSettingsController.safeConxtext && ClientSettingsController.safeConxtext._currentSetting) {
                return ClientSettingsController.safeConxtext._currentSetting;
            }
            return { ShowJobStart: true, ShowJobEnd: true };
        };
        ClientSettingsController._closeWindow = function () {
            ClientSettingsController.safeConxtext.window.close();
        };
        ClientSettingsController.prototype._onLoad = function () {
            _super.prototype._onLoad.call(this);
            if (!ClientSettingsController.safeConxtext._currentSetting) {
                return;
            }
            $("#cbkShowStart").prop("checked", ClientSettingsController.safeConxtext._currentSetting.ShowJobStart);
            $("#cbkShowEnd").prop("checked", ClientSettingsController.safeConxtext._currentSetting.ShowJobEnd);
        };
        ClientSettingsController.safeConxtext = null;
        return ClientSettingsController;
    })(VisualCron.WindowBase);
    VisualCron.ClientSettingsController = ClientSettingsController;
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=ClientSettingsController.js.map