/// <reference path="../typings/jquery/jquery.d.ts" />
var VisualCron;
(function (VisualCron) {
    var GridController = (function () {
        function GridController() {
        }
        GridController.removeGroupRowIfEmplty = function (groupName) {
            var groupRow = $(".k-grouping-row:getGroup(" + groupName + ")");
            if (!groupRow) {
                return;
            }
            var next = $(groupRow).next("tr.k-master-row");
            if (next.length <= 0) {
                $(groupRow).remove();
            }
        };
        GridController.fixPagesizeDropdown = function (grid) {
            var pager = $(".k-dropdown, select", grid.element);
            if (pager) {
                pager.off();
            }
        };
        GridController.keyController = function () {
            $(window.document).bind("keydown", function (e) {
                // 46 - del
                if (e.keyCode === 46) {
                    var row = $("tr.k-master-row.SelectFlag");
                    if (row.length > 0) {
                        var grid = row.parents(".k-grid").data("kendoGrid");
                        var selectedRows = grid.select();
                        var message = "Delete " + selectedRows.length + " jobs?";
                        if (selectedRows.length === 1) {
                            var nextAll = row.children("td");
                            var jname = $(nextAll.filter(":data(type=jobName)")).text();
                            message = "Delete job '" + jname + "'?";
                        }
                        if (confirm(message)) {
                            for (var i = 0; i < selectedRows.length; i++) {
                                var selectedRow = $(selectedRows[i]);
                                var jids = $(selectedRow.find(".ids"));
                                var sids = $(selectedRow.find(".serverIds"));
                                var serverId = sids.text();
                                var jobId = jids.text();
                                GridController.deleteJobWithoutConfirm(row, serverId, jobId);
                            }
                        }
                    }
                    else {
                        var trow = $("tr.SelectFlag.TaskFlag");
                        if (trow.length > 0) {
                            var grid = trow.parents(".k-grid").data("kendoGrid");
                            var _selectedRows = grid.select();
                            var message = "Delete " + _selectedRows.length + " tasks?";
                            if (_selectedRows.length === 1) {
                                var tasks = grid.dataSource.data();
                                var taskId = _selectedRows.find(".taskIds").text();
                                var taskName = "";
                                for (var u = 0; u < tasks.length; u++) {
                                    if (tasks[u].TaskId === taskId) {
                                        taskName = tasks[u].TaskName;
                                    }
                                }
                                message = "Delete task '" + taskName + "'?";
                            }
                            if (confirm(message)) {
                                for (var i = 0; i < _selectedRows.length; i++) {
                                    var _data = grid.dataItem(_selectedRows[i]);
                                    var _serverId = $(grid.element).attr("id");
                                    var _jobId = _data.JobId;
                                    var _taskId = _data.TaskId;
                                    GridController.deleteTaskWithoutConfirm(trow, _serverId, _jobId, _taskId);
                                }
                            }
                        }
                    }
                }
            });
        };
        GridController.deleteJob = function (row, serverId, jobId) {
            var nextAll = row.children("td");
            var jname = $(nextAll.filter(":data(type=jobName)")).text();
            if (confirm("Delete job '" + jname + "'?")) {
                GridController.deleteJobWithoutConfirm(row, serverId, jobId);
            }
        };
        GridController.deleteJobWithoutConfirm = function (row, serverId, jobId) {
            window.visualCron.server.removeJob(serverId, jobId);
        };
        GridController.deleteTask = function (row, serverId, jobId, taskId) {
            if (confirm("Delete task?")) {
                GridController.deleteTaskWithoutConfirm(row, serverId, jobId, taskId);
            }
        };
        GridController.deleteTaskWithoutConfirm = function (row, serverId, jobId, taskId) {
            window.visualCron.server.removeTask(serverId, jobId, taskId);
        };
        return GridController;
    })();
    VisualCron.GridController = GridController;
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=GridController.js.map