var VisualCron;
(function (VisualCron) {
    var PopupTaskController = (function () {
        function PopupTaskController() {
        }
        Object.defineProperty(PopupTaskController, "contentPageUri", {
            get: function () { return "/Home/PopupTask"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PopupTaskController, "parentId", {
            get: function () { return "popupTask" + PopupTaskController.popupTask.TaskId; },
            enumerable: true,
            configurable: true
        });
        PopupTaskController.show = function (userServerId, popupTask) {
            PopupTaskController.popupTask = popupTask.PopupRequest;
            PopupTaskController.baseMessage = popupTask;
            PopupTaskController.userServerId = userServerId;
            $("#popup-task-window").append("<div id='" + PopupTaskController.parentId + "'></div>");
            $("#" + PopupTaskController.parentId).kendoWindow({
                title: "VisualCron Popup Task",
                modal: PopupTaskController.popupTask.PopupTask.Modal,
                resizable: true,
                content: PopupTaskController.contentPageUri,
                activate: PopupTaskController.onActivate,
                close: PopupTaskController.onClose,
                visible: false,
                minWidth: 500
            });
            var window = $("#" + PopupTaskController.parentId).data("kendoWindow");
            window.center().open();
            window.resize();
            //setup manually, because status-strip not work fine
            //            window.setOptions({
            //                width: 500,
            //                height: 500
            //            });
            $("#" + PopupTaskController.parentId).parent().find(".k-window-title").prepend("<div class='popup-window-title-icon'></div> &nbsp; ");
        };
        PopupTaskController._pad = function (val) {
            return val > 9 ? val : "0" + val;
        };
        PopupTaskController.onActivate = function () {
            $("#popup-title").text(PopupTaskController.popupTask.PopupTask.Title);
            $("#tbaPopupText").val(PopupTaskController.popupTask.PopupTask.Message);
            $("#popup-job-label").text("Job: " + PopupTaskController.popupTask.TaskProcess.Job.Name);
            $("#popup-task-label").text("Task: " + PopupTaskController.popupTask.TaskProcess.Task.Name);
            $("#popup-task-title").append("<img class='popup-task-icon' src='Content/images/icons/popupTask/" + PopupTaskController._getIcon() + ".png'/>");
            if (PopupTaskController.popupTask.PopupTask.AutoClose) {
                PopupTaskController.autoCloseSeconds = PopupTaskController.popupTask.PopupTask.AutoCloseSeconds;
                PopupTaskController.timerHandler = setInterval(function () { PopupTaskController._timerHandler(); }, 1000);
            }
            PopupTaskController._addButtons();
            PopupTaskController._addInputs();
        };
        PopupTaskController.onResultButtonClick = function (buttonValue) {
            PopupTaskController._returnResponse(buttonValue);
            $("#" + PopupTaskController.parentId).data("kendoWindow").close();
        };
        PopupTaskController._getIcon = function () {
            switch (PopupTaskController.popupTask.PopupTask.Icon) {
                case 0:
                    return "Information";
                case 1:
                    return "Exclamation";
                case 2:
                    return "Question";
                case 3:
                    return "Error";
                default:
                    return "Question";
            }
        };
        PopupTaskController._returnResponse = function (buttonValue) {
            var inputValues = PopupTaskController._getInputValues();
            window.visualCron.server.sendPopupTaskResponse(PopupTaskController.userServerId, buttonValue, PopupTaskController.baseMessage, inputValues);
        };
        PopupTaskController._getInputValues = function () {
            var output = [];
            if (PopupTaskController.popupTask.PopupTask.PopupInputDisplayType === VisualCron.Interfaces.PopupTask.PopupInputDisplayT.ComboBox) {
                var item = $("#popup-task-input-combobox").data("kendoComboBox").dataItem();
                var data = {
                    Id: item.Id,
                    Value: item.InputValue,
                    Caption: item.Caption
                };
                output[0] = data;
                return output;
            }
            var index = 0;
            PopupTaskController.popupTask.PopupTask.InputList.forEach(function (v, i, arr) {
                switch (PopupTaskController.popupTask.PopupTask.PopupInputDisplayType) {
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.Button:
                        // not implemented 
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.CheckBox:
                        if ($("#" + v.Id).prop("checked")) {
                            var data_1 = {
                                Id: v.Id,
                                Value: v.InputValue,
                                Caption: v.Caption
                            };
                            output[index++] = data_1;
                        }
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.ComboBox:
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.RadioButton:
                        if ($("#" + v.Id).prop("checked")) {
                            var data_2 = {
                                Id: v.Id,
                                Value: v.InputValue,
                                Caption: v.Caption
                            };
                            output[index++] = data_2;
                        }
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.Text:
                        var data = {
                            Id: v.Id,
                            Value: $("#" + v.Id).val(),
                            Caption: v.Caption
                        };
                        output[index++] = data;
                        break;
                    default:
                        break;
                }
            });
            return output;
        };
        PopupTaskController._addInputs = function () {
            if (PopupTaskController.popupTask.PopupTask.PopupInputDisplayType === VisualCron.Interfaces.PopupTask.PopupInputDisplayT.ComboBox) {
                $("#popup-task-inputs").append("<input id=\"popup-task-input-combobox\" /><br />");
                $("#popup-task-input-combobox").kendoComboBox({
                    dataTextField: "Caption",
                    dataValueField: "InputValue",
                    dataSource: PopupTaskController.popupTask.PopupTask.InputList
                });
            }
            PopupTaskController.popupTask.PopupTask.InputList.forEach(function (v, i, arr) {
                var checked = "";
                if (v.Selected) {
                    checked = "checked";
                }
                switch (PopupTaskController.popupTask.PopupTask.PopupInputDisplayType) {
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.Button:
                        $("#popup-task-inputs").append("<a class='btn btn-primary' id=\"" + v.Id + "\">" + v.Caption + "</a><br />");
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.CheckBox:
                        $("#popup-task-inputs").append("<input name=\"input-group\" type=\"checkbox\" id=\"" + v.Id + "\" " + checked + " value=\"" + v.InputValue + "\">" + v.InputValue + "</input><br />");
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.ComboBox:
                        if (v.Selected) {
                            $("#popup-task-input-combobox").data("kendoComboBox").value("" + v.InputValue);
                        }
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.RadioButton:
                        $("#popup-task-inputs").append("<input type=\"radio\" name=\"input-group\" id=\"" + v.Id + "\" " + checked + " value=\"" + v.Id + "\">" + v.Caption + "</input><br />");
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.Text:
                        $("#popup-task-inputs").append("<label>" + v.Caption + ": </label><input type=\"text\" id=\"" + v.Id + "\" class=\"k-textbox\" value=\"" + v.InputValue + "\"/><br />");
                        break;
                    default:
                        break;
                }
            });
        };
        PopupTaskController._addButtons = function () {
            PopupTaskController.popupTask.PopupTask.Buttons.forEach(function (v, i, arr) {
                $("#result-buttons").append("<a class='btn btn-primary popup-task-button' onclick='VisualCron.PopupTaskController.onResultButtonClick(\"" + v.ButtonValue + "\")'>" + v.ButtonValue + "</a>");
            });
        };
        PopupTaskController._timerHandler = function () {
            var time = PopupTaskController.autoCloseSeconds;
            $("#popup-status-bar-text").text("Auto closing in " + PopupTaskController._pad(parseInt((time / 60), 10)) + ":" + PopupTaskController._pad(time % 60));
            if (PopupTaskController.autoCloseSeconds <= 0) {
                clearInterval(PopupTaskController.timerHandler);
                var inputValues = PopupTaskController._getInputValues();
                window.visualCron.server.sendPopupTaskResponse(PopupTaskController.userServerId, "AutoClose", PopupTaskController.baseMessage, inputValues);
                $("#" + PopupTaskController.parentId).data("kendoWindow").close();
            }
            PopupTaskController.autoCloseSeconds = PopupTaskController.autoCloseSeconds - 1;
        };
        PopupTaskController.onClose = function (e) {
            clearInterval(PopupTaskController.timerHandler);
            $("#" + PopupTaskController.parentId).data("kendoWindow").destroy();
        };
        return PopupTaskController;
    })();
    VisualCron.PopupTaskController = PopupTaskController;
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=PopupTaskController.js.map