var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var VisualCron;
(function (VisualCron) {
    var RunningJobsController = (function (_super) {
        __extends(RunningJobsController, _super);
        function RunningJobsController(url) {
            _super.call(this);
            this.url = url;
            //run timer
            RunningJobsController._setUpdater();
        }
        Object.defineProperty(RunningJobsController, "objectType", {
            get: function () { return "btnRunningJobs"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RunningJobsController.prototype, "objectType", {
            get: function () { return RunningJobsController.objectType; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RunningJobsController.prototype, "title", {
            get: function () { return "Running Jobs"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RunningJobsController.prototype, "baseElement", {
            get: function () { return RunningJobsController.baseElementStatic; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RunningJobsController, "baseElementStatic", {
            get: function () { return $("#" + RunningJobsController.objectType + "Grid").data("kendoGrid"); },
            enumerable: true,
            configurable: true
        });
        //#region override
        RunningJobsController.prototype.onAdded = function (serverId, serverObject) {
            console.log("serverObjectAdded: " + this.objectType);
            switch (RunningJobsController.currentViewStyle) {
                case VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess:
                    this._jobTaskTaskProcessAdd(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess:
                    this._jobProcessTaskProcessAdd(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess:
                    this._taskProcessGridUpdate();
                    return;
                default:
                    throw new TypeError("type not found");
            }
        };
        RunningJobsController.prototype.onRemoved = function (serverId, serverObject) {
            console.log("serverObjectRemoved: " + this.objectType);
            switch (RunningJobsController.currentViewStyle) {
                case VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess:
                    this._jobTaskTaskProcessRemove(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess:
                    this._jobProcessTaskProcessRemove(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess:
                    this._taskProcessGridUpdate();
                    return;
                default:
                    throw new TypeError("type not found");
            }
        };
        RunningJobsController.prototype.onUpdated = function (serverId, serverObject) {
            console.log("serverObjectUpdated: " + this.objectType);
            switch (RunningJobsController.currentViewStyle) {
                case VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess:
                    this._jobTaskTaskProcessUpdate(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess:
                    this._jobProcessTaskProcessUpdate(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess:
                    this._taskProcessGridUpdate();
                    return;
                default:
                    throw new TypeError("type not found");
            }
        };
        RunningJobsController.prototype._onWindowClose = function (ctx, e) {
            var handle = RunningJobsController.timer;
            if (handle != null) {
                clearInterval(handle);
            }
            _super.prototype._onWindowClose.call(this, ctx, e);
        };
        //#endregion
        //#region events
        RunningJobsController.onDataBound = function (eventArg) {
            RunningJobsController._checkDetailExist($(eventArg.sender.element).attr("id"));
        };
        RunningJobsController.onDetailDataBound = function (eventArg) {
            RunningJobsController._checkDetailExist($(eventArg.sender.element).attr("id"));
        };
        RunningJobsController.onDetailExpand = function (eventArg) {
            var gridElement = $(eventArg.detailRow).find(".k-grid");
            var grid = RunningJobsController._getGrid(gridElement);
            RunningJobsController._updateGridDS(grid);
        };
        RunningJobsController.onViewStyleChange = function (eventArg) {
            RunningJobsController._hideAllLayer();
            var currentGrid;
            switch (eventArg.sender.value()) {
                case "jobTask":
                    $("#jobTask").show();
                    currentGrid = RunningJobsController._getGrid("#btnRunningJobsGrid");
                    RunningJobsController.currentViewStyle = VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess;
                    break;
                case "jobProcessTaskProcess":
                    $("#jobProcessTaskProcess").show();
                    currentGrid = RunningJobsController._getGrid("#btnRunningJobsProcessTaskProcessGrid");
                    RunningJobsController.currentViewStyle = VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess;
                    break;
                case "taskProcess":
                    $("#taskProcess").show();
                    currentGrid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid");
                    RunningJobsController.currentViewStyle = VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess;
                    break;
                default:
                    throw new TypeError("type not found");
            }
            if (!currentGrid) {
                throw new ReferenceError("grid not found");
            }
            RunningJobsController._updateGridDS(currentGrid);
        };
        RunningJobsController.onUpdateIntervalChange = function (eventArg) {
            console.log("onUpdateIntervalChange");
            RunningJobsController.updateInterval = eventArg.sender.value();
            RunningJobsController._setUpdater();
        };
        //#endregion
        //#region private methods
        RunningJobsController.prototype._jobTaskTaskProcessAdd = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid_" + serverObject.TaskId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                var rowExist = $("#btnRunningJobsGrid td:data(jobid=" + serverObject.JobId + "):data(grid=job)");
                if (!rowExist) {
                    var grid = RunningJobsController._getGrid("#btnRunningJobsGrid");
                    RunningJobsController._updateGridDS(grid);
                    return;
                }
                var newRow = RunningJobsController._insertNewRow($("#btnRunningJobsGrid"));
                var columns = newRow.children("td");
                var column = columns.filter(":data(type=name)");
                column.data("uniqueid", serverObject.UniqueId);
                RunningJobsController._updateJobProcessGrid(serverObject);
            }
            RunningJobsController._checkDetailExist("btnRunningJobsGrid");
        };
        RunningJobsController.prototype._jobTaskTaskProcessRemove = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid_" + serverObject.TaskId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                var grid = RunningJobsController._getGrid("#btnRunningJobsGrid");
                var currentColumn = $("#btnRunningJobsGrid td:data(uniqueid=" + serverObject.UniqueId + "):data(grid=job)");
                var eq = currentColumn.parents("tr").eq(0);
                grid.collapseRow(eq);
                eq.remove();
            }
        };
        RunningJobsController.prototype._jobTaskTaskProcessUpdate = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid_" + serverObject.TaskId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                RunningJobsController._updateJobGrid(serverObject);
                RunningJobsController._updateTask(serverObject);
            }
        };
        RunningJobsController.prototype._jobProcessTaskProcessAdd = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningJobsGrid_" + serverObject.JobPId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                var rowExist = $("#btnRunningJobsProcessTaskProcessGrid td:data(jobid=" + serverObject.JobId + "):data(grid=jobProcess)");
                if (!rowExist) {
                    var grid = RunningJobsController._getGrid("#btnRunningJobsProcessTaskProcessGrid");
                    RunningJobsController._updateGridDS(grid);
                    return;
                }
                var newRow = RunningJobsController._insertNewRow($("#btnRunningJobsProcessTaskProcessGrid"));
                var columns = newRow.children("td");
                var column = columns.filter(":data(type=id)");
                column.data("uniqueid", serverObject.UniqueId);
                column.data("jobid", serverObject.JobId);
                RunningJobsController._updateJobProcessGrid(serverObject);
            }
            RunningJobsController._checkDetailExist("btnRunningJobsProcessTaskProcessGrid");
        };
        RunningJobsController.prototype._jobProcessTaskProcessRemove = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningJobsGrid_" + serverObject.JobPId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                var grid = RunningJobsController._getGrid("#btnRunningJobsProcessTaskProcessGrid");
                var currentColumn = $("#btnRunningJobsProcessTaskProcessGrid td:data(jobid=" + serverObject.JobId + "):data(grid=jobProcess)");
                var eq = currentColumn.parents("tr").eq(0);
                grid.collapseRow(eq);
                eq.remove();
            }
        };
        RunningJobsController.prototype._jobProcessTaskProcessUpdate = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningJobsGrid_" + serverObject.JobPId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                RunningJobsController._updateTaskProcessJobProcessView(serverObject);
            }
        };
        RunningJobsController.prototype._isVCTask = function (serverObject) {
            //if TaskId not exist - it is VCJobClass 
            //!serverObject.TaskId
            if (serverObject.TaskId) {
                return true;
            }
            return false;
        };
        RunningJobsController.prototype._taskProcessGridUpdate = function () {
            var grid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid");
            RunningJobsController._updateGridDS(grid);
        };
        RunningJobsController._insertNewRow = function (grid) {
            var trSource = grid.find("tbody").find("tr.k-master-row")[0];
            var insertBeforeItem = grid.find("tbody").find("tr.k-master-row")[0];
            var copyobj = $(trSource).clone();
            //hide detail icon
            //$(copyobj.find(".k-hierarchy-cell")).children().hide();
            $(copyobj.find(".k-hierarchy-cell")).children().removeClass("k-minus").addClass("k-plus");
            $(insertBeforeItem).before(copyobj);
            return copyobj;
        };
        RunningJobsController._setUpdater = function () {
            var handle = RunningJobsController.timer;
            if (handle != null) {
                clearInterval(handle);
            }
            RunningJobsController.timer = setInterval(
            //safe `this` context
            //safe `this` context
            function () { return RunningJobsController._updaterHandler(); }, RunningJobsController.updateInterval * 1000);
        };
        RunningJobsController._checkDetailExist = function (gridId) {
            var serverId = $(RunningJobsController.baseElementStatic.element).data("serverid");
            //todo: 0  - ?
            //todo: now `Exist` allways true
            window.visualCron.server.checkRunningJobExist(serverId, 0).done(function (obj) {
                obj.forEach(function (item) {
                    var img = $("td:data(uniqueid=" + item.Id + ")", "#" + gridId);
                    var prev = $(img).prev();
                    var children = prev.children();
                    if (!item.Exist) {
                        $(children).hide();
                    }
                    else {
                        $(children).css("display", "block");
                    }
                });
            });
        };
        RunningJobsController._updateGridDS = function (currentGrid) {
            if (!currentGrid) {
                return;
            }
            currentGrid.dataSource.read();
            currentGrid.refresh();
        };
        RunningJobsController._getGrid = function (gridElement) {
            return $(gridElement).data("kendoGrid");
        };
        RunningJobsController._hideAllLayer = function () {
            $("#jobTask").hide();
            $("#taskProcess").hide();
            $("#jobProcessTaskProcess").hide();
        };
        //#endregion
        //#region cell updater
        RunningJobsController._updaterHandler = function () {
            var serverId = $(RunningJobsController.baseElementStatic.element).data("serverid");
            //current grid
            window.visualCron.server.getRunningJobs(serverId, RunningJobsController.currentViewStyle).done(function (obj) {
                var data = obj;
                data.forEach(function (item) {
                    switch (item.GridType) {
                        case VisualCron.Interfaces.RunningJobsDataType.Job:
                            RunningJobsController._updateJobGrid(item);
                            break;
                        case VisualCron.Interfaces.RunningJobsDataType.JobProcess:
                            RunningJobsController._updateJobProcessGrid(item);
                            break;
                        case VisualCron.Interfaces.RunningJobsDataType.Task:
                            RunningJobsController._updateTask(item);
                            break;
                        case VisualCron.Interfaces.RunningJobsDataType.TaskProcess:
                            switch (RunningJobsController.currentViewStyle) {
                                case VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess:
                                    RunningJobsController._updateTaskProcessJobTaskView(item);
                                    break;
                                case VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess:
                                    RunningJobsController._updateTaskProcessJobProcessView(item);
                                    break;
                                case VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess:
                                    RunningJobsController._updateTaskProcessView(item);
                                    break;
                                default:
                                    throw new TypeError("type not found");
                            }
                            break;
                        default:
                            throw new TypeError("type not found");
                    }
                });
            });
        };
        RunningJobsController._updateJobGrid = function (item) {
            var currentColumn = $("#btnRunningJobsGrid td:data(uniqueid=" + item.UniqueId + "):data(grid=job)");
            currentColumn.html(item.Name);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=description)");
            currentColumn.html(item.Description);
        };
        RunningJobsController._updateTask = function (item) {
            var currentColumn = $("[id^='btnRunningTasksGrid_'] td:data(uniqueid=" + item.UniqueId + "):data(grid=jobTask)");
            //currentColumn.html(item.Id);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
        };
        RunningJobsController._updateJobProcessGrid = function (item) {
            var currentColumn = $("#btnRunningJobsProcessTaskProcessGrid td:data(uniqueid=" + item.UniqueId + "):data(grid=jobProcess)");
            currentColumn.html(item.Id);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
            currentColumn = $(columns).filter(":data(type=started)");
            currentColumn.html(item.Started);
            currentColumn = $(columns).filter(":data(type=runTime)");
            currentColumn.html(item.RunTime);
        };
        RunningJobsController._updateTaskProcessJobTaskView = function (item) {
            var currentColumn = $("[id^='btnRunningTaskProcessGrid_'] td:data(uniqueid=" + item.UniqueId + "):data(grid=jobTaskTaskProcess)");
            currentColumn.html(item.JobPId);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=id)");
            currentColumn.html(item.Id);
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
            currentColumn = $(columns).filter(":data(type=windowPId)");
            currentColumn.html(item.WindowPId);
            currentColumn = $(columns).filter(":data(type=started)");
            currentColumn.html(item.Started);
            currentColumn = $(columns).filter(":data(type=runTime)");
            currentColumn.html(item.RunTime);
        };
        RunningJobsController._updateTaskProcessJobProcessView = function (item) {
            var currentColumn = $("[id^='btnRunningJobsGrid_'] td:data(uniqueid=" + item.UniqueId + "):data(grid=jobProcessTaskProcess)");
            currentColumn.html(item.Id);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
            currentColumn = $(columns).filter(":data(type=windowPId)");
            currentColumn.html(item.WindowPId);
            currentColumn = $(columns).filter(":data(type=started)");
            currentColumn.html(item.Started);
            currentColumn = $(columns).filter(":data(type=runTime)");
            currentColumn.html(item.RunTime);
        };
        RunningJobsController._updateTaskProcessView = function (item) {
            var currentColumn = $("#btnRunningTaskProcessGrid td:data(tpid=" + item.Id + "):data(grid=taskProcess)");
            currentColumn.html(item.Id);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
            currentColumn = $(columns).filter(":data(type=windowPId)");
            currentColumn.html(item.WindowPId);
            currentColumn = $(columns).filter(":data(type=started)");
            currentColumn.html(item.Started);
            currentColumn = $(columns).filter(":data(type=runTime)");
            currentColumn.html(item.RunTime);
        };
        RunningJobsController.updateInterval = 3;
        RunningJobsController.timer = null;
        RunningJobsController.currentViewStyle = VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess;
        return RunningJobsController;
    })(VisualCron.ServerObjects.UpdatableWindowBase);
    VisualCron.RunningJobsController = RunningJobsController;
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=RunningJobsController.js.map