var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectConditions = (function (_super) {
            __extends(ServerObjectConditions, _super);
            function ServerObjectConditions(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectConditions, "objectType", {
                get: function () { return "btnConditions"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConditions.prototype, "objectType", {
                get: function () { return ServerObjectConditions.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConditions.prototype, "title", {
                get: function () { return "Manage conditions"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConditions.prototype, "baseElement", {
                get: function () { return ServerObjectConditions.baseElementStatic; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConditions, "baseElementStatic", {
                get: function () { return $("#" + ServerObjectConditions.objectType + "Grid").data("kendoGrid"); },
                enumerable: true,
                configurable: true
            });
            ServerObjectConditions.onDataBound = function (eventArg) {
                ServerObjectConditions._checkDetailExist();
            };
            ServerObjectConditions.onDetailDataBound = function (eventArg) {
                var senderGrid = eventArg.sender;
                var setId = $(senderGrid.element).data("setid");
                if (senderGrid.dataSource.data().length <= 0) {
                    ServerObjectConditions._collapseRow(setId);
                }
            };
            ServerObjectConditions.prototype.onAdded = function (serverId, serverObject) {
                console.log("serverObjectAdded: " + this.objectType);
                if (!serverObject.SetId) {
                    this._onAddedSet(serverId, serverObject);
                }
                else {
                    this._refreshDetailGrid(serverObject.SetId);
                }
                ServerObjectConditions._checkDetailExist();
            };
            ServerObjectConditions.prototype.onRemoved = function (serverId, serverObject) {
                console.log("serverObjectRemoved: " + this.objectType);
                //if SetId not exist - it is ConditionSet 
                if (!serverObject.SetId) {
                    this._onRemovedSet(serverId, serverObject);
                }
                else {
                    this._refreshDetailGrid(serverObject.SetId);
                }
                ServerObjectConditions._checkDetailExist();
            };
            ServerObjectConditions.prototype.onUpdated = function (serverId, serverObject) {
                console.log("serverObjectUpdated: " + this.objectType);
                if (!serverObject.SetId) {
                    this._onUpdatedSet(serverId, serverObject);
                }
                else {
                    this._refreshDetailGrid(serverObject.SetId);
                }
                ServerObjectConditions._checkDetailExist();
            };
            ServerObjectConditions.prototype._onAddedSet = function (serverId, serverObject) {
                //for first item, just refresh table
                var len = this.baseElement.dataSource.data().length;
                if (len <= 0) {
                    this.baseElement.dataSource.read();
                    this.baseElement.refresh();
                    return;
                }
                var grid = $("#" + ServerObjectConditions.objectType + "Grid");
                var newRow = ServerObjectConditions._insertNewRow(grid);
                ServerObjectConditions._updateConditionSet(newRow, serverObject);
            };
            ServerObjectConditions.prototype._onRemovedSet = function (serverId, serverObject) {
                var row = ServerObjectConditions._collapseRow(serverObject.Id);
                row.remove();
            };
            ServerObjectConditions.prototype._onUpdatedSet = function (serverId, serverObject) {
                var id = serverObject.Id;
                var row = ServerObjectConditions._getRowById(id);
                ServerObjectConditions._updateConditionSet(row, serverObject);
            };
            ServerObjectConditions.prototype._refreshDetailGrid = function (setId) {
                var grid = $("[id*=" + setId + "]:data(setid=" + setId + ")").data("kendoGrid");
                if (!grid) {
                    return;
                }
                grid.dataSource.read();
                grid.refresh();
            };
            ServerObjectConditions._collapseRow = function (setId) {
                var row = ServerObjectConditions._getRowById(setId);
                ServerObjectConditions.baseElementStatic.collapseRow(row);
                return row;
            };
            ServerObjectConditions._getRowById = function (id) {
                var img = $("img:data(id=" + id + ")", "#" + ServerObjectConditions.objectType + "Grid");
                var row = $(img).parents("tr");
                return row;
            };
            ServerObjectConditions._insertNewRow = function (grid) {
                var trSource = grid.find("tbody").find("tr.k-master-row")[0];
                var insertBeforeItem = grid.find("tbody").find("tr.k-master-row")[0];
                var copyobj = $(trSource).clone();
                //hide detail icon
                $(copyobj.find(".k-hierarchy-cell")).children().hide();
                $(insertBeforeItem).before(copyobj);
                return copyobj;
            };
            ServerObjectConditions._updateConditionSet = function (row, serverObject) {
                var columns = row.children("td");
                var column = columns.filter(":data(name=Description)");
                column.html(serverObject.Description);
                column = columns.filter(":data(name=Icon)").children("img");
                $(column).data("id", serverObject.Id);
            };
            ServerObjectConditions._checkDetailExist = function () {
                var serverId = $(ServerObjectConditions.baseElementStatic.element).data("serverid");
                window.visualCron.server.checkConditionsExist(serverId).done(function (obj) {
                    var data = obj;
                    data.forEach(function (item, i, array) {
                        var img = $("img:data(id=" + item.Id + ")", "#" + ServerObjectConditions.objectType + "Grid");
                        var prev = $(img).parent().prev();
                        var children = prev.children();
                        if (!item.Exist) {
                            $(children).hide();
                        }
                        else {
                            $(children).css("display", "block");
                        }
                    });
                });
            };
            return ServerObjectConditions;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectConditions = ServerObjectConditions;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=ServerObjectConditions.js.map