var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectController = (function () {
            function ServerObjectController(url, objectType) {
                switch (objectType) {
                    case "btnCertificates":
                        this._this = new ServerObjects.ServerObjectCertificates(url);
                        break;
                    case "btnConditions":
                        this._this = new ServerObjects.ServerObjectConditions(url);
                        break;
                    case "btnConnections":
                        this._this = new ServerObjects.ServerObjectConnections(url);
                        break;
                    case "btnCredentials":
                        this._this = new ServerObjects.ServerObjectCredentials(url);
                        break;
                    case "btnNetDrives":
                        this._this = new ServerObjects.ServerObjectNetDrives(url);
                        break;
                    case "btnNotification":
                        this._this = new ServerObjects.ServerObjectNotification(url);
                        break;
                    case "btnPgpKeyRings":
                        this._this = new ServerObjects.ServerObjectPgpKeyRings(url);
                        break;
                    case "btnVariables":
                        this._this = new ServerObjects.ServerObjectVariables(url);
                        break;
                    case "btnClientConnections":
                        this._this = new VisualCron.ClientConnectionsController(url);
                        break;
                    case "btnRunningJobs":
                        this._this = new VisualCron.RunningJobsController(url);
                        break;
                    default:
                        throw new TypeError("type not found");
                }
            }
            ServerObjectController.prototype.createWindow = function (serverId) {
                this._this.createWindow(serverId);
            };
            ServerObjectController.prototype.onAdded = function (serverId, serverObject) {
                this._this.onAdded(serverId, serverObject);
            };
            ServerObjectController.prototype.onRemoved = function (serverId, serverObject) {
                this._this.onRemoved(serverId, serverObject);
            };
            ServerObjectController.prototype.onUpdated = function (serverId, serverObject) {
                this._this.onUpdated(serverId, serverObject);
            };
            return ServerObjectController;
        })();
        ServerObjects.ServerObjectController = ServerObjectController;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=ServerObjectController.js.map