var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectVariables = (function (_super) {
            __extends(ServerObjectVariables, _super);
            function ServerObjectVariables(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectVariables, "objectType", {
                get: function () { return "btnVariables"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables.prototype, "objectType", {
                get: function () { return ServerObjectVariables.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables.prototype, "title", {
                get: function () { return "Manage user variables"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables.prototype, "baseElement", {
                get: function () { return ServerObjectVariables.baseElementStatic; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables, "baseElementStatic", {
                get: function () { return $("#" + ServerObjectVariables.objectType + "TreeView").data("kendoTreeView"); },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables.prototype, "treeViewElement", {
                get: function () { return this.baseElement; },
                enumerable: true,
                configurable: true
            });
            ServerObjectVariables.prototype.onAdded = function (serverId, serverObject) {
                console.log("serverObjectAdded: " + this.objectType);
                var saveFilter = this.baseElement.dataSource.filter();
                this.treeViewElement.dataSource.read();
                this.baseElement.dataSource.filter(saveFilter);
            };
            ServerObjectVariables.prototype.onRemoved = function (serverId, serverObject) {
                console.log("serverObjectRemoved: " + this.objectType);
                var saveFilter = this.baseElement.dataSource.filter();
                this.treeViewElement.dataSource.read();
                this.baseElement.dataSource.filter(saveFilter);
            };
            ServerObjectVariables.prototype.onUpdated = function (serverId, serverObject) {
                console.log("serverObjectUpdated: " + this.objectType);
                var saveFilter = this.baseElement.dataSource.filter();
                this.treeViewElement.dataSource.read();
                this.baseElement.dataSource.filter(saveFilter);
            };
            ServerObjectVariables.onCopyButtonClick = function (eventArg) {
                var val = $("#tbaPrev").val();
                window.prompt("Copy to clipboard: Ctrl+C, Enter", val);
            };
            ServerObjectVariables.onSearchButtonClick = function (eventArg) {
                var stext = $("#varsSearchBox").val();
                var filter = {
                    field: "Name",
                    operator: "contains",
                    value: stext
                };
                ServerObjectVariables.baseElementStatic.dataSource.filter(filter);
            };
            ServerObjectVariables.onClearSearchButtonClick = function (eventArg) {
                $("#varsSearchBox").val("");
                ServerObjectVariables.baseElementStatic.dataSource.filter([]);
            };
            ServerObjectVariables.onVariableSelect = function (eventArg) {
                var selectedValueModel = ServerObjectVariables.baseElementStatic.dataItem(eventArg.node);
                var value = "{USERVAL{" + selectedValueModel.Name + "}}";
                $("#tbaPrev").val(value);
                $("#statusBarText").text(value);
                $("#tbaValPrev").val(selectedValueModel.ValueObject);
            };
            ServerObjectVariables.prototype._createWindowsOptions = function () {
                var wp = _super.prototype._createWindowsOptions.call(this);
                wp.width = 750;
                return wp;
            };
            return ServerObjectVariables;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectVariables = ServerObjectVariables;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=ServerObjectVariables.js.map