var VisualCron;
(function (VisualCron) {
    var PopupTaskController = (function () {
        function PopupTaskController() {
        }
        Object.defineProperty(PopupTaskController, "contentPageUri", {
            get: function () { return "/Home/PopupTask"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PopupTaskController, "parentId", {
            get: function () { return "popupTask" + PopupTaskController.popupTask.TaskId; },
            enumerable: true,
            configurable: true
        });
        PopupTaskController.show = function (userServerId, popupTask) {
            PopupTaskController.popupTask = popupTask.PopupRequest;
            PopupTaskController.baseMessage = popupTask;
            PopupTaskController.userServerId = userServerId;
            $("#popup-task-window").append("<div id='" + PopupTaskController.parentId + "'></div>");
            $("#" + PopupTaskController.parentId).kendoWindow({
                title: "VisualCron Popup Task",
                modal: PopupTaskController.popupTask.PopupTask.Modal,
                resizable: true,
                content: PopupTaskController.contentPageUri,
                activate: PopupTaskController.onActivate,
                close: PopupTaskController.onClose,
                visible: false,
                minWidth: 500
            });
            var window = $("#" + PopupTaskController.parentId).data("kendoWindow");
            window.center().open();
            window.resize();
            //setup manually, because status-strip not work fine
            //            window.setOptions({
            //                width: 500,
            //                height: 500
            //            });
            $("#" + PopupTaskController.parentId).parent().find(".k-window-title").prepend("<div class='popup-window-title-icon'></div> &nbsp; ");
        };
        PopupTaskController._pad = function (val) {
            return val > 9 ? val : "0" + val;
        };
        PopupTaskController.onActivate = function () {
            $("#popup-title").text(PopupTaskController.popupTask.PopupTask.Title);
            $("#tbaPopupText").val(PopupTaskController.popupTask.PopupTask.Message);
            $("#popup-job-label").text("Job: " + PopupTaskController.popupTask.TaskProcess.Job.Name);
            $("#popup-task-label").text("Task: " + PopupTaskController.popupTask.TaskProcess.Task.Name);
            $("#popup-task-title").append("<img class='popup-task-icon' src='Content/images/icons/popupTask/" + PopupTaskController._getIcon() + ".png'/>");
            if (PopupTaskController.popupTask.PopupTask.AutoClose) {
                PopupTaskController.autoCloseSeconds = PopupTaskController.popupTask.PopupTask.AutoCloseSeconds;
                PopupTaskController.timerHandler = setInterval(function () { PopupTaskController._timerHandler(); }, 1000);
            }
            PopupTaskController._addButtons();
            PopupTaskController._addInputs();
        };
        PopupTaskController.onResultButtonClick = function (buttonValue) {
            PopupTaskController._returnResponse(buttonValue);
            $("#" + PopupTaskController.parentId).data("kendoWindow").close();
        };
        PopupTaskController._getIcon = function () {
            switch (PopupTaskController.popupTask.PopupTask.Icon) {
                case 0:
                    return "Information";
                case 1:
                    return "Exclamation";
                case 2:
                    return "Question";
                case 3:
                    return "Error";
                default:
                    return "Question";
            }
        };
        PopupTaskController._returnResponse = function (buttonValue) {
            var inputValues = PopupTaskController._getInputValues();
            window.visualCron.server.sendPopupTaskResponse(PopupTaskController.userServerId, buttonValue, PopupTaskController.baseMessage, inputValues);
        };
        PopupTaskController._getInputValues = function () {
            var output = [];
            if (PopupTaskController.popupTask.PopupTask.PopupInputDisplayType === VisualCron.Interfaces.PopupTask.PopupInputDisplayT.ComboBox) {
                var item = $("#popup-task-input-combobox").data("kendoComboBox").dataItem();
                var data = {
                    Id: item.Id,
                    Value: item.InputValue,
                    Caption: item.Caption
                };
                output[0] = data;
                return output;
            }
            var index = 0;
            PopupTaskController.popupTask.PopupTask.InputList.forEach(function (v, i, arr) {
                switch (PopupTaskController.popupTask.PopupTask.PopupInputDisplayType) {
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.Button:
                        // not implemented 
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.CheckBox:
                        if ($("#" + v.Id).prop("checked")) {
                            var data_1 = {
                                Id: v.Id,
                                Value: v.InputValue,
                                Caption: v.Caption
                            };
                            output[index++] = data_1;
                        }
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.ComboBox:
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.RadioButton:
                        if ($("#" + v.Id).prop("checked")) {
                            var data_2 = {
                                Id: v.Id,
                                Value: v.InputValue,
                                Caption: v.Caption
                            };
                            output[index++] = data_2;
                        }
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.Text:
                        var data = {
                            Id: v.Id,
                            Value: $("#" + v.Id).val(),
                            Caption: v.Caption
                        };
                        output[index++] = data;
                        break;
                    default:
                        break;
                }
            });
            return output;
        };
        PopupTaskController._addInputs = function () {
            if (PopupTaskController.popupTask.PopupTask.PopupInputDisplayType === VisualCron.Interfaces.PopupTask.PopupInputDisplayT.ComboBox) {
                $("#popup-task-inputs").append("<input id=\"popup-task-input-combobox\" /><br />");
                $("#popup-task-input-combobox").kendoComboBox({
                    dataTextField: "Caption",
                    dataValueField: "InputValue",
                    dataSource: PopupTaskController.popupTask.PopupTask.InputList
                });
            }
            PopupTaskController.popupTask.PopupTask.InputList.forEach(function (v, i, arr) {
                var checked = "";
                if (v.Selected) {
                    checked = "checked";
                }
                switch (PopupTaskController.popupTask.PopupTask.PopupInputDisplayType) {
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.Button:
                        $("#popup-task-inputs").append("<a class='btn btn-primary' id=\"" + v.Id + "\">" + v.Caption + "</a><br />");
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.CheckBox:
                        $("#popup-task-inputs").append("<input name=\"input-group\" type=\"checkbox\" id=\"" + v.Id + "\" " + checked + " value=\"" + v.InputValue + "\">" + v.InputValue + "</input><br />");
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.ComboBox:
                        if (v.Selected) {
                            $("#popup-task-input-combobox").data("kendoComboBox").value("" + v.InputValue);
                        }
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.RadioButton:
                        $("#popup-task-inputs").append("<input type=\"radio\" name=\"input-group\" id=\"" + v.Id + "\" " + checked + " value=\"" + v.Id + "\">" + v.Caption + "</input><br />");
                        break;
                    case VisualCron.Interfaces.PopupTask.PopupInputDisplayT.Text:
                        $("#popup-task-inputs").append("<label>" + v.Caption + ": </label><input type=\"text\" id=\"" + v.Id + "\" class=\"k-textbox\" value=\"" + v.InputValue + "\"/><br />");
                        break;
                    default:
                        break;
                }
            });
        };
        PopupTaskController._addButtons = function () {
            PopupTaskController.popupTask.PopupTask.Buttons.forEach(function (v, i, arr) {
                $("#result-buttons").append("<a class='btn btn-primary popup-task-button' onclick='VisualCron.PopupTaskController.onResultButtonClick(\"" + v.ButtonValue + "\")'>" + v.ButtonValue + "</a>");
            });
        };
        PopupTaskController._timerHandler = function () {
            var time = PopupTaskController.autoCloseSeconds;
            $("#popup-status-bar-text").text("Auto closing in " + PopupTaskController._pad(parseInt((time / 60), 10)) + ":" + PopupTaskController._pad(time % 60));
            if (PopupTaskController.autoCloseSeconds <= 0) {
                clearInterval(PopupTaskController.timerHandler);
                var inputValues = PopupTaskController._getInputValues();
                window.visualCron.server.sendPopupTaskResponse(PopupTaskController.userServerId, "AutoClose", PopupTaskController.baseMessage, inputValues);
                $("#" + PopupTaskController.parentId).data("kendoWindow").close();
            }
            PopupTaskController.autoCloseSeconds = PopupTaskController.autoCloseSeconds - 1;
        };
        PopupTaskController.onClose = function (e) {
            clearInterval(PopupTaskController.timerHandler);
            $("#" + PopupTaskController.parentId).data("kendoWindow").destroy();
        };
        return PopupTaskController;
    })();
    VisualCron.PopupTaskController = PopupTaskController;
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var PromptPasswordController = (function () {
        function PromptPasswordController() {
        }
        Object.defineProperty(PromptPasswordController, "promptWindow", {
            get: function () { return $("#EnterPasswordWindow").data("kendoWindow"); },
            enumerable: true,
            configurable: true
        });
        PromptPasswordController.show = function (connection) {
            PromptPasswordController.promptWindow.center().open();
            if (connection) {
                PromptPasswordController.connection = connection;
                $("#UsernameText").val(connection.Username);
                $("#PasswordText").val(connection.Password);
            }
        };
        PromptPasswordController.okButtonOnClick = function () {
            var user = $("#UsernameText").val();
            var pass = $("#PasswordText").val();
            PromptPasswordController.promptWindow.close();
            $("#loading_popub").css("display", "block");
            window.visualCron.server.connect(PromptPasswordController.connection.ConnectionId, user, pass);
        };
        PromptPasswordController.cancelButtonOnClick = function () {
            PromptPasswordController.promptWindow.close();
            $("#loading_popub").css("display", "none");
        };
        return PromptPasswordController;
    })();
    VisualCron.PromptPasswordController = PromptPasswordController;
})(VisualCron || (VisualCron = {}));
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var VisualCron;
(function (VisualCron) {
    var ClientSettingsController = (function (_super) {
        __extends(ClientSettingsController, _super);
        function ClientSettingsController(uri) {
            _super.call(this);
            this._currentSetting = null;
            this.url = uri;
            ClientSettingsController.safeConxtext = this;
        }
        Object.defineProperty(ClientSettingsController, "objectType", {
            get: function () { return "btnClientSettings"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ClientSettingsController.prototype, "objectType", {
            get: function () { return ClientSettingsController.objectType; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ClientSettingsController.prototype, "title", {
            get: function () { return "Client settings"; },
            enumerable: true,
            configurable: true
        });
        ClientSettingsController.prototype.loadSettings = function () {
            window.visualCron.server.getClientSettings().done(function (obj) {
                ClientSettingsController.safeConxtext._currentSetting = obj;
            });
        };
        ClientSettingsController.prototype._createWindowsOptions = function () {
            var _this = this;
            var wp = {
                draggable: true,
                modal: true,
                height: 350,
                width: 300,
                resizable: true,
                close: function (e) {
                    //anonymous function save 'this' context
                    _this._onWindowClose(_this, e);
                }
            };
            return wp;
        };
        ClientSettingsController.onClick = function (eventArg) {
            var id = eventArg.id;
            switch (id) {
                case "btnOk":
                    ClientSettingsController.safeConxtext._currentSetting = {
                        ShowJobStart: $("#cbkShowStart").prop("checked"),
                        ShowJobEnd: $("#cbkShowEnd").prop("checked")
                    };
                    window.visualCron.server.saveClientSettings(ClientSettingsController.safeConxtext._currentSetting).fail(function (f) { alert(f); });
                    ClientSettingsController._closeWindow();
                    break;
                case "btnCancel":
                    ClientSettingsController._closeWindow();
                    break;
                default:
                    throw new TypeError("type not found");
            }
        };
        ClientSettingsController.getSettings = function () {
            if (ClientSettingsController.safeConxtext && ClientSettingsController.safeConxtext._currentSetting) {
                return ClientSettingsController.safeConxtext._currentSetting;
            }
            return { ShowJobStart: true, ShowJobEnd: true };
        };
        ClientSettingsController._closeWindow = function () {
            ClientSettingsController.safeConxtext.window.close();
        };
        ClientSettingsController.prototype._onLoad = function () {
            _super.prototype._onLoad.call(this);
            if (!ClientSettingsController.safeConxtext._currentSetting) {
                return;
            }
            $("#cbkShowStart").prop("checked", ClientSettingsController.safeConxtext._currentSetting.ShowJobStart);
            $("#cbkShowEnd").prop("checked", ClientSettingsController.safeConxtext._currentSetting.ShowJobEnd);
        };
        ClientSettingsController.safeConxtext = null;
        return ClientSettingsController;
    })(VisualCron.WindowBase);
    VisualCron.ClientSettingsController = ClientSettingsController;
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ContextMenuController = (function () {
        function ContextMenuController() {
        }
        ContextMenuController.jobsContextMenuOnOpen = function (sender) {
            //if tasks ConextMenu was opened it needs to be closed prior to opening this one
            $("[id^=TasksContextMenu]").each(function (n, x) {
                var cm = $(x).data("kendoContextMenu");
                if (cm) {
                    cm.close(x);
                }
            });
            // as we need to search through several tables simultaneously
            // we can switch menu on first one, then switch off on second etc
            // so we use flag to prevent this
            var stopProcessing = false;
            $("[id^=jobsGrid]").each(function (n, x) {
                var grid = $(x).data("kendoGrid");
                if (!grid) {
                    return;
                }
                if (stopProcessing) {
                    //in case there is a multiple seletion - don't need to iterate further
                    //return - exits from .each(function), not from "TasksContextMenu_OnOpen"
                    return;
                }
                var selectedRows = grid.select();
                var cMenu = $(sender.item).data("kendoContextMenu");
                if (selectedRows.length > 1) {
                    stopProcessing = true;
                    cMenu.enable("#jsRun", true);
                    cMenu.enable("#jsStop", true);
                    cMenu.enable("#jsDelete", true);
                    cMenu.enable("#jsActivate", true);
                    cMenu.enable("#jsDeactivate", true);
                }
                else {
                    cMenu.enable("#jsDeactivate", false);
                    cMenu.enable("#jsActivate", false);
                    cMenu.enable("#jsDelete", false);
                    cMenu.enable("#jsStop", false);
                    cMenu.enable("#jsRun", false);
                }
            });
        };
        ContextMenuController.jobsContextMenuOnClicked = function (sender) {
            console.log("on: JobsContextMenu_OnClicked");
            var row = $("tr.k-master-row.SelectFlag");
            if (row.length > 0) {
                row = $(row[0]);
                //get selected row and it's values
                var jids = $(row.find(".ids"));
                var sids = $(row.find(".serverIds"));
                var serverId = sids.text();
                var jobId = jids.text();
                var itype = sender.item.id;
                //if single action is selected then we leave handler after it's finished
                switch (itype) {
                    case "jActivate":
                        window.visualCron.server.activateJob(serverId, jobId);
                        return;
                    case "jDeactivate":
                        window.visualCron.server.deactivateJob(serverId, jobId);
                        return;
                    case "jDelete":
                        VisualCron.GridController.deleteJob(row, serverId, jobId);
                        return;
                    case "jRun":
                        window.visualCron.server.runJob(serverId, jobId, "");
                        return;
                    case "jStop":
                        window.visualCron.server.stopJob(serverId, jobId);
                        return;
                    case "jLog":
                        ContextMenuController._openLogWindow(serverId, jobId);
                        return;
                }
                if (itype === "jsDelete") {
                    if (!confirm("Delete selected jobs?")) {
                        return;
                    }
                }
                //if multiple actions are required we iterate through list
                $("[id^=jobsGrid]").each(function (n, x) {
                    var grid = $(x).data("kendoGrid");
                    if (!grid) {
                        return;
                    }
                    var selectedRows = grid.select();
                    for (var i = 0; i < selectedRows.length; i++) {
                        var selectedRow = $(selectedRows[i]);
                        jids = $(selectedRow.find(".ids"));
                        sids = $(selectedRow.find(".serverIds"));
                        serverId = sids.text();
                        jobId = jids.text();
                        switch (itype) {
                            //selected
                            case "jsActivate":
                                window.visualCron.server.activateJob(serverId, jobId);
                                break;
                            case "jsDeactivate":
                                window.visualCron.server.deactivateJob(serverId, jobId);
                                break;
                            case "jsDelete":
                                VisualCron.GridController.deleteJobWithoutConfirm(selectedRows, serverId, jobId);
                                break;
                            case "jsRun":
                                window.visualCron.server.runJob(serverId, jobId, "");
                                break;
                            case "jsStop":
                                window.visualCron.server.stopJob(serverId, jobId);
                                break;
                        }
                    }
                });
            }
        };
        ContextMenuController.jobsContextMenuOnClose = function (sender) {
        };
        ContextMenuController.tasksContextMenuOnOpen = function (sender) {
            var openedMenu = $("#JobsContextMenu");
            if (openedMenu.length > 0) {
                var cm = $(openedMenu).data("kendoContextMenu");
                if (cm) {
                    cm.close(openedMenu);
                }
            }
            var taskGrids = $(".tasksGrid");
            // as we need to search through several tables simultaneously
            // we can switch menu on first one, then switch off on second etc
            // so we use flag to prevent this
            var stopProcessing = false;
            taskGrids.each(function (n, x) {
                var grid = $(x).data("kendoGrid");
                if (!grid) {
                    return;
                }
                if (stopProcessing) {
                    //in case there is a multiple secletion - don't need to iterate further
                    //return - exits from .each(function), not from "TasksContextMenu_OnOpen"
                    return;
                }
                var selectedRows = grid.select();
                var cMenu = $(sender.item).data("kendoContextMenu");
                if (selectedRows.length > 1) {
                    stopProcessing = true;
                    cMenu.enable("#tsRun", true);
                    cMenu.enable("#tsStop", true);
                    cMenu.enable("#tsDelete", true);
                    cMenu.enable("#tsActivate", true);
                    cMenu.enable("#tsDeactivate", true);
                }
                else {
                    cMenu.enable("#tsDeactivate", false);
                    cMenu.enable("#tsActivate", false);
                    cMenu.enable("#tsDelete", false);
                    cMenu.enable("#tsStop", false);
                    cMenu.enable("#tsRun", false);
                }
            });
        };
        ContextMenuController.tasksContextMenuOnClicked = function (e, sender) {
            console.log("on: JobsContextMenu_OnClicked");
            var row = $("tr.SelectFlag.TaskFlag");
            if (row.length > 0) {
                var data = $($(row[0]).find(".taskIds"));
                var serverId = data.data("serverid");
                var jobId = $(row[0]).parents(".tasksGrid").data("jobId");
                var taskId = data.html();
                var stype = e.item.id;
                var oWnd;
                switch (stype) {
                    case "tActivate":
                        window.visualCron.server.activateTask(serverId, jobId, taskId);
                        break;
                    case "tDeactivate":
                        window.visualCron.server.deactivateTask(serverId, jobId, taskId);
                        break;
                    case "tRun":
                        window.visualCron.server.runTask(serverId, jobId, taskId);
                        break;
                    case "tStop":
                        window.visualCron.server.stopTask(serverId, jobId, taskId);
                        break;
                    case "tjRun":
                        window.visualCron.server.runJob(serverId, jobId, taskId);
                        break;
                    case "tDelete":
                        VisualCron.GridController.deleteTask(row, serverId, jobId, taskId);
                        break;
                    case "tLog":
                        ContextMenuController._openLogWindow(serverId, jobId);
                        break;
                    case "tOutput":
                        window.OutputWindowController.loadOutputText(serverId, jobId, taskId, 1, false);
                        oWnd = $("#OutputWindow").data("kendoWindow");
                        oWnd.center().open();
                        break;
                    case "tOutputErr":
                        window.OutputWindowController.loadOutputText(serverId, jobId, taskId, 0, false);
                        oWnd = $("#OutputWindow").data("kendoWindow");
                        oWnd.center().open();
                        break;
                }
                if (stype === "tsDelete") {
                    if (!confirm("Delete selected tasks?")) {
                        return;
                    }
                }
                //in case this is a mupltiple elements command, then iterate through them and do selected action
                $(".tasksGrid").each(function (n, x) {
                    var dGrid = $(x).data("kendoGrid");
                    if (!dGrid) {
                        return;
                    }
                    var selectedRows = dGrid.select();
                    for (var i = 0; i < selectedRows.length; i++) {
                        var _data = dGrid.dataItem(selectedRows[i]);
                        var _parentDetailRow = $(x).parents("tr.k-detail-row");
                        var _masterRow = $(_parentDetailRow).prev(".k-master-row");
                        var _serverIdRow = $(_masterRow).children("td.serverIds");
                        var _serverId = $(_serverIdRow).html();
                        var _jobId = _data.JobId;
                        var _taskId = _data.TaskId;
                        switch (stype) {
                            //selected
                            case "tsActivate":
                                window.visualCron.server.activateTask(_serverId, _jobId, _taskId);
                                break;
                            case "tsDeactivate":
                                window.visualCron.server.deactivateTask(_serverId, _jobId, _taskId);
                                break;
                            case "tsRun":
                                window.visualCron.server.runTask(_serverId, _jobId, _taskId);
                                break;
                            case "tsStop":
                                window.visualCron.server.stopTask(_serverId, _jobId, _taskId);
                                break;
                            case "tsDelete":
                                VisualCron.GridController.deleteTaskWithoutConfirm(selectedRows, _serverId, _jobId, _taskId);
                                break;
                        }
                    }
                });
            }
        };
        ContextMenuController._openLogWindow = function (serverId, jobId) {
            $("#JobLogHistory").data("serverId", serverId);
            $("#JobLogHistory").data("jobId", jobId);
            window.setDefaultHistory();
            //load history for current day
            window.HistoryWindowController.OnGetButton_Click();
            var oWnd = $("#JobLogHistory").data("kendoWindow");
            var firstJobCell = $(".k-master-row>td:data(type=jobId):getJobById(" + jobId + ")");
            var columns = firstJobCell.nextAll("td");
            var jobNameColumn = $(columns).filter(":data(type=jobName)");
            oWnd.title("Job history - " + jobNameColumn.html());
            oWnd.center().open();
        };
        return ContextMenuController;
    })();
    VisualCron.ContextMenuController = ContextMenuController;
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var RunningJobsController = (function (_super) {
        __extends(RunningJobsController, _super);
        function RunningJobsController(url) {
            _super.call(this);
            this.url = url;
            //run timer
            RunningJobsController._setUpdater();
        }
        Object.defineProperty(RunningJobsController, "objectType", {
            get: function () { return "btnRunningJobs"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RunningJobsController.prototype, "objectType", {
            get: function () { return RunningJobsController.objectType; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RunningJobsController.prototype, "title", {
            get: function () { return "Running Jobs"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RunningJobsController.prototype, "baseElement", {
            get: function () { return RunningJobsController.baseElementStatic; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RunningJobsController, "baseElementStatic", {
            get: function () { return $("#" + RunningJobsController.objectType + "Grid").data("kendoGrid"); },
            enumerable: true,
            configurable: true
        });
        //#region override
        RunningJobsController.prototype.onAdded = function (serverId, serverObject) {
            console.log("serverObjectAdded: " + this.objectType);
            switch (RunningJobsController.currentViewStyle) {
                case VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess:
                    this._jobTaskTaskProcessAdd(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess:
                    this._jobProcessTaskProcessAdd(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess:
                    this._taskProcessGridUpdate();
                    return;
                default:
                    throw new TypeError("type not found");
            }
        };
        RunningJobsController.prototype.onRemoved = function (serverId, serverObject) {
            console.log("serverObjectRemoved: " + this.objectType);
            switch (RunningJobsController.currentViewStyle) {
                case VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess:
                    this._jobTaskTaskProcessRemove(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess:
                    this._jobProcessTaskProcessRemove(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess:
                    this._taskProcessGridUpdate();
                    return;
                default:
                    throw new TypeError("type not found");
            }
        };
        RunningJobsController.prototype.onUpdated = function (serverId, serverObject) {
            console.log("serverObjectUpdated: " + this.objectType);
            switch (RunningJobsController.currentViewStyle) {
                case VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess:
                    this._jobTaskTaskProcessUpdate(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess:
                    this._jobProcessTaskProcessUpdate(serverObject);
                    break;
                case VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess:
                    this._taskProcessGridUpdate();
                    return;
                default:
                    throw new TypeError("type not found");
            }
        };
        RunningJobsController.prototype._onWindowClose = function (ctx, e) {
            var handle = RunningJobsController.timer;
            if (handle != null) {
                clearInterval(handle);
            }
            _super.prototype._onWindowClose.call(this, ctx, e);
        };
        //#endregion
        //#region events
        RunningJobsController.onDataBound = function (eventArg) {
            RunningJobsController._checkDetailExist($(eventArg.sender.element).attr("id"));
        };
        RunningJobsController.onDetailDataBound = function (eventArg) {
            RunningJobsController._checkDetailExist($(eventArg.sender.element).attr("id"));
        };
        RunningJobsController.onDetailExpand = function (eventArg) {
            var gridElement = $(eventArg.detailRow).find(".k-grid");
            var grid = RunningJobsController._getGrid(gridElement);
            RunningJobsController._updateGridDS(grid);
        };
        RunningJobsController.onViewStyleChange = function (eventArg) {
            RunningJobsController._hideAllLayer();
            var currentGrid;
            switch (eventArg.sender.value()) {
                case "jobTask":
                    $("#jobTask").show();
                    currentGrid = RunningJobsController._getGrid("#btnRunningJobsGrid");
                    RunningJobsController.currentViewStyle = VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess;
                    break;
                case "jobProcessTaskProcess":
                    $("#jobProcessTaskProcess").show();
                    currentGrid = RunningJobsController._getGrid("#btnRunningJobsProcessTaskProcessGrid");
                    RunningJobsController.currentViewStyle = VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess;
                    break;
                case "taskProcess":
                    $("#taskProcess").show();
                    currentGrid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid");
                    RunningJobsController.currentViewStyle = VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess;
                    break;
                default:
                    throw new TypeError("type not found");
            }
            if (!currentGrid) {
                throw new ReferenceError("grid not found");
            }
            RunningJobsController._updateGridDS(currentGrid);
        };
        RunningJobsController.onUpdateIntervalChange = function (eventArg) {
            console.log("onUpdateIntervalChange");
            RunningJobsController.updateInterval = eventArg.sender.value();
            RunningJobsController._setUpdater();
        };
        //#endregion
        //#region private methods
        RunningJobsController.prototype._jobTaskTaskProcessAdd = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid_" + serverObject.TaskId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                var rowExist = $("#btnRunningJobsGrid td:data(jobid=" + serverObject.JobId + "):data(grid=job)");
                if (!rowExist) {
                    var grid = RunningJobsController._getGrid("#btnRunningJobsGrid");
                    RunningJobsController._updateGridDS(grid);
                    return;
                }
                var newRow = RunningJobsController._insertNewRow($("#btnRunningJobsGrid"));
                var columns = newRow.children("td");
                var column = columns.filter(":data(type=name)");
                column.data("uniqueid", serverObject.UniqueId);
                RunningJobsController._updateJobProcessGrid(serverObject);
            }
            RunningJobsController._checkDetailExist("btnRunningJobsGrid");
        };
        RunningJobsController.prototype._jobTaskTaskProcessRemove = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid_" + serverObject.TaskId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                var grid = RunningJobsController._getGrid("#btnRunningJobsGrid");
                var currentColumn = $("#btnRunningJobsGrid td:data(uniqueid=" + serverObject.UniqueId + "):data(grid=job)");
                var eq = currentColumn.parents("tr").eq(0);
                grid.collapseRow(eq);
                eq.remove();
            }
        };
        RunningJobsController.prototype._jobTaskTaskProcessUpdate = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid_" + serverObject.TaskId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                RunningJobsController._updateJobGrid(serverObject);
                RunningJobsController._updateTask(serverObject);
            }
        };
        RunningJobsController.prototype._jobProcessTaskProcessAdd = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningJobsGrid_" + serverObject.JobPId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                var rowExist = $("#btnRunningJobsProcessTaskProcessGrid td:data(jobid=" + serverObject.JobId + "):data(grid=jobProcess)");
                if (!rowExist) {
                    var grid = RunningJobsController._getGrid("#btnRunningJobsProcessTaskProcessGrid");
                    RunningJobsController._updateGridDS(grid);
                    return;
                }
                var newRow = RunningJobsController._insertNewRow($("#btnRunningJobsProcessTaskProcessGrid"));
                var columns = newRow.children("td");
                var column = columns.filter(":data(type=id)");
                column.data("uniqueid", serverObject.UniqueId);
                column.data("jobid", serverObject.JobId);
                RunningJobsController._updateJobProcessGrid(serverObject);
            }
            RunningJobsController._checkDetailExist("btnRunningJobsProcessTaskProcessGrid");
        };
        RunningJobsController.prototype._jobProcessTaskProcessRemove = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningJobsGrid_" + serverObject.JobPId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                var grid = RunningJobsController._getGrid("#btnRunningJobsProcessTaskProcessGrid");
                var currentColumn = $("#btnRunningJobsProcessTaskProcessGrid td:data(jobid=" + serverObject.JobId + "):data(grid=jobProcess)");
                var eq = currentColumn.parents("tr").eq(0);
                grid.collapseRow(eq);
                eq.remove();
            }
        };
        RunningJobsController.prototype._jobProcessTaskProcessUpdate = function (serverObject) {
            if (this._isVCTask(serverObject)) {
                var grid = RunningJobsController._getGrid("#btnRunningJobsGrid_" + serverObject.JobPId);
                RunningJobsController._updateGridDS(grid);
            }
            else {
                RunningJobsController._updateTaskProcessJobProcessView(serverObject);
            }
        };
        RunningJobsController.prototype._isVCTask = function (serverObject) {
            //if TaskId not exist - it is VCJobClass 
            //!serverObject.TaskId
            if (serverObject.TaskId) {
                return true;
            }
            return false;
        };
        RunningJobsController.prototype._taskProcessGridUpdate = function () {
            var grid = RunningJobsController._getGrid("#btnRunningTaskProcessGrid");
            RunningJobsController._updateGridDS(grid);
        };
        RunningJobsController._insertNewRow = function (grid) {
            var trSource = grid.find("tbody").find("tr.k-master-row")[0];
            var insertBeforeItem = grid.find("tbody").find("tr.k-master-row")[0];
            var copyobj = $(trSource).clone();
            //hide detail icon
            //$(copyobj.find(".k-hierarchy-cell")).children().hide();
            $(copyobj.find(".k-hierarchy-cell")).children().removeClass("k-minus").addClass("k-plus");
            $(insertBeforeItem).before(copyobj);
            return copyobj;
        };
        RunningJobsController._setUpdater = function () {
            var handle = RunningJobsController.timer;
            if (handle != null) {
                clearInterval(handle);
            }
            RunningJobsController.timer = setInterval(
            //safe `this` context
            //safe `this` context
            function () { return RunningJobsController._updaterHandler(); }, RunningJobsController.updateInterval * 1000);
        };
        RunningJobsController._checkDetailExist = function (gridId) {
            var serverId = $(RunningJobsController.baseElementStatic.element).data("serverid");
            //todo: 0  - ?
            //todo: now `Exist` allways true
            window.visualCron.server.checkRunningJobExist(serverId, 0).done(function (obj) {
                obj.forEach(function (item) {
                    var img = $("td:data(uniqueid=" + item.Id + ")", "#" + gridId);
                    var prev = $(img).prev();
                    var children = prev.children();
                    if (!item.Exist) {
                        $(children).hide();
                    }
                    else {
                        $(children).css("display", "block");
                    }
                });
            });
        };
        RunningJobsController._updateGridDS = function (currentGrid) {
            if (!currentGrid) {
                return;
            }
            currentGrid.dataSource.read();
            currentGrid.refresh();
        };
        RunningJobsController._getGrid = function (gridElement) {
            return $(gridElement).data("kendoGrid");
        };
        RunningJobsController._hideAllLayer = function () {
            $("#jobTask").hide();
            $("#taskProcess").hide();
            $("#jobProcessTaskProcess").hide();
        };
        //#endregion
        //#region cell updater
        RunningJobsController._updaterHandler = function () {
            var serverId = $(RunningJobsController.baseElementStatic.element).data("serverid");
            //current grid
            window.visualCron.server.getRunningJobs(serverId, RunningJobsController.currentViewStyle).done(function (obj) {
                var data = obj;
                data.forEach(function (item) {
                    switch (item.GridType) {
                        case VisualCron.Interfaces.RunningJobsDataType.Job:
                            RunningJobsController._updateJobGrid(item);
                            break;
                        case VisualCron.Interfaces.RunningJobsDataType.JobProcess:
                            RunningJobsController._updateJobProcessGrid(item);
                            break;
                        case VisualCron.Interfaces.RunningJobsDataType.Task:
                            RunningJobsController._updateTask(item);
                            break;
                        case VisualCron.Interfaces.RunningJobsDataType.TaskProcess:
                            switch (RunningJobsController.currentViewStyle) {
                                case VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess:
                                    RunningJobsController._updateTaskProcessJobTaskView(item);
                                    break;
                                case VisualCron.Interfaces.RunningJobsViewStyle.JobProcessTaskProcess:
                                    RunningJobsController._updateTaskProcessJobProcessView(item);
                                    break;
                                case VisualCron.Interfaces.RunningJobsViewStyle.TaskProcess:
                                    RunningJobsController._updateTaskProcessView(item);
                                    break;
                                default:
                                    throw new TypeError("type not found");
                            }
                            break;
                        default:
                            throw new TypeError("type not found");
                    }
                });
            });
        };
        RunningJobsController._updateJobGrid = function (item) {
            var currentColumn = $("#btnRunningJobsGrid td:data(uniqueid=" + item.UniqueId + "):data(grid=job)");
            currentColumn.html(item.Name);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=description)");
            currentColumn.html(item.Description);
        };
        RunningJobsController._updateTask = function (item) {
            var currentColumn = $("[id^='btnRunningTasksGrid_'] td:data(uniqueid=" + item.UniqueId + "):data(grid=jobTask)");
            //currentColumn.html(item.Id);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
        };
        RunningJobsController._updateJobProcessGrid = function (item) {
            var currentColumn = $("#btnRunningJobsProcessTaskProcessGrid td:data(uniqueid=" + item.UniqueId + "):data(grid=jobProcess)");
            currentColumn.html(item.Id);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
            currentColumn = $(columns).filter(":data(type=started)");
            currentColumn.html(item.Started);
            currentColumn = $(columns).filter(":data(type=runTime)");
            currentColumn.html(item.RunTime);
        };
        RunningJobsController._updateTaskProcessJobTaskView = function (item) {
            var currentColumn = $("[id^='btnRunningTaskProcessGrid_'] td:data(uniqueid=" + item.UniqueId + "):data(grid=jobTaskTaskProcess)");
            currentColumn.html(item.JobPId);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=id)");
            currentColumn.html(item.Id);
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
            currentColumn = $(columns).filter(":data(type=windowPId)");
            currentColumn.html(item.WindowPId);
            currentColumn = $(columns).filter(":data(type=started)");
            currentColumn.html(item.Started);
            currentColumn = $(columns).filter(":data(type=runTime)");
            currentColumn.html(item.RunTime);
        };
        RunningJobsController._updateTaskProcessJobProcessView = function (item) {
            var currentColumn = $("[id^='btnRunningJobsGrid_'] td:data(uniqueid=" + item.UniqueId + "):data(grid=jobProcessTaskProcess)");
            currentColumn.html(item.Id);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
            currentColumn = $(columns).filter(":data(type=windowPId)");
            currentColumn.html(item.WindowPId);
            currentColumn = $(columns).filter(":data(type=started)");
            currentColumn.html(item.Started);
            currentColumn = $(columns).filter(":data(type=runTime)");
            currentColumn.html(item.RunTime);
        };
        RunningJobsController._updateTaskProcessView = function (item) {
            var currentColumn = $("#btnRunningTaskProcessGrid td:data(tpid=" + item.Id + "):data(grid=taskProcess)");
            currentColumn.html(item.Id);
            var columns = currentColumn.nextAll("td");
            currentColumn = $(columns).filter(":data(type=name)");
            currentColumn.html(item.Name);
            currentColumn = $(columns).filter(":data(type=windowPId)");
            currentColumn.html(item.WindowPId);
            currentColumn = $(columns).filter(":data(type=started)");
            currentColumn.html(item.Started);
            currentColumn = $(columns).filter(":data(type=runTime)");
            currentColumn.html(item.RunTime);
        };
        RunningJobsController.updateInterval = 3;
        RunningJobsController.timer = null;
        RunningJobsController.currentViewStyle = VisualCron.Interfaces.RunningJobsViewStyle.JobTaskTaskProcess;
        return RunningJobsController;
    })(VisualCron.ServerObjects.UpdatableWindowBase);
    VisualCron.RunningJobsController = RunningJobsController;
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ClientConnectionsController = (function (_super) {
        __extends(ClientConnectionsController, _super);
        function ClientConnectionsController(url) {
            _super.call(this);
            this.url = url;
        }
        Object.defineProperty(ClientConnectionsController, "objectType", {
            get: function () { return "btnClientConnections"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ClientConnectionsController.prototype, "objectType", {
            get: function () { return ClientConnectionsController.objectType; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ClientConnectionsController.prototype, "title", {
            get: function () { return "Server connections manager"; },
            enumerable: true,
            configurable: true
        });
        return ClientConnectionsController;
    })(VisualCron.ServerObjects.UpdatableWindowBase);
    VisualCron.ClientConnectionsController = ClientConnectionsController;
})(VisualCron || (VisualCron = {}));
/// <reference path="../typings/jquery/jquery.d.ts" />
var VisualCron;
(function (VisualCron) {
    var GridController = (function () {
        function GridController() {
        }
        GridController.removeGroupRowIfEmplty = function (groupName) {
            var groupRow = $(".k-grouping-row:getGroup(" + groupName + ")");
            if (!groupRow) {
                return;
            }
            var next = $(groupRow).next("tr.k-master-row");
            if (next.length <= 0) {
                $(groupRow).remove();
            }
        };
        GridController.fixPagesizeDropdown = function (grid) {
            var pager = $(".k-dropdown, select", grid.element);
            if (pager) {
                pager.off();
            }
        };
        GridController.keyController = function () {
            $(window.document).bind("keydown", function (e) {
                // 46 - del
                if (e.keyCode === 46) {
                    var row = $("tr.k-master-row.SelectFlag");
                    if (row.length > 0) {
                        var grid = row.parents(".k-grid").data("kendoGrid");
                        var selectedRows = grid.select();
                        var message = "Delete " + selectedRows.length + " jobs?";
                        if (selectedRows.length === 1) {
                            var nextAll = row.children("td");
                            var jname = $(nextAll.filter(":data(type=jobName)")).text();
                            message = "Delete job '" + jname + "'?";
                        }
                        if (confirm(message)) {
                            for (var i = 0; i < selectedRows.length; i++) {
                                var selectedRow = $(selectedRows[i]);
                                var jids = $(selectedRow.find(".ids"));
                                var sids = $(selectedRow.find(".serverIds"));
                                var serverId = sids.text();
                                var jobId = jids.text();
                                GridController.deleteJobWithoutConfirm(row, serverId, jobId);
                            }
                        }
                    }
                    else {
                        var trow = $("tr.SelectFlag.TaskFlag");
                        if (trow.length > 0) {
                            var grid = trow.parents(".k-grid").data("kendoGrid");
                            var _selectedRows = grid.select();
                            var message = "Delete " + _selectedRows.length + " tasks?";
                            if (_selectedRows.length === 1) {
                                var tasks = grid.dataSource.data();
                                var taskId = _selectedRows.find(".taskIds").text();
                                var taskName = "";
                                for (var u = 0; u < tasks.length; u++) {
                                    if (tasks[u].TaskId === taskId) {
                                        taskName = tasks[u].TaskName;
                                    }
                                }
                                message = "Delete task '" + taskName + "'?";
                            }
                            if (confirm(message)) {
                                for (var i = 0; i < _selectedRows.length; i++) {
                                    var _data = grid.dataItem(_selectedRows[i]);
                                    var _serverId = $(grid.element).attr("id");
                                    var _jobId = _data.JobId;
                                    var _taskId = _data.TaskId;
                                    GridController.deleteTaskWithoutConfirm(trow, _serverId, _jobId, _taskId);
                                }
                            }
                        }
                    }
                }
            });
        };
        GridController.deleteJob = function (row, serverId, jobId) {
            var nextAll = row.children("td");
            var jname = $(nextAll.filter(":data(type=jobName)")).text();
            if (confirm("Delete job '" + jname + "'?")) {
                GridController.deleteJobWithoutConfirm(row, serverId, jobId);
            }
        };
        GridController.deleteJobWithoutConfirm = function (row, serverId, jobId) {
            window.visualCron.server.removeJob(serverId, jobId);
        };
        GridController.deleteTask = function (row, serverId, jobId, taskId) {
            if (confirm("Delete task?")) {
                GridController.deleteTaskWithoutConfirm(row, serverId, jobId, taskId);
            }
        };
        GridController.deleteTaskWithoutConfirm = function (row, serverId, jobId, taskId) {
            window.visualCron.server.removeTask(serverId, jobId, taskId);
        };
        return GridController;
    })();
    VisualCron.GridController = GridController;
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var Interfaces;
    (function (Interfaces) {
        (function (RunningJobsViewStyle) {
            RunningJobsViewStyle[RunningJobsViewStyle["JobTaskTaskProcess"] = 0] = "JobTaskTaskProcess";
            RunningJobsViewStyle[RunningJobsViewStyle["JobProcessTaskProcess"] = 1] = "JobProcessTaskProcess";
            RunningJobsViewStyle[RunningJobsViewStyle["TaskProcess"] = 2] = "TaskProcess";
        })(Interfaces.RunningJobsViewStyle || (Interfaces.RunningJobsViewStyle = {}));
        var RunningJobsViewStyle = Interfaces.RunningJobsViewStyle;
        (function (RunningJobsDataType) {
            RunningJobsDataType[RunningJobsDataType["Job"] = 0] = "Job";
            RunningJobsDataType[RunningJobsDataType["Task"] = 1] = "Task";
            RunningJobsDataType[RunningJobsDataType["JobProcess"] = 2] = "JobProcess";
            RunningJobsDataType[RunningJobsDataType["TaskProcess"] = 3] = "TaskProcess";
        })(Interfaces.RunningJobsDataType || (Interfaces.RunningJobsDataType = {}));
        var RunningJobsDataType = Interfaces.RunningJobsDataType;
        var PopupTask;
        (function (PopupTask) {
            (function (PopupInputDisplayT) {
                PopupInputDisplayT[PopupInputDisplayT["Button"] = 0] = "Button";
                PopupInputDisplayT[PopupInputDisplayT["Text"] = 1] = "Text";
                PopupInputDisplayT[PopupInputDisplayT["RadioButton"] = 2] = "RadioButton";
                PopupInputDisplayT[PopupInputDisplayT["CheckBox"] = 3] = "CheckBox";
                PopupInputDisplayT[PopupInputDisplayT["ComboBox"] = 4] = "ComboBox";
            })(PopupTask.PopupInputDisplayT || (PopupTask.PopupInputDisplayT = {}));
            var PopupInputDisplayT = PopupTask.PopupInputDisplayT;
        })(PopupTask = Interfaces.PopupTask || (Interfaces.PopupTask = {}));
    })(Interfaces = VisualCron.Interfaces || (VisualCron.Interfaces = {}));
})(VisualCron || (VisualCron = {}));
/// <reference path="../typings/jquery/jquery.d.ts" />
// extend jquery
(function ($) {
    //TODO: Important: don't use createPseudo
    $.extend($.expr[":"], {
        //example: 
        //$(".element:data(key=value)")
        data: $.expr.createPseudo(function (dataName) { return function (elem) {
            var params = dataName.split("=");
            var d = $(elem).data(params[0].trim());
            if (d + "" === params[1] + "") {
                return true;
            }
            return false;
        }; }),
        //example:
        //var gridJob = $(".element:getJobById(jobid)"); 
        getJobById: $.expr.createPseudo(function (jobId) { return function (elem) {
            if ($(elem).html() == jobId) {
                return true;
            }
            return false;
        }; }),
        getGroup: $.expr.createPseudo(function (groupName) { return function (elem) {
            var pElement = $(elem).find("p");
            if (pElement.length > 0) {
                var v = pElement.text();
                if (v == "Group: " + groupName) {
                    return true;
                }
            }
            return false;
        }; })
    });
})(jQuery);
var VisualCron;
(function (VisualCron) {
    var NotificationController = (function () {
        function NotificationController() {
        }
        NotificationController.showNotification = function (vcJob, status) {
            var notificator = $("#jobNotification").data("kendoNotification");
            notificator.show({ jobStatus: status, jobName: vcJob.Name, jobTime: vcJob.RunTime }, "job_start");
        };
        NotificationController.hideNotification = function () {
            var notificator = $("#jobNotification").data("kendoNotification");
            notificator.hide();
        };
        return NotificationController;
    })();
    VisualCron.NotificationController = NotificationController;
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ui = kendo.ui;
    var WindowBase = (function () {
        function WindowBase() {
            this.window = null;
            this.url = "Not Implemented";
        }
        Object.defineProperty(WindowBase.prototype, "baseElement", {
            get: function () { return $("#" + this.objectType + "Grid").data("kendoGrid"); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WindowBase, "objectType", {
            get: function () { return "Not Implemented"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WindowBase.prototype, "objectType", {
            get: function () { return WindowBase.objectType; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WindowBase.prototype, "title", {
            get: function () { return "Not Implemented"; },
            enumerable: true,
            configurable: true
        });
        WindowBase.prototype.createWindow = function (serverId) {
            var _this = this;
            var data = {
                serverId: serverId,
                objectType: this.objectType
            };
            var target = this._createElement(); // ReSharper disable UnusedParameter
            //params(resp, text, xreq) need for not to override 'this'
            target.load(this.url, data, function (resp, text, xreq) { return _this._onLoad(); });
            // ReSharper restore UnusedParameter
        };
        WindowBase.prototype._createWindow = function (windowParams) {
            var rootElement = $("#root" + this.objectType)[0];
            this.window = new ui.Window(rootElement, windowParams);
            this.window.center();
            $(this.window.element).addClass("resizeble");
            this._setFooter();
        };
        WindowBase.prototype._createElement = function () {
            var root = $("#ServerObjectsRoot");
            var childElement = $("#win" + this.objectType);
            if (childElement.length <= 0) {
                var childHtml = "<div id='win" + this.objectType + "'></div>";
                root.append(childHtml);
                childElement = $("#win" + this.objectType);
            }
            return childElement;
        };
        WindowBase.prototype._onWindowClose = function (ctx, e) {
            var rootObj = $("#root" + this.objectType);
            var parent = rootObj.parents(".k-window");
            //wait for end "close window" animation
            setTimeout(function () { return parent.remove(); }, 300);
        };
        WindowBase.prototype._createWindowsOptions = function () {
            var _this = this;
            var wp = {
                draggable: true,
                modal: true,
                height: 500,
                width: 1000,
                resizable: true,
                close: function (e) {
                    //anonymous function save 'this' context
                    _this._onWindowClose(_this, e);
                }
            };
            return wp;
        };
        WindowBase.prototype._setFooter = function () {
            var footer = $(".status-strip");
            var parent = footer.parents("#root" + this.objectType);
            var isCopy = footer.data("isCopy");
            if (isCopy) {
                return;
            }
            parent.after(footer);
            footer.data("isCopy", true);
        };
        WindowBase.prototype._onLoad = function () {
            var windowParams = this._createWindowsOptions();
            windowParams.title = this.title;
            this._createWindow(windowParams);
        };
        return WindowBase;
    })();
    VisualCron.WindowBase = WindowBase;
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var UpdatableWindowBase = (function (_super) {
            __extends(UpdatableWindowBase, _super);
            function UpdatableWindowBase() {
                _super.call(this);
            }
            UpdatableWindowBase.prototype.createWindow = function (serverId) {
                var _this = this;
                var data = {
                    serverId: serverId,
                    objectType: this.objectType
                };
                this._addEventHandler();
                var target = this._createElement(); // ReSharper disable UnusedParameter
                //params(resp, text, xreq) need for not to override 'this'
                target.load(this.url, data, function (resp, text, xreq) { return _this._onLoad(); });
                // ReSharper restore UnusedParameter
            };
            UpdatableWindowBase.prototype.onAdded = function (serverId, serverObject) {
                console.log("serverObjectAdded: " + this.objectType);
                this.baseElement.dataSource.read();
                this.baseElement.refresh();
            };
            UpdatableWindowBase.prototype.onRemoved = function (serverId, serverObject) {
                console.log("serverObjectRemoved: " + this.objectType);
                this.baseElement.dataSource.read();
                this.baseElement.refresh();
            };
            UpdatableWindowBase.prototype.onUpdated = function (serverId, serverObject) {
                console.log("serverObjectUpdated: " + this.objectType);
                this.baseElement.dataSource.read();
                this.baseElement.refresh();
            };
            UpdatableWindowBase.prototype._addEventHandler = function () {
                var childElement = $("#win" + this.objectType);
                var serverId = $("#currentServerId").data("currentserverid"); //if event handler was added, not add again
                if (childElement.length > 0) {
                    return;
                }
                window.visualCron.server.addEventHandler(this.objectType, serverId);
            };
            return UpdatableWindowBase;
        })(VisualCron.WindowBase);
        ServerObjects.UpdatableWindowBase = UpdatableWindowBase;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectCertificates = (function (_super) {
            __extends(ServerObjectCertificates, _super);
            function ServerObjectCertificates(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectCertificates, "objectType", {
                get: function () { return "btnCertificates"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectCertificates.prototype, "objectType", {
                get: function () { return ServerObjectCertificates.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectCertificates.prototype, "title", {
                get: function () { return "Manage certificates"; },
                enumerable: true,
                configurable: true
            });
            return ServerObjectCertificates;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectCertificates = ServerObjectCertificates;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectConnections = (function (_super) {
            __extends(ServerObjectConnections, _super);
            function ServerObjectConnections(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectConnections, "objectType", {
                get: function () { return "btnConnections"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConnections.prototype, "objectType", {
                get: function () { return ServerObjectConnections.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConnections.prototype, "title", {
                get: function () { return "Manage connections"; },
                enumerable: true,
                configurable: true
            });
            ServerObjectConnections.onAddButtonClick = function (eventArg) {
                var addBtn = $(eventArg.target);
                var listBtn = addBtn.next(); //kendo click
                $(listBtn).mousedown().mouseup();
            };
            return ServerObjectConnections;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectConnections = ServerObjectConnections;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectCredentials = (function (_super) {
            __extends(ServerObjectCredentials, _super);
            function ServerObjectCredentials(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectCredentials, "objectType", {
                get: function () { return "btnCredentials"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectCredentials.prototype, "objectType", {
                get: function () { return ServerObjectCredentials.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectCredentials.prototype, "title", {
                get: function () { return "Manage credentials"; },
                enumerable: true,
                configurable: true
            });
            return ServerObjectCredentials;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectCredentials = ServerObjectCredentials;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectNetDrives = (function (_super) {
            __extends(ServerObjectNetDrives, _super);
            function ServerObjectNetDrives(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectNetDrives, "objectType", {
                get: function () { return "btnNetDrives"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectNetDrives.prototype, "objectType", {
                get: function () { return ServerObjectNetDrives.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectNetDrives.prototype, "title", {
                get: function () { return "Manage network drives"; },
                enumerable: true,
                configurable: true
            });
            return ServerObjectNetDrives;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectNetDrives = ServerObjectNetDrives;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectNotification = (function (_super) {
            __extends(ServerObjectNotification, _super);
            function ServerObjectNotification(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectNotification, "objectType", {
                get: function () { return "btnNotification"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectNotification.prototype, "objectType", {
                get: function () { return ServerObjectNotification.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectNotification.prototype, "title", {
                get: function () { return "Manage notification"; },
                enumerable: true,
                configurable: true
            });
            return ServerObjectNotification;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectNotification = ServerObjectNotification;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectPgpKeyRings = (function (_super) {
            __extends(ServerObjectPgpKeyRings, _super);
            function ServerObjectPgpKeyRings(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectPgpKeyRings, "objectType", {
                get: function () { return "btnPgpKeyRings"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectPgpKeyRings.prototype, "objectType", {
                get: function () { return ServerObjectPgpKeyRings.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectPgpKeyRings.prototype, "title", {
                get: function () { return "Manage PGP Key Rings"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectPgpKeyRings.prototype, "baseElement", {
                get: function () { return $("#" + this.objectType + "TreeView").data("kendoTreeView"); },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectPgpKeyRings.prototype, "treeViewElement", {
                get: function () { return this.baseElement; },
                enumerable: true,
                configurable: true
            });
            ServerObjectPgpKeyRings.prototype.onAdded = function (serverId, serverObject) {
                console.log("serverObjectAdded: " + this.objectType);
                this.treeViewElement.dataSource.read();
            };
            ServerObjectPgpKeyRings.prototype.onRemoved = function (serverId, serverObject) {
                console.log("serverObjectRemoved: " + this.objectType);
                this.treeViewElement.dataSource.read();
            };
            ServerObjectPgpKeyRings.prototype.onUpdated = function (serverId, serverObject) {
                console.log("serverObjectUpdated: " + this.objectType);
                this.treeViewElement.dataSource.read();
            };
            return ServerObjectPgpKeyRings;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectPgpKeyRings = ServerObjectPgpKeyRings;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectVariables = (function (_super) {
            __extends(ServerObjectVariables, _super);
            function ServerObjectVariables(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectVariables, "objectType", {
                get: function () { return "btnVariables"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables.prototype, "objectType", {
                get: function () { return ServerObjectVariables.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables.prototype, "title", {
                get: function () { return "Manage user variables"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables.prototype, "baseElement", {
                get: function () { return ServerObjectVariables.baseElementStatic; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables, "baseElementStatic", {
                get: function () { return $("#" + ServerObjectVariables.objectType + "TreeView").data("kendoTreeView"); },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectVariables.prototype, "treeViewElement", {
                get: function () { return this.baseElement; },
                enumerable: true,
                configurable: true
            });
            ServerObjectVariables.prototype.onAdded = function (serverId, serverObject) {
                console.log("serverObjectAdded: " + this.objectType);
                var saveFilter = this.baseElement.dataSource.filter();
                this.treeViewElement.dataSource.read();
                this.baseElement.dataSource.filter(saveFilter);
            };
            ServerObjectVariables.prototype.onRemoved = function (serverId, serverObject) {
                console.log("serverObjectRemoved: " + this.objectType);
                var saveFilter = this.baseElement.dataSource.filter();
                this.treeViewElement.dataSource.read();
                this.baseElement.dataSource.filter(saveFilter);
            };
            ServerObjectVariables.prototype.onUpdated = function (serverId, serverObject) {
                console.log("serverObjectUpdated: " + this.objectType);
                var saveFilter = this.baseElement.dataSource.filter();
                this.treeViewElement.dataSource.read();
                this.baseElement.dataSource.filter(saveFilter);
            };
            ServerObjectVariables.onCopyButtonClick = function (eventArg) {
                var val = $("#tbaPrev").val();
                window.prompt("Copy to clipboard: Ctrl+C, Enter", val);
            };
            ServerObjectVariables.onSearchButtonClick = function (eventArg) {
                var stext = $("#varsSearchBox").val();
                var filter = {
                    field: "Name",
                    operator: "contains",
                    value: stext
                };
                ServerObjectVariables.baseElementStatic.dataSource.filter(filter);
            };
            ServerObjectVariables.onClearSearchButtonClick = function (eventArg) {
                $("#varsSearchBox").val("");
                ServerObjectVariables.baseElementStatic.dataSource.filter([]);
            };
            ServerObjectVariables.onVariableSelect = function (eventArg) {
                var selectedValueModel = ServerObjectVariables.baseElementStatic.dataItem(eventArg.node);
                var value = "{USERVAL{" + selectedValueModel.Name + "}}";
                $("#tbaPrev").val(value);
                $("#statusBarText").text(value);
                $("#tbaValPrev").val(selectedValueModel.ValueObject);
            };
            ServerObjectVariables.prototype._createWindowsOptions = function () {
                var wp = _super.prototype._createWindowsOptions.call(this);
                wp.width = 750;
                return wp;
            };
            return ServerObjectVariables;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectVariables = ServerObjectVariables;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectConditions = (function (_super) {
            __extends(ServerObjectConditions, _super);
            function ServerObjectConditions(url) {
                _super.call(this);
                this.url = url;
            }
            Object.defineProperty(ServerObjectConditions, "objectType", {
                get: function () { return "btnConditions"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConditions.prototype, "objectType", {
                get: function () { return ServerObjectConditions.objectType; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConditions.prototype, "title", {
                get: function () { return "Manage conditions"; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConditions.prototype, "baseElement", {
                get: function () { return ServerObjectConditions.baseElementStatic; },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(ServerObjectConditions, "baseElementStatic", {
                get: function () { return $("#" + ServerObjectConditions.objectType + "Grid").data("kendoGrid"); },
                enumerable: true,
                configurable: true
            });
            ServerObjectConditions.onDataBound = function (eventArg) {
                ServerObjectConditions._checkDetailExist();
            };
            ServerObjectConditions.onDetailDataBound = function (eventArg) {
                var senderGrid = eventArg.sender;
                var setId = $(senderGrid.element).data("setid");
                if (senderGrid.dataSource.data().length <= 0) {
                    ServerObjectConditions._collapseRow(setId);
                }
            };
            ServerObjectConditions.prototype.onAdded = function (serverId, serverObject) {
                console.log("serverObjectAdded: " + this.objectType);
                if (!serverObject.SetId) {
                    this._onAddedSet(serverId, serverObject);
                }
                else {
                    this._refreshDetailGrid(serverObject.SetId);
                }
                ServerObjectConditions._checkDetailExist();
            };
            ServerObjectConditions.prototype.onRemoved = function (serverId, serverObject) {
                console.log("serverObjectRemoved: " + this.objectType);
                //if SetId not exist - it is ConditionSet 
                if (!serverObject.SetId) {
                    this._onRemovedSet(serverId, serverObject);
                }
                else {
                    this._refreshDetailGrid(serverObject.SetId);
                }
                ServerObjectConditions._checkDetailExist();
            };
            ServerObjectConditions.prototype.onUpdated = function (serverId, serverObject) {
                console.log("serverObjectUpdated: " + this.objectType);
                if (!serverObject.SetId) {
                    this._onUpdatedSet(serverId, serverObject);
                }
                else {
                    this._refreshDetailGrid(serverObject.SetId);
                }
                ServerObjectConditions._checkDetailExist();
            };
            ServerObjectConditions.prototype._onAddedSet = function (serverId, serverObject) {
                //for first item, just refresh table
                var len = this.baseElement.dataSource.data().length;
                if (len <= 0) {
                    this.baseElement.dataSource.read();
                    this.baseElement.refresh();
                    return;
                }
                var grid = $("#" + ServerObjectConditions.objectType + "Grid");
                var newRow = ServerObjectConditions._insertNewRow(grid);
                ServerObjectConditions._updateConditionSet(newRow, serverObject);
            };
            ServerObjectConditions.prototype._onRemovedSet = function (serverId, serverObject) {
                var row = ServerObjectConditions._collapseRow(serverObject.Id);
                row.remove();
            };
            ServerObjectConditions.prototype._onUpdatedSet = function (serverId, serverObject) {
                var id = serverObject.Id;
                var row = ServerObjectConditions._getRowById(id);
                ServerObjectConditions._updateConditionSet(row, serverObject);
            };
            ServerObjectConditions.prototype._refreshDetailGrid = function (setId) {
                var grid = $("[id*=" + setId + "]:data(setid=" + setId + ")").data("kendoGrid");
                if (!grid) {
                    return;
                }
                grid.dataSource.read();
                grid.refresh();
            };
            ServerObjectConditions._collapseRow = function (setId) {
                var row = ServerObjectConditions._getRowById(setId);
                ServerObjectConditions.baseElementStatic.collapseRow(row);
                return row;
            };
            ServerObjectConditions._getRowById = function (id) {
                var img = $("img:data(id=" + id + ")", "#" + ServerObjectConditions.objectType + "Grid");
                var row = $(img).parents("tr");
                return row;
            };
            ServerObjectConditions._insertNewRow = function (grid) {
                var trSource = grid.find("tbody").find("tr.k-master-row")[0];
                var insertBeforeItem = grid.find("tbody").find("tr.k-master-row")[0];
                var copyobj = $(trSource).clone();
                //hide detail icon
                $(copyobj.find(".k-hierarchy-cell")).children().hide();
                $(insertBeforeItem).before(copyobj);
                return copyobj;
            };
            ServerObjectConditions._updateConditionSet = function (row, serverObject) {
                var columns = row.children("td");
                var column = columns.filter(":data(name=Description)");
                column.html(serverObject.Description);
                column = columns.filter(":data(name=Icon)").children("img");
                $(column).data("id", serverObject.Id);
            };
            ServerObjectConditions._checkDetailExist = function () {
                var serverId = $(ServerObjectConditions.baseElementStatic.element).data("serverid");
                window.visualCron.server.checkConditionsExist(serverId).done(function (obj) {
                    var data = obj;
                    data.forEach(function (item, i, array) {
                        var img = $("img:data(id=" + item.Id + ")", "#" + ServerObjectConditions.objectType + "Grid");
                        var prev = $(img).parent().prev();
                        var children = prev.children();
                        if (!item.Exist) {
                            $(children).hide();
                        }
                        else {
                            $(children).css("display", "block");
                        }
                    });
                });
            };
            return ServerObjectConditions;
        })(ServerObjects.UpdatableWindowBase);
        ServerObjects.ServerObjectConditions = ServerObjectConditions;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var ServerObjectController = (function () {
            function ServerObjectController(url, objectType) {
                switch (objectType) {
                    case "btnCertificates":
                        this._this = new ServerObjects.ServerObjectCertificates(url);
                        break;
                    case "btnConditions":
                        this._this = new ServerObjects.ServerObjectConditions(url);
                        break;
                    case "btnConnections":
                        this._this = new ServerObjects.ServerObjectConnections(url);
                        break;
                    case "btnCredentials":
                        this._this = new ServerObjects.ServerObjectCredentials(url);
                        break;
                    case "btnNetDrives":
                        this._this = new ServerObjects.ServerObjectNetDrives(url);
                        break;
                    case "btnNotification":
                        this._this = new ServerObjects.ServerObjectNotification(url);
                        break;
                    case "btnPgpKeyRings":
                        this._this = new ServerObjects.ServerObjectPgpKeyRings(url);
                        break;
                    case "btnVariables":
                        this._this = new ServerObjects.ServerObjectVariables(url);
                        break;
                    case "btnClientConnections":
                        this._this = new VisualCron.ClientConnectionsController(url);
                        break;
                    case "btnRunningJobs":
                        this._this = new VisualCron.RunningJobsController(url);
                        break;
                    default:
                        throw new TypeError("type not found");
                }
            }
            ServerObjectController.prototype.createWindow = function (serverId) {
                this._this.createWindow(serverId);
            };
            ServerObjectController.prototype.onAdded = function (serverId, serverObject) {
                this._this.onAdded(serverId, serverObject);
            };
            ServerObjectController.prototype.onRemoved = function (serverId, serverObject) {
                this._this.onRemoved(serverId, serverObject);
            };
            ServerObjectController.prototype.onUpdated = function (serverId, serverObject) {
                this._this.onUpdated(serverId, serverObject);
            };
            return ServerObjectController;
        })();
        ServerObjects.ServerObjectController = ServerObjectController;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
/// <reference path="../typings/jquery/jquery.d.ts" />
/// <reference path="../kendo/typescript/kendo.all.d.ts" />
var VisualCron;
(function (VisualCron) {
    var TaskGridBaseController = (function () {
        function TaskGridBaseController() {
        }
        TaskGridBaseController.readData = function (eventArg) {
            //read data manual
            //autobind now work fine with group
            var serverId = $(eventArg.masterRow).children(":data(type=serverId)").text();
            var jobId = $(eventArg.masterRow).children(":data(type=jobId)").text();
            var detailGrid = $(eventArg.detailRow).find(".tasksGrid").data("kendoGrid");
            if (detailGrid == null) {
                return;
            }
            var detalrow = $(eventArg.detailRow).find(".tasksGrid");
            detalrow.data("jobId", jobId);
            var optionalData = {
                serverId: serverId,
                jobId: jobId
            };
            if (detailGrid.dataSource != null) {
                detailGrid.dataSource.read(optionalData);
            }
        };
        return TaskGridBaseController;
    })();
    VisualCron.TaskGridBaseController = TaskGridBaseController;
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=TypeScriptOutput.js.map