var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var VisualCron;
(function (VisualCron) {
    var ServerObjects;
    (function (ServerObjects) {
        var UpdatableWindowBase = (function (_super) {
            __extends(UpdatableWindowBase, _super);
            function UpdatableWindowBase() {
                _super.call(this);
            }
            UpdatableWindowBase.prototype.createWindow = function (serverId) {
                var _this = this;
                var data = {
                    serverId: serverId,
                    objectType: this.objectType
                };
                this._addEventHandler();
                var target = this._createElement(); // ReSharper disable UnusedParameter
                //params(resp, text, xreq) need for not to override 'this'
                target.load(this.url, data, function (resp, text, xreq) { return _this._onLoad(); });
                // ReSharper restore UnusedParameter
            };
            UpdatableWindowBase.prototype.onAdded = function (serverId, serverObject) {
                console.log("serverObjectAdded: " + this.objectType);
                this.baseElement.dataSource.read();
                this.baseElement.refresh();
            };
            UpdatableWindowBase.prototype.onRemoved = function (serverId, serverObject) {
                console.log("serverObjectRemoved: " + this.objectType);
                this.baseElement.dataSource.read();
                this.baseElement.refresh();
            };
            UpdatableWindowBase.prototype.onUpdated = function (serverId, serverObject) {
                console.log("serverObjectUpdated: " + this.objectType);
                this.baseElement.dataSource.read();
                this.baseElement.refresh();
            };
            UpdatableWindowBase.prototype._addEventHandler = function () {
                var childElement = $("#win" + this.objectType);
                var serverId = $("#currentServerId").data("currentserverid"); //if event handler was added, not add again
                if (childElement.length > 0) {
                    return;
                }
                window.visualCron.server.addEventHandler(this.objectType, serverId);
            };
            return UpdatableWindowBase;
        })(VisualCron.WindowBase);
        ServerObjects.UpdatableWindowBase = UpdatableWindowBase;
    })(ServerObjects = VisualCron.ServerObjects || (VisualCron.ServerObjects = {}));
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=UpdatableWindowBase.js.map