var VisualCron;
(function (VisualCron) {
    var ui = kendo.ui;
    var WindowBase = (function () {
        function WindowBase() {
            this.window = null;
            this.url = "Not Implemented";
        }
        Object.defineProperty(WindowBase.prototype, "baseElement", {
            get: function () { return $("#" + this.objectType + "Grid").data("kendoGrid"); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WindowBase, "objectType", {
            get: function () { return "Not Implemented"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WindowBase.prototype, "objectType", {
            get: function () { return WindowBase.objectType; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WindowBase.prototype, "title", {
            get: function () { return "Not Implemented"; },
            enumerable: true,
            configurable: true
        });
        WindowBase.prototype.createWindow = function (serverId) {
            var _this = this;
            var data = {
                serverId: serverId,
                objectType: this.objectType
            };
            var target = this._createElement(); // ReSharper disable UnusedParameter
            //params(resp, text, xreq) need for not to override 'this'
            target.load(this.url, data, function (resp, text, xreq) { return _this._onLoad(); });
            // ReSharper restore UnusedParameter
        };
        WindowBase.prototype._createWindow = function (windowParams) {
            var rootElement = $("#root" + this.objectType)[0];
            this.window = new ui.Window(rootElement, windowParams);
            this.window.center();
            $(this.window.element).addClass("resizeble");
            this._setFooter();
        };
        WindowBase.prototype._createElement = function () {
            var root = $("#ServerObjectsRoot");
            var childElement = $("#win" + this.objectType);
            if (childElement.length <= 0) {
                var childHtml = "<div id='win" + this.objectType + "'></div>";
                root.append(childHtml);
                childElement = $("#win" + this.objectType);
            }
            return childElement;
        };
        WindowBase.prototype._onWindowClose = function (ctx, e) {
            var rootObj = $("#root" + this.objectType);
            var parent = rootObj.parents(".k-window");
            //wait for end "close window" animation
            setTimeout(function () { return parent.remove(); }, 300);
        };
        WindowBase.prototype._createWindowsOptions = function () {
            var _this = this;
            var wp = {
                draggable: true,
                modal: true,
                height: 500,
                width: 1000,
                resizable: true,
                close: function (e) {
                    //anonymous function save 'this' context
                    _this._onWindowClose(_this, e);
                }
            };
            return wp;
        };
        WindowBase.prototype._setFooter = function () {
            var footer = $(".status-strip");
            var parent = footer.parents("#root" + this.objectType);
            var isCopy = footer.data("isCopy");
            if (isCopy) {
                return;
            }
            parent.after(footer);
            footer.data("isCopy", true);
        };
        WindowBase.prototype._onLoad = function () {
            var windowParams = this._createWindowsOptions();
            windowParams.title = this.title;
            this._createWindow(windowParams);
        };
        return WindowBase;
    })();
    VisualCron.WindowBase = WindowBase;
})(VisualCron || (VisualCron = {}));
//# sourceMappingURL=WindowBase.js.map