﻿/* START MicrosoftAjax.js */
//----------------------------------------------------------
// Copyright (C) Microsoft Corporation. All rights reserved.
//----------------------------------------------------------
// MicrosoftAjax.js
Function.__typeName = "Function"; Function.__class = true; Function.createCallback = function (b, a) { return function () { var e = arguments.length; if (e > 0) { var d = []; for (var c = 0; c < e; c++) d[c] = arguments[c]; d[e] = a; return b.apply(this, d) } return b.call(this, a) } }; Function.createDelegate = function (a, b) { return function () { return b.apply(a, arguments) } }; Function.emptyFunction = Function.emptyMethod = function () { }; Function.validateParameters = function (c, b, a) { return Function._validateParams(c, b, a) }; Function._validateParams = function (g, e, c) { var a, d = e.length; c = c || typeof c === "undefined"; a = Function._validateParameterCount(g, e, c); if (a) { a.popStackFrame(); return a } for (var b = 0, i = g.length; b < i; b++) { var f = e[Math.min(b, d - 1)], h = f.name; if (f.parameterArray) h += "[" + (b - d + 1) + "]"; else if (!c && b >= d) break; a = Function._validateParameter(g[b], f, h); if (a) { a.popStackFrame(); return a } } return null }; Function._validateParameterCount = function (j, d, i) { var a, c, b = d.length, e = j.length; if (e < b) { var f = b; for (a = 0; a < b; a++) { var g = d[a]; if (g.optional || g.parameterArray) f-- } if (e < f) c = true } else if (i && e > b) { c = true; for (a = 0; a < b; a++) if (d[a].parameterArray) { c = false; break } } if (c) { var h = Error.parameterCount(); h.popStackFrame(); return h } return null }; Function._validateParameter = function (c, a, h) { var b, g = a.type, l = !!a.integer, k = !!a.domElement, m = !!a.mayBeNull; b = Function._validateParameterType(c, g, l, k, m, h); if (b) { b.popStackFrame(); return b } var e = a.elementType, f = !!a.elementMayBeNull; if (g === Array && typeof c !== "undefined" && c !== null && (e || !f)) { var j = !!a.elementInteger, i = !!a.elementDomElement; for (var d = 0; d < c.length; d++) { var n = c[d]; b = Function._validateParameterType(n, e, j, i, f, h + "[" + d + "]"); if (b) { b.popStackFrame(); return b } } } return null }; Function._validateParameterType = function (b, c, k, j, h, d) { var a, g; if (typeof b === "undefined") if (h) return null; else { a = Error.argumentUndefined(d); a.popStackFrame(); return a } if (b === null) if (h) return null; else { a = Error.argumentNull(d); a.popStackFrame(); return a } if (c && c.__enum) { if (typeof b !== "number") { a = Error.argumentType(d, Object.getType(b), c); a.popStackFrame(); return a } if (b % 1 === 0) { var e = c.prototype; if (!c.__flags || b === 0) { for (g in e) if (e[g] === b) return null } else { var i = b; for (g in e) { var f = e[g]; if (f === 0) continue; if ((f & b) === f) i -= f; if (i === 0) return null } } } a = Error.argumentOutOfRange(d, b, String.format(Sys.Res.enumInvalidValue, b, c.getName())); a.popStackFrame(); return a } if (j && (!Sys._isDomElement(b) || b.nodeType === 3)) { a = Error.argument(d, Sys.Res.argumentDomElement); a.popStackFrame(); return a } if (c && !Sys._isInstanceOfType(c, b)) { a = Error.argumentType(d, Object.getType(b), c); a.popStackFrame(); return a } if (c === Number && k) if (b % 1 !== 0) { a = Error.argumentOutOfRange(d, b, Sys.Res.argumentInteger); a.popStackFrame(); return a } return null }; Error.__typeName = "Error"; Error.__class = true; Error.create = function (d, b) { var a = new Error(d); a.message = d; if (b) for (var c in b) a[c] = b[c]; a.popStackFrame(); return a }; Error.argument = function (a, c) { var b = "Sys.ArgumentException: " + (c ? c : Sys.Res.argument); if (a) b += "\n" + String.format(Sys.Res.paramName, a); var d = Error.create(b, { name: "Sys.ArgumentException", paramName: a }); d.popStackFrame(); return d }; Error.argumentNull = function (a, c) { var b = "Sys.ArgumentNullException: " + (c ? c : Sys.Res.argumentNull); if (a) b += "\n" + String.format(Sys.Res.paramName, a); var d = Error.create(b, { name: "Sys.ArgumentNullException", paramName: a }); d.popStackFrame(); return d }; Error.argumentOutOfRange = function (c, a, d) { var b = "Sys.ArgumentOutOfRangeException: " + (d ? d : Sys.Res.argumentOutOfRange); if (c) b += "\n" + String.format(Sys.Res.paramName, c); if (typeof a !== "undefined" && a !== null) b += "\n" + String.format(Sys.Res.actualValue, a); var e = Error.create(b, { name: "Sys.ArgumentOutOfRangeException", paramName: c, actualValue: a }); e.popStackFrame(); return e }; Error.argumentType = function (d, c, b, e) { var a = "Sys.ArgumentTypeException: "; if (e) a += e; else if (c && b) a += String.format(Sys.Res.argumentTypeWithTypes, c.getName(), b.getName()); else a += Sys.Res.argumentType; if (d) a += "\n" + String.format(Sys.Res.paramName, d); var f = Error.create(a, { name: "Sys.ArgumentTypeException", paramName: d, actualType: c, expectedType: b }); f.popStackFrame(); return f }; Error.argumentUndefined = function (a, c) { var b = "Sys.ArgumentUndefinedException: " + (c ? c : Sys.Res.argumentUndefined); if (a) b += "\n" + String.format(Sys.Res.paramName, a); var d = Error.create(b, { name: "Sys.ArgumentUndefinedException", paramName: a }); d.popStackFrame(); return d }; Error.format = function (a) { var c = "Sys.FormatException: " + (a ? a : Sys.Res.format), b = Error.create(c, { name: "Sys.FormatException" }); b.popStackFrame(); return b }; Error.invalidOperation = function (a) { var c = "Sys.InvalidOperationException: " + (a ? a : Sys.Res.invalidOperation), b = Error.create(c, { name: "Sys.InvalidOperationException" }); b.popStackFrame(); return b }; Error.notImplemented = function (a) { var c = "Sys.NotImplementedException: " + (a ? a : Sys.Res.notImplemented), b = Error.create(c, { name: "Sys.NotImplementedException" }); b.popStackFrame(); return b }; Error.parameterCount = function (a) { var c = "Sys.ParameterCountException: " + (a ? a : Sys.Res.parameterCount), b = Error.create(c, { name: "Sys.ParameterCountException" }); b.popStackFrame(); return b }; Error.prototype.popStackFrame = function () { if (typeof this.stack === "undefined" || this.stack === null || typeof this.fileName === "undefined" || this.fileName === null || typeof this.lineNumber === "undefined" || this.lineNumber === null) return; var a = this.stack.split("\n"), c = a[0], e = this.fileName + ":" + this.lineNumber; while (typeof c !== "undefined" && c !== null && c.indexOf(e) === -1) { a.shift(); c = a[0] } var d = a[1]; if (typeof d === "undefined" || d === null) return; var b = d.match(/@(.*):(\d+)$/); if (typeof b === "undefined" || b === null) return; this.fileName = b[1]; this.lineNumber = parseInt(b[2]); a.shift(); this.stack = a.join("\n") }; Object.__typeName = "Object"; Object.__class = true; Object.getType = function (b) { var a = b.constructor; if (!a || typeof a !== "function" || !a.__typeName || a.__typeName === "Object") return Object; return a }; Object.getTypeName = function (a) { return Object.getType(a).getName() }; String.__typeName = "String"; String.__class = true; String.prototype.endsWith = function (a) { return this.substr(this.length - a.length) === a }; String.prototype.startsWith = function (a) { return this.substr(0, a.length) === a }; String.prototype.trim = function () { return this.replace(/^\s+|\s+$/g, "") }; String.prototype.trimEnd = function () { return this.replace(/\s+$/, "") }; String.prototype.trimStart = function () { return this.replace(/^\s+/, "") }; String.format = function () { return String._toFormattedString(false, arguments) }; String._toFormattedString = function (l, j) { var c = "", e = j[0]; for (var a = 0; true;) { var f = e.indexOf("{", a), d = e.indexOf("}", a); if (f < 0 && d < 0) { c += e.slice(a); break } if (d > 0 && (d < f || f < 0)) { c += e.slice(a, d + 1); a = d + 2; continue } c += e.slice(a, f); a = f + 1; if (e.charAt(a) === "{") { c += "{"; a++; continue } if (d < 0) break; var h = e.substring(a, d), g = h.indexOf(":"), k = parseInt(g < 0 ? h : h.substring(0, g), 10) + 1, i = g < 0 ? "" : h.substring(g + 1), b = j[k]; if (typeof b === "undefined" || b === null) b = ""; if (b.toFormattedString) c += b.toFormattedString(i); else if (l && b.localeFormat) c += b.localeFormat(i); else if (b.format) c += b.format(i); else c += b.toString(); a = d + 1 } return c }; Boolean.__typeName = "Boolean"; Boolean.__class = true; Boolean.parse = function (b) { var a = b.trim().toLowerCase(); if (a === "false") return false; if (a === "true") return true }; Date.__typeName = "Date"; Date.__class = true; Number.__typeName = "Number"; Number.__class = true; RegExp.__typeName = "RegExp"; RegExp.__class = true; if (!window) this.window = this; window.Type = Function; Type.prototype.callBaseMethod = function (a, d, b) { var c = Sys._getBaseMethod(this, a, d); if (!b) return c.apply(a); else return c.apply(a, b) }; Type.prototype.getBaseMethod = function (a, b) { return Sys._getBaseMethod(this, a, b) }; Type.prototype.getBaseType = function () { return typeof this.__baseType === "undefined" ? null : this.__baseType }; Type.prototype.getInterfaces = function () { var a = [], b = this; while (b) { var c = b.__interfaces; if (c) for (var d = 0, f = c.length; d < f; d++) { var e = c[d]; if (!Array.contains(a, e)) a[a.length] = e } b = b.__baseType } return a }; Type.prototype.getName = function () { return typeof this.__typeName === "undefined" ? "" : this.__typeName }; Type.prototype.implementsInterface = function (d) { this.resolveInheritance(); var c = d.getName(), a = this.__interfaceCache; if (a) { var e = a[c]; if (typeof e !== "undefined") return e } else a = this.__interfaceCache = {}; var b = this; while (b) { var f = b.__interfaces; if (f) if (Array.indexOf(f, d) !== -1) return a[c] = true; b = b.__baseType } return a[c] = false }; Type.prototype.inheritsFrom = function (b) { this.resolveInheritance(); var a = this.__baseType; while (a) { if (a === b) return true; a = a.__baseType } return false }; Type.prototype.initializeBase = function (a, b) { this.resolveInheritance(); if (this.__baseType) if (!b) this.__baseType.apply(a); else this.__baseType.apply(a, b); return a }; Type.prototype.isImplementedBy = function (a) { if (typeof a === "undefined" || a === null) return false; var b = Object.getType(a); return !!(b.implementsInterface && b.implementsInterface(this)) }; Type.prototype.isInstanceOfType = function (a) { return Sys._isInstanceOfType(this, a) }; Type.prototype.registerClass = function (c, b, d) { this.prototype.constructor = this; this.__typeName = c; this.__class = true; if (b) { this.__baseType = b; this.__basePrototypePending = true } Sys.__upperCaseTypes[c.toUpperCase()] = this; if (d) { this.__interfaces = []; for (var a = 2, f = arguments.length; a < f; a++) { var e = arguments[a]; this.__interfaces.push(e) } } return this }; Type.prototype.registerInterface = function (a) { Sys.__upperCaseTypes[a.toUpperCase()] = this; this.prototype.constructor = this; this.__typeName = a; this.__interface = true; return this }; Type.prototype.resolveInheritance = function () { if (this.__basePrototypePending) { var b = this.__baseType; b.resolveInheritance(); for (var a in b.prototype) { var c = b.prototype[a]; if (!this.prototype[a]) this.prototype[a] = c } delete this.__basePrototypePending } }; Type.getRootNamespaces = function () { return Array.clone(Sys.__rootNamespaces) }; Type.isClass = function (a) { if (typeof a === "undefined" || a === null) return false; return !!a.__class }; Type.isInterface = function (a) { if (typeof a === "undefined" || a === null) return false; return !!a.__interface }; Type.isNamespace = function (a) { if (typeof a === "undefined" || a === null) return false; return !!a.__namespace }; Type.parse = function (typeName, ns) { var fn; if (ns) { fn = Sys.__upperCaseTypes[ns.getName().toUpperCase() + "." + typeName.toUpperCase()]; return fn || null } if (!typeName) return null; if (!Type.__htClasses) Type.__htClasses = {}; fn = Type.__htClasses[typeName]; if (!fn) { fn = eval(typeName); Type.__htClasses[typeName] = fn } return fn }; Type.registerNamespace = function (e) { var d = window, c = e.split("."); for (var b = 0; b < c.length; b++) { var f = c[b], a = d[f]; if (!a) a = d[f] = {}; if (!a.__namespace) { if (b === 0 && e !== "Sys") Sys.__rootNamespaces[Sys.__rootNamespaces.length] = a; a.__namespace = true; a.__typeName = c.slice(0, b + 1).join("."); a.getName = function () { return this.__typeName } } d = a } }; Type._checkDependency = function (c, a) { var d = Type._registerScript._scripts, b = d ? !!d[c] : false; if (typeof a !== "undefined" && !b) throw Error.invalidOperation(String.format(Sys.Res.requiredScriptReferenceNotIncluded, a, c)); return b }; Type._registerScript = function (a, c) { var b = Type._registerScript._scripts; if (!b) Type._registerScript._scripts = b = {}; if (b[a]) throw Error.invalidOperation(String.format(Sys.Res.scriptAlreadyLoaded, a)); b[a] = true; if (c) for (var d = 0, f = c.length; d < f; d++) { var e = c[d]; if (!Type._checkDependency(e)) throw Error.invalidOperation(String.format(Sys.Res.scriptDependencyNotFound, a, e)) } }; Type.registerNamespace("Sys"); Sys.__upperCaseTypes = {}; Sys.__rootNamespaces = [Sys]; Sys._isInstanceOfType = function (c, b) { if (typeof b === "undefined" || b === null) return false; if (b instanceof c) return true; var a = Object.getType(b); return !!(a === c) || a.inheritsFrom && a.inheritsFrom(c) || a.implementsInterface && a.implementsInterface(c) }; Sys._getBaseMethod = function (d, e, c) { var b = d.getBaseType(); if (b) { var a = b.prototype[c]; return a instanceof Function ? a : null } return null }; Sys._isDomElement = function (a) { var c = false; if (typeof a.nodeType !== "number") { var b = a.ownerDocument || a.document || a; if (b != a) { var d = b.defaultView || b.parentWindow; c = d != a } else c = typeof b.body === "undefined" } return !c }; Array.__typeName = "Array"; Array.__class = true; Array.add = Array.enqueue = function (a, b) { a[a.length] = b }; Array.addRange = function (a, b) { a.push.apply(a, b) }; Array.clear = function (a) { a.length = 0 }; Array.clone = function (a) { if (a.length === 1) return [a[0]]; else return Array.apply(null, a) }; Array.contains = function (a, b) { return Sys._indexOf(a, b) >= 0 }; Array.dequeue = function (a) { return a.shift() }; Array.forEach = function (b, e, d) { for (var a = 0, f = b.length; a < f; a++) { var c = b[a]; if (typeof c !== "undefined") e.call(d, c, a, b) } }; Array.indexOf = function (a, c, b) { return Sys._indexOf(a, c, b) }; Array.insert = function (a, b, c) { a.splice(b, 0, c) }; Array.parse = function (value) { if (!value) return []; return eval(value) }; Array.remove = function (b, c) { var a = Sys._indexOf(b, c); if (a >= 0) b.splice(a, 1); return a >= 0 }; Array.removeAt = function (a, b) { a.splice(b, 1) }; Sys._indexOf = function (d, e, a) { if (typeof e === "undefined") return -1; var c = d.length; if (c !== 0) { a = a - 0; if (isNaN(a)) a = 0; else { if (isFinite(a)) a = a - a % 1; if (a < 0) a = Math.max(0, c + a) } for (var b = a; b < c; b++) if (typeof d[b] !== "undefined" && d[b] === e) return b } return -1 }; Type._registerScript._scripts = { "MicrosoftAjaxCore.js": true, "MicrosoftAjaxGlobalization.js": true, "MicrosoftAjaxSerialization.js": true, "MicrosoftAjaxComponentModel.js": true, "MicrosoftAjaxHistory.js": true, "MicrosoftAjaxNetwork.js": true, "MicrosoftAjaxWebServices.js": true }; Sys.IDisposable = function () { }; Sys.IDisposable.prototype = {}; Sys.IDisposable.registerInterface("Sys.IDisposable"); Sys.StringBuilder = function (a) { this._parts = typeof a !== "undefined" && a !== null && a !== "" ? [a.toString()] : []; this._value = {}; this._len = 0 }; Sys.StringBuilder.prototype = { append: function (a) { this._parts[this._parts.length] = a }, appendLine: function (a) { this._parts[this._parts.length] = typeof a === "undefined" || a === null || a === "" ? "\r\n" : a + "\r\n" }, clear: function () { this._parts = []; this._value = {}; this._len = 0 }, isEmpty: function () { if (this._parts.length === 0) return true; return this.toString() === "" }, toString: function (a) { a = a || ""; var b = this._parts; if (this._len !== b.length) { this._value = {}; this._len = b.length } var d = this._value; if (typeof d[a] === "undefined") { if (a !== "") for (var c = 0; c < b.length;) if (typeof b[c] === "undefined" || b[c] === "" || b[c] === null) b.splice(c, 1); else c++; d[a] = this._parts.join(a) } return d[a] } }; Sys.StringBuilder.registerClass("Sys.StringBuilder"); Sys.Browser = {}; Sys.Browser.InternetExplorer = {}; Sys.Browser.Firefox = {}; Sys.Browser.Safari = {}; Sys.Browser.Opera = {}; Sys.Browser.agent = null; Sys.Browser.hasDebuggerStatement = false; Sys.Browser.name = navigator.appName; Sys.Browser.version = parseFloat(navigator.appVersion); Sys.Browser.documentMode = 0; if (navigator.userAgent.indexOf(" MSIE ") > -1) { Sys.Browser.agent = Sys.Browser.InternetExplorer; Sys.Browser.version = parseFloat(navigator.userAgent.match(/MSIE (\d+\.\d+)/)[1]); if (Sys.Browser.version >= 8) if (document.documentMode >= 7) Sys.Browser.documentMode = document.documentMode; Sys.Browser.hasDebuggerStatement = true } else if (navigator.userAgent.indexOf(" Firefox/") > -1) { Sys.Browser.agent = Sys.Browser.Firefox; Sys.Browser.version = parseFloat(navigator.userAgent.match(/Firefox\/(\d+\.\d+)/)[1]); Sys.Browser.name = "Firefox"; Sys.Browser.hasDebuggerStatement = true } else if (navigator.userAgent.indexOf(" AppleWebKit/") > -1) { Sys.Browser.agent = Sys.Browser.Safari; Sys.Browser.version = parseFloat(navigator.userAgent.match(/AppleWebKit\/(\d+(\.\d+)?)/)[1]); Sys.Browser.name = "Safari" } else if (navigator.userAgent.indexOf("Opera/") > -1) Sys.Browser.agent = Sys.Browser.Opera; Sys.EventArgs = function () { }; Sys.EventArgs.registerClass("Sys.EventArgs"); Sys.EventArgs.Empty = new Sys.EventArgs; Sys.CancelEventArgs = function () { Sys.CancelEventArgs.initializeBase(this); this._cancel = false }; Sys.CancelEventArgs.prototype = { get_cancel: function () { return this._cancel }, set_cancel: function (a) { this._cancel = a } }; Sys.CancelEventArgs.registerClass("Sys.CancelEventArgs", Sys.EventArgs); Type.registerNamespace("Sys.UI"); Sys._Debug = function () { }; Sys._Debug.prototype = { _appendConsole: function (a) { if (typeof Debug !== "undefined" && Debug.writeln) Debug.writeln(a); if (window.console && window.console.log) window.console.log(a); if (window.opera) window.opera.postError(a); if (window.debugService) window.debugService.trace(a) }, _appendTrace: function (b) { var a = document.getElementById("TraceConsole"); if (a && a.tagName.toUpperCase() === "TEXTAREA") a.value += b + "\n" }, assert: function (c, a, b) { if (!c) { a = b && this.assert.caller ? String.format(Sys.Res.assertFailedCaller, a, this.assert.caller) : String.format(Sys.Res.assertFailed, a); if (confirm(String.format(Sys.Res.breakIntoDebugger, a))) this.fail(a) } }, clearTrace: function () { var a = document.getElementById("TraceConsole"); if (a && a.tagName.toUpperCase() === "TEXTAREA") a.value = "" }, fail: function (message) { this._appendConsole(message); if (Sys.Browser.hasDebuggerStatement) eval("debugger") }, trace: function (a) { this._appendConsole(a); this._appendTrace(a) }, traceDump: function (a, b) { var c = this._traceDump(a, b, true) }, _traceDump: function (a, c, f, b, d) { c = c ? c : "traceDump"; b = b ? b : ""; if (a === null) { this.trace(b + c + ": null"); return } switch (typeof a) { case "undefined": this.trace(b + c + ": Undefined"); break; case "number": case "string": case "boolean": this.trace(b + c + ": " + a); break; default: if (Date.isInstanceOfType(a) || RegExp.isInstanceOfType(a)) { this.trace(b + c + ": " + a.toString()); break } if (!d) d = []; else if (Array.contains(d, a)) { this.trace(b + c + ": ..."); return } Array.add(d, a); if (a == window || a === document || window.HTMLElement && a instanceof HTMLElement || typeof a.nodeName === "string") { var k = a.tagName ? a.tagName : "DomElement"; if (a.id) k += " - " + a.id; this.trace(b + c + " {" + k + "}") } else { var i = Object.getTypeName(a); this.trace(b + c + (typeof i === "string" ? " {" + i + "}" : "")); if (b === "" || f) { b += "    "; var e, j, l, g, h; if (Array.isInstanceOfType(a)) { j = a.length; for (e = 0; e < j; e++) this._traceDump(a[e], "[" + e + "]", f, b, d) } else for (g in a) { h = a[g]; if (!Function.isInstanceOfType(h)) this._traceDump(h, g, f, b, d) } } } Array.remove(d, a) } } }; Sys._Debug.registerClass("Sys._Debug"); Sys.Debug = new Sys._Debug; Sys.Debug.isDebug = false; function Sys$Enum$parse(c, e) { var a, b, i; if (e) { a = this.__lowerCaseValues; if (!a) { this.__lowerCaseValues = a = {}; var g = this.prototype; for (var f in g) a[f.toLowerCase()] = g[f] } } else a = this.prototype; if (!this.__flags) { i = e ? c.toLowerCase() : c; b = a[i.trim()]; if (typeof b !== "number") throw Error.argument("value", String.format(Sys.Res.enumInvalidValue, c, this.__typeName)); return b } else { var h = (e ? c.toLowerCase() : c).split(","), j = 0; for (var d = h.length - 1; d >= 0; d--) { var k = h[d].trim(); b = a[k]; if (typeof b !== "number") throw Error.argument("value", String.format(Sys.Res.enumInvalidValue, c.split(",")[d].trim(), this.__typeName)); j |= b } return j } } function Sys$Enum$toString(c) { if (typeof c === "undefined" || c === null) return this.__string; var d = this.prototype, a; if (!this.__flags || c === 0) { for (a in d) if (d[a] === c) return a } else { var b = this.__sortedValues; if (!b) { b = []; for (a in d) b[b.length] = { key: a, value: d[a] }; b.sort(function (a, b) { return a.value - b.value }); this.__sortedValues = b } var e = [], g = c; for (a = b.length - 1; a >= 0; a--) { var h = b[a], f = h.value; if (f === 0) continue; if ((f & c) === f) { e[e.length] = h.key; g -= f; if (g === 0) break } } if (e.length && g === 0) return e.reverse().join(", ") } return "" } Type.prototype.registerEnum = function (b, c) { Sys.__upperCaseTypes[b.toUpperCase()] = this; for (var a in this.prototype) this[a] = this.prototype[a]; this.__typeName = b; this.parse = Sys$Enum$parse; this.__string = this.toString(); this.toString = Sys$Enum$toString; this.__flags = c; this.__enum = true }; Type.isEnum = function (a) { if (typeof a === "undefined" || a === null) return false; return !!a.__enum }; Type.isFlags = function (a) { if (typeof a === "undefined" || a === null) return false; return !!a.__flags }; Sys.CollectionChange = function (e, a, c, b, d) { this.action = e; if (a) if (!(a instanceof Array)) a = [a]; this.newItems = a || null; if (typeof c !== "number") c = -1; this.newStartingIndex = c; if (b) if (!(b instanceof Array)) b = [b]; this.oldItems = b || null; if (typeof d !== "number") d = -1; this.oldStartingIndex = d }; Sys.CollectionChange.registerClass("Sys.CollectionChange"); Sys.NotifyCollectionChangedAction = function () { throw Error.notImplemented() }; Sys.NotifyCollectionChangedAction.prototype = { add: 0, remove: 1, reset: 2 }; Sys.NotifyCollectionChangedAction.registerEnum("Sys.NotifyCollectionChangedAction"); Sys.NotifyCollectionChangedEventArgs = function (a) { this._changes = a; Sys.NotifyCollectionChangedEventArgs.initializeBase(this) }; Sys.NotifyCollectionChangedEventArgs.prototype = { get_changes: function () { return this._changes || [] } }; Sys.NotifyCollectionChangedEventArgs.registerClass("Sys.NotifyCollectionChangedEventArgs", Sys.EventArgs); Sys.Observer = function () { }; Sys.Observer.registerClass("Sys.Observer"); Sys.Observer.makeObservable = function (a) { var c = a instanceof Array, b = Sys.Observer; if (a.setValue === b._observeMethods.setValue) return a; b._addMethods(a, b._observeMethods); if (c) b._addMethods(a, b._arrayMethods); return a }; Sys.Observer._addMethods = function (c, b) { for (var a in b) c[a] = b[a] }; Sys.Observer._addEventHandler = function (c, a, b) { Sys.Observer._getContext(c, true).events._addHandler(a, b) }; Sys.Observer.addEventHandler = function (c, a, b) { Sys.Observer._addEventHandler(c, a, b) }; Sys.Observer._removeEventHandler = function (c, a, b) { Sys.Observer._getContext(c, true).events._removeHandler(a, b) }; Sys.Observer.removeEventHandler = function (c, a, b) { Sys.Observer._removeEventHandler(c, a, b) }; Sys.Observer.raiseEvent = function (b, e, d) { var c = Sys.Observer._getContext(b); if (!c) return; var a = c.events.getHandler(e); if (a) a(b, d) }; Sys.Observer.addPropertyChanged = function (b, a) { Sys.Observer._addEventHandler(b, "propertyChanged", a) }; Sys.Observer.removePropertyChanged = function (b, a) { Sys.Observer._removeEventHandler(b, "propertyChanged", a) }; Sys.Observer.beginUpdate = function (a) { Sys.Observer._getContext(a, true).updating = true }; Sys.Observer.endUpdate = function (b) { var a = Sys.Observer._getContext(b); if (!a || !a.updating) return; a.updating = false; var d = a.dirty; a.dirty = false; if (d) { if (b instanceof Array) { var c = a.changes; a.changes = null; Sys.Observer.raiseCollectionChanged(b, c) } Sys.Observer.raisePropertyChanged(b, "") } }; Sys.Observer.isUpdating = function (b) { var a = Sys.Observer._getContext(b); return a ? a.updating : false }; Sys.Observer._setValue = function (a, j, g) { var b, f, k = a, d = j.split("."); for (var i = 0, m = d.length - 1; i < m; i++) { var l = d[i]; b = a["get_" + l]; if (typeof b === "function") a = b.call(a); else a = a[l]; var n = typeof a; if (a === null || n === "undefined") throw Error.invalidOperation(String.format(Sys.Res.nullReferenceInPath, j)) } var e, c = d[m]; b = a["get_" + c]; f = a["set_" + c]; if (typeof b === "function") e = b.call(a); else e = a[c]; if (typeof f === "function") f.call(a, g); else a[c] = g; if (e !== g) { var h = Sys.Observer._getContext(k); if (h && h.updating) { h.dirty = true; return } Sys.Observer.raisePropertyChanged(k, d[0]) } }; Sys.Observer.setValue = function (b, a, c) { Sys.Observer._setValue(b, a, c) }; Sys.Observer.raisePropertyChanged = function (b, a) { Sys.Observer.raiseEvent(b, "propertyChanged", new Sys.PropertyChangedEventArgs(a)) }; Sys.Observer.addCollectionChanged = function (b, a) { Sys.Observer._addEventHandler(b, "collectionChanged", a) }; Sys.Observer.removeCollectionChanged = function (b, a) { Sys.Observer._removeEventHandler(b, "collectionChanged", a) }; Sys.Observer._collectionChange = function (d, c) { var a = Sys.Observer._getContext(d); if (a && a.updating) { a.dirty = true; var b = a.changes; if (!b) a.changes = b = [c]; else b.push(c) } else { Sys.Observer.raiseCollectionChanged(d, [c]); Sys.Observer.raisePropertyChanged(d, "length") } }; Sys.Observer.add = function (a, b) { var c = new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.add, [b], a.length); Array.add(a, b); Sys.Observer._collectionChange(a, c) }; Sys.Observer.addRange = function (a, b) { var c = new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.add, b, a.length); Array.addRange(a, b); Sys.Observer._collectionChange(a, c) }; Sys.Observer.clear = function (a) { var b = Array.clone(a); Array.clear(a); Sys.Observer._collectionChange(a, new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.reset, null, -1, b, 0)) }; Sys.Observer.insert = function (a, b, c) { Array.insert(a, b, c); Sys.Observer._collectionChange(a, new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.add, [c], b)) }; Sys.Observer.remove = function (a, b) { var c = Array.indexOf(a, b); if (c !== -1) { Array.remove(a, b); Sys.Observer._collectionChange(a, new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.remove, null, -1, [b], c)); return true } return false }; Sys.Observer.removeAt = function (b, a) { if (a > -1 && a < b.length) { var c = b[a]; Array.removeAt(b, a); Sys.Observer._collectionChange(b, new Sys.CollectionChange(Sys.NotifyCollectionChangedAction.remove, null, -1, [c], a)) } }; Sys.Observer.raiseCollectionChanged = function (b, a) { Sys.Observer.raiseEvent(b, "collectionChanged", new Sys.NotifyCollectionChangedEventArgs(a)) }; Sys.Observer._observeMethods = { add_propertyChanged: function (a) { Sys.Observer._addEventHandler(this, "propertyChanged", a) }, remove_propertyChanged: function (a) { Sys.Observer._removeEventHandler(this, "propertyChanged", a) }, addEventHandler: function (a, b) { Sys.Observer._addEventHandler(this, a, b) }, removeEventHandler: function (a, b) { Sys.Observer._removeEventHandler(this, a, b) }, get_isUpdating: function () { return Sys.Observer.isUpdating(this) }, beginUpdate: function () { Sys.Observer.beginUpdate(this) }, endUpdate: function () { Sys.Observer.endUpdate(this) }, setValue: function (b, a) { Sys.Observer._setValue(this, b, a) }, raiseEvent: function (b, a) { Sys.Observer.raiseEvent(this, b, a) }, raisePropertyChanged: function (a) { Sys.Observer.raiseEvent(this, "propertyChanged", new Sys.PropertyChangedEventArgs(a)) } }; Sys.Observer._arrayMethods = { add_collectionChanged: function (a) { Sys.Observer._addEventHandler(this, "collectionChanged", a) }, remove_collectionChanged: function (a) { Sys.Observer._removeEventHandler(this, "collectionChanged", a) }, add: function (a) { Sys.Observer.add(this, a) }, addRange: function (a) { Sys.Observer.addRange(this, a) }, clear: function () { Sys.Observer.clear(this) }, insert: function (a, b) { Sys.Observer.insert(this, a, b) }, remove: function (a) { return Sys.Observer.remove(this, a) }, removeAt: function (a) { Sys.Observer.removeAt(this, a) }, raiseCollectionChanged: function (a) { Sys.Observer.raiseEvent(this, "collectionChanged", new Sys.NotifyCollectionChangedEventArgs(a)) } }; Sys.Observer._getContext = function (b, c) { var a = b._observerContext; if (a) return a(); if (c) return (b._observerContext = Sys.Observer._createContext())(); return null }; Sys.Observer._createContext = function () { var a = { events: new Sys.EventHandlerList }; return function () { return a } }; Date._appendPreOrPostMatch = function (e, b) { var d = 0, a = false; for (var c = 0, g = e.length; c < g; c++) { var f = e.charAt(c); switch (f) { case "'": if (a) b.append("'"); else d++; a = false; break; case "\\": if (a) b.append("\\"); a = !a; break; default: b.append(f); a = false } } return d }; Date._expandFormat = function (a, b) { if (!b) b = "F"; var c = b.length; if (c === 1) switch (b) { case "d": return a.ShortDatePattern; case "D": return a.LongDatePattern; case "t": return a.ShortTimePattern; case "T": return a.LongTimePattern; case "f": return a.LongDatePattern + " " + a.ShortTimePattern; case "F": return a.FullDateTimePattern; case "M": case "m": return a.MonthDayPattern; case "s": return a.SortableDateTimePattern; case "Y": case "y": return a.YearMonthPattern; default: throw Error.format(Sys.Res.formatInvalidString) } else if (c === 2 && b.charAt(0) === "%") b = b.charAt(1); return b }; Date._expandYear = function (c, a) { var d = new Date, e = Date._getEra(d); if (a < 100) { var b = Date._getEraYear(d, c, e); a += b - b % 100; if (a > c.Calendar.TwoDigitYearMax) a -= 100 } return a }; Date._getEra = function (e, c) { if (!c) return 0; var b, d = e.getTime(); for (var a = 0, f = c.length; a < f; a += 4) { b = c[a + 2]; if (b === null || d >= b) return a } return 0 }; Date._getEraYear = function (d, b, e, c) { var a = d.getFullYear(); if (!c && b.eras) a -= b.eras[e + 3]; return a }; Date._getParseRegExp = function (b, e) { if (!b._parseRegExp) b._parseRegExp = {}; else if (b._parseRegExp[e]) return b._parseRegExp[e]; var c = Date._expandFormat(b, e); c = c.replace(/([\^\$\.\*\+\?\|\[\]\(\)\{\}])/g, "\\\\$1"); var a = new Sys.StringBuilder("^"), j = [], f = 0, i = 0, h = Date._getTokenRegExp(), d; while ((d = h.exec(c)) !== null) { var l = c.slice(f, d.index); f = h.lastIndex; i += Date._appendPreOrPostMatch(l, a); if (i % 2 === 1) { a.append(d[0]); continue } switch (d[0]) { case "dddd": case "ddd": case "MMMM": case "MMM": case "gg": case "g": a.append("(\\D+)"); break; case "tt": case "t": a.append("(\\D*)"); break; case "yyyy": a.append("(\\d{4})"); break; case "fff": a.append("(\\d{3})"); break; case "ff": a.append("(\\d{2})"); break; case "f": a.append("(\\d)"); break; case "dd": case "d": case "MM": case "M": case "yy": case "y": case "HH": case "H": case "hh": case "h": case "mm": case "m": case "ss": case "s": a.append("(\\d\\d?)"); break; case "zzz": a.append("([+-]?\\d\\d?:\\d{2})"); break; case "zz": case "z": a.append("([+-]?\\d\\d?)"); break; case "/": a.append("(\\" + b.DateSeparator + ")") } Array.add(j, d[0]) } Date._appendPreOrPostMatch(c.slice(f), a); a.append("$"); var k = a.toString().replace(/\s+/g, "\\s+"), g = { "regExp": k, "groups": j }; b._parseRegExp[e] = g; return g }; Date._getTokenRegExp = function () { return /\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g }; Date.parseLocale = function (a) { return Date._parse(a, Sys.CultureInfo.CurrentCulture, arguments) }; Date.parseInvariant = function (a) { return Date._parse(a, Sys.CultureInfo.InvariantCulture, arguments) }; Date._parse = function (h, d, i) { var a, c, b, f, e, g = false; for (a = 1, c = i.length; a < c; a++) { f = i[a]; if (f) { g = true; b = Date._parseExact(h, f, d); if (b) return b } } if (!g) { e = d._getDateTimeFormats(); for (a = 0, c = e.length; a < c; a++) { b = Date._parseExact(h, e[a], d); if (b) return b } } return null }; Date._parseExact = function (w, D, k) { w = w.trim(); var g = k.dateTimeFormat, A = Date._getParseRegExp(g, D), C = (new RegExp(A.regExp)).exec(w); if (C === null) return null; var B = A.groups, x = null, e = null, c = null, j = null, i = null, d = 0, h, p = 0, q = 0, f = 0, l = null, v = false; for (var s = 0, E = B.length; s < E; s++) { var a = C[s + 1]; if (a) switch (B[s]) { case "dd": case "d": j = parseInt(a, 10); if (j < 1 || j > 31) return null; break; case "MMMM": c = k._getMonthIndex(a); if (c < 0 || c > 11) return null; break; case "MMM": c = k._getAbbrMonthIndex(a); if (c < 0 || c > 11) return null; break; case "M": case "MM": c = parseInt(a, 10) - 1; if (c < 0 || c > 11) return null; break; case "y": case "yy": e = Date._expandYear(g, parseInt(a, 10)); if (e < 0 || e > 9999) return null; break; case "yyyy": e = parseInt(a, 10); if (e < 0 || e > 9999) return null; break; case "h": case "hh": d = parseInt(a, 10); if (d === 12) d = 0; if (d < 0 || d > 11) return null; break; case "H": case "HH": d = parseInt(a, 10); if (d < 0 || d > 23) return null; break; case "m": case "mm": p = parseInt(a, 10); if (p < 0 || p > 59) return null; break; case "s": case "ss": q = parseInt(a, 10); if (q < 0 || q > 59) return null; break; case "tt": case "t": var z = a.toUpperCase(); v = z === g.PMDesignator.toUpperCase(); if (!v && z !== g.AMDesignator.toUpperCase()) return null; break; case "f": f = parseInt(a, 10) * 100; if (f < 0 || f > 999) return null; break; case "ff": f = parseInt(a, 10) * 10; if (f < 0 || f > 999) return null; break; case "fff": f = parseInt(a, 10); if (f < 0 || f > 999) return null; break; case "dddd": i = k._getDayIndex(a); if (i < 0 || i > 6) return null; break; case "ddd": i = k._getAbbrDayIndex(a); if (i < 0 || i > 6) return null; break; case "zzz": var u = a.split(/:/); if (u.length !== 2) return null; h = parseInt(u[0], 10); if (h < -12 || h > 13) return null; var m = parseInt(u[1], 10); if (m < 0 || m > 59) return null; l = h * 60 + (a.startsWith("-") ? -m : m); break; case "z": case "zz": h = parseInt(a, 10); if (h < -12 || h > 13) return null; l = h * 60; break; case "g": case "gg": var o = a; if (!o || !g.eras) return null; o = o.toLowerCase().trim(); for (var r = 0, F = g.eras.length; r < F; r += 4) if (o === g.eras[r + 1].toLowerCase()) { x = r; break } if (x === null) return null } } var b = new Date, t, n = g.Calendar.convert; if (n) t = n.fromGregorian(b)[0]; else t = b.getFullYear(); if (e === null) e = t; else if (g.eras) e += g.eras[(x || 0) + 3]; if (c === null) c = 0; if (j === null) j = 1; if (n) { b = n.toGregorian(e, c, j); if (b === null) return null } else { b.setFullYear(e, c, j); if (b.getDate() !== j) return null; if (i !== null && b.getDay() !== i) return null } if (v && d < 12) d += 12; b.setHours(d, p, q, f); if (l !== null) { var y = b.getMinutes() - (l + b.getTimezoneOffset()); b.setHours(b.getHours() + parseInt(y / 60, 10), y % 60) } return b }; Date.prototype.format = function (a) { return this._toFormattedString(a, Sys.CultureInfo.InvariantCulture) }; Date.prototype.localeFormat = function (a) { return this._toFormattedString(a, Sys.CultureInfo.CurrentCulture) }; Date.prototype._toFormattedString = function (e, j) { var b = j.dateTimeFormat, n = b.Calendar.convert; if (!e || !e.length || e === "i") if (j && j.name.length) if (n) return this._toFormattedString(b.FullDateTimePattern, j); else { var r = new Date(this.getTime()), x = Date._getEra(this, b.eras); r.setFullYear(Date._getEraYear(this, b, x)); return r.toLocaleString() } else return this.toString(); var l = b.eras, k = e === "s"; e = Date._expandFormat(b, e); var a = new Sys.StringBuilder, c; function d(a) { if (a < 10) return "0" + a; return a.toString() } function m(a) { if (a < 10) return "00" + a; if (a < 100) return "0" + a; return a.toString() } function v(a) { if (a < 10) return "000" + a; else if (a < 100) return "00" + a; else if (a < 1000) return "0" + a; return a.toString() } var h, p, t = /([^d]|^)(d|dd)([^d]|$)/g; function s() { if (h || p) return h; h = t.test(e); p = true; return h } var q = 0, o = Date._getTokenRegExp(), f; if (!k && n) f = n.fromGregorian(this); for (; true;) { var w = o.lastIndex, i = o.exec(e), u = e.slice(w, i ? i.index : e.length); q += Date._appendPreOrPostMatch(u, a); if (!i) break; if (q % 2 === 1) { a.append(i[0]); continue } function g(a, b) { if (f) return f[b]; switch (b) { case 0: return a.getFullYear(); case 1: return a.getMonth(); case 2: return a.getDate() } } switch (i[0]) { case "dddd": a.append(b.DayNames[this.getDay()]); break; case "ddd": a.append(b.AbbreviatedDayNames[this.getDay()]); break; case "dd": h = true; a.append(d(g(this, 2))); break; case "d": h = true; a.append(g(this, 2)); break; case "MMMM": a.append(b.MonthGenitiveNames && s() ? b.MonthGenitiveNames[g(this, 1)] : b.MonthNames[g(this, 1)]); break; case "MMM": a.append(b.AbbreviatedMonthGenitiveNames && s() ? b.AbbreviatedMonthGenitiveNames[g(this, 1)] : b.AbbreviatedMonthNames[g(this, 1)]); break; case "MM": a.append(d(g(this, 1) + 1)); break; case "M": a.append(g(this, 1) + 1); break; case "yyyy": a.append(v(f ? f[0] : Date._getEraYear(this, b, Date._getEra(this, l), k))); break; case "yy": a.append(d((f ? f[0] : Date._getEraYear(this, b, Date._getEra(this, l), k)) % 100)); break; case "y": a.append((f ? f[0] : Date._getEraYear(this, b, Date._getEra(this, l), k)) % 100); break; case "hh": c = this.getHours() % 12; if (c === 0) c = 12; a.append(d(c)); break; case "h": c = this.getHours() % 12; if (c === 0) c = 12; a.append(c); break; case "HH": a.append(d(this.getHours())); break; case "H": a.append(this.getHours()); break; case "mm": a.append(d(this.getMinutes())); break; case "m": a.append(this.getMinutes()); break; case "ss": a.append(d(this.getSeconds())); break; case "s": a.append(this.getSeconds()); break; case "tt": a.append(this.getHours() < 12 ? b.AMDesignator : b.PMDesignator); break; case "t": a.append((this.getHours() < 12 ? b.AMDesignator : b.PMDesignator).charAt(0)); break; case "f": a.append(m(this.getMilliseconds()).charAt(0)); break; case "ff": a.append(m(this.getMilliseconds()).substr(0, 2)); break; case "fff": a.append(m(this.getMilliseconds())); break; case "z": c = this.getTimezoneOffset() / 60; a.append((c <= 0 ? "+" : "-") + Math.floor(Math.abs(c))); break; case "zz": c = this.getTimezoneOffset() / 60; a.append((c <= 0 ? "+" : "-") + d(Math.floor(Math.abs(c)))); break; case "zzz": c = this.getTimezoneOffset() / 60; a.append((c <= 0 ? "+" : "-") + d(Math.floor(Math.abs(c))) + ":" + d(Math.abs(this.getTimezoneOffset() % 60))); break; case "g": case "gg": if (b.eras) a.append(b.eras[Date._getEra(this, l) + 1]); break; case "/": a.append(b.DateSeparator) } } return a.toString() }; String.localeFormat = function () { return String._toFormattedString(true, arguments) }; Number.parseLocale = function (a) { return Number._parse(a, Sys.CultureInfo.CurrentCulture) }; Number.parseInvariant = function (a) { return Number._parse(a, Sys.CultureInfo.InvariantCulture) }; Number._parse = function (b, o) { b = b.trim(); if (b.match(/^[+-]?infinity$/i)) return parseFloat(b); if (b.match(/^0x[a-f0-9]+$/i)) return parseInt(b); var a = o.numberFormat, g = Number._parseNumberNegativePattern(b, a, a.NumberNegativePattern), h = g[0], e = g[1]; if (h === "" && a.NumberNegativePattern !== 1) { g = Number._parseNumberNegativePattern(b, a, 1); h = g[0]; e = g[1] } if (h === "") h = "+"; var j, d, f = e.indexOf("e"); if (f < 0) f = e.indexOf("E"); if (f < 0) { d = e; j = null } else { d = e.substr(0, f); j = e.substr(f + 1) } var c, k, m = d.indexOf(a.NumberDecimalSeparator); if (m < 0) { c = d; k = null } else { c = d.substr(0, m); k = d.substr(m + a.NumberDecimalSeparator.length) } c = c.split(a.NumberGroupSeparator).join(""); var n = a.NumberGroupSeparator.replace(/\u00A0/g, " "); if (a.NumberGroupSeparator !== n) c = c.split(n).join(""); var l = h + c; if (k !== null) l += "." + k; if (j !== null) { var i = Number._parseNumberNegativePattern(j, a, 1); if (i[0] === "") i[0] = "+"; l += "e" + i[0] + i[1] } if (l.match(/^[+-]?\d*\.?\d*(e[+-]?\d+)?$/)) return parseFloat(l); return Number.NaN }; Number._parseNumberNegativePattern = function (a, d, e) { var b = d.NegativeSign, c = d.PositiveSign; switch (e) { case 4: b = " " + b; c = " " + c; case 3: if (a.endsWith(b)) return ["-", a.substr(0, a.length - b.length)]; else if (a.endsWith(c)) return ["+", a.substr(0, a.length - c.length)]; break; case 2: b += " "; c += " "; case 1: if (a.startsWith(b)) return ["-", a.substr(b.length)]; else if (a.startsWith(c)) return ["+", a.substr(c.length)]; break; case 0: if (a.startsWith("(") && a.endsWith(")")) return ["-", a.substr(1, a.length - 2)] } return ["", a] }; Number.prototype.format = function (a) { return this._toFormattedString(a, Sys.CultureInfo.InvariantCulture) }; Number.prototype.localeFormat = function (a) { return this._toFormattedString(a, Sys.CultureInfo.CurrentCulture) }; Number.prototype._toFormattedString = function (e, j) { if (!e || e.length === 0 || e === "i") if (j && j.name.length > 0) return this.toLocaleString(); else return this.toString(); var o = ["n %", "n%", "%n"], n = ["-n %", "-n%", "-%n"], p = ["(n)", "-n", "- n", "n-", "n -"], m = ["$n", "n$", "$ n", "n $"], l = ["($n)", "-$n", "$-n", "$n-", "(n$)", "-n$", "n-$", "n$-", "-n $", "-$ n", "n $-", "$ n-", "$ -n", "n- $", "($ n)", "(n $)"]; function g(a, c, d) { for (var b = a.length; b < c; b++) a = d ? "0" + a : a + "0"; return a } function i(j, i, l, n, p) { var h = l[0], k = 1, o = Math.pow(10, i), m = Math.round(j * o) / o; if (!isFinite(m)) m = j; j = m; var b = j.toString(), a = "", c, e = b.split(/e/i); b = e[0]; c = e.length > 1 ? parseInt(e[1]) : 0; e = b.split("."); b = e[0]; a = e.length > 1 ? e[1] : ""; var q; if (c > 0) { a = g(a, c, false); b += a.slice(0, c); a = a.substr(c) } else if (c < 0) { c = -c; b = g(b, c + 1, true); a = b.slice(-c, b.length) + a; b = b.slice(0, -c) } if (i > 0) { if (a.length > i) a = a.slice(0, i); else a = g(a, i, false); a = p + a } else a = ""; var d = b.length - 1, f = ""; while (d >= 0) { if (h === 0 || h > d) if (f.length > 0) return b.slice(0, d + 1) + n + f + a; else return b.slice(0, d + 1) + a; if (f.length > 0) f = b.slice(d - h + 1, d + 1) + n + f; else f = b.slice(d - h + 1, d + 1); d -= h; if (k < l.length) { h = l[k]; k++ } } return b.slice(0, d + 1) + n + f + a } var a = j.numberFormat, d = Math.abs(this); if (!e) e = "D"; var b = -1; if (e.length > 1) b = parseInt(e.slice(1), 10); var c; switch (e.charAt(0)) { case "d": case "D": c = "n"; if (b !== -1) d = g("" + d, b, true); if (this < 0) d = -d; break; case "c": case "C": if (this < 0) c = l[a.CurrencyNegativePattern]; else c = m[a.CurrencyPositivePattern]; if (b === -1) b = a.CurrencyDecimalDigits; d = i(Math.abs(this), b, a.CurrencyGroupSizes, a.CurrencyGroupSeparator, a.CurrencyDecimalSeparator); break; case "n": case "N": if (this < 0) c = p[a.NumberNegativePattern]; else c = "n"; if (b === -1) b = a.NumberDecimalDigits; d = i(Math.abs(this), b, a.NumberGroupSizes, a.NumberGroupSeparator, a.NumberDecimalSeparator); break; case "p": case "P": if (this < 0) c = n[a.PercentNegativePattern]; else c = o[a.PercentPositivePattern]; if (b === -1) b = a.PercentDecimalDigits; d = i(Math.abs(this) * 100, b, a.PercentGroupSizes, a.PercentGroupSeparator, a.PercentDecimalSeparator); break; default: throw Error.format(Sys.Res.formatBadFormatSpecifier) } var k = /n|\$|-|%/g, f = ""; for (; true;) { var q = k.lastIndex, h = k.exec(c); f += c.slice(q, h ? h.index : c.length); if (!h) break; switch (h[0]) { case "n": f += d; break; case "$": f += a.CurrencySymbol; break; case "-": if (/[1-9]/.test(d)) f += a.NegativeSign; break; case "%": f += a.PercentSymbol } } return f }; Sys.CultureInfo = function (c, b, a) { this.name = c; this.numberFormat = b; this.dateTimeFormat = a }; Sys.CultureInfo.prototype = { _getDateTimeFormats: function () { if (!this._dateTimeFormats) { var a = this.dateTimeFormat; this._dateTimeFormats = [a.MonthDayPattern, a.YearMonthPattern, a.ShortDatePattern, a.ShortTimePattern, a.LongDatePattern, a.LongTimePattern, a.FullDateTimePattern, a.RFC1123Pattern, a.SortableDateTimePattern, a.UniversalSortableDateTimePattern] } return this._dateTimeFormats }, _getIndex: function (c, d, e) { var b = this._toUpper(c), a = Array.indexOf(d, b); if (a === -1) a = Array.indexOf(e, b); return a }, _getMonthIndex: function (a) { if (!this._upperMonths) { this._upperMonths = this._toUpperArray(this.dateTimeFormat.MonthNames); this._upperMonthsGenitive = this._toUpperArray(this.dateTimeFormat.MonthGenitiveNames) } return this._getIndex(a, this._upperMonths, this._upperMonthsGenitive) }, _getAbbrMonthIndex: function (a) { if (!this._upperAbbrMonths) { this._upperAbbrMonths = this._toUpperArray(this.dateTimeFormat.AbbreviatedMonthNames); this._upperAbbrMonthsGenitive = this._toUpperArray(this.dateTimeFormat.AbbreviatedMonthGenitiveNames) } return this._getIndex(a, this._upperAbbrMonths, this._upperAbbrMonthsGenitive) }, _getDayIndex: function (a) { if (!this._upperDays) this._upperDays = this._toUpperArray(this.dateTimeFormat.DayNames); return Array.indexOf(this._upperDays, this._toUpper(a)) }, _getAbbrDayIndex: function (a) { if (!this._upperAbbrDays) this._upperAbbrDays = this._toUpperArray(this.dateTimeFormat.AbbreviatedDayNames); return Array.indexOf(this._upperAbbrDays, this._toUpper(a)) }, _toUpperArray: function (c) { var b = []; for (var a = 0, d = c.length; a < d; a++) b[a] = this._toUpper(c[a]); return b }, _toUpper: function (a) { return a.split("\u00a0").join(" ").toUpperCase() } }; Sys.CultureInfo.registerClass("Sys.CultureInfo"); Sys.CultureInfo._parse = function (a) { var b = a.dateTimeFormat; if (b && !b.eras) b.eras = a.eras; return new Sys.CultureInfo(a.name, a.numberFormat, b) }; Sys.CultureInfo.InvariantCulture = Sys.CultureInfo._parse({ "name": "", "numberFormat": { "CurrencyDecimalDigits": 2, "CurrencyDecimalSeparator": ".", "IsReadOnly": true, "CurrencyGroupSizes": [3], "NumberGroupSizes": [3], "PercentGroupSizes": [3], "CurrencyGroupSeparator": ",", "CurrencySymbol": "\u00a4", "NaNSymbol": "NaN", "CurrencyNegativePattern": 0, "NumberNegativePattern": 1, "PercentPositivePattern": 0, "PercentNegativePattern": 0, "NegativeInfinitySymbol": "-Infinity", "NegativeSign": "-", "NumberDecimalDigits": 2, "NumberDecimalSeparator": ".", "NumberGroupSeparator": ",", "CurrencyPositivePattern": 0, "PositiveInfinitySymbol": "Infinity", "PositiveSign": "+", "PercentDecimalDigits": 2, "PercentDecimalSeparator": ".", "PercentGroupSeparator": ",", "PercentSymbol": "%", "PerMilleSymbol": "\u2030", "NativeDigits": ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"], "DigitSubstitution": 1 }, "dateTimeFormat": { "AMDesignator": "AM", "Calendar": { "MinSupportedDateTime": "@-62135568000000@", "MaxSupportedDateTime": "@253402300799999@", "AlgorithmType": 1, "CalendarType": 1, "Eras": [1], "TwoDigitYearMax": 2029, "IsReadOnly": true }, "DateSeparator": "/", "FirstDayOfWeek": 0, "CalendarWeekRule": 0, "FullDateTimePattern": "dddd, dd MMMM yyyy HH:mm:ss", "LongDatePattern": "dddd, dd MMMM yyyy", "LongTimePattern": "HH:mm:ss", "MonthDayPattern": "MMMM dd", "PMDesignator": "PM", "RFC1123Pattern": "ddd, dd MMM yyyy HH':'mm':'ss 'GMT'", "ShortDatePattern": "MM/dd/yyyy", "ShortTimePattern": "HH:mm", "SortableDateTimePattern": "yyyy'-'MM'-'dd'T'HH':'mm':'ss", "TimeSeparator": ":", "UniversalSortableDateTimePattern": "yyyy'-'MM'-'dd HH':'mm':'ss'Z'", "YearMonthPattern": "yyyy MMMM", "AbbreviatedDayNames": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "ShortestDayNames": ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"], "DayNames": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], "AbbreviatedMonthNames": ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", ""], "MonthNames": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", ""], "IsReadOnly": true, "NativeCalendarName": "Gregorian Calendar", "AbbreviatedMonthGenitiveNames": ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", ""], "MonthGenitiveNames": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", ""] }, "eras": [1, "A.D.", null, 0] }); if (typeof __cultureInfo === "object") { Sys.CultureInfo.CurrentCulture = Sys.CultureInfo._parse(__cultureInfo); delete __cultureInfo } else Sys.CultureInfo.CurrentCulture = Sys.CultureInfo._parse({ "name": "en-US", "numberFormat": { "CurrencyDecimalDigits": 2, "CurrencyDecimalSeparator": ".", "IsReadOnly": false, "CurrencyGroupSizes": [3], "NumberGroupSizes": [3], "PercentGroupSizes": [3], "CurrencyGroupSeparator": ",", "CurrencySymbol": "$", "NaNSymbol": "NaN", "CurrencyNegativePattern": 0, "NumberNegativePattern": 1, "PercentPositivePattern": 0, "PercentNegativePattern": 0, "NegativeInfinitySymbol": "-Infinity", "NegativeSign": "-", "NumberDecimalDigits": 2, "NumberDecimalSeparator": ".", "NumberGroupSeparator": ",", "CurrencyPositivePattern": 0, "PositiveInfinitySymbol": "Infinity", "PositiveSign": "+", "PercentDecimalDigits": 2, "PercentDecimalSeparator": ".", "PercentGroupSeparator": ",", "PercentSymbol": "%", "PerMilleSymbol": "\u2030", "NativeDigits": ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"], "DigitSubstitution": 1 }, "dateTimeFormat": { "AMDesignator": "AM", "Calendar": { "MinSupportedDateTime": "@-62135568000000@", "MaxSupportedDateTime": "@253402300799999@", "AlgorithmType": 1, "CalendarType": 1, "Eras": [1], "TwoDigitYearMax": 2029, "IsReadOnly": false }, "DateSeparator": "/", "FirstDayOfWeek": 0, "CalendarWeekRule": 0, "FullDateTimePattern": "dddd, MMMM dd, yyyy h:mm:ss tt", "LongDatePattern": "dddd, MMMM dd, yyyy", "LongTimePattern": "h:mm:ss tt", "MonthDayPattern": "MMMM dd", "PMDesignator": "PM", "RFC1123Pattern": "ddd, dd MMM yyyy HH':'mm':'ss 'GMT'", "ShortDatePattern": "M/d/yyyy", "ShortTimePattern": "h:mm tt", "SortableDateTimePattern": "yyyy'-'MM'-'dd'T'HH':'mm':'ss", "TimeSeparator": ":", "UniversalSortableDateTimePattern": "yyyy'-'MM'-'dd HH':'mm':'ss'Z'", "YearMonthPattern": "MMMM, yyyy", "AbbreviatedDayNames": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "ShortestDayNames": ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"], "DayNames": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], "AbbreviatedMonthNames": ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", ""], "MonthNames": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", ""], "IsReadOnly": false, "NativeCalendarName": "Gregorian Calendar", "AbbreviatedMonthGenitiveNames": ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", ""], "MonthGenitiveNames": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", ""] }, "eras": [1, "A.D.", null, 0] }); Type.registerNamespace("Sys.Serialization"); Sys.Serialization.JavaScriptSerializer = function () { }; Sys.Serialization.JavaScriptSerializer.registerClass("Sys.Serialization.JavaScriptSerializer"); Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs = []; Sys.Serialization.JavaScriptSerializer._charsToEscape = []; Sys.Serialization.JavaScriptSerializer._dateRegEx = new RegExp('(^|[^\\\\])\\"\\\\/Date\\((-?[0-9]+)(?:[a-zA-Z]|(?:\\+|-)[0-9]{4})?\\)\\\\/\\"', "g"); Sys.Serialization.JavaScriptSerializer._escapeChars = {}; Sys.Serialization.JavaScriptSerializer._escapeRegEx = new RegExp('["\\\\\\x00-\\x1F]', "i"); Sys.Serialization.JavaScriptSerializer._escapeRegExGlobal = new RegExp('["\\\\\\x00-\\x1F]', "g"); Sys.Serialization.JavaScriptSerializer._jsonRegEx = new RegExp("[^,:{}\\[\\]0-9.\\-+Eaeflnr-u \\n\\r\\t]", "g"); Sys.Serialization.JavaScriptSerializer._jsonStringRegEx = new RegExp('"(\\\\.|[^"\\\\])*"', "g"); Sys.Serialization.JavaScriptSerializer._serverTypeFieldName = "__type"; Sys.Serialization.JavaScriptSerializer._init = function () { var c = ["\\u0000", "\\u0001", "\\u0002", "\\u0003", "\\u0004", "\\u0005", "\\u0006", "\\u0007", "\\b", "\\t", "\\n", "\\u000b", "\\f", "\\r", "\\u000e", "\\u000f", "\\u0010", "\\u0011", "\\u0012", "\\u0013", "\\u0014", "\\u0015", "\\u0016", "\\u0017", "\\u0018", "\\u0019", "\\u001a", "\\u001b", "\\u001c", "\\u001d", "\\u001e", "\\u001f"]; Sys.Serialization.JavaScriptSerializer._charsToEscape[0] = "\\"; Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs["\\"] = new RegExp("\\\\", "g"); Sys.Serialization.JavaScriptSerializer._escapeChars["\\"] = "\\\\"; Sys.Serialization.JavaScriptSerializer._charsToEscape[1] = '"'; Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs['"'] = new RegExp('"', "g"); Sys.Serialization.JavaScriptSerializer._escapeChars['"'] = '\\"'; for (var a = 0; a < 32; a++) { var b = String.fromCharCode(a); Sys.Serialization.JavaScriptSerializer._charsToEscape[a + 2] = b; Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs[b] = new RegExp(b, "g"); Sys.Serialization.JavaScriptSerializer._escapeChars[b] = c[a] } }; Sys.Serialization.JavaScriptSerializer._serializeBooleanWithBuilder = function (b, a) { a.append(b.toString()) }; Sys.Serialization.JavaScriptSerializer._serializeNumberWithBuilder = function (a, b) { if (isFinite(a)) b.append(String(a)); else throw Error.invalidOperation(Sys.Res.cannotSerializeNonFiniteNumbers) }; Sys.Serialization.JavaScriptSerializer._serializeStringWithBuilder = function (a, c) { c.append('"'); if (Sys.Serialization.JavaScriptSerializer._escapeRegEx.test(a)) { if (Sys.Serialization.JavaScriptSerializer._charsToEscape.length === 0) Sys.Serialization.JavaScriptSerializer._init(); if (a.length < 128) a = a.replace(Sys.Serialization.JavaScriptSerializer._escapeRegExGlobal, function (a) { return Sys.Serialization.JavaScriptSerializer._escapeChars[a] }); else for (var d = 0; d < 34; d++) { var b = Sys.Serialization.JavaScriptSerializer._charsToEscape[d]; if (a.indexOf(b) !== -1) if (Sys.Browser.agent === Sys.Browser.Opera || Sys.Browser.agent === Sys.Browser.FireFox) a = a.split(b).join(Sys.Serialization.JavaScriptSerializer._escapeChars[b]); else a = a.replace(Sys.Serialization.JavaScriptSerializer._charsToEscapeRegExs[b], Sys.Serialization.JavaScriptSerializer._escapeChars[b]) } } c.append(a); c.append('"') }; Sys.Serialization.JavaScriptSerializer._serializeWithBuilder = function (b, a, i, g) { var c; switch (typeof b) { case "object": if (b) if (Number.isInstanceOfType(b)) Sys.Serialization.JavaScriptSerializer._serializeNumberWithBuilder(b, a); else if (Boolean.isInstanceOfType(b)) Sys.Serialization.JavaScriptSerializer._serializeBooleanWithBuilder(b, a); else if (String.isInstanceOfType(b)) Sys.Serialization.JavaScriptSerializer._serializeStringWithBuilder(b, a); else if (Array.isInstanceOfType(b)) { a.append("["); for (c = 0; c < b.length; ++c) { if (c > 0) a.append(","); Sys.Serialization.JavaScriptSerializer._serializeWithBuilder(b[c], a, false, g) } a.append("]") } else { if (Date.isInstanceOfType(b)) { a.append('"\\/Date('); a.append(b.getTime()); a.append(')\\/"'); break } var d = [], f = 0; for (var e in b) { if (e.startsWith("$")) continue; if (e === Sys.Serialization.JavaScriptSerializer._serverTypeFieldName && f !== 0) { d[f++] = d[0]; d[0] = e } else d[f++] = e } if (i) d.sort(); a.append("{"); var j = false; for (c = 0; c < f; c++) { var h = b[d[c]]; if (typeof h !== "undefined" && typeof h !== "function") { if (j) a.append(","); else j = true; Sys.Serialization.JavaScriptSerializer._serializeWithBuilder(d[c], a, i, g); a.append(":"); Sys.Serialization.JavaScriptSerializer._serializeWithBuilder(h, a, i, g) } } a.append("}") } else a.append("null"); break; case "number": Sys.Serialization.JavaScriptSerializer._serializeNumberWithBuilder(b, a); break; case "string": Sys.Serialization.JavaScriptSerializer._serializeStringWithBuilder(b, a); break; case "boolean": Sys.Serialization.JavaScriptSerializer._serializeBooleanWithBuilder(b, a); break; default: a.append("null") } }; Sys.Serialization.JavaScriptSerializer.serialize = function (b) { var a = new Sys.StringBuilder; Sys.Serialization.JavaScriptSerializer._serializeWithBuilder(b, a, false); return a.toString() }; Sys.Serialization.JavaScriptSerializer.deserialize = function (data, secure) { if (data.length === 0) throw Error.argument("data", Sys.Res.cannotDeserializeEmptyString); try { var exp = data.replace(Sys.Serialization.JavaScriptSerializer._dateRegEx, "$1new Date($2)"); if (secure && Sys.Serialization.JavaScriptSerializer._jsonRegEx.test(exp.replace(Sys.Serialization.JavaScriptSerializer._jsonStringRegEx, ""))) throw null; return eval("(" + exp + ")") } catch (a) { throw Error.argument("data", Sys.Res.cannotDeserializeInvalidJson) } }; Type.registerNamespace("Sys.UI"); Sys.EventHandlerList = function () { this._list = {} }; Sys.EventHandlerList.prototype = { _addHandler: function (b, a) { Array.add(this._getEvent(b, true), a) }, addHandler: function (b, a) { this._addHandler(b, a) }, _removeHandler: function (c, b) { var a = this._getEvent(c); if (!a) return; Array.remove(a, b) }, removeHandler: function (b, a) { this._removeHandler(b, a) }, getHandler: function (b) { var a = this._getEvent(b); if (!a || a.length === 0) return null; a = Array.clone(a); return function (c, d) { for (var b = 0, e = a.length; b < e; b++) a[b](c, d) } }, _getEvent: function (a, b) { if (!this._list[a]) { if (!b) return null; this._list[a] = [] } return this._list[a] } }; Sys.EventHandlerList.registerClass("Sys.EventHandlerList"); Sys.CommandEventArgs = function (c, a, b) { Sys.CommandEventArgs.initializeBase(this); this._commandName = c; this._commandArgument = a; this._commandSource = b }; Sys.CommandEventArgs.prototype = { _commandName: null, _commandArgument: null, _commandSource: null, get_commandName: function () { return this._commandName }, get_commandArgument: function () { return this._commandArgument }, get_commandSource: function () { return this._commandSource } }; Sys.CommandEventArgs.registerClass("Sys.CommandEventArgs", Sys.CancelEventArgs); Sys.INotifyPropertyChange = function () { }; Sys.INotifyPropertyChange.prototype = {}; Sys.INotifyPropertyChange.registerInterface("Sys.INotifyPropertyChange"); Sys.PropertyChangedEventArgs = function (a) { Sys.PropertyChangedEventArgs.initializeBase(this); this._propertyName = a }; Sys.PropertyChangedEventArgs.prototype = { get_propertyName: function () { return this._propertyName } }; Sys.PropertyChangedEventArgs.registerClass("Sys.PropertyChangedEventArgs", Sys.EventArgs); Sys.INotifyDisposing = function () { }; Sys.INotifyDisposing.prototype = {}; Sys.INotifyDisposing.registerInterface("Sys.INotifyDisposing"); Sys.Component = function () { if (Sys.Application) Sys.Application.registerDisposableObject(this) }; Sys.Component.prototype = { _id: null, _initialized: false, _updating: false, get_events: function () { if (!this._events) this._events = new Sys.EventHandlerList; return this._events }, get_id: function () { return this._id }, set_id: function (a) { this._id = a }, get_isInitialized: function () { return this._initialized }, get_isUpdating: function () { return this._updating }, add_disposing: function (a) { this.get_events().addHandler("disposing", a) }, remove_disposing: function (a) { this.get_events().removeHandler("disposing", a) }, add_propertyChanged: function (a) { this.get_events().addHandler("propertyChanged", a) }, remove_propertyChanged: function (a) { this.get_events().removeHandler("propertyChanged", a) }, beginUpdate: function () { this._updating = true }, dispose: function () { if (this._events) { var a = this._events.getHandler("disposing"); if (a) a(this, Sys.EventArgs.Empty) } delete this._events; Sys.Application.unregisterDisposableObject(this); Sys.Application.removeComponent(this) }, endUpdate: function () { this._updating = false; if (!this._initialized) this.initialize(); this.updated() }, initialize: function () { this._initialized = true }, raisePropertyChanged: function (b) { if (!this._events) return; var a = this._events.getHandler("propertyChanged"); if (a) a(this, new Sys.PropertyChangedEventArgs(b)) }, updated: function () { } }; Sys.Component.registerClass("Sys.Component", null, Sys.IDisposable, Sys.INotifyPropertyChange, Sys.INotifyDisposing); function Sys$Component$_setProperties(a, i) { var d, j = Object.getType(a), e = j === Object || j === Sys.UI.DomElement, h = Sys.Component.isInstanceOfType(a) && !a.get_isUpdating(); if (h) a.beginUpdate(); for (var c in i) { var b = i[c], f = e ? null : a["get_" + c]; if (e || typeof f !== "function") { var k = a[c]; if (!b || typeof b !== "object" || e && !k) a[c] = b; else Sys$Component$_setProperties(k, b) } else { var l = a["set_" + c]; if (typeof l === "function") l.apply(a, [b]); else if (b instanceof Array) { d = f.apply(a); for (var g = 0, m = d.length, n = b.length; g < n; g++, m++) d[m] = b[g] } else if (typeof b === "object" && Object.getType(b) === Object) { d = f.apply(a); Sys$Component$_setProperties(d, b) } } } if (h) a.endUpdate() } function Sys$Component$_setReferences(c, b) { for (var a in b) { var e = c["set_" + a], d = $find(b[a]); e.apply(c, [d]) } } var $create = Sys.Component.create = function (h, f, d, c, g) { var a = g ? new h(g) : new h, b = Sys.Application, i = b.get_isCreatingComponents(); a.beginUpdate(); if (f) Sys$Component$_setProperties(a, f); if (d) for (var e in d) a["add_" + e](d[e]); if (a.get_id()) b.addComponent(a); if (i) { b._createdComponents[b._createdComponents.length] = a; if (c) b._addComponentToSecondPass(a, c); else a.endUpdate() } else { if (c) Sys$Component$_setReferences(a, c); a.endUpdate() } return a }; Sys.UI.MouseButton = function () { throw Error.notImplemented() }; Sys.UI.MouseButton.prototype = { leftButton: 0, middleButton: 1, rightButton: 2 }; Sys.UI.MouseButton.registerEnum("Sys.UI.MouseButton"); Sys.UI.Key = function () { throw Error.notImplemented() }; Sys.UI.Key.prototype = { backspace: 8, tab: 9, enter: 13, esc: 27, space: 32, pageUp: 33, pageDown: 34, end: 35, home: 36, left: 37, up: 38, right: 39, down: 40, del: 127 }; Sys.UI.Key.registerEnum("Sys.UI.Key"); Sys.UI.Point = function (a, b) { this.rawX = a; this.rawY = b; this.x = Math.round(a); this.y = Math.round(b) }; Sys.UI.Point.registerClass("Sys.UI.Point"); Sys.UI.Bounds = function (c, d, b, a) { this.x = c; this.y = d; this.height = a; this.width = b }; Sys.UI.Bounds.registerClass("Sys.UI.Bounds"); Sys.UI.DomEvent = function (e) { var a = e, b = this.type = a.type.toLowerCase(); this.rawEvent = a; this.altKey = a.altKey; if (typeof a.button !== "undefined") this.button = typeof a.which !== "undefined" ? a.button : a.button === 4 ? Sys.UI.MouseButton.middleButton : a.button === 2 ? Sys.UI.MouseButton.rightButton : Sys.UI.MouseButton.leftButton; if (b === "keypress") this.charCode = a.charCode || a.keyCode; else if (a.keyCode && a.keyCode === 46) this.keyCode = 127; else this.keyCode = a.keyCode; this.clientX = a.clientX; this.clientY = a.clientY; this.ctrlKey = a.ctrlKey; this.target = a.target ? a.target : a.srcElement; if (!b.startsWith("key")) if (typeof a.offsetX !== "undefined" && typeof a.offsetY !== "undefined") { this.offsetX = a.offsetX; this.offsetY = a.offsetY } else if (this.target && this.target.nodeType !== 3 && typeof a.clientX === "number") { var c = Sys.UI.DomElement.getLocation(this.target), d = Sys.UI.DomElement._getWindow(this.target); this.offsetX = (d.pageXOffset || 0) + a.clientX - c.x; this.offsetY = (d.pageYOffset || 0) + a.clientY - c.y } this.screenX = a.screenX; this.screenY = a.screenY; this.shiftKey = a.shiftKey }; Sys.UI.DomEvent.prototype = { preventDefault: function () { if (this.rawEvent.preventDefault) this.rawEvent.preventDefault(); else if (window.event) this.rawEvent.returnValue = false }, stopPropagation: function () { if (this.rawEvent.stopPropagation) this.rawEvent.stopPropagation(); else if (window.event) this.rawEvent.cancelBubble = true } }; Sys.UI.DomEvent.registerClass("Sys.UI.DomEvent"); var $addHandler = Sys.UI.DomEvent.addHandler = function (a, d, e, g) { if (!a._events) a._events = {}; var c = a._events[d]; if (!c) a._events[d] = c = []; var b; if (a.addEventListener) { b = function (b) { return e.call(a, new Sys.UI.DomEvent(b)) }; a.addEventListener(d, b, false) } else if (a.attachEvent) { b = function () { var b = {}; try { b = Sys.UI.DomElement._getWindow(a).event } catch (c) { } return e.call(a, new Sys.UI.DomEvent(b)) }; a.attachEvent("on" + d, b) } c[c.length] = { handler: e, browserHandler: b, autoRemove: g }; if (g) { var f = a.dispose; if (f !== Sys.UI.DomEvent._disposeHandlers) { a.dispose = Sys.UI.DomEvent._disposeHandlers; if (typeof f !== "undefined") a._chainDispose = f } } }, $addHandlers = Sys.UI.DomEvent.addHandlers = function (f, d, c, e) { for (var b in d) { var a = d[b]; if (c) a = Function.createDelegate(c, a); $addHandler(f, b, a, e || false) } }, $clearHandlers = Sys.UI.DomEvent.clearHandlers = function (a) { Sys.UI.DomEvent._clearHandlers(a, false) }; Sys.UI.DomEvent._clearHandlers = function (a, g) { if (a._events) { var e = a._events; for (var b in e) { var d = e[b]; for (var c = d.length - 1; c >= 0; c--) { var f = d[c]; if (!g || f.autoRemove) $removeHandler(a, b, f.handler) } } a._events = null } }; Sys.UI.DomEvent._disposeHandlers = function () { Sys.UI.DomEvent._clearHandlers(this, true); var b = this._chainDispose, a = typeof b; if (a !== "undefined") { this.dispose = b; this._chainDispose = null; if (a === "function") this.dispose() } }; var $removeHandler = Sys.UI.DomEvent.removeHandler = function (b, a, c) { Sys.UI.DomEvent._removeHandler(b, a, c) }; Sys.UI.DomEvent._removeHandler = function (a, e, f) { var d = null, c = a._events[e]; for (var b = 0, g = c.length; b < g; b++) if (c[b].handler === f) { d = c[b].browserHandler; break } if (a.removeEventListener) a.removeEventListener(e, d, false); else if (a.detachEvent) a.detachEvent("on" + e, d); c.splice(b, 1) }; Sys.UI.DomElement = function () { }; Sys.UI.DomElement.registerClass("Sys.UI.DomElement"); Sys.UI.DomElement.addCssClass = function (a, b) { if (!Sys.UI.DomElement.containsCssClass(a, b)) if (a.className === "") a.className = b; else a.className += " " + b }; Sys.UI.DomElement.containsCssClass = function (b, a) { return Array.contains(b.className.split(" "), a) }; Sys.UI.DomElement.getBounds = function (a) { var b = Sys.UI.DomElement.getLocation(a); return new Sys.UI.Bounds(b.x, b.y, a.offsetWidth || 0, a.offsetHeight || 0) }; var $get = Sys.UI.DomElement.getElementById = function (f, e) { if (!e) return document.getElementById(f); if (e.getElementById) return e.getElementById(f); var c = [], d = e.childNodes; for (var b = 0; b < d.length; b++) { var a = d[b]; if (a.nodeType == 1) c[c.length] = a } while (c.length) { a = c.shift(); if (a.id == f) return a; d = a.childNodes; for (b = 0; b < d.length; b++) { a = d[b]; if (a.nodeType == 1) c[c.length] = a } } return null }; if (document.documentElement.getBoundingClientRect) Sys.UI.DomElement.getLocation = function (a) { if (a.self || a.nodeType === 9 || a === document.documentElement || a.parentNode === a.ownerDocument.documentElement) return new Sys.UI.Point(0, 0); var f = a.getBoundingClientRect(); if (!f) return new Sys.UI.Point(0, 0); var e = a.ownerDocument.documentElement, h = a.ownerDocument.body, l, c = Math.round(f.left) + (e.scrollLeft || h.scrollLeft), d = Math.round(f.top) + (e.scrollTop || h.scrollTop); if (Sys.Browser.agent === Sys.Browser.InternetExplorer) { try { var g = a.ownerDocument.parentWindow.frameElement || null; if (g) { var i = g.frameBorder === "0" || g.frameBorder === "no" ? 2 : 0; c += i; d += i } } catch (m) { } if (Sys.Browser.version === 7 && !document.documentMode) { var j = document.body, k = j.getBoundingClientRect(), b = (k.right - k.left) / j.clientWidth; b = Math.round(b * 100); b = (b - b % 5) / 100; if (!isNaN(b) && b !== 1) { c = Math.round(c / b); d = Math.round(d / b) } } if ((document.documentMode || 0) < 8) { c -= e.clientLeft; d -= e.clientTop } } return new Sys.UI.Point(c, d) }; else if (Sys.Browser.agent === Sys.Browser.Safari) Sys.UI.DomElement.getLocation = function (c) { if (c.window && c.window === c || c.nodeType === 9) return new Sys.UI.Point(0, 0); var d = 0, e = 0, a, j = null, g = null, b; for (a = c; a; j = a, (g = b, a = a.offsetParent)) { b = Sys.UI.DomElement._getCurrentStyle(a); var f = a.tagName ? a.tagName.toUpperCase() : null; if ((a.offsetLeft || a.offsetTop) && (f !== "BODY" || (!g || g.position !== "absolute"))) { d += a.offsetLeft; e += a.offsetTop } if (j && Sys.Browser.version >= 3) { d += parseInt(b.borderLeftWidth); e += parseInt(b.borderTopWidth) } } b = Sys.UI.DomElement._getCurrentStyle(c); var h = b ? b.position : null; if (!h || h !== "absolute") for (a = c.parentNode; a; a = a.parentNode) { f = a.tagName ? a.tagName.toUpperCase() : null; if (f !== "BODY" && f !== "HTML" && (a.scrollLeft || a.scrollTop)) { d -= a.scrollLeft || 0; e -= a.scrollTop || 0 } b = Sys.UI.DomElement._getCurrentStyle(a); var i = b ? b.position : null; if (i && i === "absolute") break } return new Sys.UI.Point(d, e) }; else Sys.UI.DomElement.getLocation = function (d) { if (d.window && d.window === d || d.nodeType === 9) return new Sys.UI.Point(0, 0); var e = 0, f = 0, a, i = null, g = null, b = null; for (a = d; a; i = a, (g = b, a = a.offsetParent)) { var c = a.tagName ? a.tagName.toUpperCase() : null; b = Sys.UI.DomElement._getCurrentStyle(a); if ((a.offsetLeft || a.offsetTop) && !(c === "BODY" && (!g || g.position !== "absolute"))) { e += a.offsetLeft; f += a.offsetTop } if (i !== null && b) { if (c !== "TABLE" && c !== "TD" && c !== "HTML") { e += parseInt(b.borderLeftWidth) || 0; f += parseInt(b.borderTopWidth) || 0 } if (c === "TABLE" && (b.position === "relative" || b.position === "absolute")) { e += parseInt(b.marginLeft) || 0; f += parseInt(b.marginTop) || 0 } } } b = Sys.UI.DomElement._getCurrentStyle(d); var h = b ? b.position : null; if (!h || h !== "absolute") for (a = d.parentNode; a; a = a.parentNode) { c = a.tagName ? a.tagName.toUpperCase() : null; if (c !== "BODY" && c !== "HTML" && (a.scrollLeft || a.scrollTop)) { e -= a.scrollLeft || 0; f -= a.scrollTop || 0; b = Sys.UI.DomElement._getCurrentStyle(a); if (b) { e += parseInt(b.borderLeftWidth) || 0; f += parseInt(b.borderTopWidth) || 0 } } } return new Sys.UI.Point(e, f) }; Sys.UI.DomElement.isDomElement = function (a) { return Sys._isDomElement(a) }; Sys.UI.DomElement.removeCssClass = function (d, c) { var a = " " + d.className + " ", b = a.indexOf(" " + c + " "); if (b >= 0) d.className = (a.substr(0, b) + " " + a.substring(b + c.length + 1, a.length)).trim() }; Sys.UI.DomElement.resolveElement = function (b, c) { var a = b; if (!a) return null; if (typeof a === "string") a = Sys.UI.DomElement.getElementById(a, c); return a }; Sys.UI.DomElement.raiseBubbleEvent = function (c, d) { var b = c; while (b) { var a = b.control; if (a && a.onBubbleEvent && a.raiseBubbleEvent) { Sys.UI.DomElement._raiseBubbleEventFromControl(a, c, d); return } b = b.parentNode } }; Sys.UI.DomElement._raiseBubbleEventFromControl = function (a, b, c) { if (!a.onBubbleEvent(b, c)) a._raiseBubbleEvent(b, c) }; Sys.UI.DomElement.setLocation = function (b, c, d) { var a = b.style; a.position = "absolute"; a.left = c + "px"; a.top = d + "px" }; Sys.UI.DomElement.toggleCssClass = function (b, a) { if (Sys.UI.DomElement.containsCssClass(b, a)) Sys.UI.DomElement.removeCssClass(b, a); else Sys.UI.DomElement.addCssClass(b, a) }; Sys.UI.DomElement.getVisibilityMode = function (a) { return a._visibilityMode === Sys.UI.VisibilityMode.hide ? Sys.UI.VisibilityMode.hide : Sys.UI.VisibilityMode.collapse }; Sys.UI.DomElement.setVisibilityMode = function (a, b) { Sys.UI.DomElement._ensureOldDisplayMode(a); if (a._visibilityMode !== b) { a._visibilityMode = b; if (Sys.UI.DomElement.getVisible(a) === false) if (a._visibilityMode === Sys.UI.VisibilityMode.hide) a.style.display = a._oldDisplayMode; else a.style.display = "none"; a._visibilityMode = b } }; Sys.UI.DomElement.getVisible = function (b) { var a = b.currentStyle || Sys.UI.DomElement._getCurrentStyle(b); if (!a) return true; return a.visibility !== "hidden" && a.display !== "none" }; Sys.UI.DomElement.setVisible = function (a, b) { if (b !== Sys.UI.DomElement.getVisible(a)) { Sys.UI.DomElement._ensureOldDisplayMode(a); a.style.visibility = b ? "visible" : "hidden"; if (b || a._visibilityMode === Sys.UI.VisibilityMode.hide) a.style.display = a._oldDisplayMode; else a.style.display = "none" } }; Sys.UI.DomElement._ensureOldDisplayMode = function (a) { if (!a._oldDisplayMode) { var b = a.currentStyle || Sys.UI.DomElement._getCurrentStyle(a); a._oldDisplayMode = b ? b.display : null; if (!a._oldDisplayMode || a._oldDisplayMode === "none") switch (a.tagName.toUpperCase()) { case "DIV": case "P": case "ADDRESS": case "BLOCKQUOTE": case "BODY": case "COL": case "COLGROUP": case "DD": case "DL": case "DT": case "FIELDSET": case "FORM": case "H1": case "H2": case "H3": case "H4": case "H5": case "H6": case "HR": case "IFRAME": case "LEGEND": case "OL": case "PRE": case "TABLE": case "TD": case "TH": case "TR": case "UL": a._oldDisplayMode = "block"; break; case "LI": a._oldDisplayMode = "list-item"; break; default: a._oldDisplayMode = "inline" } } }; Sys.UI.DomElement._getWindow = function (a) { var b = a.ownerDocument || a.document || a; return b.defaultView || b.parentWindow }; Sys.UI.DomElement._getCurrentStyle = function (a) { if (a.nodeType === 3) return null; var c = Sys.UI.DomElement._getWindow(a); if (a.documentElement) a = a.documentElement; var b = c && a !== c && c.getComputedStyle ? c.getComputedStyle(a, null) : a.currentStyle || a.style; if (!b && Sys.Browser.agent === Sys.Browser.Safari && a.style) { var g = a.style.display, f = a.style.position; a.style.position = "absolute"; a.style.display = "block"; var e = c.getComputedStyle(a, null); a.style.display = g; a.style.position = f; b = {}; for (var d in e) b[d] = e[d]; b.display = "none" } return b }; Sys.IContainer = function () { }; Sys.IContainer.prototype = {}; Sys.IContainer.registerInterface("Sys.IContainer"); Sys.ApplicationLoadEventArgs = function (b, a) { Sys.ApplicationLoadEventArgs.initializeBase(this); this._components = b; this._isPartialLoad = a }; Sys.ApplicationLoadEventArgs.prototype = { get_components: function () { return this._components }, get_isPartialLoad: function () { return this._isPartialLoad } }; Sys.ApplicationLoadEventArgs.registerClass("Sys.ApplicationLoadEventArgs", Sys.EventArgs); Sys._Application = function () { Sys._Application.initializeBase(this); this._disposableObjects = []; this._components = {}; this._createdComponents = []; this._secondPassComponents = []; this._unloadHandlerDelegate = Function.createDelegate(this, this._unloadHandler); Sys.UI.DomEvent.addHandler(window, "unload", this._unloadHandlerDelegate); this._domReady() }; Sys._Application.prototype = { _creatingComponents: false, _disposing: false, _deleteCount: 0, get_isCreatingComponents: function () { return this._creatingComponents }, get_isDisposing: function () { return this._disposing }, add_init: function (a) { if (this._initialized) a(this, Sys.EventArgs.Empty); else this.get_events().addHandler("init", a) }, remove_init: function (a) { this.get_events().removeHandler("init", a) }, add_load: function (a) { this.get_events().addHandler("load", a) }, remove_load: function (a) { this.get_events().removeHandler("load", a) }, add_unload: function (a) { this.get_events().addHandler("unload", a) }, remove_unload: function (a) { this.get_events().removeHandler("unload", a) }, addComponent: function (a) { this._components[a.get_id()] = a }, beginCreateComponents: function () { this._creatingComponents = true }, dispose: function () { if (!this._disposing) { this._disposing = true; if (this._timerCookie) { window.clearTimeout(this._timerCookie); delete this._timerCookie } if (this._endRequestHandler) { Sys.WebForms.PageRequestManager.getInstance().remove_endRequest(this._endRequestHandler); delete this._endRequestHandler } if (this._beginRequestHandler) { Sys.WebForms.PageRequestManager.getInstance().remove_beginRequest(this._beginRequestHandler); delete this._beginRequestHandler } if (window.pageUnload) window.pageUnload(this, Sys.EventArgs.Empty); var c = this.get_events().getHandler("unload"); if (c) c(this, Sys.EventArgs.Empty); var b = Array.clone(this._disposableObjects); for (var a = 0, f = b.length; a < f; a++) { var d = b[a]; if (typeof d !== "undefined") d.dispose() } Array.clear(this._disposableObjects); Sys.UI.DomEvent.removeHandler(window, "unload", this._unloadHandlerDelegate); if (Sys._ScriptLoader) { var e = Sys._ScriptLoader.getInstance(); if (e) e.dispose() } Sys._Application.callBaseMethod(this, "dispose") } }, disposeElement: function (c, j) { if (c.nodeType === 1) { var b, h = c.getElementsByTagName("*"), g = h.length, i = new Array(g); for (b = 0; b < g; b++) i[b] = h[b]; for (b = g - 1; b >= 0; b--) { var d = i[b], f = d.dispose; if (f && typeof f === "function") d.dispose(); else { var e = d.control; if (e && typeof e.dispose === "function") e.dispose() } var a = d._behaviors; if (a) this._disposeComponents(a); a = d._components; if (a) { this._disposeComponents(a); d._components = null } } if (!j) { var f = c.dispose; if (f && typeof f === "function") c.dispose(); else { var e = c.control; if (e && typeof e.dispose === "function") e.dispose() } var a = c._behaviors; if (a) this._disposeComponents(a); a = c._components; if (a) { this._disposeComponents(a); c._components = null } } } }, endCreateComponents: function () { var b = this._secondPassComponents; for (var a = 0, d = b.length; a < d; a++) { var c = b[a].component; Sys$Component$_setReferences(c, b[a].references); c.endUpdate() } this._secondPassComponents = []; this._creatingComponents = false }, findComponent: function (b, a) { return a ? Sys.IContainer.isInstanceOfType(a) ? a.findComponent(b) : a[b] || null : Sys.Application._components[b] || null }, getComponents: function () { var a = [], b = this._components; for (var c in b) a[a.length] = b[c]; return a }, initialize: function () { if (!this.get_isInitialized() && !this._disposing) { Sys._Application.callBaseMethod(this, "initialize"); this._raiseInit(); if (this.get_stateString) { if (Sys.WebForms && Sys.WebForms.PageRequestManager) { this._beginRequestHandler = Function.createDelegate(this, this._onPageRequestManagerBeginRequest); Sys.WebForms.PageRequestManager.getInstance().add_beginRequest(this._beginRequestHandler); this._endRequestHandler = Function.createDelegate(this, this._onPageRequestManagerEndRequest); Sys.WebForms.PageRequestManager.getInstance().add_endRequest(this._endRequestHandler) } var a = this.get_stateString(); if (a !== this._currentEntry) this._navigate(a); else this._ensureHistory() } this.raiseLoad() } }, notifyScriptLoaded: function () { }, registerDisposableObject: function (b) { if (!this._disposing) { var a = this._disposableObjects, c = a.length; a[c] = b; b.__msdisposeindex = c } }, raiseLoad: function () { var b = this.get_events().getHandler("load"), a = new Sys.ApplicationLoadEventArgs(Array.clone(this._createdComponents), !!this._loaded); this._loaded = true; if (b) b(this, a); if (window.pageLoad) window.pageLoad(this, a); this._createdComponents = [] }, removeComponent: function (b) { var a = b.get_id(); if (a) delete this._components[a] }, unregisterDisposableObject: function (a) { if (!this._disposing) { var e = a.__msdisposeindex; if (typeof e === "number") { var b = this._disposableObjects; delete b[e]; delete a.__msdisposeindex; if (++this._deleteCount > 1000) { var c = []; for (var d = 0, f = b.length; d < f; d++) { a = b[d]; if (typeof a !== "undefined") { a.__msdisposeindex = c.length; c.push(a) } } this._disposableObjects = c; this._deleteCount = 0 } } } }, _addComponentToSecondPass: function (b, a) { this._secondPassComponents[this._secondPassComponents.length] = { component: b, references: a } }, _disposeComponents: function (a) { if (a) for (var b = a.length - 1; b >= 0; b--) { var c = a[b]; if (typeof c.dispose === "function") c.dispose() } }, _domReady: function () { var a, g, f = this; function b() { f.initialize() } var c = function () { Sys.UI.DomEvent.removeHandler(window, "load", c); b() }; Sys.UI.DomEvent.addHandler(window, "load", c); if (document.addEventListener) try { document.addEventListener("DOMContentLoaded", a = function () { document.removeEventListener("DOMContentLoaded", a, false); b() }, false) } catch (h) { } else if (document.attachEvent) if (window == window.top && document.documentElement.doScroll) { var e, d = document.createElement("div"); a = function () { try { d.doScroll("left") } catch (c) { e = window.setTimeout(a, 0); return } d = null; b() }; a() } else document.attachEvent("onreadystatechange", a = function () { if (document.readyState === "complete") { document.detachEvent("onreadystatechange", a); b() } }) }, _raiseInit: function () { var a = this.get_events().getHandler("init"); if (a) { this.beginCreateComponents(); a(this, Sys.EventArgs.Empty); this.endCreateComponents() } }, _unloadHandler: function () { this.dispose() } }; Sys._Application.registerClass("Sys._Application", Sys.Component, Sys.IContainer); Sys.Application = new Sys._Application; var $find = Sys.Application.findComponent; Sys.UI.Behavior = function (b) { Sys.UI.Behavior.initializeBase(this); this._element = b; var a = b._behaviors; if (!a) b._behaviors = [this]; else a[a.length] = this }; Sys.UI.Behavior.prototype = { _name: null, get_element: function () { return this._element }, get_id: function () { var a = Sys.UI.Behavior.callBaseMethod(this, "get_id"); if (a) return a; if (!this._element || !this._element.id) return ""; return this._element.id + "$" + this.get_name() }, get_name: function () { if (this._name) return this._name; var a = Object.getTypeName(this), b = a.lastIndexOf("."); if (b !== -1) a = a.substr(b + 1); if (!this.get_isInitialized()) this._name = a; return a }, set_name: function (a) { this._name = a }, initialize: function () { Sys.UI.Behavior.callBaseMethod(this, "initialize"); var a = this.get_name(); if (a) this._element[a] = this }, dispose: function () { Sys.UI.Behavior.callBaseMethod(this, "dispose"); var a = this._element; if (a) { var c = this.get_name(); if (c) a[c] = null; var b = a._behaviors; Array.remove(b, this); if (b.length === 0) a._behaviors = null; delete this._element } } }; Sys.UI.Behavior.registerClass("Sys.UI.Behavior", Sys.Component); Sys.UI.Behavior.getBehaviorByName = function (b, c) { var a = b[c]; return a && Sys.UI.Behavior.isInstanceOfType(a) ? a : null }; Sys.UI.Behavior.getBehaviors = function (a) { if (!a._behaviors) return []; return Array.clone(a._behaviors) }; Sys.UI.Behavior.getBehaviorsByType = function (d, e) { var a = d._behaviors, c = []; if (a) for (var b = 0, f = a.length; b < f; b++) if (e.isInstanceOfType(a[b])) c[c.length] = a[b]; return c }; Sys.UI.VisibilityMode = function () { throw Error.notImplemented() }; Sys.UI.VisibilityMode.prototype = { hide: 0, collapse: 1 }; Sys.UI.VisibilityMode.registerEnum("Sys.UI.VisibilityMode"); Sys.UI.Control = function (a) { Sys.UI.Control.initializeBase(this); this._element = a; a.control = this; var b = this.get_role(); if (b) a.setAttribute("role", b) }; Sys.UI.Control.prototype = { _parent: null, _visibilityMode: Sys.UI.VisibilityMode.hide, get_element: function () { return this._element }, get_id: function () { if (!this._element) return ""; return this._element.id }, set_id: function () { throw Error.invalidOperation(Sys.Res.cantSetId) }, get_parent: function () { if (this._parent) return this._parent; if (!this._element) return null; var a = this._element.parentNode; while (a) { if (a.control) return a.control; a = a.parentNode } return null }, set_parent: function (a) { this._parent = a }, get_role: function () { return null }, get_visibilityMode: function () { return Sys.UI.DomElement.getVisibilityMode(this._element) }, set_visibilityMode: function (a) { Sys.UI.DomElement.setVisibilityMode(this._element, a) }, get_visible: function () { return Sys.UI.DomElement.getVisible(this._element) }, set_visible: function (a) { Sys.UI.DomElement.setVisible(this._element, a) }, addCssClass: function (a) { Sys.UI.DomElement.addCssClass(this._element, a) }, dispose: function () { Sys.UI.Control.callBaseMethod(this, "dispose"); if (this._element) { this._element.control = null; delete this._element } if (this._parent) delete this._parent }, onBubbleEvent: function () { return false }, raiseBubbleEvent: function (a, b) { this._raiseBubbleEvent(a, b) }, _raiseBubbleEvent: function (b, c) { var a = this.get_parent(); while (a) { if (a.onBubbleEvent(b, c)) return; a = a.get_parent() } }, removeCssClass: function (a) { Sys.UI.DomElement.removeCssClass(this._element, a) }, toggleCssClass: function (a) { Sys.UI.DomElement.toggleCssClass(this._element, a) } }; Sys.UI.Control.registerClass("Sys.UI.Control", Sys.Component); Sys.HistoryEventArgs = function (a) { Sys.HistoryEventArgs.initializeBase(this); this._state = a }; Sys.HistoryEventArgs.prototype = { get_state: function () { return this._state } }; Sys.HistoryEventArgs.registerClass("Sys.HistoryEventArgs", Sys.EventArgs); Sys.Application._appLoadHandler = null; Sys.Application._beginRequestHandler = null; Sys.Application._clientId = null; Sys.Application._currentEntry = ""; Sys.Application._endRequestHandler = null; Sys.Application._history = null; Sys.Application._enableHistory = false; Sys.Application._historyFrame = null; Sys.Application._historyInitialized = false; Sys.Application._historyPointIsNew = false; Sys.Application._ignoreTimer = false; Sys.Application._initialState = null; Sys.Application._state = {}; Sys.Application._timerCookie = 0; Sys.Application._timerHandler = null; Sys.Application._uniqueId = null; Sys._Application.prototype.get_stateString = function () { var a = null; if (Sys.Browser.agent === Sys.Browser.Firefox) { var c = window.location.href, b = c.indexOf("#"); if (b !== -1) a = c.substring(b + 1); else a = ""; return a } else a = window.location.hash; if (a.length > 0 && a.charAt(0) === "#") a = a.substring(1); return a }; Sys._Application.prototype.get_enableHistory = function () { return this._enableHistory }; Sys._Application.prototype.set_enableHistory = function (a) { this._enableHistory = a }; Sys._Application.prototype.add_navigate = function (a) { this.get_events().addHandler("navigate", a) }; Sys._Application.prototype.remove_navigate = function (a) { this.get_events().removeHandler("navigate", a) }; Sys._Application.prototype.addHistoryPoint = function (c, f) { this._ensureHistory(); var b = this._state; for (var a in c) { var d = c[a]; if (d === null) { if (typeof b[a] !== "undefined") delete b[a] } else b[a] = d } var e = this._serializeState(b); this._historyPointIsNew = true; this._setState(e, f); this._raiseNavigate() }; Sys._Application.prototype.setServerId = function (a, b) { this._clientId = a; this._uniqueId = b }; Sys._Application.prototype.setServerState = function (a) { this._ensureHistory(); this._state.__s = a; this._updateHiddenField(a) }; Sys._Application.prototype._deserializeState = function (a) { var e = {}; a = a || ""; var b = a.indexOf("&&"); if (b !== -1 && b + 2 < a.length) { e.__s = a.substr(b + 2); a = a.substr(0, b) } var g = a.split("&"); for (var f = 0, j = g.length; f < j; f++) { var d = g[f], c = d.indexOf("="); if (c !== -1 && c + 1 < d.length) { var i = d.substr(0, c), h = d.substr(c + 1); e[i] = decodeURIComponent(h) } } return e }; Sys._Application.prototype._enableHistoryInScriptManager = function () { this._enableHistory = true }; Sys._Application.prototype._ensureHistory = function () { if (!this._historyInitialized && this._enableHistory) { if (Sys.Browser.agent === Sys.Browser.InternetExplorer && (!document.documentMode || document.documentMode < 8)) { this._historyFrame = document.getElementById("__historyFrame"); this._ignoreIFrame = true } this._timerHandler = Function.createDelegate(this, this._onIdle); this._timerCookie = window.setTimeout(this._timerHandler, 100); try { this._initialState = this._deserializeState(this.get_stateString()) } catch (a) { } this._historyInitialized = true } }; Sys._Application.prototype._navigate = function (c) { this._ensureHistory(); var b = this._deserializeState(c); if (this._uniqueId) { var d = this._state.__s || "", a = b.__s || ""; if (a !== d) { this._updateHiddenField(a); __doPostBack(this._uniqueId, a); this._state = b; return } } this._setState(c); this._state = b; this._raiseNavigate() }; Sys._Application.prototype._onIdle = function () { delete this._timerCookie; var a = this.get_stateString(); if (a !== this._currentEntry) { if (!this._ignoreTimer) { this._historyPointIsNew = false; this._navigate(a) } } else this._ignoreTimer = false; this._timerCookie = window.setTimeout(this._timerHandler, 100) }; Sys._Application.prototype._onIFrameLoad = function (a) { if (!document.documentMode || document.documentMode < 8) { this._ensureHistory(); if (!this._ignoreIFrame) { this._historyPointIsNew = false; this._navigate(a) } this._ignoreIFrame = false } }; Sys._Application.prototype._onPageRequestManagerBeginRequest = function () { this._ignoreTimer = true; this._originalTitle = document.title }; Sys._Application.prototype._onPageRequestManagerEndRequest = function (g, f) { var d = f.get_dataItems()[this._clientId], c = this._originalTitle; this._originalTitle = null; var b = document.getElementById("__EVENTTARGET"); if (b && b.value === this._uniqueId) b.value = ""; if (typeof d !== "undefined") { this.setServerState(d); this._historyPointIsNew = true } else this._ignoreTimer = false; var a = this._serializeState(this._state); if (a !== this._currentEntry) { this._ignoreTimer = true; if (typeof c === "string") { if (Sys.Browser.agent !== Sys.Browser.InternetExplorer || Sys.Browser.version > 7) { var e = document.title; document.title = c; this._setState(a); document.title = e } else this._setState(a); this._raiseNavigate() } else { this._setState(a); this._raiseNavigate() } } }; Sys._Application.prototype._raiseNavigate = function () { var d = this._historyPointIsNew, c = this.get_events().getHandler("navigate"), b = {}; for (var a in this._state) if (a !== "__s") b[a] = this._state[a]; var e = new Sys.HistoryEventArgs(b); if (c) c(this, e); if (!d) { var f; try { if (Sys.Browser.agent === Sys.Browser.Firefox && window.location.hash && (!window.frameElement || window.top.location.hash)) Sys.Browser.version < 3.5 ? window.history.go(0) : (location.hash = this.get_stateString()) } catch (g) { } } }; Sys._Application.prototype._serializeState = function (d) { var b = []; for (var a in d) { var e = d[a]; if (a === "__s") var c = e; else b[b.length] = a + "=" + encodeURIComponent(e) } return b.join("&") + (c ? "&&" + c : "") }; Sys._Application.prototype._setState = function (a, b) { if (this._enableHistory) { a = a || ""; if (a !== this._currentEntry) { if (window.theForm) { var d = window.theForm.action, e = d.indexOf("#"); window.theForm.action = (e !== -1 ? d.substring(0, e) : d) + "#" + a } if (this._historyFrame && this._historyPointIsNew) { var f = document.createElement("div"); f.appendChild(document.createTextNode(b || document.title)); var g = f.innerHTML; this._ignoreIFrame = true; var c = this._historyFrame.contentWindow.document; c.open("javascript:'<html></html>'"); c.write("<html><head><title>" + g + "</title><scri" + 'pt type="text/javascript">parent.Sys.Application._onIFrameLoad(' + Sys.Serialization.JavaScriptSerializer.serialize(a) + ");</scri" + "pt></head><body></body></html>"); c.close() } this._ignoreTimer = false; this._currentEntry = a; if (this._historyFrame || this._historyPointIsNew) { var h = this.get_stateString(); if (a !== h) { window.location.hash = a; this._currentEntry = this.get_stateString(); if (typeof b !== "undefined" && b !== null) document.title = b } } this._historyPointIsNew = false } } }; Sys._Application.prototype._updateHiddenField = function (b) { if (this._clientId) { var a = document.getElementById(this._clientId); if (a) a.value = b } }; if (!window.XMLHttpRequest) window.XMLHttpRequest = function () { var b = ["Msxml2.XMLHTTP.3.0", "Msxml2.XMLHTTP"]; for (var a = 0, c = b.length; a < c; a++) try { return new ActiveXObject(b[a]) } catch (d) { } return null }; Type.registerNamespace("Sys.Net"); Sys.Net.WebRequestExecutor = function () { this._webRequest = null; this._resultObject = null }; Sys.Net.WebRequestExecutor.prototype = { get_webRequest: function () { return this._webRequest }, _set_webRequest: function (a) { this._webRequest = a }, get_started: function () { throw Error.notImplemented() }, get_responseAvailable: function () { throw Error.notImplemented() }, get_timedOut: function () { throw Error.notImplemented() }, get_aborted: function () { throw Error.notImplemented() }, get_responseData: function () { throw Error.notImplemented() }, get_statusCode: function () { throw Error.notImplemented() }, get_statusText: function () { throw Error.notImplemented() }, get_xml: function () { throw Error.notImplemented() }, get_object: function () { if (!this._resultObject) this._resultObject = Sys.Serialization.JavaScriptSerializer.deserialize(this.get_responseData()); return this._resultObject }, executeRequest: function () { throw Error.notImplemented() }, abort: function () { throw Error.notImplemented() }, getResponseHeader: function () { throw Error.notImplemented() }, getAllResponseHeaders: function () { throw Error.notImplemented() } }; Sys.Net.WebRequestExecutor.registerClass("Sys.Net.WebRequestExecutor"); Sys.Net.XMLDOM = function (d) { if (!window.DOMParser) { var c = ["Msxml2.DOMDocument.3.0", "Msxml2.DOMDocument"]; for (var b = 0, f = c.length; b < f; b++) try { var a = new ActiveXObject(c[b]); a.async = false; a.loadXML(d); a.setProperty("SelectionLanguage", "XPath"); return a } catch (g) { } } else try { var e = new window.DOMParser; return e.parseFromString(d, "text/xml") } catch (g) { } return null }; Sys.Net.XMLHttpExecutor = function () { Sys.Net.XMLHttpExecutor.initializeBase(this); var a = this; this._xmlHttpRequest = null; this._webRequest = null; this._responseAvailable = false; this._timedOut = false; this._timer = null; this._aborted = false; this._started = false; this._onReadyStateChange = function () { if (a._xmlHttpRequest.readyState === 4) { try { if (typeof a._xmlHttpRequest.status === "undefined") return } catch (b) { return } a._clearTimer(); a._responseAvailable = true; try { a._webRequest.completed(Sys.EventArgs.Empty) } finally { if (a._xmlHttpRequest != null) { a._xmlHttpRequest.onreadystatechange = Function.emptyMethod; a._xmlHttpRequest = null } } } }; this._clearTimer = function () { if (a._timer != null) { window.clearTimeout(a._timer); a._timer = null } }; this._onTimeout = function () { if (!a._responseAvailable) { a._clearTimer(); a._timedOut = true; a._xmlHttpRequest.onreadystatechange = Function.emptyMethod; a._xmlHttpRequest.abort(); a._webRequest.completed(Sys.EventArgs.Empty); a._xmlHttpRequest = null } } }; Sys.Net.XMLHttpExecutor.prototype = { get_timedOut: function () { return this._timedOut }, get_started: function () { return this._started }, get_responseAvailable: function () { return this._responseAvailable }, get_aborted: function () { return this._aborted }, executeRequest: function () { this._webRequest = this.get_webRequest(); var c = this._webRequest.get_body(), a = this._webRequest.get_headers(); this._xmlHttpRequest = new XMLHttpRequest; this._xmlHttpRequest.onreadystatechange = this._onReadyStateChange; var e = this._webRequest.get_httpVerb(); this._xmlHttpRequest.open(e, this._webRequest.getResolvedUrl(), true); this._xmlHttpRequest.setRequestHeader("X-Requested-With", "XMLHttpRequest"); if (a) for (var b in a) { var f = a[b]; if (typeof f !== "function") this._xmlHttpRequest.setRequestHeader(b, f) } if (e.toLowerCase() === "post") { if (a === null || !a["Content-Type"]) this._xmlHttpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8"); if (!c) c = "" } var d = this._webRequest.get_timeout(); if (d > 0) this._timer = window.setTimeout(Function.createDelegate(this, this._onTimeout), d); this._xmlHttpRequest.send(c); this._started = true }, getResponseHeader: function (b) { var a; try { a = this._xmlHttpRequest.getResponseHeader(b) } catch (c) { } if (!a) a = ""; return a }, getAllResponseHeaders: function () { return this._xmlHttpRequest.getAllResponseHeaders() }, get_responseData: function () { return this._xmlHttpRequest.responseText }, get_statusCode: function () { var a = 0; try { a = this._xmlHttpRequest.status } catch (b) { } return a }, get_statusText: function () { return this._xmlHttpRequest.statusText }, get_xml: function () { var a = this._xmlHttpRequest.responseXML; if (!a || !a.documentElement) { a = Sys.Net.XMLDOM(this._xmlHttpRequest.responseText); if (!a || !a.documentElement) return null } else if (navigator.userAgent.indexOf("MSIE") !== -1 && typeof a.setProperty != "undefined") a.setProperty("SelectionLanguage", "XPath"); if (a.documentElement.namespaceURI === "http://www.mozilla.org/newlayout/xml/parsererror.xml" && a.documentElement.tagName === "parsererror") return null; if (a.documentElement.firstChild && a.documentElement.firstChild.tagName === "parsererror") return null; return a }, abort: function () { if (this._aborted || this._responseAvailable || this._timedOut) return; this._aborted = true; this._clearTimer(); if (this._xmlHttpRequest && !this._responseAvailable) { this._xmlHttpRequest.onreadystatechange = Function.emptyMethod; this._xmlHttpRequest.abort(); this._xmlHttpRequest = null; this._webRequest.completed(Sys.EventArgs.Empty) } } }; Sys.Net.XMLHttpExecutor.registerClass("Sys.Net.XMLHttpExecutor", Sys.Net.WebRequestExecutor); Sys.Net._WebRequestManager = function () { this._defaultTimeout = 0; this._defaultExecutorType = "Sys.Net.XMLHttpExecutor" }; Sys.Net._WebRequestManager.prototype = { add_invokingRequest: function (a) { this._get_eventHandlerList().addHandler("invokingRequest", a) }, remove_invokingRequest: function (a) { this._get_eventHandlerList().removeHandler("invokingRequest", a) }, add_completedRequest: function (a) { this._get_eventHandlerList().addHandler("completedRequest", a) }, remove_completedRequest: function (a) { this._get_eventHandlerList().removeHandler("completedRequest", a) }, _get_eventHandlerList: function () { if (!this._events) this._events = new Sys.EventHandlerList; return this._events }, get_defaultTimeout: function () { return this._defaultTimeout }, set_defaultTimeout: function (a) { this._defaultTimeout = a }, get_defaultExecutorType: function () { return this._defaultExecutorType }, set_defaultExecutorType: function (a) { this._defaultExecutorType = a }, executeRequest: function (webRequest) { var executor = webRequest.get_executor(); if (!executor) { var failed = false; try { var executorType = eval(this._defaultExecutorType); executor = new executorType } catch (a) { failed = true } webRequest.set_executor(executor) } if (executor.get_aborted()) return; var evArgs = new Sys.Net.NetworkRequestEventArgs(webRequest), handler = this._get_eventHandlerList().getHandler("invokingRequest"); if (handler) handler(this, evArgs); if (!evArgs.get_cancel()) executor.executeRequest() } }; Sys.Net._WebRequestManager.registerClass("Sys.Net._WebRequestManager"); Sys.Net.WebRequestManager = new Sys.Net._WebRequestManager; Sys.Net.NetworkRequestEventArgs = function (a) { Sys.Net.NetworkRequestEventArgs.initializeBase(this); this._webRequest = a }; Sys.Net.NetworkRequestEventArgs.prototype = { get_webRequest: function () { return this._webRequest } }; Sys.Net.NetworkRequestEventArgs.registerClass("Sys.Net.NetworkRequestEventArgs", Sys.CancelEventArgs); Sys.Net.WebRequest = function () { this._url = ""; this._headers = {}; this._body = null; this._userContext = null; this._httpVerb = null; this._executor = null; this._invokeCalled = false; this._timeout = 0 }; Sys.Net.WebRequest.prototype = { add_completed: function (a) { this._get_eventHandlerList().addHandler("completed", a) }, remove_completed: function (a) { this._get_eventHandlerList().removeHandler("completed", a) }, completed: function (b) { var a = Sys.Net.WebRequestManager._get_eventHandlerList().getHandler("completedRequest"); if (a) a(this._executor, b); a = this._get_eventHandlerList().getHandler("completed"); if (a) a(this._executor, b) }, _get_eventHandlerList: function () { if (!this._events) this._events = new Sys.EventHandlerList; return this._events }, get_url: function () { return this._url }, set_url: function (a) { this._url = a }, get_headers: function () { return this._headers }, get_httpVerb: function () { if (this._httpVerb === null) { if (this._body === null) return "GET"; return "POST" } return this._httpVerb }, set_httpVerb: function (a) { this._httpVerb = a }, get_body: function () { return this._body }, set_body: function (a) { this._body = a }, get_userContext: function () { return this._userContext }, set_userContext: function (a) { this._userContext = a }, get_executor: function () { return this._executor }, set_executor: function (a) { this._executor = a; this._executor._set_webRequest(this) }, get_timeout: function () { if (this._timeout === 0) return Sys.Net.WebRequestManager.get_defaultTimeout(); return this._timeout }, set_timeout: function (a) { this._timeout = a }, getResolvedUrl: function () { return Sys.Net.WebRequest._resolveUrl(this._url) }, invoke: function () { Sys.Net.WebRequestManager.executeRequest(this); this._invokeCalled = true } }; Sys.Net.WebRequest._resolveUrl = function (b, a) { if (b && b.indexOf("://") !== -1) return b; if (!a || a.length === 0) { var d = document.getElementsByTagName("base")[0]; if (d && d.href && d.href.length > 0) a = d.href; else a = document.URL } var c = a.indexOf("?"); if (c !== -1) a = a.substr(0, c); c = a.indexOf("#"); if (c !== -1) a = a.substr(0, c); a = a.substr(0, a.lastIndexOf("/") + 1); if (!b || b.length === 0) return a; if (b.charAt(0) === "/") { var e = a.indexOf("://"), g = a.indexOf("/", e + 3); return a.substr(0, g) + b } else { var f = a.lastIndexOf("/"); return a.substr(0, f + 1) + b } }; Sys.Net.WebRequest._createQueryString = function (c, b, f) { b = b || encodeURIComponent; var h = 0, e, g, d, a = new Sys.StringBuilder; if (c) for (d in c) { e = c[d]; if (typeof e === "function") continue; g = Sys.Serialization.JavaScriptSerializer.serialize(e); if (h++) a.append("&"); a.append(d); a.append("="); a.append(b(g)) } if (f) { if (h) a.append("&"); a.append(f) } return a.toString() }; Sys.Net.WebRequest._createUrl = function (a, b, c) { if (!b && !c) return a; var d = Sys.Net.WebRequest._createQueryString(b, null, c); return d.length ? a + (a && a.indexOf("?") >= 0 ? "&" : "?") + d : a }; Sys.Net.WebRequest.registerClass("Sys.Net.WebRequest"); Sys._ScriptLoaderTask = function (b, a) { this._scriptElement = b; this._completedCallback = a }; Sys._ScriptLoaderTask.prototype = { get_scriptElement: function () { return this._scriptElement }, dispose: function () { if (this._disposed) return; this._disposed = true; this._removeScriptElementHandlers(); Sys._ScriptLoaderTask._clearScript(this._scriptElement); this._scriptElement = null }, execute: function () { if (this._ensureReadyStateLoaded()) this._executeInternal() }, _executeInternal: function () { this._addScriptElementHandlers(); document.getElementsByTagName("head")[0].appendChild(this._scriptElement) }, _ensureReadyStateLoaded: function () { if (this._useReadyState() && this._scriptElement.readyState !== "loaded" && this._scriptElement.readyState !== "complete") { this._scriptDownloadDelegate = Function.createDelegate(this, this._executeInternal); $addHandler(this._scriptElement, "readystatechange", this._scriptDownloadDelegate); return false } return true }, _addScriptElementHandlers: function () { if (this._scriptDownloadDelegate) { $removeHandler(this._scriptElement, "readystatechange", this._scriptDownloadDelegate); this._scriptDownloadDelegate = null } this._scriptLoadDelegate = Function.createDelegate(this, this._scriptLoadHandler); if (this._useReadyState()) $addHandler(this._scriptElement, "readystatechange", this._scriptLoadDelegate); else $addHandler(this._scriptElement, "load", this._scriptLoadDelegate); if (this._scriptElement.addEventListener) { this._scriptErrorDelegate = Function.createDelegate(this, this._scriptErrorHandler); this._scriptElement.addEventListener("error", this._scriptErrorDelegate, false) } }, _removeScriptElementHandlers: function () { if (this._scriptLoadDelegate) { var a = this.get_scriptElement(); if (this._scriptDownloadDelegate) { $removeHandler(this._scriptElement, "readystatechange", this._scriptDownloadDelegate); this._scriptDownloadDelegate = null } if (this._useReadyState() && this._scriptLoadDelegate) $removeHandler(a, "readystatechange", this._scriptLoadDelegate); else $removeHandler(a, "load", this._scriptLoadDelegate); if (this._scriptErrorDelegate) { this._scriptElement.removeEventListener("error", this._scriptErrorDelegate, false); this._scriptErrorDelegate = null } this._scriptLoadDelegate = null } }, _scriptErrorHandler: function () { if (this._disposed) return; this._completedCallback(this.get_scriptElement(), false) }, _scriptLoadHandler: function () { if (this._disposed) return; var a = this.get_scriptElement(); if (this._useReadyState() && a.readyState !== "complete") return; this._completedCallback(a, true) }, _useReadyState: function () { return Sys.Browser.agent === Sys.Browser.InternetExplorer && (Sys.Browser.version < 9 || (document.documentMode || 0) < 9) } }; Sys._ScriptLoaderTask.registerClass("Sys._ScriptLoaderTask", null, Sys.IDisposable); Sys._ScriptLoaderTask._clearScript = function (a) { if (!Sys.Debug.isDebug && a.parentNode) a.parentNode.removeChild(a) }; Type.registerNamespace("Sys.Net"); Sys.Net.WebServiceProxy = function () { }; Sys.Net.WebServiceProxy.prototype = { get_timeout: function () { return this._timeout || 0 }, set_timeout: function (a) { if (a < 0) throw Error.argumentOutOfRange("value", a, Sys.Res.invalidTimeout); this._timeout = a }, get_defaultUserContext: function () { return typeof this._userContext === "undefined" ? null : this._userContext }, set_defaultUserContext: function (a) { this._userContext = a }, get_defaultSucceededCallback: function () { return this._succeeded || null }, set_defaultSucceededCallback: function (a) { this._succeeded = a }, get_defaultFailedCallback: function () { return this._failed || null }, set_defaultFailedCallback: function (a) { this._failed = a }, get_enableJsonp: function () { return !!this._jsonp }, set_enableJsonp: function (a) { this._jsonp = a }, get_path: function () { return this._path || null }, set_path: function (a) { this._path = a }, get_jsonpCallbackParameter: function () { return this._callbackParameter || "callback" }, set_jsonpCallbackParameter: function (a) { this._callbackParameter = a }, _invoke: function (d, e, g, f, c, b, a) { c = c || this.get_defaultSucceededCallback(); b = b || this.get_defaultFailedCallback(); if (a === null || typeof a === "undefined") a = this.get_defaultUserContext(); return Sys.Net.WebServiceProxy.invoke(d, e, g, f, c, b, a, this.get_timeout(), this.get_enableJsonp(), this.get_jsonpCallbackParameter()) } }; Sys.Net.WebServiceProxy.registerClass("Sys.Net.WebServiceProxy"); Sys.Net.WebServiceProxy.invoke = function (q, a, m, l, j, b, g, e, w, p) { var i = w !== false ? Sys.Net.WebServiceProxy._xdomain.exec(q) : null, c, n = i && i.length === 3 && (i[1] !== location.protocol || i[2] !== location.host); m = n || m; if (n) { p = p || "callback"; c = "_jsonp" + Sys._jsonp++ } if (!l) l = {}; var r = l; if (!m || !r) r = {}; var s, h, f = null, k, o = null, u = Sys.Net.WebRequest._createUrl(a ? q + "/" + encodeURIComponent(a) : q, r, n ? p + "=Sys." + c : null); if (n) { s = document.createElement("script"); s.src = u; k = new Sys._ScriptLoaderTask(s, function (d, b) { if (!b || c) t({ Message: String.format(Sys.Res.webServiceFailedNoMsg, a) }, -1) }); function v() { if (f === null) return; f = null; h = new Sys.Net.WebServiceError(true, String.format(Sys.Res.webServiceTimedOut, a)); k.dispose(); delete Sys[c]; if (b) b(h, g, a) } function t(d, e) { if (f !== null) { window.clearTimeout(f); f = null } k.dispose(); delete Sys[c]; c = null; if (typeof e !== "undefined" && e !== 200) { if (b) { h = new Sys.Net.WebServiceError(false, d.Message || String.format(Sys.Res.webServiceFailedNoMsg, a), d.StackTrace || null, d.ExceptionType || null, d); h._statusCode = e; b(h, g, a) } } else if (j) j(d, g, a) } Sys[c] = t; e = e || Sys.Net.WebRequestManager.get_defaultTimeout(); if (e > 0) f = window.setTimeout(v, e); k.execute(); return null } var d = new Sys.Net.WebRequest; d.set_url(u); d.get_headers()["Content-Type"] = "application/json; charset=utf-8"; if (!m) { o = Sys.Serialization.JavaScriptSerializer.serialize(l); if (o === "{}") o = "" } d.set_body(o); d.add_completed(x); if (e && e > 0) d.set_timeout(e); d.invoke(); function x(d) { if (d.get_responseAvailable()) { var f = d.get_statusCode(), c = null; try { var e = d.getResponseHeader("Content-Type"); if (e.startsWith("application/json")) c = d.get_object(); else if (e.startsWith("text/xml")) c = d.get_xml(); else c = d.get_responseData() } catch (m) { } var k = d.getResponseHeader("jsonerror"), h = k === "true"; if (h) { if (c) c = new Sys.Net.WebServiceError(false, c.Message, c.StackTrace, c.ExceptionType, c) } else if (e.startsWith("application/json")) c = !c || typeof c.d === "undefined" ? c : c.d; if (f < 200 || f >= 300 || h) { if (b) { if (!c || !h) c = new Sys.Net.WebServiceError(false, String.format(Sys.Res.webServiceFailedNoMsg, a)); c._statusCode = f; b(c, g, a) } } else if (j) j(c, g, a) } else { var i; if (d.get_timedOut()) i = String.format(Sys.Res.webServiceTimedOut, a); else i = String.format(Sys.Res.webServiceFailedNoMsg, a); if (b) b(new Sys.Net.WebServiceError(d.get_timedOut(), i, "", ""), g, a) } } return d }; Sys.Net.WebServiceProxy._generateTypedConstructor = function (a) { return function (b) { if (b) for (var c in b) this[c] = b[c]; this.__type = a } }; Sys._jsonp = 0; Sys.Net.WebServiceProxy._xdomain = /^\s*([a-zA-Z0-9\+\-\.]+\:)\/\/([^?#\/]+)/; Sys.Net.WebServiceError = function (d, e, c, a, b) { this._timedOut = d; this._message = e; this._stackTrace = c; this._exceptionType = a; this._errorObject = b; this._statusCode = -1 }; Sys.Net.WebServiceError.prototype = { get_timedOut: function () { return this._timedOut }, get_statusCode: function () { return this._statusCode }, get_message: function () { return this._message }, get_stackTrace: function () { return this._stackTrace || "" }, get_exceptionType: function () { return this._exceptionType || "" }, get_errorObject: function () { return this._errorObject || null } }; Sys.Net.WebServiceError.registerClass("Sys.Net.WebServiceError");
Type.registerNamespace('Sys'); Sys.Res = {
    "argumentInteger": "Значение должно быть целым числом.", "invokeCalledTwice": "Не удается направить вызов больше одного раза.", "webServiceFailed": "Сбой метода сервера \"{0}\" из-за ошибки: {1}", "argumentType": "Не удается преобразовать объект в требуемый тип.", "argumentNull": "Значение не может быть неопределенным.", "scriptAlreadyLoaded": "Обнаружено несколько ссылок на скрипт \"{0}\". Если используются прямые ссылки на скрипты Microsoft AJAX, задайте для свойства MicrosoftAjaxMode диспетчера ScriptManager значение Explicit.", "scriptDependencyNotFound": "Не удалось загрузить скрипт \"{0}\", поскольку он зависит от скрипта \"{1}\".", "formatBadFormatSpecifier": "Недопустимый описатель формата.", "requiredScriptReferenceNotIncluded": "Для \"{0}\" требуется включить в \"{1}\" ссылку на скрипт.", "webServiceFailedNoMsg": "Сбой метода сервера \"{0}\".", "argumentDomElement": "Значение должно быть элементом DOM.", "invalidExecutorType": "Не удалось создать допустимый Sys.Net.WebRequestExecutor из: {0}.", "cannotCallBeforeResponse": "Не удается вызвать {0}, если responseAvailable имеет значение false.", "actualValue": "Фактическое значение было {0}.", "enumInvalidValue": "\"{0}\" не является допустимым значением для перечисления {1}.", "scriptLoadFailed": "Не удалось загрузить скрипт \"{0}\".", "parameterCount": "Несоответствие числа параметров.", "cannotDeserializeEmptyString": "Не удается десериализовать пустую строку.", "formatInvalidString": "Входная строка имела неверный формат.", "invalidTimeout": "Значение должно быть больше или равно 0.", "cannotAbortBeforeStart": "Не удается прервать, если не запущен исполнитель.", "argument": "Значение не попадает в ожидаемый диапазон.", "cannotDeserializeInvalidJson": "Не удается десериализовать. Данные не соответствуют допустимому JSON.", "invalidHttpVerb": "Не удается задать httpVerb как пустую строку или строку со значением NULL.", "nullWebRequest": "Не удается вызвать executeRequest с webRequest, имеющим значение NULL.", "eventHandlerInvalid": "Обработчик не был добавлен с помощью метода Sys.UI.DomEvent.addHandler.", "cannotSerializeNonFiniteNumbers": "Не удается сериализовать неконечные числа.", "argumentUndefined": "Значение не может быть неопределенным.", "webServiceInvalidReturnType": "Метод сервера \"{0}\" возвратил недопустимый тип. Ожидается тип: {1}", "servicePathNotSet": "Путь к веб-службе не был задан.", "argumentTypeWithTypes": "Невозможно преобразовать объект типа \"{0}\" к типу \"{1}\".", "cannotCallOnceStarted": "Не удается вызвать {0} после старта.", "badBaseUrl1": "Базовый URL-адрес не содержит ://.", "badBaseUrl2": "Базовый URL-адрес не содержит еще одного символа /.", "badBaseUrl3": "Не удается найти завершающий символа/ в базовом URL-адресе.", "setExecutorAfterActive": "Не удается задать исполнителя после его активизации.", "paramName": "Имя параметра: {0}", "nullReferenceInPath": "Обнаружена null-ссылка во время вычисления пути к данным: \"{0}\".", "cannotCallOutsideHandler": "Не удается вызвать {0}, который находится вне пределов обработчика завершенного события.", "cannotSerializeObjectWithCycle": "Не удается сериализовать объект с циклической ссылкой в дочерних свойствах.", "format": "Один из идентифицированных элементов имел недопустимый формат.", "assertFailedCaller": "Ошибка при выполнении утверждения: {0}\r\nв {1}", "argumentOutOfRange": "Заданный аргумент находится вне диапазона допустимых значений.", "webServiceTimedOut": "Превышен интервал ожидания для метода сервера \"{0}\".", "notImplemented": "Метод или операция не реализована.", "assertFailed": "Ошибка при выполнении утверждения: {0}", "invalidOperation": "Операция является недопустимой из-за текущего состояния объекта.", "breakIntoDebugger": "{0}\r\n\r\nПереключиться в отладчик?"
};
/* END MicrosoftAjax.js */
/* START MicrosoftAjaxWebForms.js */
//----------------------------------------------------------
// Copyright (C) Microsoft Corporation. All rights reserved.
//----------------------------------------------------------
// MicrosoftAjaxWebForms.js
Type._registerScript("MicrosoftAjaxWebForms.js", ["MicrosoftAjaxCore.js", "MicrosoftAjaxSerialization.js", "MicrosoftAjaxNetwork.js", "MicrosoftAjaxComponentModel.js"]); Type.registerNamespace("Sys.WebForms"); Sys.WebForms.BeginRequestEventArgs = function (c, b, a) { Sys.WebForms.BeginRequestEventArgs.initializeBase(this); this._request = c; this._postBackElement = b; this._updatePanelsToUpdate = a }; Sys.WebForms.BeginRequestEventArgs.prototype = { get_postBackElement: function () { return this._postBackElement }, get_request: function () { return this._request }, get_updatePanelsToUpdate: function () { return this._updatePanelsToUpdate ? Array.clone(this._updatePanelsToUpdate) : [] } }; Sys.WebForms.BeginRequestEventArgs.registerClass("Sys.WebForms.BeginRequestEventArgs", Sys.EventArgs); Sys.WebForms.EndRequestEventArgs = function (c, a, b) { Sys.WebForms.EndRequestEventArgs.initializeBase(this); this._errorHandled = false; this._error = c; this._dataItems = a || {}; this._response = b }; Sys.WebForms.EndRequestEventArgs.prototype = { get_dataItems: function () { return this._dataItems }, get_error: function () { return this._error }, get_errorHandled: function () { return this._errorHandled }, set_errorHandled: function (a) { this._errorHandled = a }, get_response: function () { return this._response } }; Sys.WebForms.EndRequestEventArgs.registerClass("Sys.WebForms.EndRequestEventArgs", Sys.EventArgs); Sys.WebForms.InitializeRequestEventArgs = function (c, b, a) { Sys.WebForms.InitializeRequestEventArgs.initializeBase(this); this._request = c; this._postBackElement = b; this._updatePanelsToUpdate = a }; Sys.WebForms.InitializeRequestEventArgs.prototype = { get_postBackElement: function () { return this._postBackElement }, get_request: function () { return this._request }, get_updatePanelsToUpdate: function () { return this._updatePanelsToUpdate ? Array.clone(this._updatePanelsToUpdate) : [] }, set_updatePanelsToUpdate: function (a) { this._updated = true; this._updatePanelsToUpdate = a } }; Sys.WebForms.InitializeRequestEventArgs.registerClass("Sys.WebForms.InitializeRequestEventArgs", Sys.CancelEventArgs); Sys.WebForms.PageLoadedEventArgs = function (b, a, c) { Sys.WebForms.PageLoadedEventArgs.initializeBase(this); this._panelsUpdated = b; this._panelsCreated = a; this._dataItems = c || {} }; Sys.WebForms.PageLoadedEventArgs.prototype = { get_dataItems: function () { return this._dataItems }, get_panelsCreated: function () { return this._panelsCreated }, get_panelsUpdated: function () { return this._panelsUpdated } }; Sys.WebForms.PageLoadedEventArgs.registerClass("Sys.WebForms.PageLoadedEventArgs", Sys.EventArgs); Sys.WebForms.PageLoadingEventArgs = function (b, a, c) { Sys.WebForms.PageLoadingEventArgs.initializeBase(this); this._panelsUpdating = b; this._panelsDeleting = a; this._dataItems = c || {} }; Sys.WebForms.PageLoadingEventArgs.prototype = { get_dataItems: function () { return this._dataItems }, get_panelsDeleting: function () { return this._panelsDeleting }, get_panelsUpdating: function () { return this._panelsUpdating } }; Sys.WebForms.PageLoadingEventArgs.registerClass("Sys.WebForms.PageLoadingEventArgs", Sys.EventArgs); Sys._ScriptLoader = function () { this._scriptsToLoad = null; this._sessions = []; this._scriptLoadedDelegate = Function.createDelegate(this, this._scriptLoadedHandler) }; Sys._ScriptLoader.prototype = { dispose: function () { this._stopSession(); this._loading = false; if (this._events) delete this._events; this._sessions = null; this._currentSession = null; this._scriptLoadedDelegate = null }, loadScripts: function (d, b, c, a) { var e = { allScriptsLoadedCallback: b, scriptLoadFailedCallback: c, scriptLoadTimeoutCallback: a, scriptsToLoad: this._scriptsToLoad, scriptTimeout: d }; this._scriptsToLoad = null; this._sessions[this._sessions.length] = e; if (!this._loading) this._nextSession() }, queueCustomScriptTag: function (a) { if (!this._scriptsToLoad) this._scriptsToLoad = []; Array.add(this._scriptsToLoad, a) }, queueScriptBlock: function (a) { if (!this._scriptsToLoad) this._scriptsToLoad = []; Array.add(this._scriptsToLoad, { text: a }) }, queueScriptReference: function (a, b) { if (!this._scriptsToLoad) this._scriptsToLoad = []; Array.add(this._scriptsToLoad, { src: a, fallback: b }) }, _createScriptElement: function (c) { var a = document.createElement("script"); a.type = "text/javascript"; for (var b in c) a[b] = c[b]; return a }, _loadScriptsInternal: function () { var c = this._currentSession; if (c.scriptsToLoad && c.scriptsToLoad.length > 0) { var b = Array.dequeue(c.scriptsToLoad), f = this._scriptLoadedDelegate; if (b.fallback) { var g = b.fallback; delete b.fallback; var d = this; f = function (b, a) { a || function () { var a = d._createScriptElement({ src: g }); d._currentTask = new Sys._ScriptLoaderTask(a, d._scriptLoadedDelegate); d._currentTask.execute() }() } } var a = this._createScriptElement(b); if (a.text && Sys.Browser.agent === Sys.Browser.Safari) { a.innerHTML = a.text; delete a.text } if (typeof b.src === "string") { this._currentTask = new Sys._ScriptLoaderTask(a, f); this._currentTask.execute() } else { document.getElementsByTagName("head")[0].appendChild(a); Sys._ScriptLoaderTask._clearScript(a); this._loadScriptsInternal() } } else { this._stopSession(); var e = c.allScriptsLoadedCallback; if (e) e(this); this._nextSession() } }, _nextSession: function () { if (this._sessions.length === 0) { this._loading = false; this._currentSession = null; return } this._loading = true; var a = Array.dequeue(this._sessions); this._currentSession = a; if (a.scriptTimeout > 0) this._timeoutCookie = window.setTimeout(Function.createDelegate(this, this._scriptLoadTimeoutHandler), a.scriptTimeout * 1000); this._loadScriptsInternal() }, _raiseError: function () { var b = this._currentSession.scriptLoadFailedCallback, a = this._currentTask.get_scriptElement(); this._stopSession(); if (b) { b(this, a); this._nextSession() } else { this._loading = false; throw Sys._ScriptLoader._errorScriptLoadFailed(a.src) } }, _scriptLoadedHandler: function (a, b) { if (b) { Array.add(Sys._ScriptLoader._getLoadedScripts(), a.src); this._currentTask.dispose(); this._currentTask = null; this._loadScriptsInternal() } else this._raiseError() }, _scriptLoadTimeoutHandler: function () { var a = this._currentSession.scriptLoadTimeoutCallback; this._stopSession(); if (a) a(this); this._nextSession() }, _stopSession: function () { if (this._timeoutCookie) { window.clearTimeout(this._timeoutCookie); this._timeoutCookie = null } if (this._currentTask) { this._currentTask.dispose(); this._currentTask = null } } }; Sys._ScriptLoader.registerClass("Sys._ScriptLoader", null, Sys.IDisposable); Sys._ScriptLoader.getInstance = function () { var a = Sys._ScriptLoader._activeInstance; if (!a) a = Sys._ScriptLoader._activeInstance = new Sys._ScriptLoader; return a }; Sys._ScriptLoader.isScriptLoaded = function (b) { var a = document.createElement("script"); a.src = b; return Array.contains(Sys._ScriptLoader._getLoadedScripts(), a.src) }; Sys._ScriptLoader.readLoadedScripts = function () { if (!Sys._ScriptLoader._referencedScripts) { var c = Sys._ScriptLoader._referencedScripts = [], d = document.getElementsByTagName("script"); for (var b = d.length - 1; b >= 0; b--) { var e = d[b], a = e.src; if (a.length) if (!Array.contains(c, a)) Array.add(c, a) } } }; Sys._ScriptLoader._errorScriptLoadFailed = function (b) { var a; a = Sys.Res.scriptLoadFailed; var d = "Sys.ScriptLoadFailedException: " + String.format(a, b), c = Error.create(d, { name: "Sys.ScriptLoadFailedException", "scriptUrl": b }); c.popStackFrame(); return c }; Sys._ScriptLoader._getLoadedScripts = function () { if (!Sys._ScriptLoader._referencedScripts) { Sys._ScriptLoader._referencedScripts = []; Sys._ScriptLoader.readLoadedScripts() } return Sys._ScriptLoader._referencedScripts }; Sys.WebForms.PageRequestManager = function () { this._form = null; this._activeDefaultButton = null; this._activeDefaultButtonClicked = false; this._updatePanelIDs = null; this._updatePanelClientIDs = null; this._updatePanelHasChildrenAsTriggers = null; this._asyncPostBackControlIDs = null; this._asyncPostBackControlClientIDs = null; this._postBackControlIDs = null; this._postBackControlClientIDs = null; this._scriptManagerID = null; this._pageLoadedHandler = null; this._additionalInput = null; this._onsubmit = null; this._onSubmitStatements = []; this._originalDoPostBack = null; this._originalDoPostBackWithOptions = null; this._originalFireDefaultButton = null; this._originalDoCallback = null; this._isCrossPost = false; this._postBackSettings = null; this._request = null; this._onFormSubmitHandler = null; this._onFormElementClickHandler = null; this._onWindowUnloadHandler = null; this._asyncPostBackTimeout = null; this._controlIDToFocus = null; this._scrollPosition = null; this._processingRequest = false; this._scriptDisposes = {}; this._transientFields = ["__VIEWSTATEENCRYPTED", "__VIEWSTATEFIELDCOUNT"]; this._textTypes = /^(text|password|hidden|search|tel|url|email|number|range|color|datetime|date|month|week|time|datetime-local)$/i }; Sys.WebForms.PageRequestManager.prototype = { _get_eventHandlerList: function () { if (!this._events) this._events = new Sys.EventHandlerList; return this._events }, get_isInAsyncPostBack: function () { return this._request !== null }, add_beginRequest: function (a) { this._get_eventHandlerList().addHandler("beginRequest", a) }, remove_beginRequest: function (a) { this._get_eventHandlerList().removeHandler("beginRequest", a) }, add_endRequest: function (a) { this._get_eventHandlerList().addHandler("endRequest", a) }, remove_endRequest: function (a) { this._get_eventHandlerList().removeHandler("endRequest", a) }, add_initializeRequest: function (a) { this._get_eventHandlerList().addHandler("initializeRequest", a) }, remove_initializeRequest: function (a) { this._get_eventHandlerList().removeHandler("initializeRequest", a) }, add_pageLoaded: function (a) { this._get_eventHandlerList().addHandler("pageLoaded", a) }, remove_pageLoaded: function (a) { this._get_eventHandlerList().removeHandler("pageLoaded", a) }, add_pageLoading: function (a) { this._get_eventHandlerList().addHandler("pageLoading", a) }, remove_pageLoading: function (a) { this._get_eventHandlerList().removeHandler("pageLoading", a) }, abortPostBack: function () { if (!this._processingRequest && this._request) { this._request.get_executor().abort(); this._request = null } }, beginAsyncPostBack: function (c, a, f, d, e) { if (d && typeof Page_ClientValidate === "function" && !Page_ClientValidate(e || null)) return; this._postBackSettings = this._createPostBackSettings(true, c, a); var b = this._form; b.__EVENTTARGET.value = a || ""; b.__EVENTARGUMENT.value = f || ""; this._isCrossPost = false; this._additionalInput = null; this._onFormSubmit() }, _cancelPendingCallbacks: function () { for (var a = 0, e = window.__pendingCallbacks.length; a < e; a++) { var c = window.__pendingCallbacks[a]; if (c) { if (!c.async) window.__synchronousCallBackIndex = -1; window.__pendingCallbacks[a] = null; var d = "__CALLBACKFRAME" + a, b = document.getElementById(d); if (b) b.parentNode.removeChild(b) } } }, _commitControls: function (a, b) { if (a) { this._updatePanelIDs = a.updatePanelIDs; this._updatePanelClientIDs = a.updatePanelClientIDs; this._updatePanelHasChildrenAsTriggers = a.updatePanelHasChildrenAsTriggers; this._asyncPostBackControlIDs = a.asyncPostBackControlIDs; this._asyncPostBackControlClientIDs = a.asyncPostBackControlClientIDs; this._postBackControlIDs = a.postBackControlIDs; this._postBackControlClientIDs = a.postBackControlClientIDs } if (typeof b !== "undefined" && b !== null) this._asyncPostBackTimeout = b * 1000 }, _createHiddenField: function (c, d) { var b, a = document.getElementById(c); if (a) if (!a._isContained) a.parentNode.removeChild(a); else b = a.parentNode; if (!b) { b = document.createElement("span"); b.style.cssText = "display:none !important"; this._form.appendChild(b) } b.innerHTML = "<input type='hidden' />"; a = b.childNodes[0]; a._isContained = true; a.id = a.name = c; a.value = d }, _createPageRequestManagerTimeoutError: function () { var b = "Sys.WebForms.PageRequestManagerTimeoutException: " + Sys.WebForms.Res.PRM_TimeoutError, a = Error.create(b, { name: "Sys.WebForms.PageRequestManagerTimeoutException" }); a.popStackFrame(); return a }, _createPageRequestManagerServerError: function (a, d) { var c = "Sys.WebForms.PageRequestManagerServerErrorException: " + (d || String.format(Sys.WebForms.Res.PRM_ServerError, a)), b = Error.create(c, { name: "Sys.WebForms.PageRequestManagerServerErrorException", httpStatusCode: a }); b.popStackFrame(); return b }, _createPageRequestManagerParserError: function (b) { var c = "Sys.WebForms.PageRequestManagerParserErrorException: " + String.format(Sys.WebForms.Res.PRM_ParserError, b), a = Error.create(c, { name: "Sys.WebForms.PageRequestManagerParserErrorException" }); a.popStackFrame(); return a }, _createPanelID: function (e, b) { var c = b.asyncTarget, a = this._ensureUniqueIds(e || b.panelsToUpdate), d = a instanceof Array ? a.join(",") : a || this._scriptManagerID; if (c) d += "|" + c; return encodeURIComponent(this._scriptManagerID) + "=" + encodeURIComponent(d) + "&" }, _createPostBackSettings: function (d, a, c, b) { return { async: d, asyncTarget: c, panelsToUpdate: a, sourceElement: b } }, _convertToClientIDs: function (a, f, e, d) { if (a) for (var b = 0, h = a.length; b < h; b += d ? 2 : 1) { var c = a[b], g = (d ? a[b + 1] : "") || this._uniqueIDToClientID(c); Array.add(f, c); Array.add(e, g) } }, dispose: function () { if (this._form) { Sys.UI.DomEvent.removeHandler(this._form, "submit", this._onFormSubmitHandler); Sys.UI.DomEvent.removeHandler(this._form, "click", this._onFormElementClickHandler); Sys.UI.DomEvent.removeHandler(window, "unload", this._onWindowUnloadHandler); Sys.UI.DomEvent.removeHandler(window, "load", this._pageLoadedHandler) } if (this._originalDoPostBack) { window.__doPostBack = this._originalDoPostBack; this._originalDoPostBack = null } if (this._originalDoPostBackWithOptions) { window.WebForm_DoPostBackWithOptions = this._originalDoPostBackWithOptions; this._originalDoPostBackWithOptions = null } if (this._originalFireDefaultButton) { window.WebForm_FireDefaultButton = this._originalFireDefaultButton; this._originalFireDefaultButton = null } if (this._originalDoCallback) { window.WebForm_DoCallback = this._originalDoCallback; this._originalDoCallback = null } this._form = null; this._updatePanelIDs = null; this._updatePanelClientIDs = null; this._asyncPostBackControlIDs = null; this._asyncPostBackControlClientIDs = null; this._postBackControlIDs = null; this._postBackControlClientIDs = null; this._asyncPostBackTimeout = null; this._scrollPosition = null; this._activeElement = null }, _doCallback: function (d, b, c, f, a, e) { if (!this.get_isInAsyncPostBack()) this._originalDoCallback(d, b, c, f, a, e) }, _doPostBack: function (a, k) { var f = window.event; if (!f) { var d = arguments.callee ? arguments.callee.caller : null; if (d) { var j = 30; while (d.arguments.callee.caller && --j) d = d.arguments.callee.caller; f = j && d.arguments.length ? d.arguments[0] : null } } this._additionalInput = null; var h = this._form; if (a === null || typeof a === "undefined" || this._isCrossPost) { this._postBackSettings = this._createPostBackSettings(false); this._isCrossPost = false } else { var c = this._masterPageUniqueID, l = this._uniqueIDToClientID(a), g = document.getElementById(l); if (!g && c) if (a.indexOf(c + "$") === 0) g = document.getElementById(l.substr(c.length + 1)); if (!g) if (Array.contains(this._asyncPostBackControlIDs, a)) this._postBackSettings = this._createPostBackSettings(true, null, a); else if (Array.contains(this._postBackControlIDs, a)) this._postBackSettings = this._createPostBackSettings(false); else { var e = this._findNearestElement(a); if (e) this._postBackSettings = this._getPostBackSettings(e, a); else { if (c) { c += "$"; if (a.indexOf(c) === 0) e = this._findNearestElement(a.substr(c.length)) } if (e) this._postBackSettings = this._getPostBackSettings(e, a); else { var b; try { b = f ? f.target || f.srcElement : null } catch (n) { } b = b || this._activeElement; var m = /__doPostBack\(|WebForm_DoPostBackWithOptions\(/; function i(b) { b = b ? b.toString() : ""; return m.test(b) && b.indexOf("'" + a + "'") !== -1 || b.indexOf('"' + a + '"') !== -1 } if (b && (b.name === a || i(b.href) || i(b.onclick) || i(b.onchange))) this._postBackSettings = this._getPostBackSettings(b, a); else this._postBackSettings = this._createPostBackSettings(false) } } } else this._postBackSettings = this._getPostBackSettings(g, a) } if (!this._postBackSettings.async) { h.onsubmit = this._onsubmit; this._originalDoPostBack(a, k); h.onsubmit = null; return } h.__EVENTTARGET.value = a; h.__EVENTARGUMENT.value = k; this._onFormSubmit() }, _doPostBackWithOptions: function (a) { this._isCrossPost = a && a.actionUrl; var d = true; if (a.validation) if (typeof Page_ClientValidate == "function") d = Page_ClientValidate(a.validationGroup); if (d) { if (typeof a.actionUrl != "undefined" && a.actionUrl != null && a.actionUrl.length > 0) theForm.action = a.actionUrl; if (a.trackFocus) { var c = theForm.elements["__LASTFOCUS"]; if (typeof c != "undefined" && c != null) if (typeof document.activeElement == "undefined") c.value = a.eventTarget; else { var b = document.activeElement; if (typeof b != "undefined" && b != null) if (typeof b.id != "undefined" && b.id != null && b.id.length > 0) c.value = b.id; else if (typeof b.name != "undefined") c.value = b.name } } } if (a.clientSubmit) this._doPostBack(a.eventTarget, a.eventArgument) }, _elementContains: function (b, a) { while (a) { if (a === b) return true; a = a.parentNode } return false }, _endPostBack: function (a, d, f) { if (this._request === d.get_webRequest()) { this._processingRequest = false; this._additionalInput = null; this._request = null } var e = this._get_eventHandlerList().getHandler("endRequest"), b = false; if (e) { var c = new Sys.WebForms.EndRequestEventArgs(a, f ? f.dataItems : {}, d); e(this, c); b = c.get_errorHandled() } if (a && !b) throw a }, _ensureUniqueIds: function (a) { if (!a) return a; a = a instanceof Array ? a : [a]; var c = []; for (var b = 0, f = a.length; b < f; b++) { var e = a[b], d = Array.indexOf(this._updatePanelClientIDs, e); c.push(d > -1 ? this._updatePanelIDs[d] : e) } return c }, _findNearestElement: function (a) { while (a.length > 0) { var d = this._uniqueIDToClientID(a), c = document.getElementById(d); if (c) return c; var b = a.lastIndexOf("$"); if (b === -1) return null; a = a.substring(0, b) } return null }, _findText: function (b, a) { var c = Math.max(0, a - 20), d = Math.min(b.length, a + 20); return b.substring(c, d) }, _fireDefaultButton: function (a, d) { if (a.keyCode === 13) { var c = a.srcElement || a.target; if (!c || c.tagName.toLowerCase() !== "textarea") { var b = document.getElementById(d); if (b && typeof b.click !== "undefined") { this._activeDefaultButton = b; this._activeDefaultButtonClicked = false; try { b.click() } finally { this._activeDefaultButton = null } a.cancelBubble = true; if (typeof a.stopPropagation === "function") a.stopPropagation(); return false } } } return true }, _getPageLoadedEventArgs: function (n, c) { var m = [], l = [], k = c ? c.version4 : false, d = c ? c.updatePanelData : null, e, g, h, b; if (!d) { e = this._updatePanelIDs; g = this._updatePanelClientIDs; h = null; b = null } else { e = d.updatePanelIDs; g = d.updatePanelClientIDs; h = d.childUpdatePanelIDs; b = d.panelsToRefreshIDs } var a, f, j, i; if (b) for (a = 0, f = b.length; a < f; a += k ? 2 : 1) { j = b[a]; i = (k ? b[a + 1] : "") || this._uniqueIDToClientID(j); Array.add(m, document.getElementById(i)) } for (a = 0, f = e.length; a < f; a++) if (n || Array.indexOf(h, e[a]) !== -1) Array.add(l, document.getElementById(g[a])); return new Sys.WebForms.PageLoadedEventArgs(m, l, c ? c.dataItems : {}) }, _getPageLoadingEventArgs: function (f) { var j = [], i = [], c = f.updatePanelData, k = c.oldUpdatePanelIDs, l = c.oldUpdatePanelClientIDs, n = c.updatePanelIDs, m = c.childUpdatePanelIDs, d = c.panelsToRefreshIDs, a, e, b, g, h = f.version4; for (a = 0, e = d.length; a < e; a += h ? 2 : 1) { b = d[a]; g = (h ? d[a + 1] : "") || this._uniqueIDToClientID(b); Array.add(j, document.getElementById(g)) } for (a = 0, e = k.length; a < e; a++) { b = k[a]; if (Array.indexOf(d, b) === -1 && (Array.indexOf(n, b) === -1 || Array.indexOf(m, b) > -1)) Array.add(i, document.getElementById(l[a])) } return new Sys.WebForms.PageLoadingEventArgs(j, i, f.dataItems) }, _getPostBackSettings: function (a, c) { var d = a, b = null; while (a) { if (a.id) { if (!b && Array.contains(this._asyncPostBackControlClientIDs, a.id)) b = this._createPostBackSettings(true, null, c, d); else if (!b && Array.contains(this._postBackControlClientIDs, a.id)) return this._createPostBackSettings(false); else { var e = Array.indexOf(this._updatePanelClientIDs, a.id); if (e !== -1) if (this._updatePanelHasChildrenAsTriggers[e]) return this._createPostBackSettings(true, [this._updatePanelIDs[e]], c, d); else return this._createPostBackSettings(true, null, c, d) } if (!b && this._matchesParentIDInList(a.id, this._asyncPostBackControlClientIDs)) b = this._createPostBackSettings(true, null, c, d); else if (!b && this._matchesParentIDInList(a.id, this._postBackControlClientIDs)) return this._createPostBackSettings(false) } a = a.parentNode } if (!b) return this._createPostBackSettings(false); else return b }, _getScrollPosition: function () { var a = document.documentElement; if (a && (this._validPosition(a.scrollLeft) || this._validPosition(a.scrollTop))) return { x: a.scrollLeft, y: a.scrollTop }; else { a = document.body; if (a && (this._validPosition(a.scrollLeft) || this._validPosition(a.scrollTop))) return { x: a.scrollLeft, y: a.scrollTop }; else if (this._validPosition(window.pageXOffset) || this._validPosition(window.pageYOffset)) return { x: window.pageXOffset, y: window.pageYOffset }; else return { x: 0, y: 0 } } }, _initializeInternal: function (f, g, a, b, e, c, d) { if (this._prmInitialized) throw Error.invalidOperation(Sys.WebForms.Res.PRM_CannotRegisterTwice); this._prmInitialized = true; this._masterPageUniqueID = d; this._scriptManagerID = f; this._form = Sys.UI.DomElement.resolveElement(g); this._onsubmit = this._form.onsubmit; this._form.onsubmit = null; this._onFormSubmitHandler = Function.createDelegate(this, this._onFormSubmit); this._onFormElementClickHandler = Function.createDelegate(this, this._onFormElementClick); this._onWindowUnloadHandler = Function.createDelegate(this, this._onWindowUnload); Sys.UI.DomEvent.addHandler(this._form, "submit", this._onFormSubmitHandler); Sys.UI.DomEvent.addHandler(this._form, "click", this._onFormElementClickHandler); Sys.UI.DomEvent.addHandler(window, "unload", this._onWindowUnloadHandler); this._originalDoPostBack = window.__doPostBack; if (this._originalDoPostBack) window.__doPostBack = Function.createDelegate(this, this._doPostBack); this._originalDoPostBackWithOptions = window.WebForm_DoPostBackWithOptions; if (this._originalDoPostBackWithOptions) window.WebForm_DoPostBackWithOptions = Function.createDelegate(this, this._doPostBackWithOptions); this._originalFireDefaultButton = window.WebForm_FireDefaultButton; if (this._originalFireDefaultButton) window.WebForm_FireDefaultButton = Function.createDelegate(this, this._fireDefaultButton); this._originalDoCallback = window.WebForm_DoCallback; if (this._originalDoCallback) window.WebForm_DoCallback = Function.createDelegate(this, this._doCallback); this._pageLoadedHandler = Function.createDelegate(this, this._pageLoadedInitialLoad); Sys.UI.DomEvent.addHandler(window, "load", this._pageLoadedHandler); if (a) this._updateControls(a, b, e, c, true) }, _matchesParentIDInList: function (c, b) { for (var a = 0, d = b.length; a < d; a++) if (c.startsWith(b[a] + "_")) return true; return false }, _onFormElementActive: function (a, d, e) { if (a.disabled) return; this._activeElement = a; this._postBackSettings = this._getPostBackSettings(a, a.name); if (a.name) { var b = a.tagName.toUpperCase(); if (b === "INPUT") { var c = a.type; if (c === "submit") this._additionalInput = encodeURIComponent(a.name) + "=" + encodeURIComponent(a.value); else if (c === "image") this._additionalInput = encodeURIComponent(a.name) + ".x=" + d + "&" + encodeURIComponent(a.name) + ".y=" + e } else if (b === "BUTTON" && a.name.length !== 0 && a.type === "submit") this._additionalInput = encodeURIComponent(a.name) + "=" + encodeURIComponent(a.value) } }, _onFormElementClick: function (a) { this._activeDefaultButtonClicked = a.target === this._activeDefaultButton; this._onFormElementActive(a.target, a.offsetX, a.offsetY) }, _onFormSubmit: function (i) { var f, x, h = true, z = this._isCrossPost; this._isCrossPost = false; if (this._onsubmit) h = this._onsubmit(); if (h) for (f = 0, x = this._onSubmitStatements.length; f < x; f++) if (!this._onSubmitStatements[f]()) { h = false; break } if (!h) { if (i) i.preventDefault(); return } var w = this._form; if (z) return; if (this._activeDefaultButton && !this._activeDefaultButtonClicked) this._onFormElementActive(this._activeDefaultButton, 0, 0); if (!this._postBackSettings || !this._postBackSettings.async) return; var b = new Sys.StringBuilder, s = w.elements, B = s.length, t = this._createPanelID(null, this._postBackSettings); b.append(t); for (f = 0; f < B; f++) { var e = s[f], g = e.name; if (typeof g === "undefined" || g === null || g.length === 0 || g === this._scriptManagerID) continue; var n = e.tagName.toUpperCase(); if (n === "INPUT") { var p = e.type; if (this._textTypes.test(p) || (p === "checkbox" || p === "radio") && e.checked) { b.append(encodeURIComponent(g)); b.append("="); b.append(encodeURIComponent(e.value)); b.append("&") } } else if (n === "SELECT") { var A = e.options.length; for (var q = 0; q < A; q++) { var u = e.options[q]; if (u.selected) { b.append(encodeURIComponent(g)); b.append("="); b.append(encodeURIComponent(u.value)); b.append("&") } } } else if (n === "TEXTAREA") { b.append(encodeURIComponent(g)); b.append("="); b.append(encodeURIComponent(e.value)); b.append("&") } } b.append("__ASYNCPOST=true&"); if (this._additionalInput) { b.append(this._additionalInput); this._additionalInput = null } var c = new Sys.Net.WebRequest, a = w.action; if (Sys.Browser.agent === Sys.Browser.InternetExplorer) { var r = a.indexOf("#"); if (r !== -1) a = a.substr(0, r); var o = "", v = "", m = a.indexOf("?"); if (m !== -1) { v = a.substr(m); a = a.substr(0, m) } if (/^https?\:\/\/.*$/gi.test(a)) { var y = a.indexOf("//") + 2, l = a.indexOf("/", y); if (l === -1) { o = a; a = "" } else { o = a.substr(0, l); a = a.substr(l) } } a = o + encodeURI(decodeURI(a)) + v } c.set_url(a); c.get_headers()["X-MicrosoftAjax"] = "Delta=true"; c.get_headers()["Cache-Control"] = "no-cache"; c.set_timeout(this._asyncPostBackTimeout); c.add_completed(Function.createDelegate(this, this._onFormSubmitCompleted)); c.set_body(b.toString()); var j, d, k = this._get_eventHandlerList().getHandler("initializeRequest"); if (k) { j = this._postBackSettings.panelsToUpdate; d = new Sys.WebForms.InitializeRequestEventArgs(c, this._postBackSettings.sourceElement, j); k(this, d); h = !d.get_cancel() } if (!h) { if (i) i.preventDefault(); return } if (d && d._updated) { j = d.get_updatePanelsToUpdate(); c.set_body(c.get_body().replace(t, this._createPanelID(j, this._postBackSettings))) } this._scrollPosition = this._getScrollPosition(); this.abortPostBack(); k = this._get_eventHandlerList().getHandler("beginRequest"); if (k) { d = new Sys.WebForms.BeginRequestEventArgs(c, this._postBackSettings.sourceElement, j || this._postBackSettings.panelsToUpdate); k(this, d) } if (this._originalDoCallback) this._cancelPendingCallbacks(); this._request = c; this._processingRequest = false; c.invoke(); if (i) i.preventDefault() }, _onFormSubmitCompleted: function (c) { this._processingRequest = true; if (c.get_timedOut()) { this._endPostBack(this._createPageRequestManagerTimeoutError(), c, null); return } if (c.get_aborted()) { this._endPostBack(null, c, null); return } if (!this._request || c.get_webRequest() !== this._request) return; if (c.get_statusCode() !== 200) { this._endPostBack(this._createPageRequestManagerServerError(c.get_statusCode()), c, null); return } var a = this._parseDelta(c); if (!a) return; var b, e; if (a.asyncPostBackControlIDsNode && a.postBackControlIDsNode && a.updatePanelIDsNode && a.panelsToRefreshNode && a.childUpdatePanelIDsNode) { var r = this._updatePanelIDs, n = this._updatePanelClientIDs, i = a.childUpdatePanelIDsNode.content, p = i.length ? i.split(",") : [], m = this._splitNodeIntoArray(a.asyncPostBackControlIDsNode), o = this._splitNodeIntoArray(a.postBackControlIDsNode), q = this._splitNodeIntoArray(a.updatePanelIDsNode), g = this._splitNodeIntoArray(a.panelsToRefreshNode), h = a.version4; for (b = 0, e = g.length; b < e; b += h ? 2 : 1) { var j = (h ? g[b + 1] : "") || this._uniqueIDToClientID(g[b]); if (!document.getElementById(j)) { this._endPostBack(Error.invalidOperation(String.format(Sys.WebForms.Res.PRM_MissingPanel, j)), c, a); return } } var f = this._processUpdatePanelArrays(q, m, o, h); f.oldUpdatePanelIDs = r; f.oldUpdatePanelClientIDs = n; f.childUpdatePanelIDs = p; f.panelsToRefreshIDs = g; a.updatePanelData = f } a.dataItems = {}; var d; for (b = 0, e = a.dataItemNodes.length; b < e; b++) { d = a.dataItemNodes[b]; a.dataItems[d.id] = d.content } for (b = 0, e = a.dataItemJsonNodes.length; b < e; b++) { d = a.dataItemJsonNodes[b]; a.dataItems[d.id] = Sys.Serialization.JavaScriptSerializer.deserialize(d.content) } var l = this._get_eventHandlerList().getHandler("pageLoading"); if (l) l(this, this._getPageLoadingEventArgs(a)); Sys._ScriptLoader.readLoadedScripts(); Sys.Application.beginCreateComponents(); var k = Sys._ScriptLoader.getInstance(); this._queueScripts(k, a.scriptBlockNodes, true, false); this._processingRequest = true; k.loadScripts(0, Function.createDelegate(this, Function.createCallback(this._scriptIncludesLoadComplete, a)), Function.createDelegate(this, Function.createCallback(this._scriptIncludesLoadFailed, a)), null) }, _onWindowUnload: function () { this.dispose() }, _pageLoaded: function (a, c) { var b = this._get_eventHandlerList().getHandler("pageLoaded"); if (b) b(this, this._getPageLoadedEventArgs(a, c)); if (!a) Sys.Application.raiseLoad() }, _pageLoadedInitialLoad: function () { this._pageLoaded(true, null) }, _parseDelta: function (h) { var c = h.get_responseData(), d, i, E, F, D, b = 0, e = null, k = []; while (b < c.length) { d = c.indexOf("|", b); if (d === -1) { e = this._findText(c, b); break } i = parseInt(c.substring(b, d), 10); if (i % 1 !== 0) { e = this._findText(c, b); break } b = d + 1; d = c.indexOf("|", b); if (d === -1) { e = this._findText(c, b); break } E = c.substring(b, d); b = d + 1; d = c.indexOf("|", b); if (d === -1) { e = this._findText(c, b); break } F = c.substring(b, d); b = d + 1; if (b + i >= c.length) { e = this._findText(c, c.length); break } D = c.substr(b, i); b += i; if (c.charAt(b) !== "|") { e = this._findText(c, b); break } b++; Array.add(k, { type: E, id: F, content: D }) } if (e) { this._endPostBack(this._createPageRequestManagerParserError(String.format(Sys.WebForms.Res.PRM_ParserErrorDetails, e)), h, null); return null } var x = [], w = [], q = [], j = [], t = [], C = [], A = [], z = [], v = [], s = [], m, p, u, n, o, r, y, g; for (var l = 0, G = k.length; l < G; l++) { var a = k[l]; switch (a.type) { case "#": g = a; break; case "updatePanel": Array.add(x, a); break; case "hiddenField": Array.add(w, a); break; case "arrayDeclaration": Array.add(q, a); break; case "scriptBlock": Array.add(j, a); break; case "fallbackScript": j[j.length - 1].fallback = a.id; case "scriptStartupBlock": Array.add(t, a); break; case "expando": Array.add(C, a); break; case "onSubmit": Array.add(A, a); break; case "asyncPostBackControlIDs": m = a; break; case "postBackControlIDs": p = a; break; case "updatePanelIDs": u = a; break; case "asyncPostBackTimeout": n = a; break; case "childUpdatePanelIDs": o = a; break; case "panelsToRefreshIDs": r = a; break; case "formAction": y = a; break; case "dataItem": Array.add(z, a); break; case "dataItemJson": Array.add(v, a); break; case "scriptDispose": Array.add(s, a); break; case "pageRedirect": if (g && parseFloat(g.content) >= 4) a.content = unescape(a.content); if (Sys.Browser.agent === Sys.Browser.InternetExplorer) { var f = document.createElement("a"); f.style.display = "none"; f.attachEvent("onclick", B); f.href = a.content; this._form.parentNode.insertBefore(f, this._form); f.click(); f.detachEvent("onclick", B); this._form.parentNode.removeChild(f); function B(a) { a.cancelBubble = true } } else window.location.href = a.content; return null; case "error": this._endPostBack(this._createPageRequestManagerServerError(Number.parseInvariant(a.id), a.content), h, null); return null; case "pageTitle": document.title = a.content; break; case "focus": this._controlIDToFocus = a.content; break; default: this._endPostBack(this._createPageRequestManagerParserError(String.format(Sys.WebForms.Res.PRM_UnknownToken, a.type)), h, null); return null } } return { version4: g ? parseFloat(g.content) >= 4 : false, executor: h, updatePanelNodes: x, hiddenFieldNodes: w, arrayDeclarationNodes: q, scriptBlockNodes: j, scriptStartupNodes: t, expandoNodes: C, onSubmitNodes: A, dataItemNodes: z, dataItemJsonNodes: v, scriptDisposeNodes: s, asyncPostBackControlIDsNode: m, postBackControlIDsNode: p, updatePanelIDsNode: u, asyncPostBackTimeoutNode: n, childUpdatePanelIDsNode: o, panelsToRefreshNode: r, formActionNode: y } }, _processUpdatePanelArrays: function (e, q, r, f) { var d, c, b; if (e) { var i = e.length, j = f ? 2 : 1; d = new Array(i / j); c = new Array(i / j); b = new Array(i / j); for (var g = 0, h = 0; g < i; g += j, h++) { var p, a = e[g], k = f ? e[g + 1] : ""; p = a.charAt(0) === "t"; a = a.substr(1); if (!k) k = this._uniqueIDToClientID(a); b[h] = p; d[h] = a; c[h] = k } } else { d = []; c = []; b = [] } var n = [], l = []; this._convertToClientIDs(q, n, l, f); var o = [], m = []; this._convertToClientIDs(r, o, m, f); return { updatePanelIDs: d, updatePanelClientIDs: c, updatePanelHasChildrenAsTriggers: b, asyncPostBackControlIDs: n, asyncPostBackControlClientIDs: l, postBackControlIDs: o, postBackControlClientIDs: m } }, _queueScripts: function (scriptLoader, scriptBlockNodes, queueIncludes, queueBlocks) { for (var i = 0, l = scriptBlockNodes.length; i < l; i++) { var scriptBlockType = scriptBlockNodes[i].id; switch (scriptBlockType) { case "ScriptContentNoTags": if (!queueBlocks) continue; scriptLoader.queueScriptBlock(scriptBlockNodes[i].content); break; case "ScriptContentWithTags": var scriptTagAttributes; eval("scriptTagAttributes = " + scriptBlockNodes[i].content); if (scriptTagAttributes.src) { if (!queueIncludes || Sys._ScriptLoader.isScriptLoaded(scriptTagAttributes.src)) continue } else if (!queueBlocks) continue; scriptLoader.queueCustomScriptTag(scriptTagAttributes); break; case "ScriptPath": var script = scriptBlockNodes[i]; if (!queueIncludes || Sys._ScriptLoader.isScriptLoaded(script.content)) continue; scriptLoader.queueScriptReference(script.content, script.fallback) } } }, _registerDisposeScript: function (a, b) { if (!this._scriptDisposes[a]) this._scriptDisposes[a] = [b]; else Array.add(this._scriptDisposes[a], b) }, _scriptIncludesLoadComplete: function (e, b) { if (b.executor.get_webRequest() !== this._request) return; this._commitControls(b.updatePanelData, b.asyncPostBackTimeoutNode ? b.asyncPostBackTimeoutNode.content : null); if (b.formActionNode) this._form.action = b.formActionNode.content; var a, d, c; for (a = 0, d = b.updatePanelNodes.length; a < d; a++) { c = b.updatePanelNodes[a]; var j = document.getElementById(c.id); if (!j) { this._endPostBack(Error.invalidOperation(String.format(Sys.WebForms.Res.PRM_MissingPanel, c.id)), b.executor, b); return } this._updatePanel(j, c.content) } for (a = 0, d = b.scriptDisposeNodes.length; a < d; a++) { c = b.scriptDisposeNodes[a]; this._registerDisposeScript(c.id, c.content) } for (a = 0, d = this._transientFields.length; a < d; a++) { var g = document.getElementById(this._transientFields[a]); if (g) { var k = g._isContained ? g.parentNode : g; k.parentNode.removeChild(k) } } for (a = 0, d = b.hiddenFieldNodes.length; a < d; a++) { c = b.hiddenFieldNodes[a]; this._createHiddenField(c.id, c.content) } if (b.scriptsFailed) throw Sys._ScriptLoader._errorScriptLoadFailed(b.scriptsFailed.src, b.scriptsFailed.multipleCallbacks); this._queueScripts(e, b.scriptBlockNodes, false, true); var i = ""; for (a = 0, d = b.arrayDeclarationNodes.length; a < d; a++) { c = b.arrayDeclarationNodes[a]; i += "Sys.WebForms.PageRequestManager._addArrayElement('" + c.id + "', " + c.content + ");\r\n" } var h = ""; for (a = 0, d = b.expandoNodes.length; a < d; a++) { c = b.expandoNodes[a]; h += c.id + " = " + c.content + "\r\n" } if (i.length) e.queueScriptBlock(i); if (h.length) e.queueScriptBlock(h); this._queueScripts(e, b.scriptStartupNodes, true, true); var f = ""; for (a = 0, d = b.onSubmitNodes.length; a < d; a++) { if (a === 0) f = "Array.add(Sys.WebForms.PageRequestManager.getInstance()._onSubmitStatements, function() {\r\n"; f += b.onSubmitNodes[a].content + "\r\n" } if (f.length) { f += "\r\nreturn true;\r\n});\r\n"; e.queueScriptBlock(f) } e.loadScripts(0, Function.createDelegate(this, Function.createCallback(this._scriptsLoadComplete, b)), null, null) }, _scriptIncludesLoadFailed: function (d, c, b, a) { a.scriptsFailed = { src: c.src, multipleCallbacks: b }; this._scriptIncludesLoadComplete(d, a) }, _scriptsLoadComplete: function (f, c) { var e = c.executor; if (window.__theFormPostData) window.__theFormPostData = ""; if (window.__theFormPostCollection) window.__theFormPostCollection = []; if (window.WebForm_InitCallback) window.WebForm_InitCallback(); if (this._scrollPosition) { if (window.scrollTo) window.scrollTo(this._scrollPosition.x, this._scrollPosition.y); this._scrollPosition = null } Sys.Application.endCreateComponents(); this._pageLoaded(false, c); this._endPostBack(null, e, c); if (this._controlIDToFocus) { var a, d; if (Sys.Browser.agent === Sys.Browser.InternetExplorer) { var b = $get(this._controlIDToFocus); a = b; if (b && !WebForm_CanFocus(b)) a = WebForm_FindFirstFocusableChild(b); if (a && typeof a.contentEditable !== "undefined") { d = a.contentEditable; a.contentEditable = false } else a = null } WebForm_AutoFocus(this._controlIDToFocus); if (a) a.contentEditable = d; this._controlIDToFocus = null } }, _splitNodeIntoArray: function (b) { var a = b.content, c = a.length ? a.split(",") : []; return c }, _uniqueIDToClientID: function (a) { return a.replace(/\$/g, "_") }, _updateControls: function (d, a, c, b, e) { this._commitControls(this._processUpdatePanelArrays(d, a, c, e), b) }, _updatePanel: function (updatePanelElement, rendering) { for (var updatePanelID in this._scriptDisposes) if (this._elementContains(updatePanelElement, document.getElementById(updatePanelID))) { var disposeScripts = this._scriptDisposes[updatePanelID]; for (var i = 0, l = disposeScripts.length; i < l; i++) eval(disposeScripts[i]); delete this._scriptDisposes[updatePanelID] } Sys.Application.disposeElement(updatePanelElement, true); updatePanelElement.innerHTML = rendering }, _validPosition: function (a) { return typeof a !== "undefined" && a !== null && a !== 0 } }; Sys.WebForms.PageRequestManager.getInstance = function () { var a = Sys.WebForms.PageRequestManager._instance; if (!a) a = Sys.WebForms.PageRequestManager._instance = new Sys.WebForms.PageRequestManager; return a }; Sys.WebForms.PageRequestManager._addArrayElement = function (a) { if (!window[a]) window[a] = []; for (var b = 1, c = arguments.length; b < c; b++) Array.add(window[a], arguments[b]) }; Sys.WebForms.PageRequestManager._initialize = function () { var a = Sys.WebForms.PageRequestManager.getInstance(); a._initializeInternal.apply(a, arguments) }; Sys.WebForms.PageRequestManager.registerClass("Sys.WebForms.PageRequestManager"); Sys.UI._UpdateProgress = function (a) { Sys.UI._UpdateProgress.initializeBase(this, [a]); this._displayAfter = 500; this._dynamicLayout = true; this._associatedUpdatePanelId = null; this._beginRequestHandlerDelegate = null; this._startDelegate = null; this._endRequestHandlerDelegate = null; this._pageRequestManager = null; this._timerCookie = null }; Sys.UI._UpdateProgress.prototype = { get_displayAfter: function () { return this._displayAfter }, set_displayAfter: function (a) { this._displayAfter = a }, get_dynamicLayout: function () { return this._dynamicLayout }, set_dynamicLayout: function (a) { this._dynamicLayout = a }, get_associatedUpdatePanelId: function () { return this._associatedUpdatePanelId }, set_associatedUpdatePanelId: function (a) { this._associatedUpdatePanelId = a }, get_role: function () { return "status" }, _clearTimeout: function () { if (this._timerCookie) { window.clearTimeout(this._timerCookie); this._timerCookie = null } }, _getUniqueID: function (b) { var a = Array.indexOf(this._pageRequestManager._updatePanelClientIDs, b); return a === -1 ? null : this._pageRequestManager._updatePanelIDs[a] }, _handleBeginRequest: function (f, e) { var b = e.get_postBackElement(), a = true, d = this._associatedUpdatePanelId; if (this._associatedUpdatePanelId) { var c = e.get_updatePanelsToUpdate(); if (c && c.length) a = Array.contains(c, d) || Array.contains(c, this._getUniqueID(d)); else a = false } while (!a && b) { if (b.id && this._associatedUpdatePanelId === b.id) a = true; b = b.parentNode } if (a) this._timerCookie = window.setTimeout(this._startDelegate, this._displayAfter) }, _startRequest: function () { if (this._pageRequestManager.get_isInAsyncPostBack()) { var a = this.get_element(); if (this._dynamicLayout) a.style.display = "block"; else a.style.visibility = "visible"; if (this.get_role() === "status") a.setAttribute("aria-hidden", "false") } this._timerCookie = null }, _handleEndRequest: function () { var a = this.get_element(); if (this._dynamicLayout) a.style.display = "none"; else a.style.visibility = "hidden"; if (this.get_role() === "status") a.setAttribute("aria-hidden", "true"); this._clearTimeout() }, dispose: function () { if (this._beginRequestHandlerDelegate !== null) { this._pageRequestManager.remove_beginRequest(this._beginRequestHandlerDelegate); this._pageRequestManager.remove_endRequest(this._endRequestHandlerDelegate); this._beginRequestHandlerDelegate = null; this._endRequestHandlerDelegate = null } this._clearTimeout(); Sys.UI._UpdateProgress.callBaseMethod(this, "dispose") }, initialize: function () { Sys.UI._UpdateProgress.callBaseMethod(this, "initialize"); if (this.get_role() === "status") this.get_element().setAttribute("aria-hidden", "true"); this._beginRequestHandlerDelegate = Function.createDelegate(this, this._handleBeginRequest); this._endRequestHandlerDelegate = Function.createDelegate(this, this._handleEndRequest); this._startDelegate = Function.createDelegate(this, this._startRequest); if (Sys.WebForms && Sys.WebForms.PageRequestManager) this._pageRequestManager = Sys.WebForms.PageRequestManager.getInstance(); if (this._pageRequestManager !== null) { this._pageRequestManager.add_beginRequest(this._beginRequestHandlerDelegate); this._pageRequestManager.add_endRequest(this._endRequestHandlerDelegate) } } }; Sys.UI._UpdateProgress.registerClass("Sys.UI._UpdateProgress", Sys.UI.Control);
Type.registerNamespace('Sys.WebForms'); Sys.WebForms.Res = {
    "PRM_UnknownToken": "Неизвестный маркер: \"{0}\".", "PRM_MissingPanel": "Не удалось найти UpdatePanel с идентификатором \"{0}\". Если UpdatePanel обновляется динамически, она должна находиться в другой UpdatePanel.", "PRM_ServerError": "При обработке запроса от сервера обнаружена неизвестная ошибка. Код состояния, возвращенный сервером: {0}", "PRM_ParserError": "Не удалось обработать сообщение, полученное от сервера. К общим причинам ошибки относится то, что при изменении ответа посредством вызовов Response.Write(), фильтры ответов, HttpModules или трассировка сервера отключены.\r\nПодробности: {0}", "PRM_TimeoutError": "Превышен интервал ожидания для запроса к серверу.", "PRM_ParserErrorDetails": "Ошибка при разборе около \"{0}\".", "PRM_CannotRegisterTwice": "Невозможно инициализировать PageRequestManager больше одного раза."
};
/* END MicrosoftAjaxWebForms.js */
/* START Telerik.Web.UI.Common.Core.js */
try {
    if (Sys.Browser.agent == Sys.Browser.InternetExplorer) {
        document.execCommand("BackgroundImageCache", false, true);
    }
} catch (err) { } Type.registerNamespace("Telerik.Web.UI");
var commonScripts = {
    cloneJsObject: function (c, d) {
        if (!d) {
            d = {};
        } for (var a in c) {
            var b = c[a];
            d[a] = (b instanceof Array) ? Array.clone(b) : b;
        } return d;
    }, isCloned: function () {
        return this._isCloned;
    }, cloneControl: function (f, d, a) {
        if (!f) {
            return null;
        } if (!d) {
            d = Object.getType(f);
        } var e = f.__clonedProperties__;
        if (null == e) {
            e = f.__clonedProperties__ = $telerik._getPropertiesParameter(f, d);
        } if (!a) {
            a = f.get_element().cloneNode(true);
            a.removeAttribute("control");
            a.removeAttribute("id");
        } var c = $create(d, e, null, null, a);
        if (f._observerContext) {
            c._observerContext = f._observerContext;
        } var b = $telerik.cloneJsObject(f.get_events());
        c._events = b;
        c._events._list = $telerik.cloneJsObject(c._events._list);
        c._isCloned = true;
        c.isCloned = $telerik.isCloned;
        return c;
    }, _getPropertiesParameter: function (h, d) {
        var c = {};
        var f = d.prototype;
        for (var b in f) {
            var a = h[b];
            if (typeof (a) == "function" && b.indexOf("get_") == 0) {
                var e = b.substring(4);
                if (null == h["set_" + e]) {
                    continue;
                } var g = a.call(h);
                if (null == g) {
                    continue;
                } c[e] = g;
            }
        } delete c.clientStateFieldID;
        delete c.id;
        return c;
    }, getOuterSize: function (a) {
        var c = $telerik.getSize(a);
        var b = $telerik.getMarginBox(a);
        return { width: c.width + b.left + b.right, height: c.height + b.top + b.bottom };
    }, getOuterBounds: function (a) {
        var c = $telerik.getBounds(a);
        var b = $telerik.getMarginBox(a);
        return { x: c.x - b.left, y: c.y - b.top, width: c.width + b.left + b.right, height: c.height + b.top + b.bottom };
    }, getInvisibleParent: function (a) {
        while (a && a != document) {
            if ("none" == $telerik.getCurrentStyle(a, "display", "")) {
                return a;
            } a = a.parentNode;
        } return null;
    }, isScrolledIntoView: function (d) {
        var a = d.ownerDocument;
        var g = (a.defaultView) ? a.defaultView : a.parentWindow;
        var c = $telerik.$(g).scrollTop(), b = c + $telerik.$(g).height(), f = $telerik.$(d).offset().top, e = f + $telerik.$(d).height();
        return ((f + ((e - f) / 4)) >= c && ((f + ((e - f) / 4)) <= b));
    }, scrollIntoView: function (b) {
        if (!b || !b.parentNode) {
            return;
        } var g = null, c = b.offsetParent, h = b.offsetTop, f = 0;
        var e = b.parentNode;
        while (e != null) {
            var d = $telerik.getCurrentStyle(e, "overflowY");
            if (d == "scroll" || d == "auto") {
                g = e;
                break;
            } if (e == c) {
                h += e.offsetTop;
                c = e.offsetParent;
            } if (e.tagName == "BODY") {
                var a = e.ownerDocument;
                if (!$telerik.isIE && a.defaultView && a.defaultView.frameElement) {
                    f = a.defaultView.frameElement.offsetHeight;
                } g = e;
                break;
            } e = e.parentNode;
        } if (!g) {
            return;
        } if (!f) {
            f = g.offsetHeight;
        } if ((g.scrollTop + f) < (h + b.offsetHeight)) {
            g.scrollTop = (h + b.offsetHeight) - f;
        } else {
            if (h < (g.scrollTop)) {
                g.scrollTop = h;
            }
        }
    }, getScrollableParent: function (a) {
        var c = a.parentNode, d = null, b;
        while (c != null) {
            b = $telerik.getCurrentStyle(c, "overflowY");
            if (b == "scroll" || b == "auto") {
                d = c;
                break;
            } c = c.parentNode;
        } return d;
    }, getScrollableParents: function (a) {
        var c = a.parentNode, d = [], b;
        while (c != null && c.nodeType === 1) {
            b = $telerik.getCurrentStyle(c, "overflowY");
            if (b == "scroll" || b == "auto") {
                d.push(c);
            } c = c.parentNode;
        } return d;
    }, fixScrollableParentBehavior_OldIE: function (a) {
        if (!($telerik.isIE6 || $telerik.isIE7) || (!a || a.nodeType !== 1)) {
            return;
        } var c = $telerik.getScrollableParent(a), b = $telerik.getComputedStyle(c, "position");
        if (b == "static") {
            c.style.position = "relative";
        }
    }, isRightToLeft: function (b) {
        while (b && b.nodeType !== 9) {
            var a = $telerik.getCurrentStyle(b, "direction");
            if (b.dir == "rtl" || a == "rtl") {
                return true;
            } if (b.dir == "ltr" || a == "ltr") {
                return false;
            } b = b.parentNode;
        } return false;
    }, getCorrectScrollLeft: function (a) {
        if ($telerik.isRightToLeft(a)) {
            return -(a.scrollWidth - a.offsetWidth - Math.abs(a.scrollLeft));
        } else {
            return a.scrollLeft;
        }
    }, _borderStyleNames: ["borderTopStyle", "borderRightStyle", "borderBottomStyle", "borderLeftStyle"], _borderWidthNames: ["borderTopWidth", "borderRightWidth", "borderBottomWidth", "borderLeftWidth"], _paddingWidthNames: ["paddingTop", "paddingRight", "paddingBottom", "paddingLeft"], _marginWidthNames: ["marginTop", "marginRight", "marginBottom", "marginLeft"], radControls: [], registerControl: function (a) {
        if (!Array.contains(this.radControls, a)) {
            Array.add(this.radControls, a);
        }
    }, unregisterControl: function (a) {
        Array.remove(this.radControls, a);
    }, repaintChildren: function (d) {
        var e = d.get_element ? d.get_element() : d;
        for (var b = 0, c = this.radControls.length;
        b < c;
        b++) {
            var a = this.radControls[b];
            if (a.repaint && this.isDescendant(e, a.get_element())) {
                a.repaint();
            }
        }
    }, _borderThickness: function () {
        $telerik._borderThicknesses = {};
        var b = document.createElement("div");
        var d = document.createElement("div");
        b.style.visibility = "hidden";
        b.style.position = "absolute";
        b.style.top = "-9999px";
        b.style.fontSize = "1px";
        d.style.height = "0px";
        d.style.overflow = "hidden";
        document.body.appendChild(b).appendChild(d);
        var a = b.offsetHeight;
        d.style.borderTop = "solid black";
        b.style.borderLeft = "1px solid red";
        d.style.borderTopWidth = "thin";
        $telerik._borderThicknesses.thin = b.offsetHeight - a;
        d.style.borderTopWidth = "medium";
        $telerik._borderThicknesses.medium = b.offsetHeight - a;
        d.style.borderTopWidth = "thick";
        $telerik._borderThicknesses.thick = b.offsetHeight - a;
        var c = $telerik.getComputedStyle(b, "border-left-color", null);
        var e = $telerik.getComputedStyle(d, "border-top-color", null);
        if (c && e && c == e) {
            document.documentElement.className += " _Telerik_a11y";
        } if (typeof (b.removeChild) !== "undefined") {
            b.removeChild(d);
        } document.body.removeChild(b);
        if (!$telerik.isSafari && !$telerik.isIE10Mode) {
            d.outerHTML = null;
        } if (!$telerik.isSafari && !$telerik.isIE10Mode) {
            b.outerHTML = null;
        } b = null;
        d = null;
    }, getCurrentStyle: function (d, a, c) {
        var b = null;
        if (d) {
            if (d.currentStyle) {
                b = d.currentStyle[a];
            } else {
                if (document.defaultView && document.defaultView.getComputedStyle) {
                    var e = document.defaultView.getComputedStyle(d, null);
                    if (e) {
                        b = e[a];
                    }
                }
            } if (!b && d.style) {
                if (d.style.getPropertyValue) {
                    b = d.style.getPropertyValue(a);
                } else {
                    if (d.style.getAttribute) {
                        b = d.style.getAttribute(a);
                    }
                }
            }
        } if ((!b || b == "" || typeof (b) === "undefined")) {
            if (typeof (c) != "undefined") {
                b = c;
            } else {
                b = null;
            }
        } return b;
    }, getComputedStyle: function (d, a, c) {
        var b = null;
        if (d) {
            if (d.currentStyle) {
                b = d.currentStyle[a];
            } else {
                if (document.defaultView && document.defaultView.getComputedStyle) {
                    var e = document.defaultView.getComputedStyle(d, null);
                    if (e) {
                        if (e.getPropertyValue) {
                            b = e.getPropertyValue(a);
                        } else {
                            b = e[a];
                        }
                    }
                }
            } if (!b && d.style) {
                if (d.style.getPropertyValue) {
                    b = d.style.getPropertyValue(a);
                } else {
                    if (d.style.getAttribute) {
                        b = d.style.getAttribute(a);
                    }
                }
            }
        } if ((!b || b == "" || typeof (b) === "undefined")) {
            if (typeof (c) != "undefined") {
                b = c;
            } else {
                b = null;
            }
        } return b;
    }, getLocation: function (g) {
        var d = g && g.ownerDocument ? g.ownerDocument : document;
        if (g === d.documentElement) {
            return new Sys.UI.Point(0, 0);
        } if (Sys.Browser.agent == Sys.Browser.InternetExplorer) {
            if (g.window === g || g.nodeType === 9 || !g.getClientRects || !g.getBoundingClientRect || g.parentElement == null) {
                return new Sys.UI.Point(0, 0);
            } var H = g.getClientRects();
            if (!H || !H.length) {
                return new Sys.UI.Point(0, 0);
            } var k = H[0];
            var c = 0;
            var f = 0;
            var p = false;
            try {
                p = d.parentWindow.frameElement;
            } catch (j) {
                p = true;
            } if (p) {
                var b = g.getBoundingClientRect();
                if (!b) {
                    return new Sys.UI.Point(0, 0);
                } var t = k.left;
                var u = k.top;
                for (var o = 1;
                o < H.length;
                o++) {
                    var F = H[o];
                    if (F.left < t) {
                        t = F.left;
                    } if (F.top < u) {
                        u = F.top;
                    }
                } c = t - b.left;
                f = u - b.top;
            } var I = 0;
            if (Sys.Browser.version < 8 || $telerik.quirksMode) {
                var n = 1;
                if (p && p.getAttribute) {
                    var a = p.getAttribute("frameborder");
                    if (a != null) {
                        n = parseInt(a, 10);
                        if (isNaN(n)) {
                            n = a.toLowerCase() == "no" ? 0 : 1;
                        }
                    }
                } I = 2 * n;
            } var e = d.documentElement;
            var D = k.left - I - c + $telerik.getCorrectScrollLeft(e);
            var E = k.top - I - f + e.scrollTop;
            var C = new Sys.UI.Point(Math.round(D), Math.round(E));
            if ($telerik.quirksMode) {
                C.x += $telerik.getCorrectScrollLeft(d.body);
                C.y += d.body.scrollTop;
            } return C;
        } var C = $telerik.originalGetLocation(g);
        if ($telerik.isOpera) {
            var z = null;
            var h = $telerik.getCurrentStyle(g, "display");
            if (h != "inline") {
                z = g.parentNode;
            } else {
                z = g.offsetParent;
            } while (z) {
                var B = z.tagName.toUpperCase();
                if (B == "BODY" || B == "HTML") {
                    break;
                } if (B == "TABLE" && z.parentNode && z.parentNode.style.display == "inline-block") {
                    var w = z.offsetLeft;
                    var v = z.style.display;
                    z.style.display = "inline-block";
                    if (z.offsetLeft > w) {
                        C.x += z.offsetLeft - w;
                    } z.style.display = v;
                } C.x -= $telerik.getCorrectScrollLeft(z);
                C.y -= z.scrollTop;
                if (h != "inline") {
                    z = z.parentNode;
                } else {
                    z = z.offsetParent;
                }
            }
        } var y = Math.max(d.documentElement.scrollTop, d.body.scrollTop);
        var x = Math.max(d.documentElement.scrollLeft, d.body.scrollLeft);
        if ($telerik.isSafari) {
            if (y > 0 || x > 0) {
                var m = d.documentElement.getElementsByTagName("form");
                if (m && m.length > 0) {
                    var l = $telerik.originalGetLocation(m[0]);
                    if (l.y && l.y < 0) {
                        C.y += y;
                    } if (l.x && l.x < 0) {
                        C.x += x;
                    }
                } else {
                    var G = g.parentNode, s = false, q = false;
                    while (G && G.tagName) {
                        var A = $telerik.originalGetLocation(G);
                        if (A.y < 0) {
                            s = true;
                        } if (A.x < 0) {
                            q = true;
                        } G = G.parentNode;
                    } if (s) {
                        C.y += y;
                    } if (q) {
                        C.x += x;
                    }
                }
            }
        } return C;
    }, setLocation: function (a, b) {
        Sys.UI.DomElement.setLocation(a, b.x, b.y);
    }, findControl: function (f, d) {
        var b = f.getElementsByTagName("*");
        for (var c = 0, e = b.length;
        c < e;
        c++) {
            var a = b[c].id;
            if (a && a.endsWith(d)) {
                return $find(a);
            }
        } return null;
    }, findElement: function (f, d) {
        var b = f.getElementsByTagName("*");
        for (var c = 0, e = b.length;
        c < e;
        c++) {
            var a = b[c].id;
            if (a && a.endsWith(d)) {
                return $get(a);
            }
        } return null;
    }, getContentSize: function (b) {
        if (!b) {
            throw Error.argumentNull("element");
        } var d = $telerik.getSize(b);
        var a = $telerik.getBorderBox(b);
        var c = $telerik.getPaddingBox(b);
        return { width: d.width - a.horizontal - c.horizontal, height: d.height - a.vertical - c.vertical };
    }, getSize: function (a) {
        if (!a) {
            throw Error.argumentNull("element");
        } return { width: a.offsetWidth, height: a.offsetHeight };
    }, setContentSize: function (b, d) {
        if (!b) {
            throw Error.argumentNull("element");
        } if (!d) {
            throw Error.argumentNull("size");
        } if ($telerik.getCurrentStyle(b, "MozBoxSizing") == "border-box" || $telerik.getCurrentStyle(b, "BoxSizing") == "border-box") {
            var a = $telerik.getBorderBox(b);
            var c = $telerik.getPaddingBox(b);
            d = { width: d.width + a.horizontal + c.horizontal, height: d.height + a.vertical + c.vertical };
        } b.style.width = d.width.toString() + "px";
        b.style.height = d.height.toString() + "px";
    }, setSize: function (c, e) {
        if (!c) {
            throw Error.argumentNull("element");
        } if (!e) {
            throw Error.argumentNull("size");
        } var a = $telerik.getBorderBox(c);
        var d = $telerik.getPaddingBox(c);
        var b = { width: e.width - a.horizontal - d.horizontal, height: e.height - a.vertical - d.vertical };
        $telerik.setContentSize(c, b);
    }, getBounds: function (a) {
        var b = $telerik.getLocation(a);
        return new Sys.UI.Bounds(b.x, b.y, a.offsetWidth || 0, a.offsetHeight || 0);
    }, setBounds: function (b, a) {
        if (!b) {
            throw Error.argumentNull("element");
        } if (!a) {
            throw Error.argumentNull("bounds");
        } $telerik.setSize(b, a);
        $telerik.setLocation(b, a);
    }, getClientBounds: function () {
        var b;
        var a;
        switch (Sys.Browser.agent) {
            case Sys.Browser.InternetExplorer: b = document.documentElement.clientWidth;
                a = document.documentElement.clientHeight;
                if (b == 0 && a == 0) {
                    b = document.body.clientWidth;
                    a = document.body.clientHeight;
                } break;
            case Sys.Browser.Safari: b = window.innerWidth;
                a = window.innerHeight;
                break;
            case Sys.Browser.Opera: if (Sys.Browser.version >= 9.5) {
                b = Math.min(window.innerWidth, document.documentElement.clientWidth);
                a = Math.min(window.innerHeight, document.documentElement.clientHeight);
            } else {
                b = Math.min(window.innerWidth, document.body.clientWidth);
                a = Math.min(window.innerHeight, document.body.clientHeight);
            } break;
            default: b = Math.min(window.innerWidth, document.documentElement.clientWidth);
                a = Math.min(window.innerHeight, document.documentElement.clientHeight);
                break;
        } return new Sys.UI.Bounds(0, 0, b, a);
    }, getMarginBox: function (b) {
        if (!b) {
            throw Error.argumentNull("element");
        } var a = { top: $telerik.getMargin(b, Telerik.Web.BoxSide.Top), right: $telerik.getMargin(b, Telerik.Web.BoxSide.Right), bottom: $telerik.getMargin(b, Telerik.Web.BoxSide.Bottom), left: $telerik.getMargin(b, Telerik.Web.BoxSide.Left) };
        a.horizontal = a.left + a.right;
        a.vertical = a.top + a.bottom;
        return a;
    }, getPaddingBox: function (b) {
        if (!b) {
            throw Error.argumentNull("element");
        } var a = { top: $telerik.getPadding(b, Telerik.Web.BoxSide.Top), right: $telerik.getPadding(b, Telerik.Web.BoxSide.Right), bottom: $telerik.getPadding(b, Telerik.Web.BoxSide.Bottom), left: $telerik.getPadding(b, Telerik.Web.BoxSide.Left) };
        a.horizontal = a.left + a.right;
        a.vertical = a.top + a.bottom;
        return a;
    }, getBorderBox: function (b) {
        if (!b) {
            throw Error.argumentNull("element");
        } var a = { top: $telerik.getBorderWidth(b, Telerik.Web.BoxSide.Top), right: $telerik.getBorderWidth(b, Telerik.Web.BoxSide.Right), bottom: $telerik.getBorderWidth(b, Telerik.Web.BoxSide.Bottom), left: $telerik.getBorderWidth(b, Telerik.Web.BoxSide.Left) };
        a.horizontal = a.left + a.right;
        a.vertical = a.top + a.bottom;
        return a;
    }, isBorderVisible: function (b, a) {
        if (!b) {
            throw Error.argumentNull("element");
        } if (a < Telerik.Web.BoxSide.Top || a > Telerik.Web.BoxSide.Left) {
            throw Error.argumentOutOfRange(String.format(Sys.Res.enumInvalidValue, a, "Telerik.Web.BoxSide"));
        } var c = $telerik._borderStyleNames[a];
        var d = $telerik.getCurrentStyle(b, c);
        return d != "none";
    }, getMargin: function (b, a) {
        if (!b) {
            throw Error.argumentNull("element");
        } if (a < Telerik.Web.BoxSide.Top || a > Telerik.Web.BoxSide.Left) {
            throw Error.argumentOutOfRange(String.format(Sys.Res.enumInvalidValue, a, "Telerik.Web.BoxSide"));
        } var d = $telerik._marginWidthNames[a];
        var e = $telerik.getCurrentStyle(b, d);
        try {
            return $telerik.parsePadding(e);
        } catch (c) {
            return 0;
        }
    }, getBorderWidth: function (b, a) {
        if (!b) {
            throw Error.argumentNull("element");
        } if (a < Telerik.Web.BoxSide.Top || a > Telerik.Web.BoxSide.Left) {
            throw Error.argumentOutOfRange(String.format(Sys.Res.enumInvalidValue, a, "Telerik.Web.BoxSide"));
        } if (!$telerik.isBorderVisible(b, a)) {
            return 0;
        } var c = $telerik._borderWidthNames[a];
        var d = $telerik.getCurrentStyle(b, c);
        return $telerik.parseBorderWidth(d);
    }, getPadding: function (b, a) {
        if (!b) {
            throw Error.argumentNull("element");
        } if (a < Telerik.Web.BoxSide.Top || a > Telerik.Web.BoxSide.Left) {
            throw Error.argumentOutOfRange(String.format(Sys.Res.enumInvalidValue, a, "Telerik.Web.BoxSide"));
        } var c = $telerik._paddingWidthNames[a];
        var d = $telerik.getCurrentStyle(b, c);
        return $telerik.parsePadding(d);
    }, parseBorderWidth: function (a) {
        if (a) {
            switch (a) {
                case "thin": case "medium": case "thick": return $telerik._borderThicknesses[a];
                case "inherit": return 0;
            } var b = $telerik.parseUnit(a);
            return b.size;
        } return 0;
    }, parsePadding: function (a) {
        if (a) {
            if (a == "auto" || a == "inherit") {
                return 0;
            } var b = $telerik.parseUnit(a);
            return b.size;
        } return 0;
    }, parseUnit: function (g) {
        if (!g) {
            throw Error.argumentNull("value");
        } g = g.trim().toLowerCase();
        var c = g.length;
        var d = -1;
        for (var b = 0;
        b < c;
        b++) {
            var a = g.substr(b, 1);
            if ((a < "0" || a > "9") && a != "-" && a != "." && a != ",") {
                break;
            } d = b;
        } if (d == -1) {
            throw Error.create("No digits");
        } var f;
        var e;
        if (d < (c - 1)) {
            f = g.substring(d + 1).trim();
        } else {
            f = "px";
        } e = parseFloat(g.substr(0, d + 1));
        if (f == "px") {
            e = Math.floor(e);
        } return { size: e, type: f };
    }, containsPoint: function (a, b, c) {
        return b >= a.x && b <= (a.x + a.width) && c >= a.y && c <= (a.y + a.height);
    }, isDescendant: function (a, b) {
        try {
            for (var d = b.parentNode;
            d != null;
            d = d.parentNode) {
                if (d == a) {
                    return true;
                }
            }
        } catch (c) { } return false;
    }, isDescendantOrSelf: function (a, b) {
        if (a === b) {
            return true;
        } return $telerik.isDescendant(a, b);
    }, addCssClasses: function (b, a) {
        for (var c = 0;
        c < a.length;
        c++) {
            Sys.UI.DomElement.addCssClass(b, a[c]);
        }
    }, removeCssClasses: function (b, a) {
        for (var c = 0;
        c < a.length;
        c++) {
            Sys.UI.DomElement.removeCssClass(b, a[c]);
        }
    }, getScrollOffset: function (b, e) {
        var c = 0;
        var f = 0;
        var d = b;
        var a = b && b.ownerDocument ? b.ownerDocument : document;
        while (d != null && d.scrollLeft != null) {
            c += $telerik.getCorrectScrollLeft(d);
            f += d.scrollTop;
            if (!e || (d == a.body && (d.scrollLeft != 0 || d.scrollTop != 0))) {
                break;
            } d = d.parentNode;
        } return { x: c, y: f };
    }, getElementByClassName: function (d, c, g) {
        if (d.getElementsByClassName) {
            return d.getElementsByClassName(c)[0];
        } var b = null;
        if (g) {
            b = d.getElementsByTagName(g);
        } else {
            b = d.getElementsByTagName("*");
        } for (var e = 0, f = b.length;
        e < f;
        e++) {
            var a = b[e];
            if (Sys.UI.DomElement.containsCssClass(a, c)) {
                return a;
            }
        } return null;
    }, getElementsByClassName: function (b, a, c) {
        if (document.getElementsByClassName) {
            getElementsByClassName = function (d, m, g) {
                g = g || document;
                var f = g.getElementsByClassName(d), k = (m) ? new RegExp("\\b" + m + "\\b", "i") : null, l = [], e;
                for (var h = 0, j = f.length;
                h < j;
                h += 1) {
                    e = f[h];
                    if (!k || k.test(e.nodeName)) {
                        l.push(e);
                    }
                } return l;
            };
        } else {
            if (document.evaluate) {
                getElementsByClassName = function (g, q, k) {
                    q = q || "*";
                    k = k || document;
                    var d = g.split(" "), f = "", r = "http://www.w3.org/1999/xhtml", n = (document.documentElement.namespaceURI === r) ? r : null, p = [], i, o;
                    for (var l = 0, m = d.length;
                    l < m;
                    l += 1) {
                        f += "[contains(concat(' ', @class, ' '), ' " + d[l] + " ')]";
                    } try {
                        i = document.evaluate(".//" + q + f, k, n, 0, null);
                    } catch (h) {
                        i = document.evaluate(".//" + q + f, k, null, 0, null);
                    } while ((o = i.iterateNext())) {
                        p.push(o);
                    } return p;
                };
            } else {
                getElementsByClassName = function (f, u, i) {
                    u = u || "*";
                    i = i || document;
                    var d = f.split(" "), e = [], h = (u === "*" && i.all) ? i.all : i.getElementsByTagName(u), g, t = [], r;
                    for (var j = 0, n = d.length;
                    j < n;
                    j += 1) {
                        e.push(new RegExp("(^|\\s)" + d[j] + "(\\s|$)"));
                    } for (var o = 0, p = h.length;
                    o < p;
                    o += 1) {
                        g = h[o];
                        r = false;
                        for (var q = 0, s = e.length;
                        q < s;
                        q += 1) {
                            r = e[q].test(g.className);
                            if (!r) {
                                break;
                            }
                        } if (r) {
                            t.push(g);
                        }
                    } return t;
                };
            }
        } return getElementsByClassName(a, c, b);
    }, _getWindow: function (b) {
        var a = b.ownerDocument || b.document || b;
        return a.defaultView || a.parentWindow;
    }, useAttachEvent: function (a) {
        return (a.attachEvent && !$telerik.isOpera);
    }, useDetachEvent: function (a) {
        return (a.detachEvent && !$telerik.isOpera);
    }, addHandler: function (e, g, h, a) {
        if (!e._events) {
            e._events = {};
        } var f = e._events[g];
        if (!f) {
            e._events[g] = f = [];
        } var b;
        if ($telerik.useAttachEvent(e)) {
            b = function () {
                var d = {};
                try {
                    d = $telerik._getWindow(e).event;
                } catch (i) { } return h.call(e, new Sys.UI.DomEvent(d));
            };
            e.attachEvent("on" + g, b);
        } else {
            if (e.addEventListener) {
                b = function (d) {
                    return h.call(e, new Sys.UI.DomEvent(d));
                };
                e.addEventListener(g, b, false);
            }
        } f[f.length] = { handler: h, browserHandler: b, autoRemove: a };
        if (a) {
            var c = e.dispose;
            if (c !== $telerik._disposeHandlers) {
                e.dispose = $telerik._disposeHandlers;
                if (typeof (c) !== "undefined") {
                    e._chainDispose = c;
                }
            }
        }
    }, addHandlers: function (b, c, e, a) {
        for (var f in c) {
            var d = c[f];
            if (e) {
                d = Function.createDelegate(e, d);
            } $telerik.addHandler(b, f, d, a || false);
        }
    }, clearHandlers: function (a) {
        $telerik._clearHandlers(a, false);
    }, _clearHandlers: function (c, a) {
        if (c._events) {
            var b = c._events;
            for (var g in b) {
                var e = b[g];
                for (var f = e.length - 1;
                f >= 0;
                f--) {
                    var d = e[f];
                    if (!a || d.autoRemove) {
                        $telerik.removeHandler(c, g, d.handler);
                    }
                }
            } c._events = null;
        }
    }, _disposeHandlers: function () {
        $telerik._clearHandlers(this, true);
        var a = this._chainDispose, b = typeof (a);
        if (b !== "undefined") {
            this.dispose = a;
            this._chainDispose = null;
            if (b === "function") {
                this.dispose();
            }
        }
    }, removeHandler: function (a, b, c) {
        $telerik._removeHandler(a, b, c);
    }, _removeHandler: function (c, d, e) {
        var a = null;
        var b = c._events[d] || [];
        for (var f = 0, g = b.length;
        f < g;
        f++) {
            if (b[f].handler === e) {
                a = b[f].browserHandler;
                break;
            }
        } if ($telerik.useDetachEvent(c)) {
            c.detachEvent("on" + d, a);
        } else {
            if (c.removeEventListener) {
                c.removeEventListener(d, a, false);
            }
        } b.splice(f, 1);
    }, _emptySrc: function () {
        return "about:blank";
    }, addExternalHandler: function (a, b, c) {
        if (!a) {
            return;
        } if ($telerik.useAttachEvent(a)) {
            a.attachEvent("on" + b, c);
        } else {
            if (a.addEventListener) {
                a.addEventListener(b, c, false);
            }
        }
    }, removeExternalHandler: function (a, b, c) {
        if (!a) {
            return;
        } if ($telerik.useDetachEvent(a)) {
            a.detachEvent("on" + b, c);
        } else {
            if (a.addEventListener) {
                a.removeEventListener(b, c, false);
            }
        }
    }, addMobileHandler: function (g, b, c, d, f, e) {
        if (!b || !g) {
            return;
        } var a = Function.createDelegate(g, $telerik.isTouchDevice ? (f || d) : d);
        if ($telerik.isTouchDevice) {
            if ($telerik.$) {
                $telerik.$(b).bind($telerik.getMobileEventCounterpart(c), a);
            } else {
                $telerik.addExternalHandler(b, $telerik.getMobileEventCounterpart(c), a);
            }
        } else {
            if (e) {
                $telerik.addExternalHandler(b, c, a);
            } else {
                $addHandler(b, c, a);
            }
        } return a;
    }, removeMobileHandler: function (a, b, c, e, d) {
        if (!a) {
            return;
        } if ($telerik.isTouchDevice) {
            if ($telerik.$) {
                $telerik.$(a).unbind($telerik.getMobileEventCounterpart(b), (e || c));
            } else {
                $telerik.removeExternalHandler(a, $telerik.getMobileEventCounterpart(b), (e || c));
            }
        } else {
            if (d) {
                $telerik.removeExternalHandler(a, b, c);
            } else {
                $removeHandler(a, b, c);
            }
        }
    }, getMobileEventCounterpart: function (a) {
        switch (a) {
            case "mousedown": return $telerik.isMobileIE10 ? "MSPointerDown" : "touchstart";
            case "mouseup": return $telerik.isMobileIE10 ? "MSPointerUp" : "touchend";
            case "mousemove": return $telerik.isMobileIE10 ? "MSPointerMove" : "touchmove";
        } return a;
    }, getTouchEventLocation: function (b) {
        var d = arguments[1], f = d ? [d + "X"] : "pageX", g = d ? [d + "Y"] : "pageY", c = { x: b[f], y: b[g] }, a = b.changedTouches || (b.originalEvent ? b.originalEvent.changedTouches : b.rawEvent ? b.rawEvent.changedTouches : false);
        if ($telerik.isTouchDevice && a && a.length < 2) {
            c.x = a[0][f];
            c.y = a[0][g];
        } if ($telerik.isMobileIE10 && b.originalEvent) {
            c.x = b.originalEvent[f];
            c.y = b.originalEvent[g];
        } return c;
    }, getTouchTarget: function (a) {
        if ($telerik.isTouchDevice) {
            var b = "originalEvent" in a ? a.originalEvent.changedTouches : "rawEvent" in a ? a.rawEvent.changedTouches : a.changedTouches;
            if ($telerik.isAndroid && $telerik.isChrome) {
                return b ? document.elementFromPoint(b[0].screenX, b[0].screenY) : a.target;
            } else {
                return b ? document.elementFromPoint(b[0].clientX, b[0].clientY) : a.target;
            }
        } else {
            return a.target;
        }
    }, cancelRawEvent: function (a) {
        if (!a) {
            return false;
        } if (a.preventDefault) {
            a.preventDefault();
        } if (a.stopPropagation) {
            a.stopPropagation();
        } a.cancelBubble = true;
        a.returnValue = false;
        return false;
    }, getOuterHtml: function (a) {
        if (a.outerHTML) {
            return a.outerHTML;
        } else {
            var b = a.cloneNode(true);
            var c = a.ownerDocument.createElement("div");
            c.appendChild(b);
            return c.innerHTML;
        }
    }, setVisible: function (a, b) {
        if (!a) {
            return;
        } if (b != $telerik.getVisible(a)) {
            if (b) {
                if (a.style.removeAttribute) {
                    a.style.removeAttribute("display");
                } else {
                    a.style.removeProperty("display");
                }
            } else {
                a.style.display = "none";
            } a.style.visibility = b ? "visible" : "hidden";
        }
    }, getVisible: function (a) {
        if (!a) {
            return false;
        } return (("none" != $telerik.getCurrentStyle(a, "display")) && ("hidden" != $telerik.getCurrentStyle(a, "visibility")));
    }, getViewPortSize: function () {
        var c = 0;
        var b = 0;
        var a = document.body;
        if (!$telerik.quirksMode && !$telerik.isSafari) {
            a = document.documentElement;
        } if (window.innerWidth) {
            c = Math.max(document.documentElement.clientWidth, document.body.clientWidth);
            b = Math.max(document.documentElement.clientHeight, document.body.clientHeight);
            if (c > window.innerWidth) {
                c = document.documentElement.clientWidth;
            } if (b > window.innerHeight) {
                b = document.documentElement.clientHeight;
            }
        } else {
            c = a.clientWidth;
            b = a.clientHeight;
        } c += a.scrollLeft;
        b += a.scrollTop;
        if ($telerik.isMobileSafari) {
            c += window.pageXOffset;
            b += window.pageYOffset;
        } return { width: c - 6, height: b - 6 };
    }, elementOverflowsTop: function (b, a) {
        var c = a || $telerik.getLocation(b);
        return c.y < 0;
    }, elementOverflowsLeft: function (b, a) {
        var c = a || $telerik.getLocation(b);
        return c.x < 0;
    }, elementOverflowsBottom: function (e, c, b) {
        var d = b || $telerik.getLocation(c);
        var a = d.y + c.offsetHeight;
        return a > e.height;
    }, elementOverflowsRight: function (e, b, a) {
        var c = a || $telerik.getLocation(b);
        var d = c.x + b.offsetWidth;
        return d > e.width;
    }, getDocumentRelativeCursorPosition: function (c) {
        var b = document.documentElement;
        var a = document.body;
        var d = c.clientX + ($telerik.getCorrectScrollLeft(b) + $telerik.getCorrectScrollLeft(a));
        var f = c.clientY + (b.scrollTop + a.scrollTop);
        if ($telerik.isIE && Sys.Browser.version < 8) {
            d -= 2;
            f -= 2;
        } return { left: d, top: f };
    }, evalScriptCode: function (b) {
        if ($telerik.isSafari) {
            b = b.replace(/^\s*<!--((.|\n)*)-->\s*$/mi, "$1");
        } var a = document.createElement("script");
        a.setAttribute("type", "text/javascript");
        a.text = b;
        var c = document.getElementsByTagName("head")[0];
        c.appendChild(a);
        a.parentNode.removeChild(a);
    }, isScriptRegistered: function (k, a) {
        if (!k) {
            return 0;
        } if (!a) {
            a = document;
        } if ($telerik._uniqueScripts == null) {
            $telerik._uniqueScripts = {};
        } var h = document.getElementsByTagName("script");
        var f = 0;
        var c = k.indexOf("?d=");
        var d = k.indexOf("&");
        var j = c > 0 && d > c ? k.substring(c + 3, d) : k;
        if ($telerik._uniqueScripts[j] != null) {
            return 2;
        } for (var b = 0, e = h.length;
        b < e;
        b++) {
            var g = h[b];
            if (g.src) {
                if (g.getAttribute("src", 2).indexOf(j) != -1) {
                    $telerik._uniqueScripts[j] = true;
                    if (!$telerik.isDescendant(a, g)) {
                        f++;
                    }
                }
            }
        } return f;
    }, evalScripts: function (b, a) {
        $telerik.registerSkins(b);
        var g = b.getElementsByTagName("script");
        var j = 0, h = 0;
        var e = function (n, o) {
            if (n - h > 0 && ($telerik.isIE || $telerik.isSafari)) {
                window.setTimeout(function () {
                    e(n, o);
                }, 5);
            } else {
                var i = document.createElement("script");
                i.setAttribute("type", "text/javascript");
                document.getElementsByTagName("head")[0].appendChild(i);
                i.loadFinished = false;
                i.onload = function () {
                    if (!this.loadFinished) {
                        this.loadFinished = true;
                        h++;
                    }
                };
                i.onreadystatechange = function () {
                    if ("loaded" === this.readyState && !this.loadFinished) {
                        this.loadFinished = true;
                        h++;
                    }
                };
                i.setAttribute("src", o);
            }
        };
        var k = [];
        for (var c = 0, d = g.length;
        c < d;
        c++) {
            var f = g[c];
            if (f.src) {
                var m = f.getAttribute("src", 2);
                if (!$telerik.isScriptRegistered(m, b)) {
                    e(j++, m);
                }
            } else {
                Array.add(k, f.innerHTML);
            }
        } var l = function () {
            if (j - h > 0) {
                window.setTimeout(l, 20);
            } else {
                for (var i = 0;
                i < k.length;
                i++) {
                    $telerik.evalScriptCode(k[i]);
                } if (a) {
                    a();
                }
            }
        };
        l();
    }, registerSkins: function (c) {
        if (!c) {
            c = document.body;
        } var h = c.getElementsByTagName("link");
        if (h && h.length > 0) {
            var a = document.getElementsByTagName("head")[0];
            if (a) {
                for (var d = 0, g = h.length;
                d < g;
                d++) {
                    var k = h[d];
                    if (k.className == "Telerik_stylesheet") {
                        var l = a.getElementsByTagName("link");
                        if (k.href.indexOf("ie7CacheFix") >= 0) {
                            try {
                                k.href = k.href.replace("&ie7CacheFix", "");
                                k.href = k.href.replace("?ie7CacheFix", "");
                            } catch (b) { }
                        } if (l && l.length > 0) {
                            var f = l.length - 1;
                            while (f >= 0 && l[f--].href != k.href) { } if (f >= 0) {
                                continue;
                            }
                        } if ($telerik.isIE && !$telerik.isIE9Mode) {
                            k.parentNode.removeChild(k);
                            k = k.cloneNode(true);
                        } a.appendChild(k);
                        if (g > h.length) {
                            g = h.length;
                            d--;
                        }
                    }
                }
            }
        }
    }, getFirstChildByTagName: function (b, d, c) {
        if (!b || !b.childNodes) {
            return null;
        } var a = b.childNodes[c] || b.firstChild;
        while (a) {
            if (a.nodeType == 1 && a.tagName.toLowerCase() == d) {
                return a;
            } a = a.nextSibling;
        } return null;
    }, getChildByClassName: function (c, a, d) {
        var b = c.childNodes[d] || c.firstChild;
        while (b) {
            if (b.nodeType == 1 && b.className.indexOf(a) > -1) {
                return b;
            } b = b.nextSibling;
        } return null;
    }, getChildrenByTagName: function (d, g) {
        var c = new Array();
        var b = d.childNodes;
        if ($telerik.isIE) {
            b = d.children;
        } for (var e = 0, f = b.length;
        e < f;
        e++) {
            var a = b[e];
            if (a.nodeType == 1 && a.tagName.toLowerCase() == g) {
                Array.add(c, a);
            }
        } return c;
    }, getChildrenByClassName: function (e, d) {
        var c = new Array();
        var b = e.childNodes;
        if ($telerik.isIE) {
            b = e.children;
        } for (var f = 0, g = b.length;
        f < g;
        f++) {
            var a = b[f];
            if (a.nodeType == 1 && a.className.indexOf(d) > -1) {
                Array.add(c, a);
            }
        } return c;
    }, mergeElementAttributes: function (d, e, b) {
        if (!d || !e) {
            return;
        } if (d.mergeAttributes) {
            e.mergeAttributes(d, b);
        } else {
            for (var a = 0;
            a < d.attributes.length;
            a++) {
                var c = d.attributes[a].nodeValue;
                e.setAttribute(d.attributes[a].nodeName, c);
            } if ("" == e.getAttribute("style")) {
                e.removeAttribute("style");
            }
        }
    }, isMouseOverElement: function (c, b) {
        var d = $telerik.getBounds(c);
        var a = $telerik.getDocumentRelativeCursorPosition(b);
        return $telerik.containsPoint(d, a.left, a.top);
    }, isMouseOverElementEx: function (b, a) {
        var d = null;
        try {
            d = $telerik.getOuterBounds(b);
        } catch (a) {
            return false;
        } if (a && a.target) {
            var f = a.target.tagName;
            if (f == "SELECT" || f == "OPTION") {
                return true;
            } if (a.clientX < 0 || a.clientY < 0) {
                return true;
            }
        } var c = $telerik.getDocumentRelativeCursorPosition(a);
        d.x += 2;
        d.y += 2;
        d.width -= 4;
        d.height -= 4;
        return $telerik.containsPoint(d, c.left, c.top);
    }, getPreviousHtmlNode: function (a) {
        if (!a || !a.previousSibling) {
            return null;
        } while (a.previousSibling) {
            if (a.previousSibling.nodeType == 1) {
                return a.previousSibling;
            } a = a.previousSibling;
        }
    }, getNextHtmlNode: function (a) {
        if (!a || !a.nextSibling) {
            return null;
        } while (a.nextSibling) {
            if (a.nextSibling.nodeType == 1) {
                return a.nextSibling;
            } a = a.nextSibling;
        }
    }, disposeElement: function (a) {
        if (typeof (Sys.WebForms) == "undefined") {
            return;
        } var b = Sys.WebForms.PageRequestManager.getInstance();
        if (b && b._destroyTree) {
            b._destroyTree(a);
        } else {
            if (Sys.Application.disposeElement) {
                Sys.Application.disposeElement(a, true);
            }
        }
    }, htmlEncode: function (d) {
        var a = /&/g, c = /</g, b = />/g;
        return ("" + d).replace(a, "&amp;").replace(c, "&lt;").replace(b, "&gt;");
    }, htmlDecode: function (d) {
        var a = /&amp;/g, c = /&lt;/g, b = /&gt;/g;
        return ("" + d).replace(b, ">").replace(c, "<").replace(a, "&");
    }
};
if (window.$telerik == undefined) {
    window.$telerik = commonScripts;
} else {
    if ($telerik.$ != undefined && $telerik.$.extend) {
        $telerik.$.extend(window.$telerik, commonScripts);
    }
} window.TelerikCommonScripts = Telerik.Web.CommonScripts = window.$telerik;
(function (i, g) {
    function b(k, j) {
        return k.indexOf(j);
    } function c(j, k) {
        return j.match(k);
    } var e = i.navigator, h = e.userAgent, f, d, a;
    $telerik.isTrident = b(h, " Trident/") > -1;
    $telerik.isIE = (b(h, " MSIE ") > -1 || $telerik.isTrident);
    $telerik.isFirefox = b(h, " Firefox/") > -1 && !$telerik.isIE;
    if ($telerik.isIE) {
        f = /MSIE ([\d\.]+)/;
        d = c(h, f);
        if (d) {
            a = d[1];
        } else {
            f = /rv:([\d\.]+)/;
            d = c(h, f);
            if (d) {
                a = d[1];
            }
        } $telerik.isIE6 = a < 7;
        $telerik.isIE7 = a == 7 || (document.documentMode && document.documentMode == 7);
        $telerik.isIE8 = document.documentMode && document.documentMode == 8;
        $telerik.isIE9 = document.documentMode && document.documentMode == 9;
        $telerik.isIE9Mode = document.documentMode && document.documentMode >= 9;
        $telerik.isIE10 = document.documentMode && document.documentMode == 10;
        $telerik.isIE10Mode = document.documentMode && document.documentMode >= 10;
    }
})(window);
if (typeof (Sys.Browser.WebKit) == "undefined") {
    Sys.Browser.WebKit = {};
} if (typeof (Sys.Browser.Chrome) == "undefined") {
    Sys.Browser.Chrome = {};
} if (navigator.userAgent.indexOf("Chrome") > -1) {
    Sys.Browser.version = parseFloat(navigator.userAgent.match(/WebKit\/(\d+(\.\d+)?)/)[1]);
    Sys.Browser.agent = Sys.Browser.Chrome;
    Sys.Browser.name = "Chrome";
} else {
    if (navigator.userAgent.indexOf("WebKit/") > -1) {
        Sys.Browser.version = parseFloat(navigator.userAgent.match(/WebKit\/(\d+(\.\d+)?)/)[1]);
        if (Sys.Browser.version < 500) {
            Sys.Browser.agent = Sys.Browser.Safari;
            Sys.Browser.name = "Safari";
        } else {
            Sys.Browser.agent = Sys.Browser.WebKit;
            Sys.Browser.name = "WebKit";
        }
    }
} $telerik.isMobileSafari = (navigator.userAgent.search(/like\sMac\sOS\sX.*Mobile\/\S+/) != -1);
$telerik.isChrome = Sys.Browser.agent == Sys.Browser.Chrome;
$telerik.isSafari6 = Sys.Browser.agent == Sys.Browser.WebKit && Sys.Browser.version >= 536;
$telerik.isSafari5 = Sys.Browser.agent == Sys.Browser.WebKit && Sys.Browser.version >= 534 && Sys.Browser.version < 536;
$telerik.isSafari4 = Sys.Browser.agent == Sys.Browser.WebKit && Sys.Browser.version >= 526 && Sys.Browser.version < 534;
$telerik.isSafari3 = Sys.Browser.agent == Sys.Browser.WebKit && Sys.Browser.version < 526 && Sys.Browser.version > 500;
$telerik.isSafari2 = Sys.Browser.agent == Sys.Browser.Safari;
$telerik.isSafari = $telerik.isSafari2 || $telerik.isSafari3 || $telerik.isSafari4 || $telerik.isSafari5 || $telerik.isSafari6 || $telerik.isChrome;
$telerik.isAndroid = (navigator.userAgent.search(/Android/i) != -1);
$telerik.isBlackBerry4 = (navigator.userAgent.search(/BlackBerry\d+\/4[\d\.]+/i) != -1);
$telerik.isBlackBerry5 = (navigator.userAgent.search(/BlackBerry\d+\/5[\d\.]+/i) != -1);
$telerik.isBlackBerry6 = (navigator.userAgent.search(/BlackBerry.*Safari\/\S+/i) != -1);
$telerik.isBlackBerry = $telerik.isBlackBerry4 || $telerik.isBlackBerry5 || $telerik.isBlackBerry6;
$telerik.isOpera = Sys.Browser.agent == Sys.Browser.Opera;
$telerik.isFirefox2 = $telerik.isFirefox && Sys.Browser.version < 3;
$telerik.isFirefox3 = $telerik.isFirefox && Sys.Browser.version >= 3;
$telerik.quirksMode = $telerik.isIE && document.compatMode != "CSS1Compat";
$telerik.standardsMode = !$telerik.quirksMode;
$telerik.OperaEngine = 0;
$telerik.OperaVersionString = window.opera ? window.opera.version() : 0;
$telerik.OperaVersion = $telerik.OperaVersionString ? (parseInt($telerik.OperaVersionString * 10) / 10) : 0;
if ($telerik.isOpera) {
    $telerik._prestoVersion = navigator.userAgent.match(/Presto\/(\d+\.(\d+)?)/);
    if ($telerik._prestoVersion) {
        $telerik.OperaEngine = parseInt($telerik._prestoVersion[1]) + (parseInt($telerik._prestoVersion[2]) / 100);
    }
} $telerik.isOpera9 = $telerik.isOpera && $telerik.OperaVerNumber < 10;
$telerik.isOpera10 = $telerik.isOpera && $telerik.OperaVersion >= 10 && $telerik.OperaVersion < 10.5;
$telerik.isOpera105 = $telerik.isOpera && $telerik.OperaVersion >= 10.5;
$telerik.isOpera11 = $telerik.isOpera && $telerik.OperaVersion > 11;
$telerik.isMobileOpera = $telerik.isOpera && (navigator.userAgent.search(/opera (?:mobi|tablet)/i) != -1);
$telerik.isMobileIE10 = $telerik.isIE10 && (navigator.userAgent.search(/\bARM\b;|\bTouch\b/i) != -1);
$telerik.isTouchDevice = $telerik.isMobileSafari || $telerik.isAndroid || $telerik.isBlackBerry6 || $telerik.isMobileOpera;
if ($telerik.isIE9Mode) {
    document.documentElement.className += " _Telerik_IE9";
} if ($telerik.isOpera11) {
    document.documentElement.className += " _Telerik_Opera11";
} else {
    if ($telerik.isOpera105) {
        document.documentElement.className += " _Telerik_Opera105";
    }
} if (document.documentElement.getBoundingClientRect) {
    $telerik.originalGetLocation = function (g) {
        var d = Function._validateParams(arguments, [{ name: "element", domElement: true }]);
        if (d) {
            throw d;
        } if (g.self || g.nodeType === 9 || (g === document.documentElement) || (g.parentNode === g.ownerDocument.documentElement)) {
            return new Sys.UI.Point(0, 0);
        } var b = g.getBoundingClientRect();
        if (!b) {
            return new Sys.UI.Point(0, 0);
        } var c = g.ownerDocument.documentElement, k = Math.round(b.left) + c.scrollLeft, l = Math.round(b.top) + c.scrollTop;
        if (Sys.Browser.agent === Sys.Browser.InternetExplorer) {
            try {
                var i = g.ownerDocument.parentWindow.frameElement || null;
                if (i) {
                    var j = (i.frameBorder === "0" || i.frameBorder === "no") ? 2 : 0;
                    k += j;
                    l += j;
                }
            } catch (h) { } if (Sys.Browser.version === 7 && !document.documentMode) {
                var a = document.body, m = a.getBoundingClientRect(), n = (m.right - m.left) / a.clientWidth;
                n = Math.round(n * 100);
                n = (n - n % 5) / 100;
                if (!isNaN(n) && (n !== 1)) {
                    k = Math.round(k / n);
                    l = Math.round(l / n);
                }
            } if ((document.documentMode || 0) < 8) {
                k -= c.clientLeft;
                l -= c.clientTop;
            }
        } return new Sys.UI.Point(k, l);
    };
} else {
    if ($telerik.isSafari) {
        $telerik.originalGetLocation = function (c) {
            var b = Function._validateParams(arguments, [{ name: "element", domElement: true }]);
            if (b) {
                throw b;
            } if ((c.window && (c.window === c)) || c.nodeType === 9) {
                return new Sys.UI.Point(0, 0);
            } var f = 0, g = 0, h, j = null, k = null, a;
            for (h = c;
            h;
            j = h, k = a, h = h.offsetParent) {
                a = Sys.UI.DomElement._getCurrentStyle(h);
                var l = h.tagName ? h.tagName.toUpperCase() : null;
                if ((h.offsetLeft || h.offsetTop) && ((l !== "BODY") || (!k || k.position !== "absolute"))) {
                    f += h.offsetLeft;
                    g += h.offsetTop;
                } if (j && Sys.Browser.version >= 3) {
                    f += parseInt(a.borderLeftWidth);
                    g += parseInt(a.borderTopWidth);
                }
            } a = Sys.UI.DomElement._getCurrentStyle(c);
            var d = a ? a.position : null;
            if (!d || (d !== "absolute")) {
                for (h = c.parentNode;
                h;
                h = h.parentNode) {
                    l = h.tagName ? h.tagName.toUpperCase() : null;
                    if ((l !== "BODY") && (l !== "HTML") && (h.scrollLeft || h.scrollTop)) {
                        f -= (h.scrollLeft || 0);
                        g -= (h.scrollTop || 0);
                    } a = Sys.UI.DomElement._getCurrentStyle(h);
                    var i = a ? a.position : null;
                    if (i && (i === "absolute")) {
                        break;
                    }
                }
            } return new Sys.UI.Point(f, g);
        };
    } else {
        $telerik.originalGetLocation = function (c) {
            var b = Function._validateParams(arguments, [{ name: "element", domElement: true }]);
            if (b) {
                throw b;
            } if ((c.window && (c.window === c)) || c.nodeType === 9) {
                return new Sys.UI.Point(0, 0);
            } var f = 0, g = 0, h, i = null, j = null, a = null;
            for (h = c;
            h;
            i = h, j = a, h = h.offsetParent) {
                var k = h.tagName ? h.tagName.toUpperCase() : null;
                a = Sys.UI.DomElement._getCurrentStyle(h);
                if ((h.offsetLeft || h.offsetTop) && !((k === "BODY") && (!j || j.position !== "absolute"))) {
                    f += h.offsetLeft;
                    g += h.offsetTop;
                } if (i !== null && a) {
                    if ((k !== "TABLE") && (k !== "TD") && (k !== "HTML")) {
                        f += parseInt(a.borderLeftWidth) || 0;
                        g += parseInt(a.borderTopWidth) || 0;
                    } if (k === "TABLE" && (a.position === "relative" || a.position === "absolute")) {
                        f += parseInt(a.marginLeft) || 0;
                        g += parseInt(a.marginTop) || 0;
                    }
                }
            } a = Sys.UI.DomElement._getCurrentStyle(c);
            var d = a ? a.position : null;
            if (!d || (d !== "absolute")) {
                for (h = c.parentNode;
                h;
                h = h.parentNode) {
                    k = h.tagName ? h.tagName.toUpperCase() : null;
                    if ((k !== "BODY") && (k !== "HTML") && (h.scrollLeft || h.scrollTop)) {
                        f -= (h.scrollLeft || 0);
                        g -= (h.scrollTop || 0);
                        a = Sys.UI.DomElement._getCurrentStyle(h);
                        if (a) {
                            f += parseInt(a.borderLeftWidth) || 0;
                            g += parseInt(a.borderTopWidth) || 0;
                        }
                    }
                }
            } return new Sys.UI.Point(f, g);
        };
    }
} Sys.Application.add_init(function () {
    try {
        $telerik._borderThickness();
    } catch (a) { }
});
Telerik.Web.UI.Orientation = function () {
    throw Error.invalidOperation();
};
Telerik.Web.UI.Orientation.prototype = { Horizontal: 0, Vertical: 1 };
Telerik.Web.UI.Orientation.registerEnum("Telerik.Web.UI.Orientation", false);
Telerik.Web.UI.RenderMode = function () {
    throw Error.invalidOperation();
};
Telerik.Web.UI.RenderMode.prototype = { Auto: 0, Classic: 1, Lite: 2, Native: 3 };
Telerik.Web.UI.RenderMode.registerEnum("Telerik.Web.UI.RenderMode", false);
Telerik.Web.UI.RadWebControl = function (a) {
    Telerik.Web.UI.RadWebControl.initializeBase(this, [a]);
    this._clientStateFieldID = null;
    this._renderMode = Telerik.Web.UI.RenderMode.Classic;
    this._shouldUpdateClientState = true;
    this._invisibleParents = [];
};
Telerik.Web.UI.RadWebControl.prototype = {
    initialize: function () {
        Telerik.Web.UI.RadWebControl.callBaseMethod(this, "initialize");
        $telerik.registerControl(this);
        if (!this.get_clientStateFieldID()) {
            return;
        } var a = $get(this.get_clientStateFieldID());
        if (!a) {
            return;
        } a.setAttribute("autocomplete", "off");
    }, dispose: function () {
        $telerik.unregisterControl(this);
        var c = this.get_element();
        this._clearParentShowHandlers();
        Telerik.Web.UI.RadWebControl.callBaseMethod(this, "dispose");
        if (c) {
            c.control = null;
            var a = true;
            if (c._events) {
                for (var b in c._events) {
                    if (c._events[b].length > 0) {
                        a = false;
                        break;
                    }
                } if (a) {
                    c._events = null;
                }
            }
        }
    }, raiseEvent: function (b, a) {
        var c = this.get_events().getHandler(b);
        if (c) {
            if (!a) {
                a = Sys.EventArgs.Empty;
            } c(this, a);
        }
    }, updateClientState: function () {
        if (this._shouldUpdateClientState) {
            this.set_clientState(this.saveClientState());
        }
    }, saveClientState: function () {
        return null;
    }, get_clientStateFieldID: function () {
        return this._clientStateFieldID;
    }, set_clientStateFieldID: function (a) {
        if (this._clientStateFieldID != a) {
            this._clientStateFieldID = a;
            this.raisePropertyChanged("ClientStateFieldID");
        }
    }, get_clientState: function () {
        if (this._clientStateFieldID) {
            var a = document.getElementById(this._clientStateFieldID);
            if (a) {
                return a.value;
            }
        } return null;
    }, set_clientState: function (b) {
        if (this._clientStateFieldID) {
            var a = document.getElementById(this._clientStateFieldID);
            if (a) {
                a.value = b;
            }
        }
    }, repaint: function () { }, canRepaint: function () {
        return this.get_element().offsetWidth > 0;
    }, add_parentShown: function (a) {
        var b = $telerik.getInvisibleParent(a);
        if (!b) {
            return;
        } if (!Array.contains(this._invisibleParents, b)) {
            Array.add(this._invisibleParents, b);
            this._handleHiddenParent(true, b);
        }
    }, remove_parentShown: function (a) {
        Array.remove(this._invisibleParents, a);
        this._handleHiddenParent(false, a);
    }, _handleHiddenParent: function (e, d) {
        if (!d) {
            return;
        } if (!this._parentShowDelegate) {
            this._parentShowDelegate = Function.createDelegate(this, this._parentShowHandler);
        } var a = this._parentShowDelegate;
        var b = "DOMAttrModified";
        if ($telerik.isIE) {
            b = "propertychange";
        } var c = e ? $telerik.addExternalHandler : $telerik.removeExternalHandler;
        c(d, b, a);
    }, _parentShowHandler: function (b) {
        if ($telerik.isIE) {
            if (b.rawEvent) {
                var b = b.rawEvent;
            } if (!b || !b.srcElement || !b.propertyName) {
                return;
            } var d = b.srcElement;
            if (b.propertyName == "style.display" || b.propertyName == "className") {
                var a = $telerik.getCurrentStyle(d, "display");
                if (a != "none") {
                    b.target = d;
                    this._runWhenParentShows(b);
                }
            }
        } else {
            if (b.attrName == "style" || b.attrName == "class") {
                var c = b.target;
                if ((b.currentTarget == b.target) && ("none" != $telerik.getCurrentStyle(c, "display"))) {
                    window.setTimeout(Function.createDelegate(this, function () {
                        this._runWhenParentShows(b);
                    }), 0);
                }
            }
        }
    }, _runWhenParentShows: function (a) {
        var b = a.target;
        this.remove_parentShown(b);
        this.repaint();
    }, _clearParentShowHandlers: function () {
        var a = this._invisibleParents;
        for (var b = 0;
        b < a.length;
        b++) {
            this.remove_parentShown(a[b]);
        } this._invisibleParents = [];
        this._parentShowDelegate = null;
    }, _getChildElement: function (a) {
        return $get(this.get_id() + "_" + a);
    }, _findChildControl: function (a) {
        return $find(this.get_id() + "_" + a);
    }
};
Telerik.Web.UI.RadWebControl.registerClass("Telerik.Web.UI.RadWebControl", Sys.UI.Control);
Telerik.Web.Timer = function () {
    Telerik.Web.Timer.initializeBase(this);
    this._interval = 1000;
    this._enabled = false;
    this._timer = null;
    this._timerCallbackDelegate = Function.createDelegate(this, this._timerCallback);
};
Telerik.Web.Timer.prototype = {
    get_interval: function () {
        return this._interval;
    }, set_interval: function (a) {
        if (this._interval !== a) {
            this._interval = a;
            this.raisePropertyChanged("interval");
            if (!this.get_isUpdating() && (this._timer !== null)) {
                this._stopTimer();
                this._startTimer();
            }
        }
    }, get_enabled: function () {
        return this._enabled;
    }, set_enabled: function (a) {
        if (a !== this.get_enabled()) {
            this._enabled = a;
            this.raisePropertyChanged("enabled");
            if (!this.get_isUpdating()) {
                if (a) {
                    this._startTimer();
                } else {
                    this._stopTimer();
                }
            }
        }
    }, add_tick: function (a) {
        this.get_events().addHandler("tick", a);
    }, remove_tick: function (a) {
        this.get_events().removeHandler("tick", a);
    }, dispose: function () {
        this.set_enabled(false);
        this._stopTimer();
        Telerik.Web.Timer.callBaseMethod(this, "dispose");
    }, updated: function () {
        Telerik.Web.Timer.callBaseMethod(this, "updated");
        if (this._enabled) {
            this._stopTimer();
            this._startTimer();
        }
    }, _timerCallback: function () {
        var a = this.get_events().getHandler("tick");
        if (a) {
            a(this, Sys.EventArgs.Empty);
        }
    }, _startTimer: function () {
        this._timer = window.setInterval(this._timerCallbackDelegate, this._interval);
    }, _stopTimer: function () {
        window.clearInterval(this._timer);
        this._timer = null;
    }
};
Telerik.Web.Timer.registerClass("Telerik.Web.Timer", Sys.Component);
Telerik.Web.BoxSide = function () { };
Telerik.Web.BoxSide.prototype = { Top: 0, Right: 1, Bottom: 2, Left: 3 };
Telerik.Web.BoxSide.registerEnum("Telerik.Web.BoxSide", false);
Telerik.Web.UI.WebServiceLoaderEventArgs = function (a) {
    Telerik.Web.UI.WebServiceLoaderEventArgs.initializeBase(this);
    this._context = a;
};
Telerik.Web.UI.WebServiceLoaderEventArgs.prototype = {
    get_context: function () {
        return this._context;
    }
};
Telerik.Web.UI.WebServiceLoaderEventArgs.registerClass("Telerik.Web.UI.WebServiceLoaderEventArgs", Sys.EventArgs);
Telerik.Web.UI.WebServiceLoaderSuccessEventArgs = function (b, a) {
    Telerik.Web.UI.WebServiceLoaderSuccessEventArgs.initializeBase(this, [a]);
    this._data = b;
};
Telerik.Web.UI.WebServiceLoaderSuccessEventArgs.prototype = {
    get_data: function () {
        return this._data;
    }
};
Telerik.Web.UI.WebServiceLoaderSuccessEventArgs.registerClass("Telerik.Web.UI.WebServiceLoaderSuccessEventArgs", Telerik.Web.UI.WebServiceLoaderEventArgs);
Telerik.Web.UI.WebServiceLoaderErrorEventArgs = function (b, a) {
    Telerik.Web.UI.WebServiceLoaderErrorEventArgs.initializeBase(this, [a]);
    this._message = b;
};
Telerik.Web.UI.WebServiceLoaderErrorEventArgs.prototype = {
    get_message: function () {
        return this._message;
    }
};
Telerik.Web.UI.WebServiceLoaderErrorEventArgs.registerClass("Telerik.Web.UI.WebServiceLoaderErrorEventArgs", Telerik.Web.UI.WebServiceLoaderEventArgs);
Telerik.Web.UI.WebServiceLoader = function (a) {
    this._webServiceSettings = a;
    this._events = null;
    this._onWebServiceSuccessDelegate = Function.createDelegate(this, this._onWebServiceSuccess);
    this._onWebServiceErrorDelegate = Function.createDelegate(this, this._onWebServiceError);
    this._currentRequest = null;
};
Telerik.Web.UI.WebServiceLoader.prototype = {
    get_webServiceSettings: function () {
        return this._webServiceSettings;
    }, get_events: function () {
        if (!this._events) {
            this._events = new Sys.EventHandlerList();
        } return this._events;
    }, loadData: function (b, a) {
        var c = this.get_webServiceSettings();
        this.invokeMethod(c.get_method(), b, a);
    }, invokeMethod: function (d, b, a) {
        var f = this.get_webServiceSettings();
        if (f.get_isEmpty()) {
            alert("Please, specify valid web service and method.");
            return;
        } this._raiseEvent("loadingStarted", new Telerik.Web.UI.WebServiceLoaderEventArgs(a));
        var e = f.get_path();
        var c = f.get_useHttpGet();
        this._currentRequest = Sys.Net.WebServiceProxy.invoke(e, d, c, b, this._onWebServiceSuccessDelegate, this._onWebServiceErrorDelegate, a);
    }, add_loadingStarted: function (a) {
        this.get_events().addHandler("loadingStarted", a);
    }, add_loadingError: function (a) {
        this.get_events().addHandler("loadingError", a);
    }, add_loadingSuccess: function (a) {
        this.get_events().addHandler("loadingSuccess", a);
    }, _serializeDictionaryAsKeyValuePairs: function (a) {
        var c = [];
        for (var b in a) {
            c[c.length] = { Key: b, Value: a[b] };
        } return c;
    }, _onWebServiceSuccess: function (b, a) {
        var c = new Telerik.Web.UI.WebServiceLoaderSuccessEventArgs(b, a);
        this._raiseEvent("loadingSuccess", c);
    }, _onWebServiceError: function (b, a) {
        var c = new Telerik.Web.UI.WebServiceLoaderErrorEventArgs(b.get_message(), a);
        this._raiseEvent("loadingError", c);
    }, _raiseEvent: function (b, a) {
        var c = this.get_events().getHandler(b);
        if (c) {
            if (!a) {
                a = Sys.EventArgs.Empty;
            } c(this, a);
        }
    }
};
Telerik.Web.UI.WebServiceLoader.registerClass("Telerik.Web.UI.WebServiceLoader");
Telerik.Web.UI.WebServiceSettings = function (a) {
    this._path = null;
    this._method = null;
    this._useHttpGet = false;
    this._odata = false;
    if (!a) {
        a = {};
    } if (typeof (a.path) != "undefined") {
        this._path = a.path;
    } if (typeof (a.method) != "undefined") {
        this._method = a.method;
    } if (typeof (a.useHttpGet) != "undefined") {
        this._useHttpGet = a.useHttpGet;
    }
};
Telerik.Web.UI.WebServiceSettings.prototype = {
    get_isWcf: function () {
        return /\.svc($|\/)/.test(this._path) && !this.get_isOData();
    }, get_isOData: function () {
        return this._odata;
    }, get_path: function () {
        return this._path;
    }, set_path: function (a) {
        this._path = a;
    }, get_method: function () {
        return this._method;
    }, set_method: function (a) {
        this._method = a;
    }, get_useHttpGet: function () {
        return this._useHttpGet;
    }, set_useHttpGet: function (a) {
        this._useHttpGet = a;
    }, get_isEmpty: function () {
        var b = this.get_path();
        var a = this.get_method();
        return (!(b && a));
    }
};
Telerik.Web.UI.WebServiceSettings.registerClass("Telerik.Web.UI.WebServiceSettings");
Telerik.Web.UI.CallbackLoader = function (a) {
    this._callbackSettings = a;
};
Telerik.Web.UI.CallbackLoader.prototype = {
    invokeCallbackMethod: function () {
        WebForm_DoCallback(this._callbackSettings._id, this._callbackSettings._arguments, this._callbackSettings._onCallbackSuccess, this._callbackSettings._context, this._callbackSettings._onCallbackError, this._callbackSettings._isAsync);
    }
};
Telerik.Web.UI.CallbackLoader.registerClass("Telerik.Web.UI.CallbackLoader");
Telerik.Web.UI.CallbackSettings = function (a) {
    this._id = a.id;
    this._arguments = a.arguments;
    this._onCallbackSuccess = a.onCallbackSuccess;
    this._context = a.context;
    this._onCallbackError = a.onCallbackError;
    this._isAsync = a.isAsync;
};
Telerik.Web.UI.CallbackSettings.registerClass("Telerik.Web.UI.CallbackSettings");
Telerik.Web.UI.ActionsManager = function (a) {
    Telerik.Web.UI.ActionsManager.initializeBase(this);
    this._actions = [];
    this._currentActionIndex = -1;
};
Telerik.Web.UI.ActionsManager.prototype = {
    get_actions: function () {
        return this._actions;
    }, shiftPointerLeft: function () {
        this._currentActionIndex--;
    }, shiftPointerRight: function () {
        this._currentActionIndex++;
    }, get_currentAction: function () {
        return this.get_actions()[this._currentActionIndex];
    }, get_nextAction: function () {
        return this.get_actions()[this._currentActionIndex + 1];
    }, addAction: function (a) {
        if (a) {
            var b = new Telerik.Web.UI.ActionsManagerEventArgs(a);
            this.raiseEvent("executeAction", b);
            this._clearActionsToRedo();
            Array.add(this._actions, a);
            this._currentActionIndex = this._actions.length - 1;
            return true;
        } return false;
    }, undo: function (d) {
        if (d == null) {
            d = 1;
        } if (d > this._actions.length) {
            d = this._actions.length;
        } var c = 0;
        var a = null;
        while (0 < d-- && 0 <= this._currentActionIndex && this._currentActionIndex < this._actions.length) {
            a = this._actions[this._currentActionIndex--];
            if (a) {
                var b = new Telerik.Web.UI.ActionsManagerEventArgs(a);
                this.raiseEvent("undoAction", b);
                c++;
            }
        }
    }, redo: function (e) {
        if (e == null) {
            e = 1;
        } if (e > this._actions.length) {
            e = this._actions.length;
        } var d = 0;
        var a = null;
        var b = this._currentActionIndex + 1;
        while (0 < e-- && 0 <= b && b < this._actions.length) {
            a = this._actions[b];
            if (a) {
                var c = new Telerik.Web.UI.ActionsManagerEventArgs(a);
                this.raiseEvent("redoAction", c);
                this._currentActionIndex = b;
                d++;
            } b++;
        }
    }, removeActionAt: function (a) {
        this._actions.splice(a, 1);
        if (this._currentActionIndex >= a) {
            this._currentActionIndex--;
        }
    }, canUndo: function () {
        return (-1 < this._currentActionIndex);
    }, canRedo: function () {
        return (this._currentActionIndex < this._actions.length - 1);
    }, getActionsToUndo: function () {
        if (this.canUndo()) {
            return (this._actions.slice(0, this._currentActionIndex + 1)).reverse();
        } return [];
    }, getActionsToRedo: function () {
        if (this.canRedo()) {
            return this._actions.slice(this._currentActionIndex + 1);
        } return [];
    }, _clearActionsToRedo: function () {
        if (this.canRedo()) {
            var a = this._currentActionIndex + 2;
            if (a < this._actions.length) {
                this._actions.splice(a, this._actions.length - a);
            }
        }
    }, add_undoAction: function (a) {
        this.get_events().addHandler("undoAction", a);
    }, remove_undoAction: function (a) {
        this.get_events().removeHandler("undoAction", a);
    }, add_redoAction: function (a) {
        this.get_events().addHandler("redoAction", a);
    }, remove_redoAction: function (a) {
        this.get_events().removeHandler("redoAction", a);
    }, add_executeAction: function (a) {
        this.get_events().addHandler("executeAction", a);
    }, remove_executeAction: function (a) {
        this.get_events().removeHandler("executeAction", a);
    }, raiseEvent: function (b, a) {
        var c = this.get_events().getHandler(b);
        if (c) {
            c(this, a);
        }
    }
};
Telerik.Web.UI.ActionsManager.registerClass("Telerik.Web.UI.ActionsManager", Sys.Component);
Telerik.Web.UI.ActionsManagerEventArgs = function (a) {
    Telerik.Web.UI.ActionsManagerEventArgs.initializeBase(this);
    this._action = a;
};
Telerik.Web.UI.ActionsManagerEventArgs.prototype = {
    get_action: function () {
        return this._action;
    }
};
Telerik.Web.UI.ActionsManagerEventArgs.registerClass("Telerik.Web.UI.ActionsManagerEventArgs", Sys.CancelEventArgs);
Telerik.Web.StringBuilder = function (a) {
    this._buffer = a || [];
};
Telerik.Web.StringBuilder.prototype = {
    append: function (b) {
        for (var a = 0;
        a < arguments.length;
        a++) {
            this._buffer[this._buffer.length] = arguments[a];
        } return this;
    }, toString: function () {
        return this._buffer.join("");
    }, get_buffer: function () {
        return this._buffer;
    }
};
Telerik.Web.UI.RadTemplateBoundEventArgs = function (a, c, b) {
    Telerik.Web.UI.RadTemplateBoundEventArgs.initializeBase(this);
    this._dataItem = a;
    this._template = c;
    this._html = b;
};
Telerik.Web.UI.RadTemplateBoundEventArgs.prototype = {
    get_dataItem: function () {
        return this._dataItem;
    }, set_html: function (a) {
        this._html = a;
    }, get_html: function (a) {
        return this._html;
    }, get_template: function (a) {
        return this._template;
    }
};
Telerik.Web.UI.RadTemplateBoundEventArgs.registerClass("Telerik.Web.UI.RadTemplateBoundEventArgs", Sys.EventArgs);
(function () {
    function g() {
        if ($telerik.$) {
            return $telerik.$.extend.apply($telerik.$, arguments);
        } var n = arguments[0] && typeof (arguments[0]) === "object" ? arguments[0] : {};
        for (var k = 1;
        k < arguments.length;
        k++) {
            var m = arguments[k];
            if (m != null) {
                for (var l in m) {
                    var j = m[l];
                    if (typeof (j) !== "undefined") {
                        n[l] = j;
                    }
                }
            }
        } return n;
    } function b(j, l) {
        if (l) {
            return "'" + j.split("'").join("\\'").replace(/\n/g, "\\n").replace(/\r/g, "\\r").replace(/\t/g, "\\t") + "'";
        } else {
            var i = j.charAt(0), k = j.substring(1);
            if (i === "=") {
                return "+(" + k + ")+";
            } else {
                if (i === ":") {
                    return "+e(" + k + ")+";
                } else {
                    return ";" + j + ";o+=";
                }
            }
        }
    } var a = /^\w+/, d = /\${([^}]*)}/g, e = /\\}/g, c = /__CURLY__/g, f = /\\#/g, h = /__SHARP__/g;
    Telerik.Web.UI.Template = {
        paramName: "data", useWithBlock: true, render: function (m, i) {
            var k, l, j = "";
            for (k = 0, l = i.length;
            k < l;
            k++) {
                j += m(i[k]);
            } return j;
        }, compile: function (r, m) {
            var q = g({}, this, m), n = q.paramName, i = n.match(a)[0], s = q.useWithBlock, k = "var o,e=$telerik.htmlEncode;", p, o, l;
            if (typeof (r) === "function") {
                if (r.length === 2) {
                    return function (t) {
                        return r($telerik.$ || jQuery, { data: t }).join("");
                    };
                } return r;
            } k += s ? "with(" + n + "){" : "";
            k += "o=";
            p = r.replace(e, "__CURLY__").replace(d, "#=e($1)#").replace(c, "}").replace(f, "__SHARP__").split("#");
            for (l = 0;
            l < p.length;
            l++) {
                k += b(p[l], l % 2 === 0);
            } k += s ? ";}" : ";";
            k += "return o;";
            k = k.replace(h, "#");
            try {
                return new Function(i, k);
            } catch (j) {
                throw new Error(String.format("Invalid template:'{0}' Generated code:'{1}'", r, k));
            }
        }
    };
})();
(function () {
    if (Sys && Sys.WebForms && Sys.WebForms.PageRequestManager) {
        Sys.WebForms.PageRequestManager.prototype._onFormElementClick = function (a) {
            if ($telerik.isIE10) {
                this._activeDefaultButtonClicked = (a.target === this._activeDefaultButton);
                this._onFormElementActive(a.target, parseInt(a.offsetX), parseInt(a.offsetY));
            } else {
                this._activeDefaultButtonClicked = (a.target === this._activeDefaultButton);
                this._onFormElementActive(a.target, a.offsetX, a.offsetY);
            }
        };
    }
}());

/* END Telerik.Web.UI.Common.Core.js */
/* START Telerik.Web.UI.Common.jQuery.js */
/*! jQuery v1.9.1 | (c) 2005, 2012 jQuery Foundation, Inc. | jquery.org/license
//@ sourceMappingURL=jquery.min.map
*/(function (e, t) {
    var n, r, i = typeof t, o = e.document, a = e.location, s = e.jQuery, u = e.$, l = {}, c = [], p = "1.9.1", f = c.concat, d = c.push, h = c.slice, g = c.indexOf, m = l.toString, y = l.hasOwnProperty, v = p.trim, b = function (e, t) { return new b.fn.init(e, t, r) }, x = /[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source, w = /\S+/g, T = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, N = /^(?:(<[\w\W]+>)[^>]*|#([\w-]*))$/, C = /^<(\w+)\s*\/?>(?:<\/\1>|)$/, k = /^[\],:{}\s]*$/, E = /(?:^|:|,)(?:\s*\[)+/g, S = /\\(?:["\\\/bfnrt]|u[\da-fA-F]{4})/g, A = /"[^"\\\r\n]*"|true|false|null|-?(?:\d+\.|)\d+(?:[eE][+-]?\d+|)/g, j = /^-ms-/, D = /-([\da-z])/gi, L = function (e, t) { return t.toUpperCase() }, H = function (e) { (o.addEventListener || "load" === e.type || "complete" === o.readyState) && (q(), b.ready()) }, q = function () { o.addEventListener ? (o.removeEventListener("DOMContentLoaded", H, !1), e.removeEventListener("load", H, !1)) : (o.detachEvent("onreadystatechange", H), e.detachEvent("onload", H)) }; b.fn = b.prototype = { jquery: p, constructor: b, init: function (e, n, r) { var i, a; if (!e) return this; if ("string" == typeof e) { if (i = "<" === e.charAt(0) && ">" === e.charAt(e.length - 1) && e.length >= 3 ? [null, e, null] : N.exec(e), !i || !i[1] && n) return !n || n.jquery ? (n || r).find(e) : this.constructor(n).find(e); if (i[1]) { if (n = n instanceof b ? n[0] : n, b.merge(this, b.parseHTML(i[1], n && n.nodeType ? n.ownerDocument || n : o, !0)), C.test(i[1]) && b.isPlainObject(n)) for (i in n) b.isFunction(this[i]) ? this[i](n[i]) : this.attr(i, n[i]); return this } if (a = o.getElementById(i[2]), a && a.parentNode) { if (a.id !== i[2]) return r.find(e); this.length = 1, this[0] = a } return this.context = o, this.selector = e, this } return e.nodeType ? (this.context = this[0] = e, this.length = 1, this) : b.isFunction(e) ? r.ready(e) : (e.selector !== t && (this.selector = e.selector, this.context = e.context), b.makeArray(e, this)) }, selector: "", length: 0, size: function () { return this.length }, toArray: function () { return h.call(this) }, get: function (e) { return null == e ? this.toArray() : 0 > e ? this[this.length + e] : this[e] }, pushStack: function (e) { var t = b.merge(this.constructor(), e); return t.prevObject = this, t.context = this.context, t }, each: function (e, t) { return b.each(this, e, t) }, ready: function (e) { return b.ready.promise().done(e), this }, slice: function () { return this.pushStack(h.apply(this, arguments)) }, first: function () { return this.eq(0) }, last: function () { return this.eq(-1) }, eq: function (e) { var t = this.length, n = +e + (0 > e ? t : 0); return this.pushStack(n >= 0 && t > n ? [this[n]] : []) }, map: function (e) { return this.pushStack(b.map(this, function (t, n) { return e.call(t, n, t) })) }, end: function () { return this.prevObject || this.constructor(null) }, push: d, sort: [].sort, splice: [].splice }, b.fn.init.prototype = b.fn, b.extend = b.fn.extend = function () { var e, n, r, i, o, a, s = arguments[0] || {}, u = 1, l = arguments.length, c = !1; for ("boolean" == typeof s && (c = s, s = arguments[1] || {}, u = 2), "object" == typeof s || b.isFunction(s) || (s = {}), l === u && (s = this, --u) ; l > u; u++) if (null != (o = arguments[u])) for (i in o) e = s[i], r = o[i], s !== r && (c && r && (b.isPlainObject(r) || (n = b.isArray(r))) ? (n ? (n = !1, a = e && b.isArray(e) ? e : []) : a = e && b.isPlainObject(e) ? e : {}, s[i] = b.extend(c, a, r)) : r !== t && (s[i] = r)); return s }, b.extend({ noConflict: function (t) { return e.$ === b && (e.$ = u), t && e.jQuery === b && (e.jQuery = s), b }, isReady: !1, readyWait: 1, holdReady: function (e) { e ? b.readyWait++ : b.ready(!0) }, ready: function (e) { if (e === !0 ? !--b.readyWait : !b.isReady) { if (!o.body) return setTimeout(b.ready); b.isReady = !0, e !== !0 && --b.readyWait > 0 || (n.resolveWith(o, [b]), b.fn.trigger && b(o).trigger("ready").off("ready")) } }, isFunction: function (e) { return "function" === b.type(e) }, isArray: Array.isArray || function (e) { return "array" === b.type(e) }, isWindow: function (e) { return null != e && e == e.window }, isNumeric: function (e) { return !isNaN(parseFloat(e)) && isFinite(e) }, type: function (e) { return null == e ? e + "" : "object" == typeof e || "function" == typeof e ? l[m.call(e)] || "object" : typeof e }, isPlainObject: function (e) { if (!e || "object" !== b.type(e) || e.nodeType || b.isWindow(e)) return !1; try { if (e.constructor && !y.call(e, "constructor") && !y.call(e.constructor.prototype, "isPrototypeOf")) return !1 } catch (n) { return !1 } var r; for (r in e); return r === t || y.call(e, r) }, isEmptyObject: function (e) { var t; for (t in e) return !1; return !0 }, error: function (e) { throw Error(e) }, parseHTML: function (e, t, n) { if (!e || "string" != typeof e) return null; "boolean" == typeof t && (n = t, t = !1), t = t || o; var r = C.exec(e), i = !n && []; return r ? [t.createElement(r[1])] : (r = b.buildFragment([e], t, i), i && b(i).remove(), b.merge([], r.childNodes)) }, parseJSON: function (n) { return e.JSON && e.JSON.parse ? e.JSON.parse(n) : null === n ? n : "string" == typeof n && (n = b.trim(n), n && k.test(n.replace(S, "@").replace(A, "]").replace(E, ""))) ? Function("return " + n)() : (b.error("Invalid JSON: " + n), t) }, parseXML: function (n) { var r, i; if (!n || "string" != typeof n) return null; try { e.DOMParser ? (i = new DOMParser, r = i.parseFromString(n, "text/xml")) : (r = new ActiveXObject("Microsoft.XMLDOM"), r.async = "false", r.loadXML(n)) } catch (o) { r = t } return r && r.documentElement && !r.getElementsByTagName("parsererror").length || b.error("Invalid XML: " + n), r }, noop: function () { }, globalEval: function (t) { t && b.trim(t) && (e.execScript || function (t) { e.eval.call(e, t) })(t) }, camelCase: function (e) { return e.replace(j, "ms-").replace(D, L) }, nodeName: function (e, t) { return e.nodeName && e.nodeName.toLowerCase() === t.toLowerCase() }, each: function (e, t, n) { var r, i = 0, o = e.length, a = M(e); if (n) { if (a) { for (; o > i; i++) if (r = t.apply(e[i], n), r === !1) break } else for (i in e) if (r = t.apply(e[i], n), r === !1) break } else if (a) { for (; o > i; i++) if (r = t.call(e[i], i, e[i]), r === !1) break } else for (i in e) if (r = t.call(e[i], i, e[i]), r === !1) break; return e }, trim: v && !v.call("\ufeff\u00a0") ? function (e) { return null == e ? "" : v.call(e) } : function (e) { return null == e ? "" : (e + "").replace(T, "") }, makeArray: function (e, t) { var n = t || []; return null != e && (M(Object(e)) ? b.merge(n, "string" == typeof e ? [e] : e) : d.call(n, e)), n }, inArray: function (e, t, n) { var r; if (t) { if (g) return g.call(t, e, n); for (r = t.length, n = n ? 0 > n ? Math.max(0, r + n) : n : 0; r > n; n++) if (n in t && t[n] === e) return n } return -1 }, merge: function (e, n) { var r = n.length, i = e.length, o = 0; if ("number" == typeof r) for (; r > o; o++) e[i++] = n[o]; else while (n[o] !== t) e[i++] = n[o++]; return e.length = i, e }, grep: function (e, t, n) { var r, i = [], o = 0, a = e.length; for (n = !!n; a > o; o++) r = !!t(e[o], o), n !== r && i.push(e[o]); return i }, map: function (e, t, n) { var r, i = 0, o = e.length, a = M(e), s = []; if (a) for (; o > i; i++) r = t(e[i], i, n), null != r && (s[s.length] = r); else for (i in e) r = t(e[i], i, n), null != r && (s[s.length] = r); return f.apply([], s) }, guid: 1, proxy: function (e, n) { var r, i, o; return "string" == typeof n && (o = e[n], n = e, e = o), b.isFunction(e) ? (r = h.call(arguments, 2), i = function () { return e.apply(n || this, r.concat(h.call(arguments))) }, i.guid = e.guid = e.guid || b.guid++, i) : t }, access: function (e, n, r, i, o, a, s) { var u = 0, l = e.length, c = null == r; if ("object" === b.type(r)) { o = !0; for (u in r) b.access(e, n, u, r[u], !0, a, s) } else if (i !== t && (o = !0, b.isFunction(i) || (s = !0), c && (s ? (n.call(e, i), n = null) : (c = n, n = function (e, t, n) { return c.call(b(e), n) })), n)) for (; l > u; u++) n(e[u], r, s ? i : i.call(e[u], u, n(e[u], r))); return o ? e : c ? n.call(e) : l ? n(e[0], r) : a }, now: function () { return (new Date).getTime() } }), b.ready.promise = function (t) { if (!n) if (n = b.Deferred(), "complete" === o.readyState) setTimeout(b.ready); else if (o.addEventListener) o.addEventListener("DOMContentLoaded", H, !1), e.addEventListener("load", H, !1); else { o.attachEvent("onreadystatechange", H), e.attachEvent("onload", H); var r = !1; try { r = null == e.frameElement && o.documentElement } catch (i) { } r && r.doScroll && function a() { if (!b.isReady) { try { r.doScroll("left") } catch (e) { return setTimeout(a, 50) } q(), b.ready() } }() } return n.promise(t) }, b.each("Boolean Number String Function Array Date RegExp Object Error".split(" "), function (e, t) { l["[object " + t + "]"] = t.toLowerCase() }); function M(e) { var t = e.length, n = b.type(e); return b.isWindow(e) ? !1 : 1 === e.nodeType && t ? !0 : "array" === n || "function" !== n && (0 === t || "number" == typeof t && t > 0 && t - 1 in e) } r = b(o); var _ = {}; function F(e) { var t = _[e] = {}; return b.each(e.match(w) || [], function (e, n) { t[n] = !0 }), t } b.Callbacks = function (e) { e = "string" == typeof e ? _[e] || F(e) : b.extend({}, e); var n, r, i, o, a, s, u = [], l = !e.once && [], c = function (t) { for (r = e.memory && t, i = !0, a = s || 0, s = 0, o = u.length, n = !0; u && o > a; a++) if (u[a].apply(t[0], t[1]) === !1 && e.stopOnFalse) { r = !1; break } n = !1, u && (l ? l.length && c(l.shift()) : r ? u = [] : p.disable()) }, p = { add: function () { if (u) { var t = u.length; (function i(t) { b.each(t, function (t, n) { var r = b.type(n); "function" === r ? e.unique && p.has(n) || u.push(n) : n && n.length && "string" !== r && i(n) }) })(arguments), n ? o = u.length : r && (s = t, c(r)) } return this }, remove: function () { return u && b.each(arguments, function (e, t) { var r; while ((r = b.inArray(t, u, r)) > -1) u.splice(r, 1), n && (o >= r && o--, a >= r && a--) }), this }, has: function (e) { return e ? b.inArray(e, u) > -1 : !(!u || !u.length) }, empty: function () { return u = [], this }, disable: function () { return u = l = r = t, this }, disabled: function () { return !u }, lock: function () { return l = t, r || p.disable(), this }, locked: function () { return !l }, fireWith: function (e, t) { return t = t || [], t = [e, t.slice ? t.slice() : t], !u || i && !l || (n ? l.push(t) : c(t)), this }, fire: function () { return p.fireWith(this, arguments), this }, fired: function () { return !!i } }; return p }, b.extend({ Deferred: function (e) { var t = [["resolve", "done", b.Callbacks("once memory"), "resolved"], ["reject", "fail", b.Callbacks("once memory"), "rejected"], ["notify", "progress", b.Callbacks("memory")]], n = "pending", r = { state: function () { return n }, always: function () { return i.done(arguments).fail(arguments), this }, then: function () { var e = arguments; return b.Deferred(function (n) { b.each(t, function (t, o) { var a = o[0], s = b.isFunction(e[t]) && e[t]; i[o[1]](function () { var e = s && s.apply(this, arguments); e && b.isFunction(e.promise) ? e.promise().done(n.resolve).fail(n.reject).progress(n.notify) : n[a + "With"](this === r ? n.promise() : this, s ? [e] : arguments) }) }), e = null }).promise() }, promise: function (e) { return null != e ? b.extend(e, r) : r } }, i = {}; return r.pipe = r.then, b.each(t, function (e, o) { var a = o[2], s = o[3]; r[o[1]] = a.add, s && a.add(function () { n = s }, t[1 ^ e][2].disable, t[2][2].lock), i[o[0]] = function () { return i[o[0] + "With"](this === i ? r : this, arguments), this }, i[o[0] + "With"] = a.fireWith }), r.promise(i), e && e.call(i, i), i }, when: function (e) { var t = 0, n = h.call(arguments), r = n.length, i = 1 !== r || e && b.isFunction(e.promise) ? r : 0, o = 1 === i ? e : b.Deferred(), a = function (e, t, n) { return function (r) { t[e] = this, n[e] = arguments.length > 1 ? h.call(arguments) : r, n === s ? o.notifyWith(t, n) : --i || o.resolveWith(t, n) } }, s, u, l; if (r > 1) for (s = Array(r), u = Array(r), l = Array(r) ; r > t; t++) n[t] && b.isFunction(n[t].promise) ? n[t].promise().done(a(t, l, n)).fail(o.reject).progress(a(t, u, s)) : --i; return i || o.resolveWith(l, n), o.promise() } }), b.support = function () { var t, n, r, a, s, u, l, c, p, f, d = o.createElement("div"); if (d.setAttribute("className", "t"), d.innerHTML = "  <link/><table></table><a href='/a'>a</a><input type='checkbox'/>", n = d.getElementsByTagName("*"), r = d.getElementsByTagName("a")[0], !n || !r || !n.length) return {}; s = o.createElement("select"), l = s.appendChild(o.createElement("option")), a = d.getElementsByTagName("input")[0], r.style.cssText = "top:1px;float:left;opacity:.5", t = { getSetAttribute: "t" !== d.className, leadingWhitespace: 3 === d.firstChild.nodeType, tbody: !d.getElementsByTagName("tbody").length, htmlSerialize: !!d.getElementsByTagName("link").length, style: /top/.test(r.getAttribute("style")), hrefNormalized: "/a" === r.getAttribute("href"), opacity: /^0.5/.test(r.style.opacity), cssFloat: !!r.style.cssFloat, checkOn: !!a.value, optSelected: l.selected, enctype: !!o.createElement("form").enctype, html5Clone: "<:nav></:nav>" !== o.createElement("nav").cloneNode(!0).outerHTML, boxModel: "CSS1Compat" === o.compatMode, deleteExpando: !0, noCloneEvent: !0, inlineBlockNeedsLayout: !1, shrinkWrapBlocks: !1, reliableMarginRight: !0, boxSizingReliable: !0, pixelPosition: !1 }, a.checked = !0, t.noCloneChecked = a.cloneNode(!0).checked, s.disabled = !0, t.optDisabled = !l.disabled; try { delete d.test } catch (h) { t.deleteExpando = !1 } a = o.createElement("input"), a.setAttribute("value", ""), t.input = "" === a.getAttribute("value"), a.value = "t", a.setAttribute("type", "radio"), t.radioValue = "t" === a.value, a.setAttribute("checked", "t"), a.setAttribute("name", "t"), u = o.createDocumentFragment(), u.appendChild(a), t.appendChecked = a.checked, t.checkClone = u.cloneNode(!0).cloneNode(!0).lastChild.checked, d.attachEvent && (d.attachEvent("onclick", function () { t.noCloneEvent = !1 }), d.cloneNode(!0).click()); for (f in { submit: !0, change: !0, focusin: !0 }) d.setAttribute(c = "on" + f, "t"), t[f + "Bubbles"] = c in e || d.attributes[c].expando === !1; return d.style.backgroundClip = "content-box", d.cloneNode(!0).style.backgroundClip = "", t.clearCloneStyle = "content-box" === d.style.backgroundClip, b(function () { var n, r, a, s = "padding:0;margin:0;border:0;display:block;box-sizing:content-box;-moz-box-sizing:content-box;-webkit-box-sizing:content-box;", u = o.getElementsByTagName("body")[0]; u && (n = o.createElement("div"), n.style.cssText = "border:0;width:0;height:0;position:absolute;top:0;left:-9999px;margin-top:1px", u.appendChild(n).appendChild(d), d.innerHTML = "<table><tr><td></td><td>t</td></tr></table>", a = d.getElementsByTagName("td"), a[0].style.cssText = "padding:0;margin:0;border:0;display:none", p = 0 === a[0].offsetHeight, a[0].style.display = "", a[1].style.display = "none", t.reliableHiddenOffsets = p && 0 === a[0].offsetHeight, d.innerHTML = "", d.style.cssText = "box-sizing:border-box;-moz-box-sizing:border-box;-webkit-box-sizing:border-box;padding:1px;border:1px;display:block;width:4px;margin-top:1%;position:absolute;top:1%;", t.boxSizing = 4 === d.offsetWidth, t.doesNotIncludeMarginInBodyOffset = 1 !== u.offsetTop, e.getComputedStyle && (t.pixelPosition = "1%" !== (e.getComputedStyle(d, null) || {}).top, t.boxSizingReliable = "4px" === (e.getComputedStyle(d, null) || { width: "4px" }).width, r = d.appendChild(o.createElement("div")), r.style.cssText = d.style.cssText = s, r.style.marginRight = r.style.width = "0", d.style.width = "1px", t.reliableMarginRight = !parseFloat((e.getComputedStyle(r, null) || {}).marginRight)), typeof d.style.zoom !== i && (d.innerHTML = "", d.style.cssText = s + "width:1px;padding:1px;display:inline;zoom:1", t.inlineBlockNeedsLayout = 3 === d.offsetWidth, d.style.display = "block", d.innerHTML = "<div></div>", d.firstChild.style.width = "5px", t.shrinkWrapBlocks = 3 !== d.offsetWidth, t.inlineBlockNeedsLayout && (u.style.zoom = 1)), u.removeChild(n), n = d = a = r = null) }), n = s = u = l = r = a = null, t }(); var O = /(?:\{[\s\S]*\}|\[[\s\S]*\])$/, B = /([A-Z])/g; function P(e, n, r, i) { if (b.acceptData(e)) { var o, a, s = b.expando, u = "string" == typeof n, l = e.nodeType, p = l ? b.cache : e, f = l ? e[s] : e[s] && s; if (f && p[f] && (i || p[f].data) || !u || r !== t) return f || (l ? e[s] = f = c.pop() || b.guid++ : f = s), p[f] || (p[f] = {}, l || (p[f].toJSON = b.noop)), ("object" == typeof n || "function" == typeof n) && (i ? p[f] = b.extend(p[f], n) : p[f].data = b.extend(p[f].data, n)), o = p[f], i || (o.data || (o.data = {}), o = o.data), r !== t && (o[b.camelCase(n)] = r), u ? (a = o[n], null == a && (a = o[b.camelCase(n)])) : a = o, a } } function R(e, t, n) { if (b.acceptData(e)) { var r, i, o, a = e.nodeType, s = a ? b.cache : e, u = a ? e[b.expando] : b.expando; if (s[u]) { if (t && (o = n ? s[u] : s[u].data)) { b.isArray(t) ? t = t.concat(b.map(t, b.camelCase)) : t in o ? t = [t] : (t = b.camelCase(t), t = t in o ? [t] : t.split(" ")); for (r = 0, i = t.length; i > r; r++) delete o[t[r]]; if (!(n ? $ : b.isEmptyObject)(o)) return } (n || (delete s[u].data, $(s[u]))) && (a ? b.cleanData([e], !0) : b.support.deleteExpando || s != s.window ? delete s[u] : s[u] = null) } } } b.extend({ cache: {}, expando: "jQuery" + (p + Math.random()).replace(/\D/g, ""), noData: { embed: !0, object: "clsid:D27CDB6E-AE6D-11cf-96B8-444553540000", applet: !0 }, hasData: function (e) { return e = e.nodeType ? b.cache[e[b.expando]] : e[b.expando], !!e && !$(e) }, data: function (e, t, n) { return P(e, t, n) }, removeData: function (e, t) { return R(e, t) }, _data: function (e, t, n) { return P(e, t, n, !0) }, _removeData: function (e, t) { return R(e, t, !0) }, acceptData: function (e) { if (e.nodeType && 1 !== e.nodeType && 9 !== e.nodeType) return !1; var t = e.nodeName && b.noData[e.nodeName.toLowerCase()]; return !t || t !== !0 && e.getAttribute("classid") === t } }), b.fn.extend({ data: function (e, n) { var r, i, o = this[0], a = 0, s = null; if (e === t) { if (this.length && (s = b.data(o), 1 === o.nodeType && !b._data(o, "parsedAttrs"))) { for (r = o.attributes; r.length > a; a++) i = r[a].name, i.indexOf("data-") || (i = b.camelCase(i.slice(5)), W(o, i, s[i])); b._data(o, "parsedAttrs", !0) } return s } return "object" == typeof e ? this.each(function () { b.data(this, e) }) : b.access(this, function (n) { return n === t ? o ? W(o, e, b.data(o, e)) : null : (this.each(function () { b.data(this, e, n) }), t) }, null, n, arguments.length > 1, null, !0) }, removeData: function (e) { return this.each(function () { b.removeData(this, e) }) } }); function W(e, n, r) { if (r === t && 1 === e.nodeType) { var i = "data-" + n.replace(B, "-$1").toLowerCase(); if (r = e.getAttribute(i), "string" == typeof r) { try { r = "true" === r ? !0 : "false" === r ? !1 : "null" === r ? null : +r + "" === r ? +r : O.test(r) ? b.parseJSON(r) : r } catch (o) { } b.data(e, n, r) } else r = t } return r } function $(e) { var t; for (t in e) if (("data" !== t || !b.isEmptyObject(e[t])) && "toJSON" !== t) return !1; return !0 } b.extend({ queue: function (e, n, r) { var i; return e ? (n = (n || "fx") + "queue", i = b._data(e, n), r && (!i || b.isArray(r) ? i = b._data(e, n, b.makeArray(r)) : i.push(r)), i || []) : t }, dequeue: function (e, t) { t = t || "fx"; var n = b.queue(e, t), r = n.length, i = n.shift(), o = b._queueHooks(e, t), a = function () { b.dequeue(e, t) }; "inprogress" === i && (i = n.shift(), r--), o.cur = i, i && ("fx" === t && n.unshift("inprogress"), delete o.stop, i.call(e, a, o)), !r && o && o.empty.fire() }, _queueHooks: function (e, t) { var n = t + "queueHooks"; return b._data(e, n) || b._data(e, n, { empty: b.Callbacks("once memory").add(function () { b._removeData(e, t + "queue"), b._removeData(e, n) }) }) } }), b.fn.extend({ queue: function (e, n) { var r = 2; return "string" != typeof e && (n = e, e = "fx", r--), r > arguments.length ? b.queue(this[0], e) : n === t ? this : this.each(function () { var t = b.queue(this, e, n); b._queueHooks(this, e), "fx" === e && "inprogress" !== t[0] && b.dequeue(this, e) }) }, dequeue: function (e) { return this.each(function () { b.dequeue(this, e) }) }, delay: function (e, t) { return e = b.fx ? b.fx.speeds[e] || e : e, t = t || "fx", this.queue(t, function (t, n) { var r = setTimeout(t, e); n.stop = function () { clearTimeout(r) } }) }, clearQueue: function (e) { return this.queue(e || "fx", []) }, promise: function (e, n) { var r, i = 1, o = b.Deferred(), a = this, s = this.length, u = function () { --i || o.resolveWith(a, [a]) }; "string" != typeof e && (n = e, e = t), e = e || "fx"; while (s--) r = b._data(a[s], e + "queueHooks"), r && r.empty && (i++, r.empty.add(u)); return u(), o.promise(n) } }); var I, z, X = /[\t\r\n]/g, U = /\r/g, V = /^(?:input|select|textarea|button|object)$/i, Y = /^(?:a|area)$/i, J = /^(?:checked|selected|autofocus|autoplay|async|controls|defer|disabled|hidden|loop|multiple|open|readonly|required|scoped)$/i, G = /^(?:checked|selected)$/i, Q = b.support.getSetAttribute, K = b.support.input; b.fn.extend({ attr: function (e, t) { return b.access(this, b.attr, e, t, arguments.length > 1) }, removeAttr: function (e) { return this.each(function () { b.removeAttr(this, e) }) }, prop: function (e, t) { return b.access(this, b.prop, e, t, arguments.length > 1) }, removeProp: function (e) { return e = b.propFix[e] || e, this.each(function () { try { this[e] = t, delete this[e] } catch (n) { } }) }, addClass: function (e) { var t, n, r, i, o, a = 0, s = this.length, u = "string" == typeof e && e; if (b.isFunction(e)) return this.each(function (t) { b(this).addClass(e.call(this, t, this.className)) }); if (u) for (t = (e || "").match(w) || []; s > a; a++) if (n = this[a], r = 1 === n.nodeType && (n.className ? (" " + n.className + " ").replace(X, " ") : " ")) { o = 0; while (i = t[o++]) 0 > r.indexOf(" " + i + " ") && (r += i + " "); n.className = b.trim(r) } return this }, removeClass: function (e) { var t, n, r, i, o, a = 0, s = this.length, u = 0 === arguments.length || "string" == typeof e && e; if (b.isFunction(e)) return this.each(function (t) { b(this).removeClass(e.call(this, t, this.className)) }); if (u) for (t = (e || "").match(w) || []; s > a; a++) if (n = this[a], r = 1 === n.nodeType && (n.className ? (" " + n.className + " ").replace(X, " ") : "")) { o = 0; while (i = t[o++]) while (r.indexOf(" " + i + " ") >= 0) r = r.replace(" " + i + " ", " "); n.className = e ? b.trim(r) : "" } return this }, toggleClass: function (e, t) { var n = typeof e, r = "boolean" == typeof t; return b.isFunction(e) ? this.each(function (n) { b(this).toggleClass(e.call(this, n, this.className, t), t) }) : this.each(function () { if ("string" === n) { var o, a = 0, s = b(this), u = t, l = e.match(w) || []; while (o = l[a++]) u = r ? u : !s.hasClass(o), s[u ? "addClass" : "removeClass"](o) } else (n === i || "boolean" === n) && (this.className && b._data(this, "__className__", this.className), this.className = this.className || e === !1 ? "" : b._data(this, "__className__") || "") }) }, hasClass: function (e) { var t = " " + e + " ", n = 0, r = this.length; for (; r > n; n++) if (1 === this[n].nodeType && (" " + this[n].className + " ").replace(X, " ").indexOf(t) >= 0) return !0; return !1 }, val: function (e) { var n, r, i, o = this[0]; { if (arguments.length) return i = b.isFunction(e), this.each(function (n) { var o, a = b(this); 1 === this.nodeType && (o = i ? e.call(this, n, a.val()) : e, null == o ? o = "" : "number" == typeof o ? o += "" : b.isArray(o) && (o = b.map(o, function (e) { return null == e ? "" : e + "" })), r = b.valHooks[this.type] || b.valHooks[this.nodeName.toLowerCase()], r && "set" in r && r.set(this, o, "value") !== t || (this.value = o)) }); if (o) return r = b.valHooks[o.type] || b.valHooks[o.nodeName.toLowerCase()], r && "get" in r && (n = r.get(o, "value")) !== t ? n : (n = o.value, "string" == typeof n ? n.replace(U, "") : null == n ? "" : n) } } }), b.extend({ valHooks: { option: { get: function (e) { var t = e.attributes.value; return !t || t.specified ? e.value : e.text } }, select: { get: function (e) { var t, n, r = e.options, i = e.selectedIndex, o = "select-one" === e.type || 0 > i, a = o ? null : [], s = o ? i + 1 : r.length, u = 0 > i ? s : o ? i : 0; for (; s > u; u++) if (n = r[u], !(!n.selected && u !== i || (b.support.optDisabled ? n.disabled : null !== n.getAttribute("disabled")) || n.parentNode.disabled && b.nodeName(n.parentNode, "optgroup"))) { if (t = b(n).val(), o) return t; a.push(t) } return a }, set: function (e, t) { var n = b.makeArray(t); return b(e).find("option").each(function () { this.selected = b.inArray(b(this).val(), n) >= 0 }), n.length || (e.selectedIndex = -1), n } } }, attr: function (e, n, r) { var o, a, s, u = e.nodeType; if (e && 3 !== u && 8 !== u && 2 !== u) return typeof e.getAttribute === i ? b.prop(e, n, r) : (a = 1 !== u || !b.isXMLDoc(e), a && (n = n.toLowerCase(), o = b.attrHooks[n] || (J.test(n) ? z : I)), r === t ? o && a && "get" in o && null !== (s = o.get(e, n)) ? s : (typeof e.getAttribute !== i && (s = e.getAttribute(n)), null == s ? t : s) : null !== r ? o && a && "set" in o && (s = o.set(e, r, n)) !== t ? s : (e.setAttribute(n, r + ""), r) : (b.removeAttr(e, n), t)) }, removeAttr: function (e, t) { var n, r, i = 0, o = t && t.match(w); if (o && 1 === e.nodeType) while (n = o[i++]) r = b.propFix[n] || n, J.test(n) ? !Q && G.test(n) ? e[b.camelCase("default-" + n)] = e[r] = !1 : e[r] = !1 : b.attr(e, n, ""), e.removeAttribute(Q ? n : r) }, attrHooks: { type: { set: function (e, t) { if (!b.support.radioValue && "radio" === t && b.nodeName(e, "input")) { var n = e.value; return e.setAttribute("type", t), n && (e.value = n), t } } } }, propFix: { tabindex: "tabIndex", readonly: "readOnly", "for": "htmlFor", "class": "className", maxlength: "maxLength", cellspacing: "cellSpacing", cellpadding: "cellPadding", rowspan: "rowSpan", colspan: "colSpan", usemap: "useMap", frameborder: "frameBorder", contenteditable: "contentEditable" }, prop: function (e, n, r) { var i, o, a, s = e.nodeType; if (e && 3 !== s && 8 !== s && 2 !== s) return a = 1 !== s || !b.isXMLDoc(e), a && (n = b.propFix[n] || n, o = b.propHooks[n]), r !== t ? o && "set" in o && (i = o.set(e, r, n)) !== t ? i : e[n] = r : o && "get" in o && null !== (i = o.get(e, n)) ? i : e[n] }, propHooks: { tabIndex: { get: function (e) { var n = e.getAttributeNode("tabindex"); return n && n.specified ? parseInt(n.value, 10) : V.test(e.nodeName) || Y.test(e.nodeName) && e.href ? 0 : t } } } }), z = { get: function (e, n) { var r = b.prop(e, n), i = "boolean" == typeof r && e.getAttribute(n), o = "boolean" == typeof r ? K && Q ? null != i : G.test(n) ? e[b.camelCase("default-" + n)] : !!i : e.getAttributeNode(n); return o && o.value !== !1 ? n.toLowerCase() : t }, set: function (e, t, n) { return t === !1 ? b.removeAttr(e, n) : K && Q || !G.test(n) ? e.setAttribute(!Q && b.propFix[n] || n, n) : e[b.camelCase("default-" + n)] = e[n] = !0, n } }, K && Q || (b.attrHooks.value = { get: function (e, n) { var r = e.getAttributeNode(n); return b.nodeName(e, "input") ? e.defaultValue : r && r.specified ? r.value : t }, set: function (e, n, r) { return b.nodeName(e, "input") ? (e.defaultValue = n, t) : I && I.set(e, n, r) } }), Q || (I = b.valHooks.button = { get: function (e, n) { var r = e.getAttributeNode(n); return r && ("id" === n || "name" === n || "coords" === n ? "" !== r.value : r.specified) ? r.value : t }, set: function (e, n, r) { var i = e.getAttributeNode(r); return i || e.setAttributeNode(i = e.ownerDocument.createAttribute(r)), i.value = n += "", "value" === r || n === e.getAttribute(r) ? n : t } }, b.attrHooks.contenteditable = { get: I.get, set: function (e, t, n) { I.set(e, "" === t ? !1 : t, n) } }, b.each(["width", "height"], function (e, n) { b.attrHooks[n] = b.extend(b.attrHooks[n], { set: function (e, r) { return "" === r ? (e.setAttribute(n, "auto"), r) : t } }) })), b.support.hrefNormalized || (b.each(["href", "src", "width", "height"], function (e, n) { b.attrHooks[n] = b.extend(b.attrHooks[n], { get: function (e) { var r = e.getAttribute(n, 2); return null == r ? t : r } }) }), b.each(["href", "src"], function (e, t) { b.propHooks[t] = { get: function (e) { return e.getAttribute(t, 4) } } })), b.support.style || (b.attrHooks.style = { get: function (e) { return e.style.cssText || t }, set: function (e, t) { return e.style.cssText = t + "" } }), b.support.optSelected || (b.propHooks.selected = b.extend(b.propHooks.selected, { get: function (e) { var t = e.parentNode; return t && (t.selectedIndex, t.parentNode && t.parentNode.selectedIndex), null } })), b.support.enctype || (b.propFix.enctype = "encoding"), b.support.checkOn || b.each(["radio", "checkbox"], function () { b.valHooks[this] = { get: function (e) { return null === e.getAttribute("value") ? "on" : e.value } } }), b.each(["radio", "checkbox"], function () { b.valHooks[this] = b.extend(b.valHooks[this], { set: function (e, n) { return b.isArray(n) ? e.checked = b.inArray(b(e).val(), n) >= 0 : t } }) }); var Z = /^(?:input|select|textarea)$/i, et = /^key/, tt = /^(?:mouse|contextmenu)|click/, nt = /^(?:focusinfocus|focusoutblur)$/, rt = /^([^.]*)(?:\.(.+)|)$/; function it() { return !0 } function ot() { return !1 } b.event = { global: {}, add: function (e, n, r, o, a) { var s, u, l, c, p, f, d, h, g, m, y, v = b._data(e); if (v) { r.handler && (c = r, r = c.handler, a = c.selector), r.guid || (r.guid = b.guid++), (u = v.events) || (u = v.events = {}), (f = v.handle) || (f = v.handle = function (e) { return typeof b === i || e && b.event.triggered === e.type ? t : b.event.dispatch.apply(f.elem, arguments) }, f.elem = e), n = (n || "").match(w) || [""], l = n.length; while (l--) s = rt.exec(n[l]) || [], g = y = s[1], m = (s[2] || "").split(".").sort(), p = b.event.special[g] || {}, g = (a ? p.delegateType : p.bindType) || g, p = b.event.special[g] || {}, d = b.extend({ type: g, origType: y, data: o, handler: r, guid: r.guid, selector: a, needsContext: a && b.expr.match.needsContext.test(a), namespace: m.join(".") }, c), (h = u[g]) || (h = u[g] = [], h.delegateCount = 0, p.setup && p.setup.call(e, o, m, f) !== !1 || (e.addEventListener ? e.addEventListener(g, f, !1) : e.attachEvent && e.attachEvent("on" + g, f))), p.add && (p.add.call(e, d), d.handler.guid || (d.handler.guid = r.guid)), a ? h.splice(h.delegateCount++, 0, d) : h.push(d), b.event.global[g] = !0; e = null } }, remove: function (e, t, n, r, i) { var o, a, s, u, l, c, p, f, d, h, g, m = b.hasData(e) && b._data(e); if (m && (c = m.events)) { t = (t || "").match(w) || [""], l = t.length; while (l--) if (s = rt.exec(t[l]) || [], d = g = s[1], h = (s[2] || "").split(".").sort(), d) { p = b.event.special[d] || {}, d = (r ? p.delegateType : p.bindType) || d, f = c[d] || [], s = s[2] && RegExp("(^|\\.)" + h.join("\\.(?:.*\\.|)") + "(\\.|$)"), u = o = f.length; while (o--) a = f[o], !i && g !== a.origType || n && n.guid !== a.guid || s && !s.test(a.namespace) || r && r !== a.selector && ("**" !== r || !a.selector) || (f.splice(o, 1), a.selector && f.delegateCount--, p.remove && p.remove.call(e, a)); u && !f.length && (p.teardown && p.teardown.call(e, h, m.handle) !== !1 || b.removeEvent(e, d, m.handle), delete c[d]) } else for (d in c) b.event.remove(e, d + t[l], n, r, !0); b.isEmptyObject(c) && (delete m.handle, b._removeData(e, "events")) } }, trigger: function (n, r, i, a) { var s, u, l, c, p, f, d, h = [i || o], g = y.call(n, "type") ? n.type : n, m = y.call(n, "namespace") ? n.namespace.split(".") : []; if (l = f = i = i || o, 3 !== i.nodeType && 8 !== i.nodeType && !nt.test(g + b.event.triggered) && (g.indexOf(".") >= 0 && (m = g.split("."), g = m.shift(), m.sort()), u = 0 > g.indexOf(":") && "on" + g, n = n[b.expando] ? n : new b.Event(g, "object" == typeof n && n), n.isTrigger = !0, n.namespace = m.join("."), n.namespace_re = n.namespace ? RegExp("(^|\\.)" + m.join("\\.(?:.*\\.|)") + "(\\.|$)") : null, n.result = t, n.target || (n.target = i), r = null == r ? [n] : b.makeArray(r, [n]), p = b.event.special[g] || {}, a || !p.trigger || p.trigger.apply(i, r) !== !1)) { if (!a && !p.noBubble && !b.isWindow(i)) { for (c = p.delegateType || g, nt.test(c + g) || (l = l.parentNode) ; l; l = l.parentNode) h.push(l), f = l; f === (i.ownerDocument || o) && h.push(f.defaultView || f.parentWindow || e) } d = 0; while ((l = h[d++]) && !n.isPropagationStopped()) n.type = d > 1 ? c : p.bindType || g, s = (b._data(l, "events") || {})[n.type] && b._data(l, "handle"), s && s.apply(l, r), s = u && l[u], s && b.acceptData(l) && s.apply && s.apply(l, r) === !1 && n.preventDefault(); if (n.type = g, !(a || n.isDefaultPrevented() || p._default && p._default.apply(i.ownerDocument, r) !== !1 || "click" === g && b.nodeName(i, "a") || !b.acceptData(i) || !u || !i[g] || b.isWindow(i))) { f = i[u], f && (i[u] = null), b.event.triggered = g; try { i[g]() } catch (v) { } b.event.triggered = t, f && (i[u] = f) } return n.result } }, dispatch: function (e) { e = b.event.fix(e); var n, r, i, o, a, s = [], u = h.call(arguments), l = (b._data(this, "events") || {})[e.type] || [], c = b.event.special[e.type] || {}; if (u[0] = e, e.delegateTarget = this, !c.preDispatch || c.preDispatch.call(this, e) !== !1) { s = b.event.handlers.call(this, e, l), n = 0; while ((o = s[n++]) && !e.isPropagationStopped()) { e.currentTarget = o.elem, a = 0; while ((i = o.handlers[a++]) && !e.isImmediatePropagationStopped()) (!e.namespace_re || e.namespace_re.test(i.namespace)) && (e.handleObj = i, e.data = i.data, r = ((b.event.special[i.origType] || {}).handle || i.handler).apply(o.elem, u), r !== t && (e.result = r) === !1 && (e.preventDefault(), e.stopPropagation())) } return c.postDispatch && c.postDispatch.call(this, e), e.result } }, handlers: function (e, n) { var r, i, o, a, s = [], u = n.delegateCount, l = e.target; if (u && l.nodeType && (!e.button || "click" !== e.type)) for (; l != this; l = l.parentNode || this) if (1 === l.nodeType && (l.disabled !== !0 || "click" !== e.type)) { for (o = [], a = 0; u > a; a++) i = n[a], r = i.selector + " ", o[r] === t && (o[r] = i.needsContext ? b(r, this).index(l) >= 0 : b.find(r, this, null, [l]).length), o[r] && o.push(i); o.length && s.push({ elem: l, handlers: o }) } return n.length > u && s.push({ elem: this, handlers: n.slice(u) }), s }, fix: function (e) { if (e[b.expando]) return e; var t, n, r, i = e.type, a = e, s = this.fixHooks[i]; s || (this.fixHooks[i] = s = tt.test(i) ? this.mouseHooks : et.test(i) ? this.keyHooks : {}), r = s.props ? this.props.concat(s.props) : this.props, e = new b.Event(a), t = r.length; while (t--) n = r[t], e[n] = a[n]; return e.target || (e.target = a.srcElement || o), 3 === e.target.nodeType && (e.target = e.target.parentNode), e.metaKey = !!e.metaKey, s.filter ? s.filter(e, a) : e }, props: "altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "), fixHooks: {}, keyHooks: { props: "char charCode key keyCode".split(" "), filter: function (e, t) { return null == e.which && (e.which = null != t.charCode ? t.charCode : t.keyCode), e } }, mouseHooks: { props: "button buttons clientX clientY fromElement offsetX offsetY pageX pageY screenX screenY toElement".split(" "), filter: function (e, n) { var r, i, a, s = n.button, u = n.fromElement; return null == e.pageX && null != n.clientX && (i = e.target.ownerDocument || o, a = i.documentElement, r = i.body, e.pageX = n.clientX + (a && a.scrollLeft || r && r.scrollLeft || 0) - (a && a.clientLeft || r && r.clientLeft || 0), e.pageY = n.clientY + (a && a.scrollTop || r && r.scrollTop || 0) - (a && a.clientTop || r && r.clientTop || 0)), !e.relatedTarget && u && (e.relatedTarget = u === e.target ? n.toElement : u), e.which || s === t || (e.which = 1 & s ? 1 : 2 & s ? 3 : 4 & s ? 2 : 0), e } }, special: { load: { noBubble: !0 }, click: { trigger: function () { return b.nodeName(this, "input") && "checkbox" === this.type && this.click ? (this.click(), !1) : t } }, focus: { trigger: function () { if (this !== o.activeElement && this.focus) try { return this.focus(), !1 } catch (e) { } }, delegateType: "focusin" }, blur: { trigger: function () { return this === o.activeElement && this.blur ? (this.blur(), !1) : t }, delegateType: "focusout" }, beforeunload: { postDispatch: function (e) { e.result !== t && (e.originalEvent.returnValue = e.result) } } }, simulate: function (e, t, n, r) { var i = b.extend(new b.Event, n, { type: e, isSimulated: !0, originalEvent: {} }); r ? b.event.trigger(i, null, t) : b.event.dispatch.call(t, i), i.isDefaultPrevented() && n.preventDefault() } }, b.removeEvent = o.removeEventListener ? function (e, t, n) { e.removeEventListener && e.removeEventListener(t, n, !1) } : function (e, t, n) { var r = "on" + t; e.detachEvent && (typeof e[r] === i && (e[r] = null), e.detachEvent(r, n)) }, b.Event = function (e, n) { return this instanceof b.Event ? (e && e.type ? (this.originalEvent = e, this.type = e.type, this.isDefaultPrevented = e.defaultPrevented || e.returnValue === !1 || e.getPreventDefault && e.getPreventDefault() ? it : ot) : this.type = e, n && b.extend(this, n), this.timeStamp = e && e.timeStamp || b.now(), this[b.expando] = !0, t) : new b.Event(e, n) }, b.Event.prototype = { isDefaultPrevented: ot, isPropagationStopped: ot, isImmediatePropagationStopped: ot, preventDefault: function () { var e = this.originalEvent; this.isDefaultPrevented = it, e && (e.preventDefault ? e.preventDefault() : e.returnValue = !1) }, stopPropagation: function () { var e = this.originalEvent; this.isPropagationStopped = it, e && (e.stopPropagation && e.stopPropagation(), e.cancelBubble = !0) }, stopImmediatePropagation: function () { this.isImmediatePropagationStopped = it, this.stopPropagation() } }, b.each({ mouseenter: "mouseover", mouseleave: "mouseout" }, function (e, t) {
        b.event.special[e] = {
            delegateType: t, bindType: t, handle: function (e) {
                var n, r = this, i = e.relatedTarget, o = e.handleObj;
                return (!i || i !== r && !b.contains(r, i)) && (e.type = o.origType, n = o.handler.apply(this, arguments), e.type = t), n
            }
        }
    }), b.support.submitBubbles || (b.event.special.submit = { setup: function () { return b.nodeName(this, "form") ? !1 : (b.event.add(this, "click._submit keypress._submit", function (e) { var n = e.target, r = b.nodeName(n, "input") || b.nodeName(n, "button") ? n.form : t; r && !b._data(r, "submitBubbles") && (b.event.add(r, "submit._submit", function (e) { e._submit_bubble = !0 }), b._data(r, "submitBubbles", !0)) }), t) }, postDispatch: function (e) { e._submit_bubble && (delete e._submit_bubble, this.parentNode && !e.isTrigger && b.event.simulate("submit", this.parentNode, e, !0)) }, teardown: function () { return b.nodeName(this, "form") ? !1 : (b.event.remove(this, "._submit"), t) } }), b.support.changeBubbles || (b.event.special.change = { setup: function () { return Z.test(this.nodeName) ? (("checkbox" === this.type || "radio" === this.type) && (b.event.add(this, "propertychange._change", function (e) { "checked" === e.originalEvent.propertyName && (this._just_changed = !0) }), b.event.add(this, "click._change", function (e) { this._just_changed && !e.isTrigger && (this._just_changed = !1), b.event.simulate("change", this, e, !0) })), !1) : (b.event.add(this, "beforeactivate._change", function (e) { var t = e.target; Z.test(t.nodeName) && !b._data(t, "changeBubbles") && (b.event.add(t, "change._change", function (e) { !this.parentNode || e.isSimulated || e.isTrigger || b.event.simulate("change", this.parentNode, e, !0) }), b._data(t, "changeBubbles", !0)) }), t) }, handle: function (e) { var n = e.target; return this !== n || e.isSimulated || e.isTrigger || "radio" !== n.type && "checkbox" !== n.type ? e.handleObj.handler.apply(this, arguments) : t }, teardown: function () { return b.event.remove(this, "._change"), !Z.test(this.nodeName) } }), b.support.focusinBubbles || b.each({ focus: "focusin", blur: "focusout" }, function (e, t) { var n = 0, r = function (e) { b.event.simulate(t, e.target, b.event.fix(e), !0) }; b.event.special[t] = { setup: function () { 0 === n++ && o.addEventListener(e, r, !0) }, teardown: function () { 0 === --n && o.removeEventListener(e, r, !0) } } }), b.fn.extend({ on: function (e, n, r, i, o) { var a, s; if ("object" == typeof e) { "string" != typeof n && (r = r || n, n = t); for (a in e) this.on(a, n, r, e[a], o); return this } if (null == r && null == i ? (i = n, r = n = t) : null == i && ("string" == typeof n ? (i = r, r = t) : (i = r, r = n, n = t)), i === !1) i = ot; else if (!i) return this; return 1 === o && (s = i, i = function (e) { return b().off(e), s.apply(this, arguments) }, i.guid = s.guid || (s.guid = b.guid++)), this.each(function () { b.event.add(this, e, i, r, n) }) }, one: function (e, t, n, r) { return this.on(e, t, n, r, 1) }, off: function (e, n, r) { var i, o; if (e && e.preventDefault && e.handleObj) return i = e.handleObj, b(e.delegateTarget).off(i.namespace ? i.origType + "." + i.namespace : i.origType, i.selector, i.handler), this; if ("object" == typeof e) { for (o in e) this.off(o, n, e[o]); return this } return (n === !1 || "function" == typeof n) && (r = n, n = t), r === !1 && (r = ot), this.each(function () { b.event.remove(this, e, r, n) }) }, bind: function (e, t, n) { return this.on(e, null, t, n) }, unbind: function (e, t) { return this.off(e, null, t) }, delegate: function (e, t, n, r) { return this.on(t, e, n, r) }, undelegate: function (e, t, n) { return 1 === arguments.length ? this.off(e, "**") : this.off(t, e || "**", n) }, trigger: function (e, t) { return this.each(function () { b.event.trigger(e, t, this) }) }, triggerHandler: function (e, n) { var r = this[0]; return r ? b.event.trigger(e, n, r, !0) : t } }), function (e, t) { var n, r, i, o, a, s, u, l, c, p, f, d, h, g, m, y, v, x = "sizzle" + -new Date, w = e.document, T = {}, N = 0, C = 0, k = it(), E = it(), S = it(), A = typeof t, j = 1 << 31, D = [], L = D.pop, H = D.push, q = D.slice, M = D.indexOf || function (e) { var t = 0, n = this.length; for (; n > t; t++) if (this[t] === e) return t; return -1 }, _ = "[\\x20\\t\\r\\n\\f]", F = "(?:\\\\.|[\\w-]|[^\\x00-\\xa0])+", O = F.replace("w", "w#"), B = "([*^$|!~]?=)", P = "\\[" + _ + "*(" + F + ")" + _ + "*(?:" + B + _ + "*(?:(['\"])((?:\\\\.|[^\\\\])*?)\\3|(" + O + ")|)|)" + _ + "*\\]", R = ":(" + F + ")(?:\\(((['\"])((?:\\\\.|[^\\\\])*?)\\3|((?:\\\\.|[^\\\\()[\\]]|" + P.replace(3, 8) + ")*)|.*)\\)|)", W = RegExp("^" + _ + "+|((?:^|[^\\\\])(?:\\\\.)*)" + _ + "+$", "g"), $ = RegExp("^" + _ + "*," + _ + "*"), I = RegExp("^" + _ + "*([\\x20\\t\\r\\n\\f>+~])" + _ + "*"), z = RegExp(R), X = RegExp("^" + O + "$"), U = { ID: RegExp("^#(" + F + ")"), CLASS: RegExp("^\\.(" + F + ")"), NAME: RegExp("^\\[name=['\"]?(" + F + ")['\"]?\\]"), TAG: RegExp("^(" + F.replace("w", "w*") + ")"), ATTR: RegExp("^" + P), PSEUDO: RegExp("^" + R), CHILD: RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + _ + "*(even|odd|(([+-]|)(\\d*)n|)" + _ + "*(?:([+-]|)" + _ + "*(\\d+)|))" + _ + "*\\)|)", "i"), needsContext: RegExp("^" + _ + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" + _ + "*((?:-\\d)?\\d*)" + _ + "*\\)|)(?=[^-]|$)", "i") }, V = /[\x20\t\r\n\f]*[+~]/, Y = /^[^{]+\{\s*\[native code/, J = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/, G = /^(?:input|select|textarea|button)$/i, Q = /^h\d$/i, K = /'|\\/g, Z = /\=[\x20\t\r\n\f]*([^'"\]]*)[\x20\t\r\n\f]*\]/g, et = /\\([\da-fA-F]{1,6}[\x20\t\r\n\f]?|.)/g, tt = function (e, t) { var n = "0x" + t - 65536; return n !== n ? t : 0 > n ? String.fromCharCode(n + 65536) : String.fromCharCode(55296 | n >> 10, 56320 | 1023 & n) }; try { q.call(w.documentElement.childNodes, 0)[0].nodeType } catch (nt) { q = function (e) { var t, n = []; while (t = this[e++]) n.push(t); return n } } function rt(e) { return Y.test(e + "") } function it() { var e, t = []; return e = function (n, r) { return t.push(n += " ") > i.cacheLength && delete e[t.shift()], e[n] = r } } function ot(e) { return e[x] = !0, e } function at(e) { var t = p.createElement("div"); try { return e(t) } catch (n) { return !1 } finally { t = null } } function st(e, t, n, r) { var i, o, a, s, u, l, f, g, m, v; if ((t ? t.ownerDocument || t : w) !== p && c(t), t = t || p, n = n || [], !e || "string" != typeof e) return n; if (1 !== (s = t.nodeType) && 9 !== s) return []; if (!d && !r) { if (i = J.exec(e)) if (a = i[1]) { if (9 === s) { if (o = t.getElementById(a), !o || !o.parentNode) return n; if (o.id === a) return n.push(o), n } else if (t.ownerDocument && (o = t.ownerDocument.getElementById(a)) && y(t, o) && o.id === a) return n.push(o), n } else { if (i[2]) return H.apply(n, q.call(t.getElementsByTagName(e), 0)), n; if ((a = i[3]) && T.getByClassName && t.getElementsByClassName) return H.apply(n, q.call(t.getElementsByClassName(a), 0)), n } if (T.qsa && !h.test(e)) { if (f = !0, g = x, m = t, v = 9 === s && e, 1 === s && "object" !== t.nodeName.toLowerCase()) { l = ft(e), (f = t.getAttribute("id")) ? g = f.replace(K, "\\$&") : t.setAttribute("id", g), g = "[id='" + g + "'] ", u = l.length; while (u--) l[u] = g + dt(l[u]); m = V.test(e) && t.parentNode || t, v = l.join(",") } if (v) try { return H.apply(n, q.call(m.querySelectorAll(v), 0)), n } catch (b) { } finally { f || t.removeAttribute("id") } } } return wt(e.replace(W, "$1"), t, n, r) } a = st.isXML = function (e) { var t = e && (e.ownerDocument || e).documentElement; return t ? "HTML" !== t.nodeName : !1 }, c = st.setDocument = function (e) { var n = e ? e.ownerDocument || e : w; return n !== p && 9 === n.nodeType && n.documentElement ? (p = n, f = n.documentElement, d = a(n), T.tagNameNoComments = at(function (e) { return e.appendChild(n.createComment("")), !e.getElementsByTagName("*").length }), T.attributes = at(function (e) { e.innerHTML = "<select></select>"; var t = typeof e.lastChild.getAttribute("multiple"); return "boolean" !== t && "string" !== t }), T.getByClassName = at(function (e) { return e.innerHTML = "<div class='hidden e'></div><div class='hidden'></div>", e.getElementsByClassName && e.getElementsByClassName("e").length ? (e.lastChild.className = "e", 2 === e.getElementsByClassName("e").length) : !1 }), T.getByName = at(function (e) { e.id = x + 0, e.innerHTML = "<a name='" + x + "'></a><div name='" + x + "'></div>", f.insertBefore(e, f.firstChild); var t = n.getElementsByName && n.getElementsByName(x).length === 2 + n.getElementsByName(x + 0).length; return T.getIdNotName = !n.getElementById(x), f.removeChild(e), t }), i.attrHandle = at(function (e) { return e.innerHTML = "<a href='#'></a>", e.firstChild && typeof e.firstChild.getAttribute !== A && "#" === e.firstChild.getAttribute("href") }) ? {} : { href: function (e) { return e.getAttribute("href", 2) }, type: function (e) { return e.getAttribute("type") } }, T.getIdNotName ? (i.find.ID = function (e, t) { if (typeof t.getElementById !== A && !d) { var n = t.getElementById(e); return n && n.parentNode ? [n] : [] } }, i.filter.ID = function (e) { var t = e.replace(et, tt); return function (e) { return e.getAttribute("id") === t } }) : (i.find.ID = function (e, n) { if (typeof n.getElementById !== A && !d) { var r = n.getElementById(e); return r ? r.id === e || typeof r.getAttributeNode !== A && r.getAttributeNode("id").value === e ? [r] : t : [] } }, i.filter.ID = function (e) { var t = e.replace(et, tt); return function (e) { var n = typeof e.getAttributeNode !== A && e.getAttributeNode("id"); return n && n.value === t } }), i.find.TAG = T.tagNameNoComments ? function (e, n) { return typeof n.getElementsByTagName !== A ? n.getElementsByTagName(e) : t } : function (e, t) { var n, r = [], i = 0, o = t.getElementsByTagName(e); if ("*" === e) { while (n = o[i++]) 1 === n.nodeType && r.push(n); return r } return o }, i.find.NAME = T.getByName && function (e, n) { return typeof n.getElementsByName !== A ? n.getElementsByName(name) : t }, i.find.CLASS = T.getByClassName && function (e, n) { return typeof n.getElementsByClassName === A || d ? t : n.getElementsByClassName(e) }, g = [], h = [":focus"], (T.qsa = rt(n.querySelectorAll)) && (at(function (e) { e.innerHTML = "<select><option selected=''></option></select>", e.querySelectorAll("[selected]").length || h.push("\\[" + _ + "*(?:checked|disabled|ismap|multiple|readonly|selected|value)"), e.querySelectorAll(":checked").length || h.push(":checked") }), at(function (e) { e.innerHTML = "<input type='hidden' i=''/>", e.querySelectorAll("[i^='']").length && h.push("[*^$]=" + _ + "*(?:\"\"|'')"), e.querySelectorAll(":enabled").length || h.push(":enabled", ":disabled"), e.querySelectorAll("*,:x"), h.push(",.*:") })), (T.matchesSelector = rt(m = f.matchesSelector || f.mozMatchesSelector || f.webkitMatchesSelector || f.oMatchesSelector || f.msMatchesSelector)) && at(function (e) { T.disconnectedMatch = m.call(e, "div"), m.call(e, "[s!='']:x"), g.push("!=", R) }), h = RegExp(h.join("|")), g = RegExp(g.join("|")), y = rt(f.contains) || f.compareDocumentPosition ? function (e, t) { var n = 9 === e.nodeType ? e.documentElement : e, r = t && t.parentNode; return e === r || !(!r || 1 !== r.nodeType || !(n.contains ? n.contains(r) : e.compareDocumentPosition && 16 & e.compareDocumentPosition(r))) } : function (e, t) { if (t) while (t = t.parentNode) if (t === e) return !0; return !1 }, v = f.compareDocumentPosition ? function (e, t) { var r; return e === t ? (u = !0, 0) : (r = t.compareDocumentPosition && e.compareDocumentPosition && e.compareDocumentPosition(t)) ? 1 & r || e.parentNode && 11 === e.parentNode.nodeType ? e === n || y(w, e) ? -1 : t === n || y(w, t) ? 1 : 0 : 4 & r ? -1 : 1 : e.compareDocumentPosition ? -1 : 1 } : function (e, t) { var r, i = 0, o = e.parentNode, a = t.parentNode, s = [e], l = [t]; if (e === t) return u = !0, 0; if (!o || !a) return e === n ? -1 : t === n ? 1 : o ? -1 : a ? 1 : 0; if (o === a) return ut(e, t); r = e; while (r = r.parentNode) s.unshift(r); r = t; while (r = r.parentNode) l.unshift(r); while (s[i] === l[i]) i++; return i ? ut(s[i], l[i]) : s[i] === w ? -1 : l[i] === w ? 1 : 0 }, u = !1, [0, 0].sort(v), T.detectDuplicates = u, p) : p }, st.matches = function (e, t) { return st(e, null, null, t) }, st.matchesSelector = function (e, t) { if ((e.ownerDocument || e) !== p && c(e), t = t.replace(Z, "='$1']"), !(!T.matchesSelector || d || g && g.test(t) || h.test(t))) try { var n = m.call(e, t); if (n || T.disconnectedMatch || e.document && 11 !== e.document.nodeType) return n } catch (r) { } return st(t, p, null, [e]).length > 0 }, st.contains = function (e, t) { return (e.ownerDocument || e) !== p && c(e), y(e, t) }, st.attr = function (e, t) { var n; return (e.ownerDocument || e) !== p && c(e), d || (t = t.toLowerCase()), (n = i.attrHandle[t]) ? n(e) : d || T.attributes ? e.getAttribute(t) : ((n = e.getAttributeNode(t)) || e.getAttribute(t)) && e[t] === !0 ? t : n && n.specified ? n.value : null }, st.error = function (e) { throw Error("Syntax error, unrecognized expression: " + e) }, st.uniqueSort = function (e) { var t, n = [], r = 1, i = 0; if (u = !T.detectDuplicates, e.sort(v), u) { for (; t = e[r]; r++) t === e[r - 1] && (i = n.push(r)); while (i--) e.splice(n[i], 1) } return e }; function ut(e, t) { var n = t && e, r = n && (~t.sourceIndex || j) - (~e.sourceIndex || j); if (r) return r; if (n) while (n = n.nextSibling) if (n === t) return -1; return e ? 1 : -1 } function lt(e) { return function (t) { var n = t.nodeName.toLowerCase(); return "input" === n && t.type === e } } function ct(e) { return function (t) { var n = t.nodeName.toLowerCase(); return ("input" === n || "button" === n) && t.type === e } } function pt(e) { return ot(function (t) { return t = +t, ot(function (n, r) { var i, o = e([], n.length, t), a = o.length; while (a--) n[i = o[a]] && (n[i] = !(r[i] = n[i])) }) }) } o = st.getText = function (e) { var t, n = "", r = 0, i = e.nodeType; if (i) { if (1 === i || 9 === i || 11 === i) { if ("string" == typeof e.textContent) return e.textContent; for (e = e.firstChild; e; e = e.nextSibling) n += o(e) } else if (3 === i || 4 === i) return e.nodeValue } else for (; t = e[r]; r++) n += o(t); return n }, i = st.selectors = { cacheLength: 50, createPseudo: ot, match: U, find: {}, relative: { ">": { dir: "parentNode", first: !0 }, " ": { dir: "parentNode" }, "+": { dir: "previousSibling", first: !0 }, "~": { dir: "previousSibling" } }, preFilter: { ATTR: function (e) { return e[1] = e[1].replace(et, tt), e[3] = (e[4] || e[5] || "").replace(et, tt), "~=" === e[2] && (e[3] = " " + e[3] + " "), e.slice(0, 4) }, CHILD: function (e) { return e[1] = e[1].toLowerCase(), "nth" === e[1].slice(0, 3) ? (e[3] || st.error(e[0]), e[4] = +(e[4] ? e[5] + (e[6] || 1) : 2 * ("even" === e[3] || "odd" === e[3])), e[5] = +(e[7] + e[8] || "odd" === e[3])) : e[3] && st.error(e[0]), e }, PSEUDO: function (e) { var t, n = !e[5] && e[2]; return U.CHILD.test(e[0]) ? null : (e[4] ? e[2] = e[4] : n && z.test(n) && (t = ft(n, !0)) && (t = n.indexOf(")", n.length - t) - n.length) && (e[0] = e[0].slice(0, t), e[2] = n.slice(0, t)), e.slice(0, 3)) } }, filter: { TAG: function (e) { return "*" === e ? function () { return !0 } : (e = e.replace(et, tt).toLowerCase(), function (t) { return t.nodeName && t.nodeName.toLowerCase() === e }) }, CLASS: function (e) { var t = k[e + " "]; return t || (t = RegExp("(^|" + _ + ")" + e + "(" + _ + "|$)")) && k(e, function (e) { return t.test(e.className || typeof e.getAttribute !== A && e.getAttribute("class") || "") }) }, ATTR: function (e, t, n) { return function (r) { var i = st.attr(r, e); return null == i ? "!=" === t : t ? (i += "", "=" === t ? i === n : "!=" === t ? i !== n : "^=" === t ? n && 0 === i.indexOf(n) : "*=" === t ? n && i.indexOf(n) > -1 : "$=" === t ? n && i.slice(-n.length) === n : "~=" === t ? (" " + i + " ").indexOf(n) > -1 : "|=" === t ? i === n || i.slice(0, n.length + 1) === n + "-" : !1) : !0 } }, CHILD: function (e, t, n, r, i) { var o = "nth" !== e.slice(0, 3), a = "last" !== e.slice(-4), s = "of-type" === t; return 1 === r && 0 === i ? function (e) { return !!e.parentNode } : function (t, n, u) { var l, c, p, f, d, h, g = o !== a ? "nextSibling" : "previousSibling", m = t.parentNode, y = s && t.nodeName.toLowerCase(), v = !u && !s; if (m) { if (o) { while (g) { p = t; while (p = p[g]) if (s ? p.nodeName.toLowerCase() === y : 1 === p.nodeType) return !1; h = g = "only" === e && !h && "nextSibling" } return !0 } if (h = [a ? m.firstChild : m.lastChild], a && v) { c = m[x] || (m[x] = {}), l = c[e] || [], d = l[0] === N && l[1], f = l[0] === N && l[2], p = d && m.childNodes[d]; while (p = ++d && p && p[g] || (f = d = 0) || h.pop()) if (1 === p.nodeType && ++f && p === t) { c[e] = [N, d, f]; break } } else if (v && (l = (t[x] || (t[x] = {}))[e]) && l[0] === N) f = l[1]; else while (p = ++d && p && p[g] || (f = d = 0) || h.pop()) if ((s ? p.nodeName.toLowerCase() === y : 1 === p.nodeType) && ++f && (v && ((p[x] || (p[x] = {}))[e] = [N, f]), p === t)) break; return f -= i, f === r || 0 === f % r && f / r >= 0 } } }, PSEUDO: function (e, t) { var n, r = i.pseudos[e] || i.setFilters[e.toLowerCase()] || st.error("unsupported pseudo: " + e); return r[x] ? r(t) : r.length > 1 ? (n = [e, e, "", t], i.setFilters.hasOwnProperty(e.toLowerCase()) ? ot(function (e, n) { var i, o = r(e, t), a = o.length; while (a--) i = M.call(e, o[a]), e[i] = !(n[i] = o[a]) }) : function (e) { return r(e, 0, n) }) : r } }, pseudos: { not: ot(function (e) { var t = [], n = [], r = s(e.replace(W, "$1")); return r[x] ? ot(function (e, t, n, i) { var o, a = r(e, null, i, []), s = e.length; while (s--) (o = a[s]) && (e[s] = !(t[s] = o)) }) : function (e, i, o) { return t[0] = e, r(t, null, o, n), !n.pop() } }), has: ot(function (e) { return function (t) { return st(e, t).length > 0 } }), contains: ot(function (e) { return function (t) { return (t.textContent || t.innerText || o(t)).indexOf(e) > -1 } }), lang: ot(function (e) { return X.test(e || "") || st.error("unsupported lang: " + e), e = e.replace(et, tt).toLowerCase(), function (t) { var n; do if (n = d ? t.getAttribute("xml:lang") || t.getAttribute("lang") : t.lang) return n = n.toLowerCase(), n === e || 0 === n.indexOf(e + "-"); while ((t = t.parentNode) && 1 === t.nodeType); return !1 } }), target: function (t) { var n = e.location && e.location.hash; return n && n.slice(1) === t.id }, root: function (e) { return e === f }, focus: function (e) { return e === p.activeElement && (!p.hasFocus || p.hasFocus()) && !!(e.type || e.href || ~e.tabIndex) }, enabled: function (e) { return e.disabled === !1 }, disabled: function (e) { return e.disabled === !0 }, checked: function (e) { var t = e.nodeName.toLowerCase(); return "input" === t && !!e.checked || "option" === t && !!e.selected }, selected: function (e) { return e.parentNode && e.parentNode.selectedIndex, e.selected === !0 }, empty: function (e) { for (e = e.firstChild; e; e = e.nextSibling) if (e.nodeName > "@" || 3 === e.nodeType || 4 === e.nodeType) return !1; return !0 }, parent: function (e) { return !i.pseudos.empty(e) }, header: function (e) { return Q.test(e.nodeName) }, input: function (e) { return G.test(e.nodeName) }, button: function (e) { var t = e.nodeName.toLowerCase(); return "input" === t && "button" === e.type || "button" === t }, text: function (e) { var t; return "input" === e.nodeName.toLowerCase() && "text" === e.type && (null == (t = e.getAttribute("type")) || t.toLowerCase() === e.type) }, first: pt(function () { return [0] }), last: pt(function (e, t) { return [t - 1] }), eq: pt(function (e, t, n) { return [0 > n ? n + t : n] }), even: pt(function (e, t) { var n = 0; for (; t > n; n += 2) e.push(n); return e }), odd: pt(function (e, t) { var n = 1; for (; t > n; n += 2) e.push(n); return e }), lt: pt(function (e, t, n) { var r = 0 > n ? n + t : n; for (; --r >= 0;) e.push(r); return e }), gt: pt(function (e, t, n) { var r = 0 > n ? n + t : n; for (; t > ++r;) e.push(r); return e }) } }; for (n in { radio: !0, checkbox: !0, file: !0, password: !0, image: !0 }) i.pseudos[n] = lt(n); for (n in { submit: !0, reset: !0 }) i.pseudos[n] = ct(n); function ft(e, t) { var n, r, o, a, s, u, l, c = E[e + " "]; if (c) return t ? 0 : c.slice(0); s = e, u = [], l = i.preFilter; while (s) { (!n || (r = $.exec(s))) && (r && (s = s.slice(r[0].length) || s), u.push(o = [])), n = !1, (r = I.exec(s)) && (n = r.shift(), o.push({ value: n, type: r[0].replace(W, " ") }), s = s.slice(n.length)); for (a in i.filter) !(r = U[a].exec(s)) || l[a] && !(r = l[a](r)) || (n = r.shift(), o.push({ value: n, type: a, matches: r }), s = s.slice(n.length)); if (!n) break } return t ? s.length : s ? st.error(e) : E(e, u).slice(0) } function dt(e) { var t = 0, n = e.length, r = ""; for (; n > t; t++) r += e[t].value; return r } function ht(e, t, n) { var i = t.dir, o = n && "parentNode" === i, a = C++; return t.first ? function (t, n, r) { while (t = t[i]) if (1 === t.nodeType || o) return e(t, n, r) } : function (t, n, s) { var u, l, c, p = N + " " + a; if (s) { while (t = t[i]) if ((1 === t.nodeType || o) && e(t, n, s)) return !0 } else while (t = t[i]) if (1 === t.nodeType || o) if (c = t[x] || (t[x] = {}), (l = c[i]) && l[0] === p) { if ((u = l[1]) === !0 || u === r) return u === !0 } else if (l = c[i] = [p], l[1] = e(t, n, s) || r, l[1] === !0) return !0 } } function gt(e) { return e.length > 1 ? function (t, n, r) { var i = e.length; while (i--) if (!e[i](t, n, r)) return !1; return !0 } : e[0] } function mt(e, t, n, r, i) { var o, a = [], s = 0, u = e.length, l = null != t; for (; u > s; s++) (o = e[s]) && (!n || n(o, r, i)) && (a.push(o), l && t.push(s)); return a } function yt(e, t, n, r, i, o) { return r && !r[x] && (r = yt(r)), i && !i[x] && (i = yt(i, o)), ot(function (o, a, s, u) { var l, c, p, f = [], d = [], h = a.length, g = o || xt(t || "*", s.nodeType ? [s] : s, []), m = !e || !o && t ? g : mt(g, f, e, s, u), y = n ? i || (o ? e : h || r) ? [] : a : m; if (n && n(m, y, s, u), r) { l = mt(y, d), r(l, [], s, u), c = l.length; while (c--) (p = l[c]) && (y[d[c]] = !(m[d[c]] = p)) } if (o) { if (i || e) { if (i) { l = [], c = y.length; while (c--) (p = y[c]) && l.push(m[c] = p); i(null, y = [], l, u) } c = y.length; while (c--) (p = y[c]) && (l = i ? M.call(o, p) : f[c]) > -1 && (o[l] = !(a[l] = p)) } } else y = mt(y === a ? y.splice(h, y.length) : y), i ? i(null, a, y, u) : H.apply(a, y) }) } function vt(e) { var t, n, r, o = e.length, a = i.relative[e[0].type], s = a || i.relative[" "], u = a ? 1 : 0, c = ht(function (e) { return e === t }, s, !0), p = ht(function (e) { return M.call(t, e) > -1 }, s, !0), f = [function (e, n, r) { return !a && (r || n !== l) || ((t = n).nodeType ? c(e, n, r) : p(e, n, r)) }]; for (; o > u; u++) if (n = i.relative[e[u].type]) f = [ht(gt(f), n)]; else { if (n = i.filter[e[u].type].apply(null, e[u].matches), n[x]) { for (r = ++u; o > r; r++) if (i.relative[e[r].type]) break; return yt(u > 1 && gt(f), u > 1 && dt(e.slice(0, u - 1)).replace(W, "$1"), n, r > u && vt(e.slice(u, r)), o > r && vt(e = e.slice(r)), o > r && dt(e)) } f.push(n) } return gt(f) } function bt(e, t) { var n = 0, o = t.length > 0, a = e.length > 0, s = function (s, u, c, f, d) { var h, g, m, y = [], v = 0, b = "0", x = s && [], w = null != d, T = l, C = s || a && i.find.TAG("*", d && u.parentNode || u), k = N += null == T ? 1 : Math.random() || .1; for (w && (l = u !== p && u, r = n) ; null != (h = C[b]) ; b++) { if (a && h) { g = 0; while (m = e[g++]) if (m(h, u, c)) { f.push(h); break } w && (N = k, r = ++n) } o && ((h = !m && h) && v--, s && x.push(h)) } if (v += b, o && b !== v) { g = 0; while (m = t[g++]) m(x, y, u, c); if (s) { if (v > 0) while (b--) x[b] || y[b] || (y[b] = L.call(f)); y = mt(y) } H.apply(f, y), w && !s && y.length > 0 && v + t.length > 1 && st.uniqueSort(f) } return w && (N = k, l = T), x }; return o ? ot(s) : s } s = st.compile = function (e, t) { var n, r = [], i = [], o = S[e + " "]; if (!o) { t || (t = ft(e)), n = t.length; while (n--) o = vt(t[n]), o[x] ? r.push(o) : i.push(o); o = S(e, bt(i, r)) } return o }; function xt(e, t, n) { var r = 0, i = t.length; for (; i > r; r++) st(e, t[r], n); return n } function wt(e, t, n, r) { var o, a, u, l, c, p = ft(e); if (!r && 1 === p.length) { if (a = p[0] = p[0].slice(0), a.length > 2 && "ID" === (u = a[0]).type && 9 === t.nodeType && !d && i.relative[a[1].type]) { if (t = i.find.ID(u.matches[0].replace(et, tt), t)[0], !t) return n; e = e.slice(a.shift().value.length) } o = U.needsContext.test(e) ? 0 : a.length; while (o--) { if (u = a[o], i.relative[l = u.type]) break; if ((c = i.find[l]) && (r = c(u.matches[0].replace(et, tt), V.test(a[0].type) && t.parentNode || t))) { if (a.splice(o, 1), e = r.length && dt(a), !e) return H.apply(n, q.call(r, 0)), n; break } } } return s(e, p)(r, t, d, n, V.test(e)), n } i.pseudos.nth = i.pseudos.eq; function Tt() { } i.filters = Tt.prototype = i.pseudos, i.setFilters = new Tt, c(), st.attr = b.attr, b.find = st, b.expr = st.selectors, b.expr[":"] = b.expr.pseudos, b.unique = st.uniqueSort, b.text = st.getText, b.isXMLDoc = st.isXML, b.contains = st.contains }(e); var at = /Until$/, st = /^(?:parents|prev(?:Until|All))/, ut = /^.[^:#\[\.,]*$/, lt = b.expr.match.needsContext, ct = { children: !0, contents: !0, next: !0, prev: !0 }; b.fn.extend({ find: function (e) { var t, n, r, i = this.length; if ("string" != typeof e) return r = this, this.pushStack(b(e).filter(function () { for (t = 0; i > t; t++) if (b.contains(r[t], this)) return !0 })); for (n = [], t = 0; i > t; t++) b.find(e, this[t], n); return n = this.pushStack(i > 1 ? b.unique(n) : n), n.selector = (this.selector ? this.selector + " " : "") + e, n }, has: function (e) { var t, n = b(e, this), r = n.length; return this.filter(function () { for (t = 0; r > t; t++) if (b.contains(this, n[t])) return !0 }) }, not: function (e) { return this.pushStack(ft(this, e, !1)) }, filter: function (e) { return this.pushStack(ft(this, e, !0)) }, is: function (e) { return !!e && ("string" == typeof e ? lt.test(e) ? b(e, this.context).index(this[0]) >= 0 : b.filter(e, this).length > 0 : this.filter(e).length > 0) }, closest: function (e, t) { var n, r = 0, i = this.length, o = [], a = lt.test(e) || "string" != typeof e ? b(e, t || this.context) : 0; for (; i > r; r++) { n = this[r]; while (n && n.ownerDocument && n !== t && 11 !== n.nodeType) { if (a ? a.index(n) > -1 : b.find.matchesSelector(n, e)) { o.push(n); break } n = n.parentNode } } return this.pushStack(o.length > 1 ? b.unique(o) : o) }, index: function (e) { return e ? "string" == typeof e ? b.inArray(this[0], b(e)) : b.inArray(e.jquery ? e[0] : e, this) : this[0] && this[0].parentNode ? this.first().prevAll().length : -1 }, add: function (e, t) { var n = "string" == typeof e ? b(e, t) : b.makeArray(e && e.nodeType ? [e] : e), r = b.merge(this.get(), n); return this.pushStack(b.unique(r)) }, addBack: function (e) { return this.add(null == e ? this.prevObject : this.prevObject.filter(e)) } }), b.fn.andSelf = b.fn.addBack; function pt(e, t) { do e = e[t]; while (e && 1 !== e.nodeType); return e } b.each({ parent: function (e) { var t = e.parentNode; return t && 11 !== t.nodeType ? t : null }, parents: function (e) { return b.dir(e, "parentNode") }, parentsUntil: function (e, t, n) { return b.dir(e, "parentNode", n) }, next: function (e) { return pt(e, "nextSibling") }, prev: function (e) { return pt(e, "previousSibling") }, nextAll: function (e) { return b.dir(e, "nextSibling") }, prevAll: function (e) { return b.dir(e, "previousSibling") }, nextUntil: function (e, t, n) { return b.dir(e, "nextSibling", n) }, prevUntil: function (e, t, n) { return b.dir(e, "previousSibling", n) }, siblings: function (e) { return b.sibling((e.parentNode || {}).firstChild, e) }, children: function (e) { return b.sibling(e.firstChild) }, contents: function (e) { return b.nodeName(e, "iframe") ? e.contentDocument || e.contentWindow.document : b.merge([], e.childNodes) } }, function (e, t) { b.fn[e] = function (n, r) { var i = b.map(this, t, n); return at.test(e) || (r = n), r && "string" == typeof r && (i = b.filter(r, i)), i = this.length > 1 && !ct[e] ? b.unique(i) : i, this.length > 1 && st.test(e) && (i = i.reverse()), this.pushStack(i) } }), b.extend({ filter: function (e, t, n) { return n && (e = ":not(" + e + ")"), 1 === t.length ? b.find.matchesSelector(t[0], e) ? [t[0]] : [] : b.find.matches(e, t) }, dir: function (e, n, r) { var i = [], o = e[n]; while (o && 9 !== o.nodeType && (r === t || 1 !== o.nodeType || !b(o).is(r))) 1 === o.nodeType && i.push(o), o = o[n]; return i }, sibling: function (e, t) { var n = []; for (; e; e = e.nextSibling) 1 === e.nodeType && e !== t && n.push(e); return n } }); function ft(e, t, n) { if (t = t || 0, b.isFunction(t)) return b.grep(e, function (e, r) { var i = !!t.call(e, r, e); return i === n }); if (t.nodeType) return b.grep(e, function (e) { return e === t === n }); if ("string" == typeof t) { var r = b.grep(e, function (e) { return 1 === e.nodeType }); if (ut.test(t)) return b.filter(t, r, !n); t = b.filter(t, r) } return b.grep(e, function (e) { return b.inArray(e, t) >= 0 === n }) } function dt(e) { var t = ht.split("|"), n = e.createDocumentFragment(); if (n.createElement) while (t.length) n.createElement(t.pop()); return n } var ht = "abbr|article|aside|audio|bdi|canvas|data|datalist|details|figcaption|figure|footer|header|hgroup|mark|meter|nav|output|progress|section|summary|time|video", gt = / jQuery\d+="(?:null|\d+)"/g, mt = RegExp("<(?:" + ht + ")[\\s/>]", "i"), yt = /^\s+/, vt = /<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi, bt = /<([\w:]+)/, xt = /<tbody/i, wt = /<|&#?\w+;/, Tt = /<(?:script|style|link)/i, Nt = /^(?:checkbox|radio)$/i, Ct = /checked\s*(?:[^=]|=\s*.checked.)/i, kt = /^$|\/(?:java|ecma)script/i, Et = /^true\/(.*)/, St = /^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g, At = { option: [1, "<select multiple='multiple'>", "</select>"], legend: [1, "<fieldset>", "</fieldset>"], area: [1, "<map>", "</map>"], param: [1, "<object>", "</object>"], thead: [1, "<table>", "</table>"], tr: [2, "<table><tbody>", "</tbody></table>"], col: [2, "<table><tbody></tbody><colgroup>", "</colgroup></table>"], td: [3, "<table><tbody><tr>", "</tr></tbody></table>"], _default: b.support.htmlSerialize ? [0, "", ""] : [1, "X<div>", "</div>"] }, jt = dt(o), Dt = jt.appendChild(o.createElement("div")); At.optgroup = At.option, At.tbody = At.tfoot = At.colgroup = At.caption = At.thead, At.th = At.td, b.fn.extend({ text: function (e) { return b.access(this, function (e) { return e === t ? b.text(this) : this.empty().append((this[0] && this[0].ownerDocument || o).createTextNode(e)) }, null, e, arguments.length) }, wrapAll: function (e) { if (b.isFunction(e)) return this.each(function (t) { b(this).wrapAll(e.call(this, t)) }); if (this[0]) { var t = b(e, this[0].ownerDocument).eq(0).clone(!0); this[0].parentNode && t.insertBefore(this[0]), t.map(function () { var e = this; while (e.firstChild && 1 === e.firstChild.nodeType) e = e.firstChild; return e }).append(this) } return this }, wrapInner: function (e) { return b.isFunction(e) ? this.each(function (t) { b(this).wrapInner(e.call(this, t)) }) : this.each(function () { var t = b(this), n = t.contents(); n.length ? n.wrapAll(e) : t.append(e) }) }, wrap: function (e) { var t = b.isFunction(e); return this.each(function (n) { b(this).wrapAll(t ? e.call(this, n) : e) }) }, unwrap: function () { return this.parent().each(function () { b.nodeName(this, "body") || b(this).replaceWith(this.childNodes) }).end() }, append: function () { return this.domManip(arguments, !0, function (e) { (1 === this.nodeType || 11 === this.nodeType || 9 === this.nodeType) && this.appendChild(e) }) }, prepend: function () { return this.domManip(arguments, !0, function (e) { (1 === this.nodeType || 11 === this.nodeType || 9 === this.nodeType) && this.insertBefore(e, this.firstChild) }) }, before: function () { return this.domManip(arguments, !1, function (e) { this.parentNode && this.parentNode.insertBefore(e, this) }) }, after: function () { return this.domManip(arguments, !1, function (e) { this.parentNode && this.parentNode.insertBefore(e, this.nextSibling) }) }, remove: function (e, t) { var n, r = 0; for (; null != (n = this[r]) ; r++) (!e || b.filter(e, [n]).length > 0) && (t || 1 !== n.nodeType || b.cleanData(Ot(n)), n.parentNode && (t && b.contains(n.ownerDocument, n) && Mt(Ot(n, "script")), n.parentNode.removeChild(n))); return this }, empty: function () { var e, t = 0; for (; null != (e = this[t]) ; t++) { 1 === e.nodeType && b.cleanData(Ot(e, !1)); while (e.firstChild) e.removeChild(e.firstChild); e.options && b.nodeName(e, "select") && (e.options.length = 0) } return this }, clone: function (e, t) { return e = null == e ? !1 : e, t = null == t ? e : t, this.map(function () { return b.clone(this, e, t) }) }, html: function (e) { return b.access(this, function (e) { var n = this[0] || {}, r = 0, i = this.length; if (e === t) return 1 === n.nodeType ? n.innerHTML.replace(gt, "") : t; if (!("string" != typeof e || Tt.test(e) || !b.support.htmlSerialize && mt.test(e) || !b.support.leadingWhitespace && yt.test(e) || At[(bt.exec(e) || ["", ""])[1].toLowerCase()])) { e = e.replace(vt, "<$1></$2>"); try { for (; i > r; r++) n = this[r] || {}, 1 === n.nodeType && (b.cleanData(Ot(n, !1)), n.innerHTML = e); n = 0 } catch (o) { } } n && this.empty().append(e) }, null, e, arguments.length) }, replaceWith: function (e) { var t = b.isFunction(e); return t || "string" == typeof e || (e = b(e).not(this).detach()), this.domManip([e], !0, function (e) { var t = this.nextSibling, n = this.parentNode; n && (b(this).remove(), n.insertBefore(e, t)) }) }, detach: function (e) { return this.remove(e, !0) }, domManip: function (e, n, r) { e = f.apply([], e); var i, o, a, s, u, l, c = 0, p = this.length, d = this, h = p - 1, g = e[0], m = b.isFunction(g); if (m || !(1 >= p || "string" != typeof g || b.support.checkClone) && Ct.test(g)) return this.each(function (i) { var o = d.eq(i); m && (e[0] = g.call(this, i, n ? o.html() : t)), o.domManip(e, n, r) }); if (p && (l = b.buildFragment(e, this[0].ownerDocument, !1, this), i = l.firstChild, 1 === l.childNodes.length && (l = i), i)) { for (n = n && b.nodeName(i, "tr"), s = b.map(Ot(l, "script"), Ht), a = s.length; p > c; c++) o = l, c !== h && (o = b.clone(o, !0, !0), a && b.merge(s, Ot(o, "script"))), r.call(n && b.nodeName(this[c], "table") ? Lt(this[c], "tbody") : this[c], o, c); if (a) for (u = s[s.length - 1].ownerDocument, b.map(s, qt), c = 0; a > c; c++) o = s[c], kt.test(o.type || "") && !b._data(o, "globalEval") && b.contains(u, o) && (o.src ? b.ajax({ url: o.src, type: "GET", dataType: "script", async: !1, global: !1, "throws": !0 }) : b.globalEval((o.text || o.textContent || o.innerHTML || "").replace(St, ""))); l = i = null } return this } }); function Lt(e, t) { return e.getElementsByTagName(t)[0] || e.appendChild(e.ownerDocument.createElement(t)) } function Ht(e) { var t = e.getAttributeNode("type"); return e.type = (t && t.specified) + "/" + e.type, e } function qt(e) { var t = Et.exec(e.type); return t ? e.type = t[1] : e.removeAttribute("type"), e } function Mt(e, t) { var n, r = 0; for (; null != (n = e[r]) ; r++) b._data(n, "globalEval", !t || b._data(t[r], "globalEval")) } function _t(e, t) { if (1 === t.nodeType && b.hasData(e)) { var n, r, i, o = b._data(e), a = b._data(t, o), s = o.events; if (s) { delete a.handle, a.events = {}; for (n in s) for (r = 0, i = s[n].length; i > r; r++) b.event.add(t, n, s[n][r]) } a.data && (a.data = b.extend({}, a.data)) } } function Ft(e, t) { var n, r, i; if (1 === t.nodeType) { if (n = t.nodeName.toLowerCase(), !b.support.noCloneEvent && t[b.expando]) { i = b._data(t); for (r in i.events) b.removeEvent(t, r, i.handle); t.removeAttribute(b.expando) } "script" === n && t.text !== e.text ? (Ht(t).text = e.text, qt(t)) : "object" === n ? (t.parentNode && (t.outerHTML = e.outerHTML), b.support.html5Clone && e.innerHTML && !b.trim(t.innerHTML) && (t.innerHTML = e.innerHTML)) : "input" === n && Nt.test(e.type) ? (t.defaultChecked = t.checked = e.checked, t.value !== e.value && (t.value = e.value)) : "option" === n ? t.defaultSelected = t.selected = e.defaultSelected : ("input" === n || "textarea" === n) && (t.defaultValue = e.defaultValue) } } b.each({ appendTo: "append", prependTo: "prepend", insertBefore: "before", insertAfter: "after", replaceAll: "replaceWith" }, function (e, t) { b.fn[e] = function (e) { var n, r = 0, i = [], o = b(e), a = o.length - 1; for (; a >= r; r++) n = r === a ? this : this.clone(!0), b(o[r])[t](n), d.apply(i, n.get()); return this.pushStack(i) } }); function Ot(e, n) { var r, o, a = 0, s = typeof e.getElementsByTagName !== i ? e.getElementsByTagName(n || "*") : typeof e.querySelectorAll !== i ? e.querySelectorAll(n || "*") : t; if (!s) for (s = [], r = e.childNodes || e; null != (o = r[a]) ; a++) !n || b.nodeName(o, n) ? s.push(o) : b.merge(s, Ot(o, n)); return n === t || n && b.nodeName(e, n) ? b.merge([e], s) : s } function Bt(e) { Nt.test(e.type) && (e.defaultChecked = e.checked) } b.extend({
        clone: function (e, t, n) { var r, i, o, a, s, u = b.contains(e.ownerDocument, e); if (b.support.html5Clone || b.isXMLDoc(e) || !mt.test("<" + e.nodeName + ">") ? o = e.cloneNode(!0) : (Dt.innerHTML = e.outerHTML, Dt.removeChild(o = Dt.firstChild)), !(b.support.noCloneEvent && b.support.noCloneChecked || 1 !== e.nodeType && 11 !== e.nodeType || b.isXMLDoc(e))) for (r = Ot(o), s = Ot(e), a = 0; null != (i = s[a]) ; ++a) r[a] && Ft(i, r[a]); if (t) if (n) for (s = s || Ot(e), r = r || Ot(o), a = 0; null != (i = s[a]) ; a++) _t(i, r[a]); else _t(e, o); return r = Ot(o, "script"), r.length > 0 && Mt(r, !u && Ot(e, "script")), r = s = i = null, o }, buildFragment: function (e, t, n, r) {
            var i, o, a, s, u, l, c, p = e.length, f = dt(t), d = [], h = 0; for (; p > h; h++) if (o = e[h], o || 0 === o) if ("object" === b.type(o)) b.merge(d, o.nodeType ? [o] : o); else if (wt.test(o)) {
                s = s || f.appendChild(t.createElement("div")), u = (bt.exec(o) || ["", ""])[1].toLowerCase(), c = At[u] || At._default, s.innerHTML = c[1] + o.replace(vt, "<$1></$2>") + c[2], i = c[0]; while (i--) s = s.lastChild; if (!b.support.leadingWhitespace && yt.test(o) && d.push(t.createTextNode(yt.exec(o)[0])), !b.support.tbody) {
                    o = "table" !== u || xt.test(o) ? "<table>" !== c[1] || xt.test(o) ? 0 : s : s.firstChild, i = o && o.childNodes.length; while (i--) b.nodeName(l = o.childNodes[i], "tbody") && !l.childNodes.length && o.removeChild(l)
                } b.merge(d, s.childNodes), s.textContent = ""; while (s.firstChild) s.removeChild(s.firstChild); s = f.lastChild
            } else d.push(t.createTextNode(o)); s && f.removeChild(s), b.support.appendChecked || b.grep(Ot(d, "input"), Bt), h = 0; while (o = d[h++]) if ((!r || -1 === b.inArray(o, r)) && (a = b.contains(o.ownerDocument, o), s = Ot(f.appendChild(o), "script"), a && Mt(s), n)) { i = 0; while (o = s[i++]) kt.test(o.type || "") && n.push(o) } return s = null, f
        }, cleanData: function (e, t) { var n, r, o, a, s = 0, u = b.expando, l = b.cache, p = b.support.deleteExpando, f = b.event.special; for (; null != (n = e[s]) ; s++) if ((t || b.acceptData(n)) && (o = n[u], a = o && l[o])) { if (a.events) for (r in a.events) f[r] ? b.event.remove(n, r) : b.removeEvent(n, r, a.handle); l[o] && (delete l[o], p ? delete n[u] : typeof n.removeAttribute !== i ? n.removeAttribute(u) : n[u] = null, c.push(o)) } }
    }); var Pt, Rt, Wt, $t = /alpha\([^)]*\)/i, It = /opacity\s*=\s*([^)]*)/, zt = /^(top|right|bottom|left)$/, Xt = /^(none|table(?!-c[ea]).+)/, Ut = /^margin/, Vt = RegExp("^(" + x + ")(.*)$", "i"), Yt = RegExp("^(" + x + ")(?!px)[a-z%]+$", "i"), Jt = RegExp("^([+-])=(" + x + ")", "i"), Gt = { BODY: "block" }, Qt = { position: "absolute", visibility: "hidden", display: "block" }, Kt = { letterSpacing: 0, fontWeight: 400 }, Zt = ["Top", "Right", "Bottom", "Left"], en = ["Webkit", "O", "Moz", "ms"]; function tn(e, t) { if (t in e) return t; var n = t.charAt(0).toUpperCase() + t.slice(1), r = t, i = en.length; while (i--) if (t = en[i] + n, t in e) return t; return r } function nn(e, t) { return e = t || e, "none" === b.css(e, "display") || !b.contains(e.ownerDocument, e) } function rn(e, t) { var n, r, i, o = [], a = 0, s = e.length; for (; s > a; a++) r = e[a], r.style && (o[a] = b._data(r, "olddisplay"), n = r.style.display, t ? (o[a] || "none" !== n || (r.style.display = ""), "" === r.style.display && nn(r) && (o[a] = b._data(r, "olddisplay", un(r.nodeName)))) : o[a] || (i = nn(r), (n && "none" !== n || !i) && b._data(r, "olddisplay", i ? n : b.css(r, "display")))); for (a = 0; s > a; a++) r = e[a], r.style && (t && "none" !== r.style.display && "" !== r.style.display || (r.style.display = t ? o[a] || "" : "none")); return e } b.fn.extend({ css: function (e, n) { return b.access(this, function (e, n, r) { var i, o, a = {}, s = 0; if (b.isArray(n)) { for (o = Rt(e), i = n.length; i > s; s++) a[n[s]] = b.css(e, n[s], !1, o); return a } return r !== t ? b.style(e, n, r) : b.css(e, n) }, e, n, arguments.length > 1) }, show: function () { return rn(this, !0) }, hide: function () { return rn(this) }, toggle: function (e) { var t = "boolean" == typeof e; return this.each(function () { (t ? e : nn(this)) ? b(this).show() : b(this).hide() }) } }), b.extend({ cssHooks: { opacity: { get: function (e, t) { if (t) { var n = Wt(e, "opacity"); return "" === n ? "1" : n } } } }, cssNumber: { columnCount: !0, fillOpacity: !0, fontWeight: !0, lineHeight: !0, opacity: !0, orphans: !0, widows: !0, zIndex: !0, zoom: !0 }, cssProps: { "float": b.support.cssFloat ? "cssFloat" : "styleFloat" }, style: function (e, n, r, i) { if (e && 3 !== e.nodeType && 8 !== e.nodeType && e.style) { var o, a, s, u = b.camelCase(n), l = e.style; if (n = b.cssProps[u] || (b.cssProps[u] = tn(l, u)), s = b.cssHooks[n] || b.cssHooks[u], r === t) return s && "get" in s && (o = s.get(e, !1, i)) !== t ? o : l[n]; if (a = typeof r, "string" === a && (o = Jt.exec(r)) && (r = (o[1] + 1) * o[2] + parseFloat(b.css(e, n)), a = "number"), !(null == r || "number" === a && isNaN(r) || ("number" !== a || b.cssNumber[u] || (r += "px"), b.support.clearCloneStyle || "" !== r || 0 !== n.indexOf("background") || (l[n] = "inherit"), s && "set" in s && (r = s.set(e, r, i)) === t))) try { l[n] = r } catch (c) { } } }, css: function (e, n, r, i) { var o, a, s, u = b.camelCase(n); return n = b.cssProps[u] || (b.cssProps[u] = tn(e.style, u)), s = b.cssHooks[n] || b.cssHooks[u], s && "get" in s && (a = s.get(e, !0, r)), a === t && (a = Wt(e, n, i)), "normal" === a && n in Kt && (a = Kt[n]), "" === r || r ? (o = parseFloat(a), r === !0 || b.isNumeric(o) ? o || 0 : a) : a }, swap: function (e, t, n, r) { var i, o, a = {}; for (o in t) a[o] = e.style[o], e.style[o] = t[o]; i = n.apply(e, r || []); for (o in t) e.style[o] = a[o]; return i } }), e.getComputedStyle ? (Rt = function (t) { return e.getComputedStyle(t, null) }, Wt = function (e, n, r) { var i, o, a, s = r || Rt(e), u = s ? s.getPropertyValue(n) || s[n] : t, l = e.style; return s && ("" !== u || b.contains(e.ownerDocument, e) || (u = b.style(e, n)), Yt.test(u) && Ut.test(n) && (i = l.width, o = l.minWidth, a = l.maxWidth, l.minWidth = l.maxWidth = l.width = u, u = s.width, l.width = i, l.minWidth = o, l.maxWidth = a)), u }) : o.documentElement.currentStyle && (Rt = function (e) { return e.currentStyle }, Wt = function (e, n, r) { var i, o, a, s = r || Rt(e), u = s ? s[n] : t, l = e.style; return null == u && l && l[n] && (u = l[n]), Yt.test(u) && !zt.test(n) && (i = l.left, o = e.runtimeStyle, a = o && o.left, a && (o.left = e.currentStyle.left), l.left = "fontSize" === n ? "1em" : u, u = l.pixelLeft + "px", l.left = i, a && (o.left = a)), "" === u ? "auto" : u }); function on(e, t, n) { var r = Vt.exec(t); return r ? Math.max(0, r[1] - (n || 0)) + (r[2] || "px") : t } function an(e, t, n, r, i) { var o = n === (r ? "border" : "content") ? 4 : "width" === t ? 1 : 0, a = 0; for (; 4 > o; o += 2) "margin" === n && (a += b.css(e, n + Zt[o], !0, i)), r ? ("content" === n && (a -= b.css(e, "padding" + Zt[o], !0, i)), "margin" !== n && (a -= b.css(e, "border" + Zt[o] + "Width", !0, i))) : (a += b.css(e, "padding" + Zt[o], !0, i), "padding" !== n && (a += b.css(e, "border" + Zt[o] + "Width", !0, i))); return a } function sn(e, t, n) { var r = !0, i = "width" === t ? e.offsetWidth : e.offsetHeight, o = Rt(e), a = b.support.boxSizing && "border-box" === b.css(e, "boxSizing", !1, o); if (0 >= i || null == i) { if (i = Wt(e, t, o), (0 > i || null == i) && (i = e.style[t]), Yt.test(i)) return i; r = a && (b.support.boxSizingReliable || i === e.style[t]), i = parseFloat(i) || 0 } return i + an(e, t, n || (a ? "border" : "content"), r, o) + "px" } function un(e) { var t = o, n = Gt[e]; return n || (n = ln(e, t), "none" !== n && n || (Pt = (Pt || b("<iframe frameborder='0' width='0' height='0'/>").css("cssText", "display:block !important")).appendTo(t.documentElement), t = (Pt[0].contentWindow || Pt[0].contentDocument).document, t.write("<!doctype html><html><body>"), t.close(), n = ln(e, t), Pt.detach()), Gt[e] = n), n } function ln(e, t) { var n = b(t.createElement(e)).appendTo(t.body), r = b.css(n[0], "display"); return n.remove(), r } b.each(["height", "width"], function (e, n) { b.cssHooks[n] = { get: function (e, r, i) { return r ? 0 === e.offsetWidth && Xt.test(b.css(e, "display")) ? b.swap(e, Qt, function () { return sn(e, n, i) }) : sn(e, n, i) : t }, set: function (e, t, r) { var i = r && Rt(e); return on(e, t, r ? an(e, n, r, b.support.boxSizing && "border-box" === b.css(e, "boxSizing", !1, i), i) : 0) } } }), b.support.opacity || (b.cssHooks.opacity = { get: function (e, t) { return It.test((t && e.currentStyle ? e.currentStyle.filter : e.style.filter) || "") ? .01 * parseFloat(RegExp.$1) + "" : t ? "1" : "" }, set: function (e, t) { var n = e.style, r = e.currentStyle, i = b.isNumeric(t) ? "alpha(opacity=" + 100 * t + ")" : "", o = r && r.filter || n.filter || ""; n.zoom = 1, (t >= 1 || "" === t) && "" === b.trim(o.replace($t, "")) && n.removeAttribute && (n.removeAttribute("filter"), "" === t || r && !r.filter) || (n.filter = $t.test(o) ? o.replace($t, i) : o + " " + i) } }), b(function () { b.support.reliableMarginRight || (b.cssHooks.marginRight = { get: function (e, n) { return n ? b.swap(e, { display: "inline-block" }, Wt, [e, "marginRight"]) : t } }), !b.support.pixelPosition && b.fn.position && b.each(["top", "left"], function (e, n) { b.cssHooks[n] = { get: function (e, r) { return r ? (r = Wt(e, n), Yt.test(r) ? b(e).position()[n] + "px" : r) : t } } }) }), b.expr && b.expr.filters && (b.expr.filters.hidden = function (e) { return 0 >= e.offsetWidth && 0 >= e.offsetHeight || !b.support.reliableHiddenOffsets && "none" === (e.style && e.style.display || b.css(e, "display")) }, b.expr.filters.visible = function (e) { return !b.expr.filters.hidden(e) }), b.each({ margin: "", padding: "", border: "Width" }, function (e, t) { b.cssHooks[e + t] = { expand: function (n) { var r = 0, i = {}, o = "string" == typeof n ? n.split(" ") : [n]; for (; 4 > r; r++) i[e + Zt[r] + t] = o[r] || o[r - 2] || o[0]; return i } }, Ut.test(e) || (b.cssHooks[e + t].set = on) }); var cn = /%20/g, pn = /\[\]$/, fn = /\r?\n/g, dn = /^(?:submit|button|image|reset|file)$/i, hn = /^(?:input|select|textarea|keygen)/i; b.fn.extend({ serialize: function () { return b.param(this.serializeArray()) }, serializeArray: function () { return this.map(function () { var e = b.prop(this, "elements"); return e ? b.makeArray(e) : this }).filter(function () { var e = this.type; return this.name && !b(this).is(":disabled") && hn.test(this.nodeName) && !dn.test(e) && (this.checked || !Nt.test(e)) }).map(function (e, t) { var n = b(this).val(); return null == n ? null : b.isArray(n) ? b.map(n, function (e) { return { name: t.name, value: e.replace(fn, "\r\n") } }) : { name: t.name, value: n.replace(fn, "\r\n") } }).get() } }), b.param = function (e, n) { var r, i = [], o = function (e, t) { t = b.isFunction(t) ? t() : null == t ? "" : t, i[i.length] = encodeURIComponent(e) + "=" + encodeURIComponent(t) }; if (n === t && (n = b.ajaxSettings && b.ajaxSettings.traditional), b.isArray(e) || e.jquery && !b.isPlainObject(e)) b.each(e, function () { o(this.name, this.value) }); else for (r in e) gn(r, e[r], n, o); return i.join("&").replace(cn, "+") }; function gn(e, t, n, r) { var i; if (b.isArray(t)) b.each(t, function (t, i) { n || pn.test(e) ? r(e, i) : gn(e + "[" + ("object" == typeof i ? t : "") + "]", i, n, r) }); else if (n || "object" !== b.type(t)) r(e, t); else for (i in t) gn(e + "[" + i + "]", t[i], n, r) } b.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "), function (e, t) { b.fn[t] = function (e, n) { return arguments.length > 0 ? this.on(t, null, e, n) : this.trigger(t) } }), b.fn.hover = function (e, t) { return this.mouseenter(e).mouseleave(t || e) }; var mn, yn, vn = b.now(), bn = /\?/, xn = /#.*$/, wn = /([?&])_=[^&]*/, Tn = /^(.*?):[ \t]*([^\r\n]*)\r?$/gm, Nn = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/, Cn = /^(?:GET|HEAD)$/, kn = /^\/\//, En = /^([\w.+-]+:)(?:\/\/([^\/?#:]*)(?::(\d+)|)|)/, Sn = b.fn.load, An = {}, jn = {}, Dn = "*/".concat("*"); try { yn = a.href } catch (Ln) { yn = o.createElement("a"), yn.href = "", yn = yn.href } mn = En.exec(yn.toLowerCase()) || []; function Hn(e) { return function (t, n) { "string" != typeof t && (n = t, t = "*"); var r, i = 0, o = t.toLowerCase().match(w) || []; if (b.isFunction(n)) while (r = o[i++]) "+" === r[0] ? (r = r.slice(1) || "*", (e[r] = e[r] || []).unshift(n)) : (e[r] = e[r] || []).push(n) } } function qn(e, n, r, i) { var o = {}, a = e === jn; function s(u) { var l; return o[u] = !0, b.each(e[u] || [], function (e, u) { var c = u(n, r, i); return "string" != typeof c || a || o[c] ? a ? !(l = c) : t : (n.dataTypes.unshift(c), s(c), !1) }), l } return s(n.dataTypes[0]) || !o["*"] && s("*") } function Mn(e, n) { var r, i, o = b.ajaxSettings.flatOptions || {}; for (i in n) n[i] !== t && ((o[i] ? e : r || (r = {}))[i] = n[i]); return r && b.extend(!0, e, r), e } b.fn.load = function (e, n, r) { if ("string" != typeof e && Sn) return Sn.apply(this, arguments); var i, o, a, s = this, u = e.indexOf(" "); return u >= 0 && (i = e.slice(u, e.length), e = e.slice(0, u)), b.isFunction(n) ? (r = n, n = t) : n && "object" == typeof n && (a = "POST"), s.length > 0 && b.ajax({ url: e, type: a, dataType: "html", data: n }).done(function (e) { o = arguments, s.html(i ? b("<div>").append(b.parseHTML(e)).find(i) : e) }).complete(r && function (e, t) { s.each(r, o || [e.responseText, t, e]) }), this }, b.each(["ajaxStart", "ajaxStop", "ajaxComplete", "ajaxError", "ajaxSuccess", "ajaxSend"], function (e, t) { b.fn[t] = function (e) { return this.on(t, e) } }), b.each(["get", "post"], function (e, n) { b[n] = function (e, r, i, o) { return b.isFunction(r) && (o = o || i, i = r, r = t), b.ajax({ url: e, type: n, dataType: o, data: r, success: i }) } }), b.extend({ active: 0, lastModified: {}, etag: {}, ajaxSettings: { url: yn, type: "GET", isLocal: Nn.test(mn[1]), global: !0, processData: !0, async: !0, contentType: "application/x-www-form-urlencoded; charset=UTF-8", accepts: { "*": Dn, text: "text/plain", html: "text/html", xml: "application/xml, text/xml", json: "application/json, text/javascript" }, contents: { xml: /xml/, html: /html/, json: /json/ }, responseFields: { xml: "responseXML", text: "responseText" }, converters: { "* text": e.String, "text html": !0, "text json": b.parseJSON, "text xml": b.parseXML }, flatOptions: { url: !0, context: !0 } }, ajaxSetup: function (e, t) { return t ? Mn(Mn(e, b.ajaxSettings), t) : Mn(b.ajaxSettings, e) }, ajaxPrefilter: Hn(An), ajaxTransport: Hn(jn), ajax: function (e, n) { "object" == typeof e && (n = e, e = t), n = n || {}; var r, i, o, a, s, u, l, c, p = b.ajaxSetup({}, n), f = p.context || p, d = p.context && (f.nodeType || f.jquery) ? b(f) : b.event, h = b.Deferred(), g = b.Callbacks("once memory"), m = p.statusCode || {}, y = {}, v = {}, x = 0, T = "canceled", N = { readyState: 0, getResponseHeader: function (e) { var t; if (2 === x) { if (!c) { c = {}; while (t = Tn.exec(a)) c[t[1].toLowerCase()] = t[2] } t = c[e.toLowerCase()] } return null == t ? null : t }, getAllResponseHeaders: function () { return 2 === x ? a : null }, setRequestHeader: function (e, t) { var n = e.toLowerCase(); return x || (e = v[n] = v[n] || e, y[e] = t), this }, overrideMimeType: function (e) { return x || (p.mimeType = e), this }, statusCode: function (e) { var t; if (e) if (2 > x) for (t in e) m[t] = [m[t], e[t]]; else N.always(e[N.status]); return this }, abort: function (e) { var t = e || T; return l && l.abort(t), k(0, t), this } }; if (h.promise(N).complete = g.add, N.success = N.done, N.error = N.fail, p.url = ((e || p.url || yn) + "").replace(xn, "").replace(kn, mn[1] + "//"), p.type = n.method || n.type || p.method || p.type, p.dataTypes = b.trim(p.dataType || "*").toLowerCase().match(w) || [""], null == p.crossDomain && (r = En.exec(p.url.toLowerCase()), p.crossDomain = !(!r || r[1] === mn[1] && r[2] === mn[2] && (r[3] || ("http:" === r[1] ? 80 : 443)) == (mn[3] || ("http:" === mn[1] ? 80 : 443)))), p.data && p.processData && "string" != typeof p.data && (p.data = b.param(p.data, p.traditional)), qn(An, p, n, N), 2 === x) return N; u = p.global, u && 0 === b.active++ && b.event.trigger("ajaxStart"), p.type = p.type.toUpperCase(), p.hasContent = !Cn.test(p.type), o = p.url, p.hasContent || (p.data && (o = p.url += (bn.test(o) ? "&" : "?") + p.data, delete p.data), p.cache === !1 && (p.url = wn.test(o) ? o.replace(wn, "$1_=" + vn++) : o + (bn.test(o) ? "&" : "?") + "_=" + vn++)), p.ifModified && (b.lastModified[o] && N.setRequestHeader("If-Modified-Since", b.lastModified[o]), b.etag[o] && N.setRequestHeader("If-None-Match", b.etag[o])), (p.data && p.hasContent && p.contentType !== !1 || n.contentType) && N.setRequestHeader("Content-Type", p.contentType), N.setRequestHeader("Accept", p.dataTypes[0] && p.accepts[p.dataTypes[0]] ? p.accepts[p.dataTypes[0]] + ("*" !== p.dataTypes[0] ? ", " + Dn + "; q=0.01" : "") : p.accepts["*"]); for (i in p.headers) N.setRequestHeader(i, p.headers[i]); if (p.beforeSend && (p.beforeSend.call(f, N, p) === !1 || 2 === x)) return N.abort(); T = "abort"; for (i in { success: 1, error: 1, complete: 1 }) N[i](p[i]); if (l = qn(jn, p, n, N)) { N.readyState = 1, u && d.trigger("ajaxSend", [N, p]), p.async && p.timeout > 0 && (s = setTimeout(function () { N.abort("timeout") }, p.timeout)); try { x = 1, l.send(y, k) } catch (C) { if (!(2 > x)) throw C; k(-1, C) } } else k(-1, "No Transport"); function k(e, n, r, i) { var c, y, v, w, T, C = n; 2 !== x && (x = 2, s && clearTimeout(s), l = t, a = i || "", N.readyState = e > 0 ? 4 : 0, r && (w = _n(p, N, r)), e >= 200 && 300 > e || 304 === e ? (p.ifModified && (T = N.getResponseHeader("Last-Modified"), T && (b.lastModified[o] = T), T = N.getResponseHeader("etag"), T && (b.etag[o] = T)), 204 === e ? (c = !0, C = "nocontent") : 304 === e ? (c = !0, C = "notmodified") : (c = Fn(p, w), C = c.state, y = c.data, v = c.error, c = !v)) : (v = C, (e || !C) && (C = "error", 0 > e && (e = 0))), N.status = e, N.statusText = (n || C) + "", c ? h.resolveWith(f, [y, C, N]) : h.rejectWith(f, [N, C, v]), N.statusCode(m), m = t, u && d.trigger(c ? "ajaxSuccess" : "ajaxError", [N, p, c ? y : v]), g.fireWith(f, [N, C]), u && (d.trigger("ajaxComplete", [N, p]), --b.active || b.event.trigger("ajaxStop"))) } return N }, getScript: function (e, n) { return b.get(e, t, n, "script") }, getJSON: function (e, t, n) { return b.get(e, t, n, "json") } }); function _n(e, n, r) { var i, o, a, s, u = e.contents, l = e.dataTypes, c = e.responseFields; for (s in c) s in r && (n[c[s]] = r[s]); while ("*" === l[0]) l.shift(), o === t && (o = e.mimeType || n.getResponseHeader("Content-Type")); if (o) for (s in u) if (u[s] && u[s].test(o)) { l.unshift(s); break } if (l[0] in r) a = l[0]; else { for (s in r) { if (!l[0] || e.converters[s + " " + l[0]]) { a = s; break } i || (i = s) } a = a || i } return a ? (a !== l[0] && l.unshift(a), r[a]) : t } function Fn(e, t) { var n, r, i, o, a = {}, s = 0, u = e.dataTypes.slice(), l = u[0]; if (e.dataFilter && (t = e.dataFilter(t, e.dataType)), u[1]) for (i in e.converters) a[i.toLowerCase()] = e.converters[i]; for (; r = u[++s];) if ("*" !== r) { if ("*" !== l && l !== r) { if (i = a[l + " " + r] || a["* " + r], !i) for (n in a) if (o = n.split(" "), o[1] === r && (i = a[l + " " + o[0]] || a["* " + o[0]])) { i === !0 ? i = a[n] : a[n] !== !0 && (r = o[0], u.splice(s--, 0, r)); break } if (i !== !0) if (i && e["throws"]) t = i(t); else try { t = i(t) } catch (c) { return { state: "parsererror", error: i ? c : "No conversion from " + l + " to " + r } } } l = r } return { state: "success", data: t } } b.ajaxSetup({ accepts: { script: "text/javascript, application/javascript, application/ecmascript, application/x-ecmascript" }, contents: { script: /(?:java|ecma)script/ }, converters: { "text script": function (e) { return b.globalEval(e), e } } }), b.ajaxPrefilter("script", function (e) { e.cache === t && (e.cache = !1), e.crossDomain && (e.type = "GET", e.global = !1) }), b.ajaxTransport("script", function (e) { if (e.crossDomain) { var n, r = o.head || b("head")[0] || o.documentElement; return { send: function (t, i) { n = o.createElement("script"), n.async = !0, e.scriptCharset && (n.charset = e.scriptCharset), n.src = e.url, n.onload = n.onreadystatechange = function (e, t) { (t || !n.readyState || /loaded|complete/.test(n.readyState)) && (n.onload = n.onreadystatechange = null, n.parentNode && n.parentNode.removeChild(n), n = null, t || i(200, "success")) }, r.insertBefore(n, r.firstChild) }, abort: function () { n && n.onload(t, !0) } } } }); var On = [], Bn = /(=)\?(?=&|$)|\?\?/; b.ajaxSetup({ jsonp: "callback", jsonpCallback: function () { var e = On.pop() || b.expando + "_" + vn++; return this[e] = !0, e } }), b.ajaxPrefilter("json jsonp", function (n, r, i) { var o, a, s, u = n.jsonp !== !1 && (Bn.test(n.url) ? "url" : "string" == typeof n.data && !(n.contentType || "").indexOf("application/x-www-form-urlencoded") && Bn.test(n.data) && "data"); return u || "jsonp" === n.dataTypes[0] ? (o = n.jsonpCallback = b.isFunction(n.jsonpCallback) ? n.jsonpCallback() : n.jsonpCallback, u ? n[u] = n[u].replace(Bn, "$1" + o) : n.jsonp !== !1 && (n.url += (bn.test(n.url) ? "&" : "?") + n.jsonp + "=" + o), n.converters["script json"] = function () { return s || b.error(o + " was not called"), s[0] }, n.dataTypes[0] = "json", a = e[o], e[o] = function () { s = arguments }, i.always(function () { e[o] = a, n[o] && (n.jsonpCallback = r.jsonpCallback, On.push(o)), s && b.isFunction(a) && a(s[0]), s = a = t }), "script") : t }); var Pn, Rn, Wn = 0, $n = e.ActiveXObject && function () { var e; for (e in Pn) Pn[e](t, !0) }; function In() { try { return new e.XMLHttpRequest } catch (t) { } } function zn() { try { return new e.ActiveXObject("Microsoft.XMLHTTP") } catch (t) { } } b.ajaxSettings.xhr = e.ActiveXObject ? function () { return !this.isLocal && In() || zn() } : In, Rn = b.ajaxSettings.xhr(), b.support.cors = !!Rn && "withCredentials" in Rn, Rn = b.support.ajax = !!Rn, Rn && b.ajaxTransport(function (n) { if (!n.crossDomain || b.support.cors) { var r; return { send: function (i, o) { var a, s, u = n.xhr(); if (n.username ? u.open(n.type, n.url, n.async, n.username, n.password) : u.open(n.type, n.url, n.async), n.xhrFields) for (s in n.xhrFields) u[s] = n.xhrFields[s]; n.mimeType && u.overrideMimeType && u.overrideMimeType(n.mimeType), n.crossDomain || i["X-Requested-With"] || (i["X-Requested-With"] = "XMLHttpRequest"); try { for (s in i) u.setRequestHeader(s, i[s]) } catch (l) { } u.send(n.hasContent && n.data || null), r = function (e, i) { var s, l, c, p; try { if (r && (i || 4 === u.readyState)) if (r = t, a && (u.onreadystatechange = b.noop, $n && delete Pn[a]), i) 4 !== u.readyState && u.abort(); else { p = {}, s = u.status, l = u.getAllResponseHeaders(), "string" == typeof u.responseText && (p.text = u.responseText); try { c = u.statusText } catch (f) { c = "" } s || !n.isLocal || n.crossDomain ? 1223 === s && (s = 204) : s = p.text ? 200 : 404 } } catch (d) { i || o(-1, d) } p && o(s, c, p, l) }, n.async ? 4 === u.readyState ? setTimeout(r) : (a = ++Wn, $n && (Pn || (Pn = {}, b(e).unload($n)), Pn[a] = r), u.onreadystatechange = r) : r() }, abort: function () { r && r(t, !0) } } } }); var Xn, Un, Vn = /^(?:toggle|show|hide)$/, Yn = RegExp("^(?:([+-])=|)(" + x + ")([a-z%]*)$", "i"), Jn = /queueHooks$/, Gn = [nr], Qn = { "*": [function (e, t) { var n, r, i = this.createTween(e, t), o = Yn.exec(t), a = i.cur(), s = +a || 0, u = 1, l = 20; if (o) { if (n = +o[2], r = o[3] || (b.cssNumber[e] ? "" : "px"), "px" !== r && s) { s = b.css(i.elem, e, !0) || n || 1; do u = u || ".5", s /= u, b.style(i.elem, e, s + r); while (u !== (u = i.cur() / a) && 1 !== u && --l) } i.unit = r, i.start = s, i.end = o[1] ? s + (o[1] + 1) * n : n } return i }] }; function Kn() { return setTimeout(function () { Xn = t }), Xn = b.now() } function Zn(e, t) { b.each(t, function (t, n) { var r = (Qn[t] || []).concat(Qn["*"]), i = 0, o = r.length; for (; o > i; i++) if (r[i].call(e, t, n)) return }) } function er(e, t, n) { var r, i, o = 0, a = Gn.length, s = b.Deferred().always(function () { delete u.elem }), u = function () { if (i) return !1; var t = Xn || Kn(), n = Math.max(0, l.startTime + l.duration - t), r = n / l.duration || 0, o = 1 - r, a = 0, u = l.tweens.length; for (; u > a; a++) l.tweens[a].run(o); return s.notifyWith(e, [l, o, n]), 1 > o && u ? n : (s.resolveWith(e, [l]), !1) }, l = s.promise({ elem: e, props: b.extend({}, t), opts: b.extend(!0, { specialEasing: {} }, n), originalProperties: t, originalOptions: n, startTime: Xn || Kn(), duration: n.duration, tweens: [], createTween: function (t, n) { var r = b.Tween(e, l.opts, t, n, l.opts.specialEasing[t] || l.opts.easing); return l.tweens.push(r), r }, stop: function (t) { var n = 0, r = t ? l.tweens.length : 0; if (i) return this; for (i = !0; r > n; n++) l.tweens[n].run(1); return t ? s.resolveWith(e, [l, t]) : s.rejectWith(e, [l, t]), this } }), c = l.props; for (tr(c, l.opts.specialEasing) ; a > o; o++) if (r = Gn[o].call(l, e, c, l.opts)) return r; return Zn(l, c), b.isFunction(l.opts.start) && l.opts.start.call(e, l), b.fx.timer(b.extend(u, { elem: e, anim: l, queue: l.opts.queue })), l.progress(l.opts.progress).done(l.opts.done, l.opts.complete).fail(l.opts.fail).always(l.opts.always) } function tr(e, t) { var n, r, i, o, a; for (i in e) if (r = b.camelCase(i), o = t[r], n = e[i], b.isArray(n) && (o = n[1], n = e[i] = n[0]), i !== r && (e[r] = n, delete e[i]), a = b.cssHooks[r], a && "expand" in a) { n = a.expand(n), delete e[r]; for (i in n) i in e || (e[i] = n[i], t[i] = o) } else t[r] = o } b.Animation = b.extend(er, { tweener: function (e, t) { b.isFunction(e) ? (t = e, e = ["*"]) : e = e.split(" "); var n, r = 0, i = e.length; for (; i > r; r++) n = e[r], Qn[n] = Qn[n] || [], Qn[n].unshift(t) }, prefilter: function (e, t) { t ? Gn.unshift(e) : Gn.push(e) } }); function nr(e, t, n) { var r, i, o, a, s, u, l, c, p, f = this, d = e.style, h = {}, g = [], m = e.nodeType && nn(e); n.queue || (c = b._queueHooks(e, "fx"), null == c.unqueued && (c.unqueued = 0, p = c.empty.fire, c.empty.fire = function () { c.unqueued || p() }), c.unqueued++, f.always(function () { f.always(function () { c.unqueued--, b.queue(e, "fx").length || c.empty.fire() }) })), 1 === e.nodeType && ("height" in t || "width" in t) && (n.overflow = [d.overflow, d.overflowX, d.overflowY], "inline" === b.css(e, "display") && "none" === b.css(e, "float") && (b.support.inlineBlockNeedsLayout && "inline" !== un(e.nodeName) ? d.zoom = 1 : d.display = "inline-block")), n.overflow && (d.overflow = "hidden", b.support.shrinkWrapBlocks || f.always(function () { d.overflow = n.overflow[0], d.overflowX = n.overflow[1], d.overflowY = n.overflow[2] })); for (i in t) if (a = t[i], Vn.exec(a)) { if (delete t[i], u = u || "toggle" === a, a === (m ? "hide" : "show")) continue; g.push(i) } if (o = g.length) { s = b._data(e, "fxshow") || b._data(e, "fxshow", {}), "hidden" in s && (m = s.hidden), u && (s.hidden = !m), m ? b(e).show() : f.done(function () { b(e).hide() }), f.done(function () { var t; b._removeData(e, "fxshow"); for (t in h) b.style(e, t, h[t]) }); for (i = 0; o > i; i++) r = g[i], l = f.createTween(r, m ? s[r] : 0), h[r] = s[r] || b.style(e, r), r in s || (s[r] = l.start, m && (l.end = l.start, l.start = "width" === r || "height" === r ? 1 : 0)) } } function rr(e, t, n, r, i) { return new rr.prototype.init(e, t, n, r, i) } b.Tween = rr, rr.prototype = { constructor: rr, init: function (e, t, n, r, i, o) { this.elem = e, this.prop = n, this.easing = i || "swing", this.options = t, this.start = this.now = this.cur(), this.end = r, this.unit = o || (b.cssNumber[n] ? "" : "px") }, cur: function () { var e = rr.propHooks[this.prop]; return e && e.get ? e.get(this) : rr.propHooks._default.get(this) }, run: function (e) { var t, n = rr.propHooks[this.prop]; return this.pos = t = this.options.duration ? b.easing[this.easing](e, this.options.duration * e, 0, 1, this.options.duration) : e, this.now = (this.end - this.start) * t + this.start, this.options.step && this.options.step.call(this.elem, this.now, this), n && n.set ? n.set(this) : rr.propHooks._default.set(this), this } }, rr.prototype.init.prototype = rr.prototype, rr.propHooks = { _default: { get: function (e) { var t; return null == e.elem[e.prop] || e.elem.style && null != e.elem.style[e.prop] ? (t = b.css(e.elem, e.prop, ""), t && "auto" !== t ? t : 0) : e.elem[e.prop] }, set: function (e) { b.fx.step[e.prop] ? b.fx.step[e.prop](e) : e.elem.style && (null != e.elem.style[b.cssProps[e.prop]] || b.cssHooks[e.prop]) ? b.style(e.elem, e.prop, e.now + e.unit) : e.elem[e.prop] = e.now } } }, rr.propHooks.scrollTop = rr.propHooks.scrollLeft = { set: function (e) { e.elem.nodeType && e.elem.parentNode && (e.elem[e.prop] = e.now) } }, b.each(["toggle", "show", "hide"], function (e, t) { var n = b.fn[t]; b.fn[t] = function (e, r, i) { return null == e || "boolean" == typeof e ? n.apply(this, arguments) : this.animate(ir(t, !0), e, r, i) } }), b.fn.extend({ fadeTo: function (e, t, n, r) { return this.filter(nn).css("opacity", 0).show().end().animate({ opacity: t }, e, n, r) }, animate: function (e, t, n, r) { var i = b.isEmptyObject(e), o = b.speed(t, n, r), a = function () { var t = er(this, b.extend({}, e), o); a.finish = function () { t.stop(!0) }, (i || b._data(this, "finish")) && t.stop(!0) }; return a.finish = a, i || o.queue === !1 ? this.each(a) : this.queue(o.queue, a) }, stop: function (e, n, r) { var i = function (e) { var t = e.stop; delete e.stop, t(r) }; return "string" != typeof e && (r = n, n = e, e = t), n && e !== !1 && this.queue(e || "fx", []), this.each(function () { var t = !0, n = null != e && e + "queueHooks", o = b.timers, a = b._data(this); if (n) a[n] && a[n].stop && i(a[n]); else for (n in a) a[n] && a[n].stop && Jn.test(n) && i(a[n]); for (n = o.length; n--;) o[n].elem !== this || null != e && o[n].queue !== e || (o[n].anim.stop(r), t = !1, o.splice(n, 1)); (t || !r) && b.dequeue(this, e) }) }, finish: function (e) { return e !== !1 && (e = e || "fx"), this.each(function () { var t, n = b._data(this), r = n[e + "queue"], i = n[e + "queueHooks"], o = b.timers, a = r ? r.length : 0; for (n.finish = !0, b.queue(this, e, []), i && i.cur && i.cur.finish && i.cur.finish.call(this), t = o.length; t--;) o[t].elem === this && o[t].queue === e && (o[t].anim.stop(!0), o.splice(t, 1)); for (t = 0; a > t; t++) r[t] && r[t].finish && r[t].finish.call(this); delete n.finish }) } }); function ir(e, t) { var n, r = { height: e }, i = 0; for (t = t ? 1 : 0; 4 > i; i += 2 - t) n = Zt[i], r["margin" + n] = r["padding" + n] = e; return t && (r.opacity = r.width = e), r } b.each({ slideDown: ir("show"), slideUp: ir("hide"), slideToggle: ir("toggle"), fadeIn: { opacity: "show" }, fadeOut: { opacity: "hide" }, fadeToggle: { opacity: "toggle" } }, function (e, t) { b.fn[e] = function (e, n, r) { return this.animate(t, e, n, r) } }), b.speed = function (e, t, n) { var r = e && "object" == typeof e ? b.extend({}, e) : { complete: n || !n && t || b.isFunction(e) && e, duration: e, easing: n && t || t && !b.isFunction(t) && t }; return r.duration = b.fx.off ? 0 : "number" == typeof r.duration ? r.duration : r.duration in b.fx.speeds ? b.fx.speeds[r.duration] : b.fx.speeds._default, (null == r.queue || r.queue === !0) && (r.queue = "fx"), r.old = r.complete, r.complete = function () { b.isFunction(r.old) && r.old.call(this), r.queue && b.dequeue(this, r.queue) }, r }, b.easing = { linear: function (e) { return e }, swing: function (e) { return .5 - Math.cos(e * Math.PI) / 2 } }, b.timers = [], b.fx = rr.prototype.init, b.fx.tick = function () { var e, n = b.timers, r = 0; for (Xn = b.now() ; n.length > r; r++) e = n[r], e() || n[r] !== e || n.splice(r--, 1); n.length || b.fx.stop(), Xn = t }, b.fx.timer = function (e) { e() && b.timers.push(e) && b.fx.start() }, b.fx.interval = 13, b.fx.start = function () { Un || (Un = setInterval(b.fx.tick, b.fx.interval)) }, b.fx.stop = function () { clearInterval(Un), Un = null }, b.fx.speeds = { slow: 600, fast: 200, _default: 400 }, b.fx.step = {}, b.expr && b.expr.filters && (b.expr.filters.animated = function (e) { return b.grep(b.timers, function (t) { return e === t.elem }).length }), b.fn.offset = function (e) { if (arguments.length) return e === t ? this : this.each(function (t) { b.offset.setOffset(this, e, t) }); var n, r, o = { top: 0, left: 0 }, a = this[0], s = a && a.ownerDocument; if (s) return n = s.documentElement, b.contains(n, a) ? (typeof a.getBoundingClientRect !== i && (o = a.getBoundingClientRect()), r = or(s), { top: o.top + (r.pageYOffset || n.scrollTop) - (n.clientTop || 0), left: o.left + (r.pageXOffset || n.scrollLeft) - (n.clientLeft || 0) }) : o }, b.offset = { setOffset: function (e, t, n) { var r = b.css(e, "position"); "static" === r && (e.style.position = "relative"); var i = b(e), o = i.offset(), a = b.css(e, "top"), s = b.css(e, "left"), u = ("absolute" === r || "fixed" === r) && b.inArray("auto", [a, s]) > -1, l = {}, c = {}, p, f; u ? (c = i.position(), p = c.top, f = c.left) : (p = parseFloat(a) || 0, f = parseFloat(s) || 0), b.isFunction(t) && (t = t.call(e, n, o)), null != t.top && (l.top = t.top - o.top + p), null != t.left && (l.left = t.left - o.left + f), "using" in t ? t.using.call(e, l) : i.css(l) } }, b.fn.extend({ position: function () { if (this[0]) { var e, t, n = { top: 0, left: 0 }, r = this[0]; return "fixed" === b.css(r, "position") ? t = r.getBoundingClientRect() : (e = this.offsetParent(), t = this.offset(), b.nodeName(e[0], "html") || (n = e.offset()), n.top += b.css(e[0], "borderTopWidth", !0), n.left += b.css(e[0], "borderLeftWidth", !0)), { top: t.top - n.top - b.css(r, "marginTop", !0), left: t.left - n.left - b.css(r, "marginLeft", !0) } } }, offsetParent: function () { return this.map(function () { var e = this.offsetParent || o.documentElement; while (e && !b.nodeName(e, "html") && "static" === b.css(e, "position")) e = e.offsetParent; return e || o.documentElement }) } }), b.each({ scrollLeft: "pageXOffset", scrollTop: "pageYOffset" }, function (e, n) { var r = /Y/.test(n); b.fn[e] = function (i) { return b.access(this, function (e, i, o) { var a = or(e); return o === t ? a ? n in a ? a[n] : a.document.documentElement[i] : e[i] : (a ? a.scrollTo(r ? b(a).scrollLeft() : o, r ? o : b(a).scrollTop()) : e[i] = o, t) }, e, i, arguments.length, null) } }); function or(e) { return b.isWindow(e) ? e : 9 === e.nodeType ? e.defaultView || e.parentWindow : !1 } b.each({ Height: "height", Width: "width" }, function (e, n) { b.each({ padding: "inner" + e, content: n, "": "outer" + e }, function (r, i) { b.fn[i] = function (i, o) { var a = arguments.length && (r || "boolean" != typeof i), s = r || (i === !0 || o === !0 ? "margin" : "border"); return b.access(this, function (n, r, i) { var o; return b.isWindow(n) ? n.document.documentElement["client" + e] : 9 === n.nodeType ? (o = n.documentElement, Math.max(n.body["scroll" + e], o["scroll" + e], n.body["offset" + e], o["offset" + e], o["client" + e])) : i === t ? b.css(n, r, s) : b.style(n, r, i, s) }, n, a ? i : t, a, null) } }) }), e.jQuery = e.$ = b, "function" == typeof define && define.amd && define.amd.jQuery && define("jquery", [], function () { return b })
})(window);

// Move jQuery to $telerik
$telerik.$ = jQuery.noConflict(true);
/* END Telerik.Web.UI.Common.jQuery.js */
/* START Telerik.Web.UI.Common.jQueryPlugins.js */
if (typeof $telerik.$ === "undefined") {
    $telerik.$ = jQuery;
    /*
     * jQuery Easing v1.3 - http://gsgd.co.uk/sandbox/jquery/easing/
     *
     * TERMS OF USE - jQuery Easing
     * 
     * Open source under the BSD License. 
     * 
     * Copyright � 2008 George McGinley Smith
     * All rights reserved.
    */
    /*
     * TERMS OF USE - EASING EQUATIONS
     * 
     * Open source under the BSD License. 
     * 
     * Copyright � 2001 Robert Penner
     * All rights reserved.
     */
} (function (a) {
    a.easing.jswing = a.easing.swing;
    a.extend(a.easing, {
        def: "easeOutQuad", swing: function (i, h, e, f, g) {
            return a.easing[a.easing.def](i, h, e, f, g);
        }, easeLinear: function (i, h, e, f, g) {
            return f * h / g + e;
        }, easeInQuad: function (i, h, e, f, g) {
            return f * (h /= g) * h + e;
        }, easeOutQuad: function (i, h, e, f, g) {
            return -f * (h /= g) * (h - 2) + e;
        }, easeInOutQuad: function (i, h, e, f, g) {
            if ((h /= g / 2) < 1) {
                return f / 2 * h * h + e;
            } return -f / 2 * ((--h) * (h - 2) - 1) + e;
        }, easeInCubic: function (i, h, e, f, g) {
            return f * (h /= g) * h * h + e;
        }, easeOutCubic: function (i, h, e, f, g) {
            return f * ((h = h / g - 1) * h * h + 1) + e;
        }, easeInOutCubic: function (i, h, e, f, g) {
            if ((h /= g / 2) < 1) {
                return f / 2 * h * h * h + e;
            } return f / 2 * ((h -= 2) * h * h + 2) + e;
        }, easeInQuart: function (i, h, e, f, g) {
            return f * (h /= g) * h * h * h + e;
        }, easeOutQuart: function (i, h, e, f, g) {
            return -f * ((h = h / g - 1) * h * h * h - 1) + e;
        }, easeInOutQuart: function (i, h, e, f, g) {
            if ((h /= g / 2) < 1) {
                return f / 2 * h * h * h * h + e;
            } return -f / 2 * ((h -= 2) * h * h * h - 2) + e;
        }, easeInQuint: function (i, h, e, f, g) {
            return f * (h /= g) * h * h * h * h + e;
        }, easeOutQuint: function (i, h, e, f, g) {
            return f * ((h = h / g - 1) * h * h * h * h + 1) + e;
        }, easeInOutQuint: function (i, h, e, f, g) {
            if ((h /= g / 2) < 1) {
                return f / 2 * h * h * h * h * h + e;
            } return f / 2 * ((h -= 2) * h * h * h * h + 2) + e;
        }, easeInSine: function (i, h, e, f, g) {
            return -f * Math.cos(h / g * (Math.PI / 2)) + f + e;
        }, easeOutSine: function (i, h, e, f, g) {
            return f * Math.sin(h / g * (Math.PI / 2)) + e;
        }, easeInOutSine: function (i, h, e, f, g) {
            return -f / 2 * (Math.cos(Math.PI * h / g) - 1) + e;
        }, easeInExpo: function (i, h, e, f, g) {
            return (h == 0) ? e : f * Math.pow(2, 10 * (h / g - 1)) + e;
        }, easeOutExpo: function (i, h, e, f, g) {
            return (h == g) ? e + f : f * (-Math.pow(2, -10 * h / g) + 1) + e;
        }, easeInOutExpo: function (i, h, e, f, g) {
            if (h == 0) {
                return e;
            } if (h == g) {
                return e + f;
            } if ((h /= g / 2) < 1) {
                return f / 2 * Math.pow(2, 10 * (h - 1)) + e;
            } return f / 2 * (-Math.pow(2, -10 * --h) + 2) + e;
        }, easeInCirc: function (i, h, e, f, g) {
            return -f * (Math.sqrt(1 - (h /= g) * h) - 1) + e;
        }, easeOutCirc: function (i, h, e, f, g) {
            return f * Math.sqrt(1 - (h = h / g - 1) * h) + e;
        }, easeInOutCirc: function (i, h, e, f, g) {
            if ((h /= g / 2) < 1) {
                return -f / 2 * (Math.sqrt(1 - h * h) - 1) + e;
            } return f / 2 * (Math.sqrt(1 - (h -= 2) * h) + 1) + e;
        }, easeInElastic: function (l, k, f, g, h) {
            var j = 1.70158;
            var i = 0;
            var e = g;
            if (k == 0) {
                return f;
            } if ((k /= h) == 1) {
                return f + g;
            } if (!i) {
                i = h * 0.3;
            } if (e < Math.abs(g)) {
                e = g;
                var j = i / 4;
            } else {
                var j = i / (2 * Math.PI) * Math.asin(g / e);
            } return -(e * Math.pow(2, 10 * (k -= 1)) * Math.sin((k * h - j) * (2 * Math.PI) / i)) + f;
        }, easeOutElastic: function (l, k, f, g, h) {
            var j = 1.70158;
            var i = 0;
            var e = g;
            if (k == 0) {
                return f;
            } if ((k /= h) == 1) {
                return f + g;
            } if (!i) {
                i = h * 0.3;
            } if (e < Math.abs(g)) {
                e = g;
                var j = i / 4;
            } else {
                var j = i / (2 * Math.PI) * Math.asin(g / e);
            } return e * Math.pow(2, -10 * k) * Math.sin((k * h - j) * (2 * Math.PI) / i) + g + f;
        }, easeInOutElastic: function (l, k, f, g, h) {
            var j = 1.70158;
            var i = 0;
            var e = g;
            if (k == 0) {
                return f;
            } if ((k /= h / 2) == 2) {
                return f + g;
            } if (!i) {
                i = h * (0.3 * 1.5);
            } if (e < Math.abs(g)) {
                e = g;
                var j = i / 4;
            } else {
                var j = i / (2 * Math.PI) * Math.asin(g / e);
            } if (k < 1) {
                return -0.5 * (e * Math.pow(2, 10 * (k -= 1)) * Math.sin((k * h - j) * (2 * Math.PI) / i)) + f;
            } return e * Math.pow(2, -10 * (k -= 1)) * Math.sin((k * h - j) * (2 * Math.PI) / i) * 0.5 + g + f;
        }, easeInBack: function (j, i, e, f, g, h) {
            if (h == undefined) {
                h = 1.70158;
            } return f * (i /= g) * i * ((h + 1) * i - h) + e;
        }, easeOutBack: function (j, i, e, f, g, h) {
            if (h == undefined) {
                h = 1.70158;
            } return f * ((i = i / g - 1) * i * ((h + 1) * i + h) + 1) + e;
        }, easeInOutBack: function (j, i, e, f, g, h) {
            if (h == undefined) {
                h = 1.70158;
            } if ((i /= g / 2) < 1) {
                return f / 2 * (i * i * (((h *= (1.525)) + 1) * i - h)) + e;
            } return f / 2 * ((i -= 2) * i * (((h *= (1.525)) + 1) * i + h) + 2) + e;
        }, easeInBounce: function (i, h, e, f, g) {
            return f - a.easing.easeOutBounce(i, g - h, 0, f, g) + e;
        }, easeOutBounce: function (i, h, e, f, g) {
            if ((h /= g) < (1 / 2.75)) {
                return f * (7.5625 * h * h) + e;
            } else {
                if (h < (2 / 2.75)) {
                    return f * (7.5625 * (h -= (1.5 / 2.75)) * h + 0.75) + e;
                } else {
                    if (h < (2.5 / 2.75)) {
                        return f * (7.5625 * (h -= (2.25 / 2.75)) * h + 0.9375) + e;
                    } else {
                        return f * (7.5625 * (h -= (2.625 / 2.75)) * h + 0.984375) + e;
                    }
                }
            }
        }, easeInOutBounce: function (i, h, e, f, g) {
            if (h < g / 2) {
                return a.easing.easeInBounce(i, h * 2, 0, f, g) * 0.5 + e;
            } return a.easing.easeOutBounce(i, h * 2 - g, 0, f, g) * 0.5 + f * 0.5 + e;
        }
    });
})($telerik.$);
/*
 * jQuery throttle / debounce - v1.1 - 3/7/2010
 * http://benalman.com/projects/jquery-throttle-debounce-plugin/
 *
 * Copyright (c) 2010 "Cowboy" Ben Alman
 * Dual licensed under the MIT and GPL licenses.
 * http://benalman.com/about/license/
 */
(function (d, c) {
    var a = $telerik.$ || d.Cowboy || (d.Cowboy = {}), b;
    a.throttle = b = function (g, i, e, f) {
        var j, h = 0;
        if (typeof i !== "boolean") {
            f = e;
            e = i;
            i = c;
        } function k() {
            var p = this, n = +new Date() - h, l = arguments;
            function o() {
                h = +new Date();
                e.apply(p, l);
            } function m() {
                j = c;
            } if (f && !j) {
                o();
            } j && clearTimeout(j);
            if (f === c && n > g) {
                o();
            } else {
                if (i !== true) {
                    j = setTimeout(f ? m : o, f === c ? g - n : g);
                }
            }
        } if (a.guid) {
            k.guid = e.guid = e.guid || a.guid++;
        } return k;
    };
    a.debounce = function (g, e, f) {
        return f === c ? b(g, e, false) : b(g, f, e !== false);
    };
})(window);
(function (b) {
    b.fx.step.height = function (e) {
        var f = $telerik.quirksMode ? 1 : 0;
        var g = e.now > f ? e.now : f;
        e.elem.style[e.prop] = Math.round(g) + e.unit;
    };
    function c(f, e) {
        return ["live", f, e.replace(/\./g, "`").replace(/ /g, "|")].join(".");
    } function a(f, e) {
        b.each(e, function (g, h) {
            if (g.indexOf("et_") > 0) {
                f[g] = h;
                return;
            } if (g == "domEvent" && h) {
                f["get_" + g] = function () {
                    return new Sys.UI.DomEvent(h.originalEvent || h.rawEvent || h);
                };
            } else {
                f["get_" + g] = function (i) {
                    return function () {
                        return i;
                    };
                }(h);
            }
        });
        return f;
    } b.extend({
        registerControlEvents: function (e, f) {
            b.each(f, function (h, g) {
                e.prototype["add_" + g] = function (i) {
                    this.get_events().addHandler(g, i);
                };
                e.prototype["remove_" + g] = function (i) {
                    this.get_events().removeHandler(g, i);
                };
            });
        }, registerControlProperties: function (e, f) {
            b.each(f, function (h, g) {
                e.prototype["get_" + h] = function () {
                    var i = this["_" + h];
                    return typeof i == "undefined" ? g : i;
                };
                e.prototype["set_" + h] = function (i) {
                    this["_" + h] = i;
                };
            });
        }, registerEnum: function (f, e, g) {
            f[e] = function () { };
            f[e].prototype = g;
            f[e].registerEnum(f.getName() + "." + e);
        }, raiseControlEvent: function (f, g, e) {
            var h = f.get_events().getHandler(g);
            if (h) {
                h(f, a(new Sys.EventArgs(), e));
            }
        }, raiseCancellableControlEvent: function (g, h, e) {
            var i = g.get_events().getHandler(h);
            if (i) {
                var f = a(new Sys.CancelEventArgs(), e);
                i(g, f);
                return f.get_cancel();
            } return false;
        }, extendEventArgs: function (e, f) {
            return a(e, f);
        }, isBogus: function (e) {
            try {
                var g = e.parentNode;
                return false;
            } catch (f) {
                return true;
            }
        }
    });
    b.eachCallback = function (e, g) {
        var f = 0;
        function h() {
            if (e.length == 0) {
                return;
            } var i = e[f];
            g.apply(i);
            f++;
            if (f < e.length) {
                setTimeout(h, 1);
            }
        } setTimeout(h, 1);
    };
    b.fn.eachCallback = function (g) {
        var e = 0;
        var f = this;
        function h() {
            if (f.length == 0) {
                return;
            } var i = f.get(e);
            g.apply(i);
            e++;
            if (e < f.length) {
                setTimeout(h, 1);
            }
        } setTimeout(h, 1);
    };
    if ($telerik.isTouchDevice) {
        var d;
        b.each(["t_touchover", "t_touchout"], function (e, f) {
            b.fn[f] = function (g) {
                return this.bind(f, g);
            };
        });
        b(document.body).bind("touchstart", function (f) {
            d = f.originalEvent.currentTarget;
        }).bind("touchmove", function (f) {
            var i = f.originalEvent.changedTouches[0], h = document.elementFromPoint(i.clientX, i.clientY);
            if (d != h) {
                var g = { target: d, relatedTarget: d, CtrlKey: false, AltKey: false, ShiftKey: false };
                b(d).trigger("t_touchout", g);
                d = h;
                b(d).trigger("t_touchover", b.extend(g, { target: d, relatedTarget: d }));
            }
        });
    }
})($telerik.$);
/*
* jQuery Double Tap Plugin.
*
* Copyright (c) 2010 Raul Sanchez (http://www.appcropolis.com)
*
* Dual licensed under the MIT and GPL licenses:
* http://www.opensource.org/licenses/mit-license.php
* http://www.gnu.org/licenses/gpl.html
*/
(function (a) {
    a.fn.doubletap = function (e, f, c) {
        var d, b;
        c = c == null ? 500 : c;
        d = $telerik.isTouchDevice ? "touchend" : "click";
        a(this).bind(d, function (h) {
            var j = new Date().getTime();
            var i = a(this).data("lastTouch") || j + 1;
            var g = j - i;
            clearTimeout(b);
            if (g < 500 && g > 0) {
                if (e != null && typeof e == "function") {
                    e(h);
                }
            } else {
                a(this).data("lastTouch", j);
                b = setTimeout(function (k) {
                    if (f != null && typeof f == "function") {
                        f(k);
                    } clearTimeout(b);
                }, c, [h]);
            } a(this).data("lastTouch", j);
        });
    };
})($telerik.$);

/* END Telerik.Web.UI.Common.jQueryPlugins.js */
/* START Telerik.Web.UI.RibbonBar.RadRibbonBarScripts.js */
$telerik.findRibbonBar = $find;
$telerik.toRibbonBar = function (a) {
    return a;
};
(function (a) {
    Type.registerNamespace("Telerik.Web.UI");
    var d = Telerik.Web.UI;
    var c = Sys.Serialization.JavaScriptSerializer;
    var b = a(document), l = ".", k = ",", H = "px", T = true, F = false, I = "RadRibbonBar", J = "rrbExtendedChrome", K = "rrbMinimized", L = "rrbExtendedChromeMinimized", e = "rrbHoveredApplicationTab", f = "rrbMIHovered", P = "rrbTabs", O = "rrbTab", Q = "rrbTabLabel", g = "rrbButtonArea", h = "rrbButtonAreaIn", m = "rrbButtonGroup", p = "rrbButtonGroupHover", n = "rrbCollapsedGroup", o = "rrbHiddenGroup", M = "rrbButton", C = "rrbMediumButton", A = "rrbLargeButton", N = "rrbSplitButton", i = "rrbButtonStrip", j = "rrbButtonStripPart", D = "rrbMenuButton", E = "rrbMenuGroupOut", R = "rrbTemplateItem", B = "rrbTemplateItemLarge", G = ":not(.rrbDisabled)", S = ":visible";
    d.RadRibbonBar = function (U) {
        d.RadRibbonBar.initializeBase(this, [U]);
        this._toggledIndices = [];
        this._toggledIndicesJson = "[]";
        this._selectedTab = null;
        this._selectedTabIndex = -1;
        this._splitButtonsWithChangedSelection = [];
        this._splitButtonSelectedButtonIndicesJson = "[]";
        this._enabledItems = [];
        this._enabledItemsJson = "[]";
        this._disabledItems = [];
        this._disabledItemsJson = "[]";
        this._comboBoxSelectedIndices = [];
        this._comboBoxSelectedIndicesJson = "[]";
        this._dropDownSelectedIndices = [];
        this._dropDownSelectedIndicesJson = "[]";
        this._colorPickerColorIndices = [];
        this._colorPickerColorIndicesJson = "[]";
        this._gallerySelectedIndices = [];
        this._gallerySelectedIndicesJson = "[]";
        this._uniqueId = "";
        this._postBackOnSelectedTabChange = false;
        this._postBackOnButtonClick = false;
        this._postBackOnSplitButtonClick = false;
        this._postBackOnMenuItemClick = false;
        this._postBackOnLauncherClick = false;
        this._postBackOnButtonToggle = false;
        this._postBackOnToggleListToggle = false;
        this._postBackOnApplicationMenuItemClick = false;
        this._postBackOnComboBoxSelectedIndexChanged = false;
        this._postBackOnComboBoxTextChanged = false;
        this._postBackOnDropDownSelectedIndexChanged = false;
        this._postBackOnNumericTextBoxValueChanged = false;
        this._postBackOnColorPickerColorChanged = false;
        this._postBackOnGalleryCommand = false;
        this._postBackOnCommand = false;
        this._postBackReference = "";
        this._enableScreenBoundaryDetection = true;
        this._expandDelay = 300;
        this._collapseDelay = 300;
        this._enabled = true;
        this._visible = true;
        this._resizeInterval = 0;
        this._toolTipHoverDelay = 650;
        this._toolTipPossitionOffsetLeft = -4;
        this._toolTipPossitionOffsetTop = 20;
        this._smallButtonCssClass = ".rrbButton";
        this._mediumButtonCssClass = ".rrbMediumButton";
        this._largeButtonCssClass = ".rrbLargeButton";
        this._splitButtonCssClass = ".rrbSplitButton";
        this._buttonStripCssClass = ".rrbButtonStrip";
        this._buttonStripPartCssClass = ".rrbButtonStripPart";
        this._buttonGuideCssClass = ".rrbButtonGuide";
        this._buttonTextCssClass = ".rrbButtonText";
        this._buttonOutCssClass = ".rrbButtonOut";
        this._buttonMidCssClass = ".rrbButtonMid";
        this._buttonTextHoverCssClass = ".rrbButtonTextHover";
        this._collapsedGroupCssClass = ".rrbCollapsedGroup";
        this._templateItemCssClass = ".rrbTemplateItem";
        this._templateItemLargeCssClass = ".rrbTemplateItemLarge";
        this._skin = null;
        this._tabs = new Telerik.Web.UI.RibbonBarTabCollection(this);
        this._pageGroups = null;
        this._pageViews = null;
        this._tabsLabelElements = null;
        this._tabsContainerElement = false;
        this._detachedGroup = null;
        this._parentElement = false;
        this._groupContainer = false;
        this._navigator = null;
        this._navigationSettings = {};
        this._escapeKeyCode = 27;
        this._$element = a(this._element);
        this._quickAccessToolbar = null;
        this._enableMinimizing = false;
        this._minimized = false;
        this._enableAutoArrange = true;
        this._minWidth = 0;
    };
    d.RadRibbonBar._typeEventDictionary = { "Telerik.Web.UI.RibbonBarButton": "ButtonClick", "Telerik.Web.UI.RibbonBarToggleList": "ToggleListToggle", "Telerik.Web.UI.RibbonBarMenu": "MenuItemClick", "Telerik.Web.UI.RibbonBarSplitButton": "SplitButtonClick", "Telerik.Web.UI.RibbonBarToggleButton": "ToggleButtonClick", "Telerik.Web.UI.RibbonBarDropDown": "DropDownItemClick", "Telerik.Web.UI.RibbonBarComboBox": "ComboBoxItemClick", "Telerik.Web.UI.RibbonBarNumericTextBox": "NumerixTextBoxButtonClick", "Telerik.Web.UI.RibbonBarColorPicker": "ColorPickerItemClick", "Telerik.Web.UI.RibbonBarGallery": "GalleryItemClick" };
    d.RadRibbonBar._preInitialize = function (V) {
        var X = document.getElementById(V), U = a(X), W = U.data("isInitialized");
        if (W || W == undefined) {
            return;
        } U.find(l + h).get(0).style.visibility = "hidden";
    };
    d.RadRibbonBar.get_eventName = function (U) {
        return d.RadRibbonBar._typeEventDictionary[U];
    };
    function u(U) {
        return (!w(U) && !v(U) && !x(U) && !z(U) && !r(U) && !s(U) && !y(U) && !q(U) && !t(U));
    } function x(U) {
        return a(U).find("span.rrbToggleButton").length > 0;
    } function w(U) {
        return a(U).find("span.rrbSplitButton").length > 0;
    } function v(U) {
        return a(U).find("span.rrbMenuButton").length > 0;
    } function z(U) {
        return a(U).hasClass("rrbTemplateItem") || a(U).hasClass("rrbTemplateItemLarge");
    } function r(U) {
        return a(U).hasClass("rrbComboBox");
    } function s(U) {
        return a(U).hasClass("rrbDropDown");
    } function y(U) {
        return a(U).hasClass("rrbNumericTextBox");
    } function q(U) {
        return a(U).hasClass("rrbColorPicker");
    } function t(U) {
        return a(U).hasClass("rrbGallery");
    } d.RadRibbonBar.prototype = {
        initialize: function () {
            d.RadRibbonBar.callBaseMethod(this, "initialize");
            var V = this, W = V._element, U = V._$element, X;
            U.data("width", U.width());
            this._updateToggledIndicesJson();
            if ($telerik.isIE7) {
                U.find("img").attr("title", "");
            } U.find(l + E).each(function () {
                var aa = a(this);
                var Z = aa.prev();
                var Y = null;
                Z.get(0)._dropDown = aa.get(0);
                aa.get(0)._button = Z;
                if (Z.children(".rrbButtonMid").hasClass("rrbSplitButton")) {
                    Y = Z.children(".rrbButtonMid").find(".rrbButtonText");
                } aa.appendTo(W);
                if (Y == null) {
                    Y = Z;
                } if (Y.parent().hasClass("rrbMenuGroupIn")) {
                    Y.bind("mouseenter", function (ac) {
                        if (aa.is(":visible")) {
                            return;
                        } var ab = V._getRelativeOffset(Y, V._$element);
                        aa.stop(true, true).show();
                        var ad = V._getDropDownWidth(aa);
                        aa.children().width(ad);
                        aa.css({ left: ab.left + Y.outerWidth(true) - 2, top: ab.top });
                        if (!aa[0]._button.hasClass("rrbExpanded")) {
                            aa[0]._button.addClass("rrbExpanded");
                        } aa.width(ad);
                    });
                } else {
                    Y.bind("click", function (ac) {
                        if (Z.hasClass("rrbDisabled")) {
                            return;
                        } V._hideMenus();
                        if (V.get_quickAccessToolbar()) {
                            V.get_quickAccessToolbar().hideDropDown();
                        } var ab = V._getRelativeOffset(Y, V._$element);
                        aa.stop(true, true).show();
                        var ad = aa.height();
                        var ae = V._getDropDownWidth(aa);
                        aa.width(ae);
                        aa.css({ left: ab.left - 1, top: ab.top + Y.outerHeight() });
                        if (!aa[0]._button.hasClass("rrbExpanded")) {
                            aa[0]._button.addClass("rrbExpanded");
                        } aa.height(ad);
                        ac.preventDefault();
                        ac.stopImmediatePropagation();
                        V._hideApplicationMenu();
                    });
                }
            });
            if (this._tabsContainerElement) {
                return;
            } this._tabsContainerElement = U.find(l + P).get(0);
            if (!this._tabsContainerElement) {
                return;
            } this._initializeApplicationMenu();
            this._initializeTabs();
            if (this._tabs._array.length == 0) {
                return;
            } X = this._tabs.getTab(this.get_selectedTabIndex());
            if (this._minimized && !this._isMinimizedAndVisible()) {
                a(X.get_element()).removeClass("rrbSelectedTab");
            } this._initializeContextualTabGroups();
            this._initializeGroups();
            if (this._qatItemsHierarchicalIndices) {
                this._initializeQuickAccessToolbar();
            } this._initializePage(X);
            this._initializeEvents();
            this._initializeKeyboardNavigation();
            this._initializeToolTIp();
            this._initializeResizing();
            U.data("isInitialized", true);
            a.raiseControlEvent(this, "load", {});
        }, _initializeToolTIp: function () {
            var U = a(this._element);
            this._toolTip = new d.RibbonBarToolTip(U.find(".rrbToolTip").get(0));
        }, _getToolTip: function () {
            return this._toolTip;
        }, _initializeKeyboardNavigation: function () {
            if (this._$element.attr("tabIndex") >= 0 || this._$element.attr("accessKey") != undefined) {
                this._navigator = new d.RadRibbonBar.Navigator(this);
                this._navigator.initialize();
            }
        }, _initializeEvents: function () {
            var W = this, U = W._$element, X = null;
            b.bind("keydown." + this._uniqueId, function (Y) {
                W._onDocumentKeyDown(Y);
            });
            U.find(".rrbSplitButton .rrbButtonText").each(function () {
                var Y = a(this);
                if (Y.parents().hasClass("rrbDisabled")) {
                    return;
                } Y.bind({
                    mouseenter: function () {
                        var Z = a(this);
                        if (!Z.hasClass("rrbButtonTextHover")) {
                            Z.addClass("rrbButtonTextHover");
                        }
                    }, mouseleave: function () {
                        var Z = a(this);
                        if (Z.hasClass("rrbButtonTextHover")) {
                            Z.removeClass("rrbButtonTextHover");
                        }
                    }
                });
            });
            U.find(".rrbButtonOut:not(.rrbButtonStrip), .rrbSplitButton .rrbButtonText, .rrbSplitButton .rrbImagePlaceholder, .rrbNumericTextBox, .rrbColorPicker, .rrbComboBox, .rrbDropDown,.rrbButtonStripPart").on({
                mouseenter: function (Z) {
                    var aa = this, Y = W._getToolTipData(aa);
                    if (Y && Y.shouldDisplayToolTip) {
                        X = setTimeout(function () {
                            W._showToolTip(Y.toolTipTextItem, Y.toolTipPositionItem, Y.isDropDownItem);
                        }, W._toolTipHoverDelay);
                    }
                }, mouseleave: function (Y) {
                    clearTimeout(X);
                    if (W._toolTip) {
                        W._toolTip._hide();
                    }
                }
            });
            var V = {
                mousedown: function (Y) {
                    var Z = a(this);
                    if (Z.hasClass("rrbGalleryItem")) {
                        Z.addClass("rrbGalleryItemSelected");
                        this._button._setHighlighted(false);
                    } else {
                        if (Z.hasClass("rrbGalleryAction")) {
                            Z.addClass("rrbGalleryActionSelected");
                            Z.removeClass("rrbGalleryActionHovered");
                        } else {
                            if (!Z.hasClass("rrbButtonClicked") && !Z.hasClass("rrbButtonStrip")) {
                                Z.addClass("rrbButtonClicked");
                            }
                        }
                    }
                    //bug: element move if focus();
                    //Z.focus();
                    Y.preventDefault();
                    Y.stopImmediatePropagation();
                }, mouseup: function (Y) {
                    var Z = a(this);
                    if (Z.hasClass("rrbGalleryItem")) {
                        Z.removeClass("rrbGalleryItemSelected");
                        this._button._setHighlighted(true);
                    } else {
                        if (Z.hasClass("rrbGalleryAction")) {
                            Z.removeClass("rrbGalleryActionSelected");
                            Z.addClass("rrbGalleryActionHovered");
                        } else {
                            if (Z.hasClass("rrbButtonClicked") && !Z.hasClass("rrbButtonStrip")) {
                                Z.removeClass("rrbButtonClicked");
                            }
                        }
                    } Y.preventDefault();
                    Y.stopImmediatePropagation();
                }, mouseenter: function (Z) {
                    var Y = a(this);
                    if (Y.hasClass("rrbListItem") || Y.hasClass("rrbCPColorBox")) {
                        Y.parent().parent().find(".rrbListItemHovered").removeClass("rrbListItemHovered");
                        Y.addClass("rrbListItemHovered");
                        return;
                    } else {
                        if (Y.hasClass("rrbGalleryAction")) {
                            Y.addClass("rrbGalleryActionHovered");
                            return;
                        } else {
                            if (Y.hasClass("rrbGalleryItem")) {
                                this._button._setHighlighted(true);
                                W._onGalleryItemPreview(this._button);
                                return;
                            } else {
                                if (!Y.parent().hasClass("rrbMenuGroupIn")) {
                                    return;
                                }
                            }
                        }
                    } var aa = Y.prevAll(".rrbButtonOut").add(Y.nextAll(".rrbButtonOut"));
                    if (aa.length) {
                        aa.each(function () {
                            var ac = a(this._dropDown);
                            var ab = a(this);
                            if (ac.is(":visible")) {
                                if (ab.hasClass("rrbExpanded")) {
                                    ab.removeClass("rrbExpanded");
                                } ac.stop(true, true).animate({ width: 0 }, "fast", function () {
                                    ac.hide();
                                });
                            }
                        });
                    }
                }, mouseleave: function () {
                    var Y = a(this);
                    if (Y.hasClass("rrbListItemHovered")) {
                        Y.removeClass("rrbListItemHovered");
                    } else {
                        if (Y.hasClass("rrbGalleryAction")) {
                            Y.removeClass("rrbGalleryActionSelected");
                            Y.removeClass("rrbGalleryActionHovered");
                        } else {
                            if (Y.hasClass("rrbGalleryItem")) {
                                if (!this._button._selected) {
                                    Y.removeClass("rrbGalleryItemSelected");
                                } this._button._setHighlighted(false);
                                W._onGalleryItemPreviewEnd(this._button);
                            } else {
                                if (Y.hasClass("rrbButtonClicked") && !Y.hasClass("rrbButtonStrip")) {
                                    Y.removeClass("rrbButtonClicked");
                                }
                            }
                        }
                    }
                }, click: function (Z) {
                    var Y = a(this), aa = Y.parent().hasClass("rrbMenuGroupIn");
                    W._hideMenus();
                    if (W.get_quickAccessToolbar()) {
                        W.get_quickAccessToolbar().hideDropDown();
                    } if (!aa) {
                        Z.preventDefault();
                    } Z.stopImmediatePropagation();
                    W._hideApplicationMenu();
                    if (this._defaultButton) {
                        W._onAnyButtonClick(this._defaultButton, Z);
                    } else {
                        if (this._button) {
                            W._onAnyButtonClick(this._button, Z);
                        } else {
                            if (Y.hasClass("rrbCPColorBox")) {
                                W._onColorPickerItemClick(this, Z);
                            } else {
                                if (Y.hasClass("rrbGalleryAction")) {
                                    W._onGalleryActionClick(this, Z);
                                }
                            }
                        }
                    }
                }
            };
            U.delegate(".rrbButtonOut:not(.rrbDisabled), .rrbButtonStripPart:not(.rrbDisabled), .rrbGallery:not(.rrbDisabled) .rrbGalleryAction", V);
            a(document).delegate(".rrbListItem:not(.rrbDisabled), .rrbCPColorBox, .rrbGallery:not(.rrbDisabled) .rrbGalleryItem", V).delegate(".rrbGalleryScrollWrap", "mousedown", function (Y) {
                Y.stopPropagation();
            });
            U.delegate(".rrbComboBox:not(.rrbDisabled) .rrbActionButton, .rrbNumericTextBox:not(.rrbDisabled) .rrbActionButton, .rrbColorPicker:not(.rrbDisabled) .rrbActionButton, .rrbDropDown:not(.rrbDisabled) .rrbDDInner", {
                mousedown: function (Z) {
                    var Y = a(this);
                    if (Y.hasClass("rrbDDInner")) {
                        Y = Y.find(".rrbActionButton");
                    } Y.focus();
                    Z.preventDefault();
                    Z.stopImmediatePropagation();
                }, click: function (ac) {
                    W._hideMenus();
                    if (W.get_quickAccessToolbar()) {
                        W.get_quickAccessToolbar().hideDropDown();
                    } W._hideApplicationMenu();
                    var Z = a(this), aa = Z.hasClass("rrbDDInner") ? this.parentNode._button : this.parentNode.parentNode._button, Y = a(aa.get_element()), ab = aa._popup;
                    if (Z.parent().hasClass("rrbNTBInner")) {
                        if (Z.hasClass("rrbActionButtonUp")) {
                            aa.increment();
                        } else {
                            aa.decrement();
                        }
                    } else {
                        if (ab) {
                            if (a(ab._element).is(":visible")) {
                                W._activeDropDownItem = null;
                                ab.hide();
                            } else {
                                if (!Y.hasClass("rrbComboBox")) {
                                    W._activeDropDownItem = aa;
                                } else {
                                    Y.find(".rrbCBInput").focus();
                                } ab.show(aa.get_element());
                            }
                        }
                    }
                }
            });
            U.delegate(".rrbComboBox .rrbCBInput", {
                focus: function (Y) {
                    W._comboBoxOldText = Y.target.value;
                }, change: function (Z) {
                    var Y = a(Z.target).parents(".rrbComboBox")[0]._button;
                    if (!Z.target.value) {
                        Y._updateInputElement(W._comboBoxOldText);
                    } else {
                        Y.set_text(Z.target.value);
                    } W._comboBoxOldText = "";
                }, keydown: function (aa) {
                    var Y = a(aa.target).parents(".rrbComboBox")[0]._button, Z = Y._popup;
                    switch (aa.keyCode) {
                        case Sys.UI.Key.enter: aa.preventDefault();
                            Y._selectHighlightedItem();
                            Y._popup.hide();
                            break;
                        case Sys.UI.Key.up: aa.preventDefault();
                            if (!a(Z._element).is(":visible")) {
                                Z.show(Y.get_element());
                            } Y.highlightPrev();
                            break;
                        case Sys.UI.Key.down: aa.preventDefault();
                            if (!a(Z._element).is(":visible")) {
                                Z.show(Y.get_element());
                            } Y.highlightNext();
                            break;
                        default: Y._popup.hide();
                    }
                }
            });
            U.delegate(".rrbNumericTextBox .rrbNTBInput", {
                focus: function (Y) {
                    var Z = Y.target, aa = a(Z).parents(".rrbNumericTextBox")[0]._button, ab = aa.get_value();
                    if (a(Z).attr("readonly") != "readonly") {
                        W._numericTextBoxOldValue = ab;
                        Z.value = ab;
                        Z.select();
                    }
                }, blur: function (Y) {
                    var Z = Y.target, ab = a(Z).parents(".rrbNumericTextBox")[0]._button, aa = Z.value;
                    if (a(Z).attr("readonly") != "readonly") {
                        if (aa != W._numericTextBoxOldValue) {
                            ab.set_value(aa);
                            W._numericTextBoxOldValue = "";
                        } else {
                            ab._updateInputElement();
                        }
                    }
                }, keydown: function (Y) {
                    var aa = Y.keyCode, Z = Y.target, ac = a(Z).parents(".rrbNumericTextBox")[0]._button, ab;
                    if (a(Z).attr("readonly") == "readonly") {
                        return;
                    } if (aa == Sys.UI.Key.up) {
                        ab = ac._getNextValue(true);
                    } else {
                        if (aa == Sys.UI.Key.down) {
                            ab = ac._getNextValue(false);
                        }
                    } if (ab || ab === 0) {
                        this.value = ab;
                        ac._value = ab;
                    }
                }
            });
            a(document).bind("mousedown", function (Z) {
                if (W._detachedGroup) {
                    W._detachedGroup._attachGroup();
                } W._detachedGroup = null;
                var Y = a(Z.target), aa = (Y.parents(".rrbButtonArea").length == 0 && !Y.hasClass("rrbButtonArea") && Y.parents(".rrbTab").length == 0 && !Y.hasClass("rrbResizeHandle") && !Y.hasClass("rrbToggleHandle"));
                if (W._isMinimizedAndVisible() && aa) {
                    W._setButtonAreaVisibility(false);
                } W._hideMenus();
                W._hideApplicationMenu();
                if (a(Z.target).parents(".rrbSlide").length == 0 && W.get_quickAccessToolbar()) {
                    W.get_quickAccessToolbar().hideDropDown();
                }
            });
            U.delegate(".rrbToggleHandle", {
                click: function (Y) {
                    if (W._isMinimizedAndVisible()) {
                        W._minimized = false;
                        W.updateClientState();
                        return;
                    } W.set_minimized(!W.get_minimized());
                }
            });
        }, _getToolTipData: function (W) {
            var U = a(W), ac = U.parents(".rrbSplitButton").get(0), Y = U.parent().hasClass("rrbMenuGroupIn"), X = U.hasClass("rrbComboBox"), Z = U.parents(".rrbQatItem").get(0), ae, ad, V = { shouldDisplayToolTip: true };
            if (U.children().first().hasClass("rrbSplitButton") || Z || X && !W._button.get_toolTip()) {
                V.shouldDisplayToolTip = false;
                return V;
            } if (ac) {
                if (ac.parentNode.title) {
                    V.shouldDisplayToolTip = false;
                    return V;
                } var ab = ac.parentNode._splitButton, aa = ab.get_items().getItem(ab.get_selectedButtonIndex());
                ad = ab;
                ae = a(W).hasClass("rrbButtonText") ? ab : aa;
            } else {
                ae = ad = W._button || W._menu;
            } if (!ae || ae.get_element().title || !ae.get_text() && !ae.get_toolTip()) {
                V.shouldDisplayToolTip = false;
                return V;
            } V.toolTipTextItem = ae;
            V.toolTipPositionItem = ad;
            V.isDropDownItem = Y;
            return V;
        }, _showToolTip: function (Y, X, W) {
            if (!this._toolTip || !this.get_element()) {
                return;
            } var Z = this._toolTip, aa = Z._element.style, U = a(X.get_element()).offset(), V = a(this.get_element()).offset(), ab = Y.get_text().replace(new RegExp("<br */>", "g"), "");
            if (a(Y.get_element()).hasClass("rrbComboBox")) {
                ab = "";
            } Z._setTitle(ab);
            Z._setText(this._htmlEncode(Y.get_toolTip()));
            aa.left = (U.left - V.left + this._toolTipPossitionOffsetLeft) + "px";
            if (W) {
                aa.top = (U.top - V.top + this._toolTipPossitionOffsetTop) + "px";
            } Z._show();
        }, _htmlEncode: function (W) {
            if (!W) {
                return;
            } var U = { "&": "&amp;", "<": "&lt;", ">": "&gt;" };
            for (var V in U) {
                W = W.replace(new RegExp(V, "g"), U[V]);
            } W = W.replace(new RegExp("&lt;br */&gt;", "g"), "<br />");
            return W;
        }, _getTabLabelElements: function () {
            if (!this._tabsLabelElements) {
                this._tabsLabelElements = a(this._tabsContainerElement).find(".rrbTab > .rrbTabLabel");
            } return this._tabsLabelElements;
        }, findTabByDomElement: function (U) {
            var V = false;
            var W = a(U).parents(l + O).get(0);
            if (W) {
                var X = a(this._tabsContainerElement).find(l + O);
                var Y = a.inArray(W, X);
                if (Y > -1) {
                    V = this.get_tabs().getTab(Y);
                }
            } return V;
        }, _isMinimizedAndVisible: function () {
            return this._minimized && !this._$element.hasClass(K);
        }, _setButtonAreaVisibility: function (V) {
            var U = this._$element;
            if (U.hasClass(J)) {
                this._$element.toggleClass(L, !V);
            } this._$element.toggleClass(K, !V);
            if (this.get_selectedTab()) {
                a(this.get_selectedTab().get_element()).toggleClass("rrbSelectedTab", V);
            } if (V) {
                if (this.get_selectedTab()) {
                    this._initializePage(this.get_selectedTab());
                } this.repaint();
            }
        }, get_minimized: function () {
            return this._minimized;
        }, set_minimized: function (X) {
            if (!this._enableMinimizing || this._minimized == X) {
                return;
            } var V = this, U = X ? "minimiz" : "maximiz", W = function (Y) {
                V._minimized = Y;
                V._setButtonAreaVisibility(!Y);
                V.updateClientState();
            };
            this._raiseEvent(U, X, {}, false, W);
        }, maximize: function () {
            this.set_minimized(false);
        }, minimize: function () {
            this.set_minimized(true);
        }, get_selectedTabIndex: function () {
            if (this._selectedTabIndex < 0) {
                if (this._tabsContainerElement) {
                    var V = a(this._tabsContainerElement).find(l + O);
                    if (V.length > 0) {
                        var U = a(this._tabsContainerElement).find(".rrbTab.rrbSelectedTab").get(0);
                        this._selectedTabIndex = a.inArray(U, V);
                        this.updateClientState();
                    }
                }
            } return this._selectedTabIndex;
        }, get_selectedTab: function () {
            var U = this._selectedTab;
            if (!U) {
                var V = this.get_selectedTabIndex();
                if (V > -1) {
                    var W = this.get_tabs();
                    U = W.getTab(V);
                    this._selectedTab = U;
                }
            } return U;
        }, _findItemByPropertyGeneric: function (Y, ab, U) {
            var aa = this._tabs;
            for (var V = 0, X = aa.get_count() ;
            V < X;
            V++) {
                var Z = aa.getTab(V), W = Z._findItemByPropertyGeneric(Y, ab, U);
                if (W) {
                    return W;
                }
            } return null;
        }, findItemByText: function (U) {
            return this._findItemByPropertyGeneric("Text", U);
        }, findItemByCommandName: function (U) {
            return this._findItemByPropertyGeneric("CommandName", U);
        }, findItemByCommandArgument: function (U) {
            return this._findItemByPropertyGeneric("CommandArgument", U);
        }, findItemByAttribute: function (U, V) {
            return this._findItemByPropertyGeneric("Attribute", U, V);
        }, _findByValueInTabsGeneric: function (aa, Z) {
            var Y = this._tabs;
            var V = Y.get_count();
            for (var U = 0;
            U < V;
            U++) {
                var X = Y.getTab(U);
                var W = X["find" + Z + "ByValue"](aa);
                if (W) {
                    return W;
                }
            } return null;
        }, findTabByValue: function (Y) {
            var X = this._tabs;
            var V = X.get_count();
            for (var U = 0;
            U < V;
            U++) {
                var W = X.getTab(U);
                if (W.get_value() == Y) {
                    return W;
                }
            } return null;
        }, findGroupByValue: function (U) {
            return this._findByValueInTabsGeneric(U, "Group");
        }, findButtonByValue: function (U) {
            return this._findByValueInTabsGeneric(U, "Button");
        }, findToggleButtonByValue: function (U) {
            return this._findByValueInTabsGeneric(U, "ToggleButton");
        }, findMenuItemByValue: function (U) {
            return this._findByValueInTabsGeneric(U, "MenuItem");
        }, get_applicationMenuDropDown: function () {
            return this.get_applicationMenu();
        }, _hideApplicationMenu: function () {
            var U = this.get_applicationMenu();
            if (U) {
                U.hide();
            }
        }, _hideApplicationMenuByStep: function () {
            var U = this.get_applicationMenu();
            if (U) {
                if (a(U.get_dropDownElement()).find(".rrbMIExpanded").length > 0) {
                    U._hideSplitMenuItems();
                } else {
                    U.hide();
                }
            }
        }, _initializeApplicationMenu: function () {
            var U = a(this._tabsContainerElement).find(".rrbApplicationTab")[0], X = this, W;
            if (!U) {
                return;
            } this._applicationMenu = new d.RibbonBarApplicationMenu(U);
            this._applicationMenu.initialize(this);
            W = this._applicationMenu.get_dropDownElement();
            var V = a(W).find(".rrbApplicationMenu>.rrbMenuGroup");
            this._initializeApplicationMenuItems(V, this._applicationMenu.get_items(), this.get_applicationMenuData());
            a(U).on({
                click: function (Y) {
                    $telerik.cancelRawEvent(Y);
                    X._applicationMenu.toggle();
                }, mouseenter: function (Y) {
                    a(this).addClass(e);
                }, mouseleave: function (Y) {
                    a(this).removeClass(e);
                }, mousedown: function (Y) {
                    Y.stopPropagation();
                }
            });
            a(W).on({
                mouseenter: function (Y) {
                    X._onApplicationMenuItemMouseEnter(Y);
                }, mouseleave: function (Y) {
                    X._onApplicationMenuItemMouseLeave(Y);
                }, click: function (Y) {
                    Y.stopPropagation();
                    if (!a(this).hasClass("rrbDisabled")) {
                        X._onApplicationMenuItemClick(Y);
                    }
                }
            }, ".rrbMenuItem").on({
                click: function (Y) {
                    Y.stopPropagation();
                    var Z = a(this).parents(".rrbMenuItem")[0]._button;
                    if (Z && Z.get_enabled()) {
                        clearTimeout(X._applicationMenuItemHoverTimer);
                        Z.open();
                    }
                }
            }, ".rrbMIToggle");
            a(W).on("mousedown", function (Y) {
                Y.stopPropagation();
            });
        }, _initializeApplicationMenuItems: function (U, V, W) {
            var X = this;
            a(U).children("li").each(function (Y) {
                var aa, Z = a(this).hasClass("rrbSplitMenuItem");
                if (Z) {
                    aa = new d.RibbonBarApplicationSplitMenuItem(this);
                } else {
                    aa = new d.RibbonBarApplicationMenuItem(this);
                } V.add(aa);
                aa.initialize(W[Y]);
                aa._setRibbonBar(X);
                if (Z) {
                    var ab = a(this).find(".rrbMenuGroup")[0];
                    X._initializeApplicationMenuItems(ab, aa.get_items(), W[Y].items);
                }
            });
        }, _onApplicationMenuItemMouseEnter: function (U) {
            var V = U.currentTarget._button;
            if (!a(U.currentTarget).hasClass("rrbDisabled")) {
                a(U.currentTarget).addClass(f);
            } if (V.get_splitMenuItem && V.get_splitMenuItem()) {
                return;
            } this._applicationMenuItemHoverTimer = setTimeout(function (W) {
                V.get_owner()._hideSplitMenuItems();
                if (V.open && V.get_enabled()) {
                    V.open();
                }
            }, 300);
        }, _onApplicationMenuItemMouseLeave: function (U) {
            a(U.currentTarget).removeClass(f);
            clearTimeout(this._applicationMenuItemHoverTimer);
        }, _onApplicationMenuItemClick: function (X) {
            var Y = X.currentTarget._button, U = Y.get_owner(), V = { applicationMenu: U, item: Y, domEvent: X };
            var W = a.raiseCancellableControlEvent(this, "applicationMenuItemClicking", V);
            if (W) {
                return;
            } a.raiseControlEvent(this, "applicationMenuItemClicked", V);
            U.hide();
            if (this._postBackOnApplicationMenuItemClick || this._postBackOnCommand) {
                this.postback("-" + Y.get_hierarchicalIndex());
            }
        }, _initializeTabs: function () {
            var W = this, Y = a(W._tabsContainerElement).find(l + O).get();
            tabData = W.get_tabData(), minWidth = 0;
            a(W._tabsContainerElement).delegate(".rrbTab > .rrbTabLabel", {
                click: function (aa) {
                    var Z = W.findTabByDomElement(aa.target);
                    if (Z) {
                        W._onTabClick(Z, aa);
                        $telerik.cancelRawEvent(aa);
                        W._hideApplicationMenu();
                    }
                }, mouseenter: function (Z) {
                    var aa = this.parentNode;
                    a(aa).addClass("rrbHoveredTab");
                }, mouseleave: function (Z) {
                    var aa = this.parentNode;
                    a(aa).removeClass("rrbHoveredTab");
                }
            });
            for (var V = 0, U = Y.length;
            V < U;
            V++) {
                var X = new d.RibbonBarTab(Y[V]);
                X.set_text(X.get_text());
                if (tabData[V].value) {
                    X.set_value(tabData[V].value);
                } this._tabs.add(X);
                minWidth += a(X._element).outerWidth(true);
            } minWidth += 10;
            a(W._tabsContainerElement).width(minWidth);
            minWidth = a(W._tabsContainerElement).outerWidth(true);
            a(W._tabsContainerElement).width("auto");
            minWidth = Math.max(minWidth, W._minWidth);
            W._minWidth = minWidth;
        }, _getNavigator: function () {
            return this._navigator;
        }, _getPageViewElements: function () {
            return this._pageViews;
        }, _setPageViewElements: function () {
            this._pageViews = this._$element.find(".rrbButtonArea > .rrbButtonAreaIn").get();
        }, _initializeGroups: function () {
            var ad = this, U = ad._$element;
            var W = ad.get_groupData();
            ad._setPageViewElements();
            U.delegate(l + m, {
                mouseenter: function () {
                    var ah = this;
                    a(ah).addClass(p);
                }, mouseleave: function () {
                    var ah = this;
                    a(ah).removeClass(p);
                }
            });
            for (var Z = 0, ab = W.length;
            Z < ab;
            Z++) {
                var ag = W[Z], aa = ag.index.split(":"), af = aa[0], ae = ad._tabs.getTab(af), ac = ad._pageViews[af], Y = aa[1], X = a(ac).find(l + m).get(Y), V = new d.RibbonBarGroup(X);
                ae.set_pageView(ac);
                ae.get_groups().add(V);
                V.initialize();
                V.set_collapsedImageUrl(ag.collapsedImageUrl);
                if (ag.value) {
                    V.set_value(ag.value);
                } ad._initializeItems(V, W[Z].itemData);
                if (W[Z].toggleListData) {
                    ad._initializeToggleLists(V, W[Z].toggleListData);
                } if (a(X).is(":visible")) {
                    a(X).find(l + i).each(function () {
                        var ah = a(this).find(l + j), ai = ah.length * ah.first().outerWidth(true);
                        this.style.width = ai + H;
                    });
                } V._ensureIntegrity();
                if (ad._enableAutoArrange) {
                    V._autoArrangeItems();
                } V._updateButtonGuidesInfo();
                if (a(X).is(":visible")) {
                    V._updateSize();
                }
            }
        }, _initializeItems: function (ah, ai) {
            var an = this, U = a(ah._element).children(), aj = U.find("a.rrbButtonOut, div.rrbTemplateItem, div.rrbTemplateItemLarge, div.rrbGallery").add("span.rrbComboBox, span.rrbDropDown, span.rrbNumericTextBox, span.rrbColorPicker", U).add(".rrbButtonStrip > .rrbButtonStripPart", U).get(), ag = ah.get_items();
            aj = a.grep(aj, function (ar, at) {
                return (!a(ar).is(".rrbMenuGroupOut .rrbButtonOut"));
            });
            var ac = null, V, af, ak;
            for (af = 0, ak = aj.length;
            af < ak;
            af++) {
                var ad = aj[af];
                if (u(ad)) {
                    var X = new d.RibbonBarButton(ad);
                    an._initializeItem(X, ai[af], ag);
                } else {
                    if (x(ad)) {
                        var aq = new d.RibbonBarToggleButton(ad);
                        an._initializeItem(aq, ai[af], ag);
                        if (aq._toggled) {
                            an._registerToggledIndex(aq.get_hierarchicalIndex());
                        }
                    } else {
                        if (v(ad)) {
                            var al = new d.RibbonBarMenu(ad);
                            an._initializeItem(al, ai[af], ag);
                            ac = a(ad._dropDown);
                            an._initializeMenuItems(ac, al.get_items(), ai[af].menuItemData);
                        } else {
                            if (w(ad)) {
                                var ao = new d.RibbonBarSplitButton(ad);
                                an._initializeItem(ao, ai[af], ag);
                                ac = a(ad._dropDown);
                                an._initializeSplitButton(ac, ao.get_items(), ai[af].buttonData);
                                if (!(typeof ai[af].selectedButtonIndex === "undefined")) {
                                    ao.set_selectedButtonIndex(ai[af].selectedButtonIndex);
                                } var aa = ao.get_defaultButton();
                                if (aa) {
                                    ao.get_element()._defaultButton = aa;
                                }
                            } else {
                                if (z(ad)) {
                                    var W = a(ad), ap = ai[af];
                                    W.bind({
                                        mousedown: function (ar) {
                                            ar.stopPropagation();
                                        }
                                    });
                                    if (ap.width) {
                                        W.width(ap.width);
                                    }
                                } else {
                                    if (r(ad)) {
                                        var Z = new d.RibbonBarComboBox(ad);
                                        V = a(ad).next();
                                        an._initializeItem(Z, ai[af], ag);
                                        an._initializeItemPopup(Z, V);
                                        an._initializeListItems(V[0], Z, ai[af].comboBoxItemData);
                                    } else {
                                        if (s(ad)) {
                                            var ab = new d.RibbonBarDropDown(ad);
                                            V = a(ad).next();
                                            an._initializeItem(ab, ai[af], ag);
                                            an._initializeItemPopup(ab, V);
                                            an._initializeListItems(V[0], ab, ai[af].dropDownItemData);
                                        } else {
                                            if (y(ad)) {
                                                var am = new d.RibbonBarNumericTextBox(ad);
                                                an._initializeItem(am, ai[af], ag);
                                            } else {
                                                if (q(ad)) {
                                                    var Y = new d.RibbonBarColorPicker(ad);
                                                    V = a(ad).next();
                                                    an._initializeItem(Y, ai[af], ag);
                                                    an._initializeItemPopup(Y, V);
                                                    V[0]._button = Y;
                                                } else {
                                                    if (t(ad)) {
                                                        var ae = new d.RibbonBarGallery(ad);
                                                        an._initializeItem(ae, ai[af], ag);
                                                        an._initializeGalleryCategories(ad, ae.get_categories(), ai[af].categoryData);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            } af = ak = null;
        }, _initializeItem: function (U, W, V) {
            V.add(U);
            U.initialize(W);
            U._setRibbonBar(this);
        }, _initializeItemPopup: function (V, U) {
            a(document.body).find("form").prepend(U);
            V._popup = new d.RadRibbonBar.DropDown(U[0]);
        }, _initializeGalleryCategories: function (X, U, W) {
            var Y = this, V = a(X).find(".rrbGalleryScrollWrap");
            V.children("ul").each(function (ab) {
                var aa = new d.RibbonBarGalleryCategory(this), Z = a(this).prev();
                U.add(aa);
                if (Z.is("strong")) {
                    aa._title = Z.text();
                } aa._setRibbonBar(Y);
                if (W && W[ab] && W[ab].itemData) {
                    Y._initializeGalleryCategoryItems(this, aa.get_items(), W[ab].itemData);
                }
            });
        }, _initializeGalleryCategoryItems: function (U, V, W) {
            var X = this;
            a(U).children("li").each(function (Z) {
                var Y = new d.RibbonBarGalleryItem(this);
                V.add(Y);
                if (W && W[Z]) {
                    if (W[Z].commandArgument) {
                        Y._commandArgument = W[Z].commandArgument;
                    } if (W[Z].imageUrl) {
                        Y._imageUrl = W[Z].imageUrl;
                    } if (W[Z].selected) {
                        Y._setSelected(true);
                    }
                } Y._setRibbonBar(X);
            });
        }, _initializeMenuItems: function (W, X, V) {
            var Y = this;
            var U = W.children(".rrbMenuGroupMid").children(".rrbMenuGroupIn");
            U.children("a.rrbButtonOut").each(function (aa) {
                var Z = new d.RibbonBarMenuItem(this);
                X.add(Z);
                if (V && V[aa]) {
                    if (V[aa].value) {
                        Z.set_value(V[aa].value);
                    } if (V[aa].toolTip) {
                        Z.set_toolTip(V[aa].toolTip);
                        this.removeAttribute("title");
                    } if (V[aa].imageUrl) {
                        Z.set_imageUrl(V[aa].imageUrl);
                    } if (V[aa].disabledImageUrl) {
                        Z.set_disabledImageUrl(V[aa].disabledImageUrl);
                    } if (V[aa].commandName) {
                        Z._commandName = V[aa].commandName;
                    } if (V[aa].commandArgument) {
                        Z._commandArgument = V[aa].commandArgument;
                    }
                } Z._setRibbonBar(Y);
                if (this._dropDown) {
                    var ab = [];
                    if (V && V[aa] && V[aa].menuItemData) {
                        ab = V[aa].menuItemData;
                    } Y._initializeMenuItems(a(this._dropDown), Z.get_items(), ab);
                }
            });
        }, _initializeSplitButton: function (W, X, U) {
            var Y = this;
            var V = W.children(".rrbMenuGroupMid").children(".rrbMenuGroupIn");
            V.children("a.rrbButtonOut").each(function (aa) {
                var Z = new d.RibbonBarButton(this);
                Z._setRibbonBar(Y);
                Z.set_shouldDisplayDefaultImage(false);
                if (U && U[aa]) {
                    if (U[aa].toolTip) {
                        Z.set_toolTip(U[aa].toolTip);
                        this.removeAttribute("title");
                    } if (U[aa].imageUrl) {
                        Z.set_imageUrl(U[aa].imageUrl);
                    } if (U[aa].imageUrlLarge) {
                        Z.set_imageUrlLarge(U[aa].imageUrlLarge);
                    } if (U[aa].disabledImageUrl) {
                        Z.set_disabledImageUrl(U[aa].disabledImageUrl);
                    } if (U[aa].disabledImageUrlLarge) {
                        Z.set_disabledImageUrlLarge(U[aa].disabledImageUrlLarge);
                    } if (U[aa].value) {
                        Z.set_value(U[aa].value);
                    } if (U[aa].commandName) {
                        Z._commandName = U[aa].commandName;
                    } if (U[aa].commandArgument) {
                        Z._commandArgument = U[aa].commandArgument;
                    }
                } X.add(Z);
            });
        }, _initializeListItems: function (Y, W, V) {
            var Z = this, X = W.get_items(), U = a(Y).children(".rrbPopup").children(".rrbList");
            U.children("li.rrbListItem").each(function (ab) {
                var aa = new d.RibbonBarListItem(this);
                X.add(aa);
                if (V && V[ab]) {
                    if (V[ab].text) {
                        aa.set_text(V[ab].text);
                    } if (V[ab].selected) {
                        W._setSelectedIndex(aa.get_index());
                    }
                } aa._setRibbonBar(Z);
            });
        }, _initializeToggleLists: function (W, ac) {
            for (var X = 0, aa = ac.length;
            X < aa;
            X++) {
                var ab = new d.RibbonBarToggleList();
                var V = ac[X].buttonIndices;
                for (var Y = 0, Z = V.length;
                Y < Z;
                Y++) {
                    var U = W.get_items().getItem(V[Y]);
                    ab.addButton(U);
                    if (U.get_toggled()) {
                        ab.set_toggledButton(U);
                    }
                }
            }
        }, _onTabClick: function (Z, V) {
            var Y = this.get_selectedTab();
            var X = this;
            if (Y) {
                if (Y != Z || this.get_minimized()) {
                    var W = function () {
                        X.set_selectedTabIndex(Z.get_index());
                        if (X.get_minimized() && !X._isMinimizedAndVisible()) {
                            X._setButtonAreaVisibility(true);
                        }
                    };
                    var U = { tab: Z, previouslySelectedTab: Y, domEvent: V };
                    this._raiseEvent("selectedTabChang", Y, U, this._postBackOnSelectedTabChange, W);
                }
            }
        }, _onAnyButtonClick: function (U, V) {
            if (!U.get_enabled()) {
                $telerik.cancelRawEvent(V);
                return;
            } var X = U.get_owner();
            var W = X.get_eventName(U);
            this["_on" + W](U, V);
        }, _onButtonClick: function (V, W) {
            var U = { button: V, domEvent: W };
            this._raiseEvent("buttonClick", V, U, this._postBackOnButtonClick || this._postBackOnCommand);
        }, _onToggleButtonClick: function (V, W) {
            var U = { button: V, domEvent: W };
            var X = this;
            var Y = function (Z) {
                Z.toggle();
                if (Z.get_toggled()) {
                    X._registerToggledIndex(Z.get_hierarchicalIndex());
                } else {
                    X._unregisterToggledIndex(Z.get_hierarchicalIndex());
                }
            };
            this._raiseEvent("buttonToggl", V, U, this._postBackOnButtonToggle || this._postBackOnCommand, Y);
        }, _onToggleListToggle: function (V, W) {
            if (V.get_toggled()) {
                return;
            } var Y = this;
            var Z = V.get_toggleList();
            var X = function (aa) {
                var ab = Z.get_toggledButton();
                if (ab) {
                    ab.set_toggled(false);
                    Y._unregisterToggledIndex(ab.get_hierarchicalIndex());
                } aa.set_toggled(true);
                Y._registerToggledIndex(aa.get_hierarchicalIndex());
                Z.set_toggledButton(aa);
            };
            var U = { button: V, buttons: Z.get_buttons(), domEvent: W };
            this._raiseEvent("toggleListToggl", V, U, this._postBackOnToggleListToggle || this._postBackOnCommand, X);
        }, _onMenuItemClick: function (W, V) {
            var U = { item: W, domEvent: V };
            this._raiseEvent("menuItemClick", W, U, this._postBackOnMenuItemClick || this._postBackOnCommand);
            if ("preventDefault" in V) {
                if (W._element.getAttribute("href") === "#") {
                    V.preventDefault();
                    return false;
                }
            }
        }, _onSplitButtonClick: function (V, W) {
            var U = { button: V, domEvent: W };
            var X = function (Y) {
                Y._ribbonBar._updateSplitButtonSelection(Y);
            };
            this._raiseEvent("splitButtonClick", V, U, this._postBackOnSplitButtonClick || this._postBackOnCommand, X);
            if ("preventDefault" in W) {
                W.preventDefault();
                return false;
            }
        }, _onComboBoxItemClick: function (V, U) {
            V.select();
        }, _onComboBoxSelectedIndexChange: function (V, W) {
            var X = V.get_items().getItem(W), U = { comboBox: V, index: W };
            var Y = function (Z) {
                Z.get_owner()._setSelectedIndex(Z.get_index());
            };
            this._raiseEvent("comboBoxSelectedIndexChang", X, U, this._postBackOnComboBoxSelectedIndexChanged, Y);
        }, _onComboBoxTextChange: function (V, W) {
            var U = { comboBox: V, text: W };
            a.raiseControlEvent(this, "comboBoxTextChanged", U);
            if (this._postBackOnComboBoxTextChanged) {
                this.postback(V.get_hierarchicalIndex() + ":-1:" + W);
            }
        }, _onDropDownItemClick: function (V, U) {
            V.select();
        }, _onDropDownSelectedIndexChange: function (V, W) {
            var X = V.get_items().getItem(W), U = { dropDown: V, index: W };
            var Y = function (Z) {
                Z.get_owner()._setSelectedIndex(Z.get_index());
            };
            this._raiseEvent("dropDownSelectedIndexChang", X, U, this._postBackOnDropDownSelectedIndexChanged, Y);
        }, _onNumericTextBoxValueChange: function (V, W) {
            var U = { numericTextBox: V, value: W };
            if (a.raiseCancellableControlEvent(this, "numericTextBoxValueChanging", U)) {
                return;
            } V._setValue(W);
            a.raiseControlEvent(this, "numericTextBoxValueChanged", U);
            if (this._postBackOnNumericTextBoxValueChanged) {
                this.postback(V.get_hierarchicalIndex() + ":" + W);
            }
        }, _onColorPickerItemClick: function (X, W) {
            var U = a(X), V = U.parents(".rrbDropDownSlide")[0]._button, Y = U.find("span").text();
            V.set_selectedColor(Y);
        }, _onColorPickerColorChange: function (V, Y) {
            var W = V.get_hierarchicalIndex(), X = V.get_selectedColor(), U = { colorPicker: V, value: Y };
            if (a.raiseCancellableControlEvent(this, "colorPickerColorChanging", U)) {
                return;
            } V._setSelectedColor(Y);
            this._unregisterColorPickerSelectedColor(W + ":" + X);
            this._registerColorPickerSelectedColor(W + ":" + Y);
            a.raiseControlEvent(this, "colorPickerColorChanged", U);
            if (this._postBackOnColorPickerColorChanged) {
                this.postback(V.get_hierarchicalIndex() + ":" + Y);
            }
        }, _onGalleryItemPreview: function (V) {
            var U = { item: V };
            a.raiseControlEvent(this, "galleryCommandPreview", U);
        }, _onGalleryItemPreviewEnd: function (V) {
            var U = { item: V };
            a.raiseControlEvent(this, "galleryCommandPreviewEnd", U);
        }, _onGalleryItemClick: function (V, U) {
            V.toggle();
        }, _onGalleryItemSelected: function (V) {
            var U = { item: V };
            a.raiseControlEvent(this, "galleryCommand", U);
            if (this._postBackOnGalleryCommand || this._postBackOnCommand) {
                this.postback(V.get_hierarchicalIndex());
            }
        }, _onGalleryActionClick: function (W, V) {
            var U = a(W), Y = U.parents(".rrbGallery")[0], X = Y._button;
            if (U.hasClass("rrbGalleryActionUp")) {
                X.scrollUp();
            } else {
                if (U.hasClass("rrbGalleryActionDown")) {
                    X.scrollDown();
                } else {
                    X.expand();
                }
            }
        }, _onDocumentKeyDown: function (V) {
            var U = this._activeDropDownItem;
            if (V.keyCode == this._escapeKeyCode) {
                this._hideMenus();
                this._hideApplicationMenuByStep();
                if (this.get_quickAccessToolbar()) {
                    this.get_quickAccessToolbar().hideDropDown();
                }
            } else {
                if (U) {
                    switch (V.keyCode) {
                        case Sys.UI.Key.enter: V.preventDefault();
                            U._selectHighlightedItem();
                            U._popup.hide();
                            this._activeDropDownItem = null;
                            break;
                        case Sys.UI.Key.left: if (U.highlightLeft !== undefined) {
                            U.highlightLeft();
                        } break;
                        case Sys.UI.Key.up: U.highlightPrev();
                            break;
                        case Sys.UI.Key.right: if (U.highlightRight !== undefined) {
                            U.highlightRight();
                        } break;
                        case Sys.UI.Key.down: U.highlightNext();
                            break;
                        default: U._popup.hide();
                            this._activeDropDownItem = null;
                            break;
                    }
                }
            }
        }, _raiseEvent: function (V, Y, U, X, W) {
            if (a.raiseCancellableControlEvent(this, V + "ing", U)) {
                return;
            } if (W) {
                W(Y);
            } a.raiseControlEvent(this, V + "ed", U);
            if (X) {
                this.postback(Y.get_hierarchicalIndex());
            }
        }, _onLauncherClick: function (W, V) {
            var U = { group: W._group, domEvent: V };
            this._raiseEvent("launcherClick", W._group, U, this._postBackOnLauncherClick);
        }, postback: function (U) {
            eval(this._postBackReference.replace("arguments", U));
        }, dispose: function () {
            d.RadRibbonBar.callBaseMethod(this, "dispose");
            if (this._applicationMenu) {
                a(this._applicationMenu.get_element()).off();
                a(this._applicationMenu.get_dropDownElement()).off();
                this._applicationMenu.dispose();
            } if (this._quickAccessToolbar) {
                this._quickAccessToolbar.dispose();
            } var U = this._getNavigator();
            if (U) {
                U.dispose();
            } a(document).off("keydown." + this._uniqueId, this._onDocumentKeyDown);
            a(window).unbind("resize", this._onResize);
        }, repaint: function () {
            var U = this;
            selectedTab = U.get_selectedTab();
            U._groupContainer.css("visibility", "hidden");
            if (!U._hasResizeHandle) {
                U._element.style.width = "auto";
            } if (U._detachedGroup) {
                U._detachedGroup._attachGroup();
            } U._detachedGroup = null;
            a(U._getPageViewElements()).hide();
            a(selectedTab.get_pageView()).show();
            U._initializePage(selectedTab);
        }, get_tabs: function () {
            return this._tabs;
        }, getTab: function (U) {
            return this._tabs.getTab(U);
        }, set_selectedTabIndex: function (W) {
            var U = this.get_selectedTab();
            var V = this.get_tabs().getTab(W);
            this._selectedTabIndex = W;
            this.updateClientState();
            this._selectedTab = V;
            if (U && V && (U != V)) {
                a(U.get_element()).removeClass("rrbSelectedTab");
                a(V.get_element()).addClass("rrbSelectedTab");
            } this.repaint();
        }, saveClientState: function () {
            var W = this._width ? (',"width":' + this._width) : "", V = this._selectedTabIndex ? (',"selectedTabIndex":' + this._selectedTabIndex) : "", U = this._navigationSettings.activated ? (',"activated":' + this._navigationSettings.activated) : "";
            return '{"toggledIndices":' + this._toggledIndicesJson + ',"splitButtonSelectedIndices":' + this._splitButtonSelectedButtonIndicesJson + ',"comboBoxSelectedIndices":' + this._comboBoxSelectedIndicesJson + ',"dropDownSelectedIndices":' + this._dropDownSelectedIndicesJson + ',"colorPickerColorIndices":' + this._colorPickerColorIndicesJson + ',"gallerySelectedIndices":' + this._gallerySelectedIndicesJson + ',"clientSideEnabledItems":' + this._enabledItemsJson + ',"clientSideDisabledItems":' + this._disabledItemsJson + ',"minimized":' + this.get_minimized() + (this._qatActiveItemIndicesJson ? ',"qatActiveItemIndices":' + this._qatActiveItemIndicesJson : "") + W + V + U + "}";
        }, _updateSplitButtonSelection: function (U) {
            var W = U.get_owner();
            if (W.get_enableButtonSelection()) {
                var V = true;
                W.set_selectedButtonIndex(U.get_hierarchicalIndex(), V);
                U = W.get_defaultButton();
                if (Array.indexOf(this._splitButtonsWithChangedSelection, W) == -1) {
                    Array.add(this._splitButtonsWithChangedSelection, W);
                } this._updateSplitButtonSelectedIndicesJson();
            } return U;
        }, _updateSplitButtonSelectedIndicesJson: function () {
            var V = [];
            for (var U = 0;
            U < this._splitButtonsWithChangedSelection.length;
            U++) {
                if (this._splitButtonsWithChangedSelection[U].get_selectedIndexDifferentFromInitial()) {
                    Array.add(V, this._splitButtonsWithChangedSelection[U].get_selectedButtonHierarchicalIndex());
                } else {
                    Array.remove(this._splitButtonsWithChangedSelection, this._splitButtonsWithChangedSelection[U]);
                }
            } var X = this._splitButtonSelectedButtonIndicesJson;
            var W = c.serialize(V);
            if (X != W) {
                this._splitButtonSelectedButtonIndicesJson = W;
                this.updateClientState();
            }
        }, _updateEnabledItems: function (V) {
            var U = V.get_hierarchicalIndex();
            if (Array.indexOf(this._disabledItems, U) != -1) {
                Array.remove(this._disabledItems, U);
                this._updateDisabledItemsJson();
            } if (Array.indexOf(this._enabledItems, U) == -1) {
                Array.add(this._enabledItems, U);
                this._updateEnabledItemsJson();
            }
        }, _updateDisabledItems: function (V) {
            var U = V.get_hierarchicalIndex();
            if (Array.indexOf(this._enabledItems, U) != -1) {
                Array.remove(this._enabledItems, U);
                this._updateEnabledItemsJson();
            } if (Array.indexOf(this._disabledItems, U) == -1) {
                Array.add(this._disabledItems, U);
                this._updateDisabledItemsJson();
            }
        }, _updateEnabledItemsJson: function () {
            var V = this._enabledItemsJson;
            var U = c.serialize(this._enabledItems);
            if (V != U) {
                this._enabledItemsJson = U;
                this.updateClientState();
            }
        }, _updateDisabledItemsJson: function () {
            var V = this._disabledItemsJson;
            var U = c.serialize(this._disabledItems);
            if (V != U) {
                this._disabledItemsJson = U;
                this.updateClientState();
            }
        }, _registerToggledIndex: function (U) {
            if (Array.indexOf(this._toggledIndices, U) == -1) {
                Array.add(this._toggledIndices, U);
                this._updateToggledIndicesJson();
            }
        }, _unregisterToggledIndex: function (U) {
            Array.remove(this._toggledIndices, U);
            this._updateToggledIndicesJson();
        }, _updateToggledIndicesJson: function () {
            this._toggledIndicesJson = c.serialize(this._toggledIndices);
            this.updateClientState();
        }, _registerComboBoxSelectedIndex: function (U) {
            if (Array.indexOf(this._comboBoxSelectedIndices, U) == -1) {
                Array.add(this._comboBoxSelectedIndices, U);
                this._updateComboBoxSelectedIndicesJson();
            }
        }, _unregisterComboBoxSelectedIndex: function (U) {
            Array.remove(this._comboBoxSelectedIndices, U);
            this._updateComboBoxSelectedIndicesJson();
        }, _updateComboBoxSelectedIndicesJson: function () {
            this._comboBoxSelectedIndicesJson = c.serialize(this._comboBoxSelectedIndices);
            this.updateClientState();
        }, _registerDropDownSelectedIndex: function (U) {
            if (Array.indexOf(this._dropDownSelectedIndices, U) == -1) {
                Array.add(this._dropDownSelectedIndices, U);
                this._updateDropDownSelectedIndicesJson();
            }
        }, _unregisterDropDownSelectedIndex: function (U) {
            Array.remove(this._dropDownSelectedIndices, U);
            this._updateDropDownSelectedIndicesJson();
        }, _updateDropDownSelectedIndicesJson: function () {
            this._dropDownSelectedIndicesJson = c.serialize(this._dropDownSelectedIndices);
            this.updateClientState();
        }, _unregisterColorPickerSelectedColor: function (U) {
            Array.remove(this._colorPickerColorIndices, U);
            this._updateColorPickerColorIndicesJson();
        }, _registerColorPickerSelectedColor: function (U) {
            Array.add(this._colorPickerColorIndices, U);
            this._updateColorPickerColorIndicesJson();
        }, _updateColorPickerColorIndicesJson: function () {
            this._colorPickerColorIndicesJson = c.serialize(this._colorPickerColorIndices);
            this.updateClientState();
        }, _registerGallerySelectedIndex: function (U) {
            if (Array.indexOf(this._gallerySelectedIndices, U) == -1) {
                Array.add(this._gallerySelectedIndices, U);
                this._updateGallerySelectedIndicesJson();
            }
        }, _unregisterGallerySelectedIndex: function (U) {
            Array.remove(this._gallerySelectedIndices, U);
            this._updateGallerySelectedIndicesJson();
        }, _updateGallerySelectedIndicesJson: function () {
            this._gallerySelectedIndicesJson = c.serialize(this._gallerySelectedIndices);
            this.updateClientState();
        }, _updateWidthInClientState: function () {
            var U = this;
            U._width = U._$element.data("width");
            U.updateClientState();
        }, _initializePage: function (ab) {
            var aa = this, U = aa._$element, Z = 0;
            aa._pageGroups = U.find(".rrbButtonAreaIn").filter(":visible").find(l + m);
            aa._groupContainer = aa._pageGroups.parent();
            aa._parentElement = aa._groupContainer.parent();
            var W = ab.get_groups()._array;
            for (var X = 0, Y = W.length;
            X < Y;
            X++) {
                var V = W[X];
                if (!V._collapsedGroup) {
                    V._spawnCollapsedGroup();
                } V._updateSize();
            } aa._groupContainer.find(l + n).each(function () {
                var ac = this, ad = a(ac).hasClass(o);
                a(ac).removeClass(o);
                Z += a(ac).outerWidth(true);
                if (ad) {
                    a(ac).addClass(o);
                }
            });
            Z += 10;
            Z = Math.max(Z, this._minWidth);
            this._minWidth = Z;
            aa._setRibbonSize({ width: U.width() });
            this._groupContainer.css("min-width", Z + H);
            this._groupContainer.css("visibility", "visible");
            this._groupContainer.find(".rrbGallery").each(function (ad, ac) {
                var ae = ac._button.get_selectedItem();
                if (ae) {
                    ae.scrollIntoView();
                }
            });
        }, _getDropDownWidth: function (U) {
            var X = U.children().children().children(".rrbButtonOut");
            var V = 0;
            var W = this;
            X.each(function () {
                var Y = a(this);
                var Z = Y.outerWidth(true) + 4;
                V = Math.max(V, Z);
            });
            return V;
        }, _getRelativeOffset: function (U, W) {
            U = a(U);
            if (typeof (W) === "string") {
                W = U.parents(W);
            } var X = W.offset();
            var V = U.offset();
            return { left: V.left - X.left, top: V.top - X.top };
        }, _hideMenus: function () {
            var ad = this, V = ad._$element, af = V.find(l + E).filter(":visible").get(), ae = a(".rrbDropDownSlide").filter(":visible").get(), X = a(".rrbSlide").find(".rrbGalleryScrollWrap").get();
            for (var Y = 0, Z = af.length;
            Y < Z;
            Y++) {
                var ab = af[Y], U = a(ab);
                U.stop(true, true).slideUp("fast", function () {
                    ab.style.display = "none";
                    ab._button.removeClass("rrbExpanded");
                });
            } for (var Y = 0, aa = ae.length;
            Y < aa;
            Y++) {
                var ac = ae[Y]._popup;
                if (ac) {
                    this._activeDropDownItem = null;
                    ac.hide();
                }
            } for (var Y = 0, aa = X.length;
            Y < aa;
            Y++) {
                var W = a(X[Y]).parents(".rrbSlide")[0]._gallery;
                if (W) {
                    W.collapse();
                }
            }
        }
    };
    a.registerControlProperties(d.RadRibbonBar, { tabData: [], groupData: [], applicationMenuData: [], defaultImageUrl: "", defaultImageUrlLarge: "", defaultDisabledImageUrl: "", defaultDisabledImageUrlLarge: "", applicationMenu: null, qatItemsHierarchicalIndices: null });
    a.registerControlEvents(d.RadRibbonBar, ["load", "selectedTabChanging", "selectedTabChanged", "buttonClicking", "buttonClicked", "splitButtonClicking", "splitButtonClicked", "menuItemClicking", "menuItemClicked", "launcherClicking", "launcherClicked", "buttonToggling", "buttonToggled", "toggleListToggling", "toggleListToggled", "applicationMenuItemClicking", "applicationMenuItemClicked", "minimizing", "minimized", "maximizing", "maximized", "comboBoxSelectedIndexChanging", "comboBoxSelectedIndexChanged", "comboBoxTextChanged", "dropDownSelectedIndexChanging", "dropDownSelectedIndexChanged", "numericTextBoxValueChanging", "numericTextBoxValueChanged", "colorPickerColorChanging", "colorPickerColorChanged", "galleryCommandPreview", "galleryCommandPreviewEnd", "galleryCommand"]);
    d.RadRibbonBar.registerClass("Telerik.Web.UI.RadRibbonBar", d.RadWebControl);
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarChild = function (c) {
        this._parent = undefined;
        this._element = c || null;
        this._text = "";
        this._ribbonBar = undefined;
    };
    b.RibbonBarChild.prototype = {
        get_index: function () {
            return this._parent.indexOf(this);
        }, _getRibbonBar: function () {
            return this._ribbonBar;
        }, _setRibbonBar: function (c) {
            this._ribbonBar = c;
        }
    };
    a.registerControlProperties(b.RibbonBarChild, { element: null, text: "" });
    b.RibbonBarChild.registerClass("Telerik.Web.UI.RibbonBarChild");
})($telerik.$);
(function () {
    var a = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    a.RibbonBarChildCollection = function (b) {
        this._owner = b;
        this._array = new Array();
    };
    a.RibbonBarChildCollection.prototype = {
        add: function (b) {
            this._array[this._array.length] = b;
            b._parent = this;
            if (this._owner && this._owner._onChildAdded) {
                this._owner._onChildAdded(b);
            }
        }, get_count: function () {
            return this._array.length;
        }, getItem: function (b) {
            return this._array[b];
        }, indexOf: function (c) {
            for (var b = 0, d = this._array.length;
            b < d;
            b++) {
                if (this._array[b] === c) {
                    return b;
                }
            } return -1;
        }, forEach: function (d) {
            for (var c = 0, b = this.get_count() ;
            c < b;
            c++) {
                d(this._array[c]);
            }
        }
    };
    a.RibbonBarChildCollection.registerClass("Telerik.Web.UI.RibbonBarChildCollection");
})();
(function (h, a) {
    Type.registerNamespace("Telerik.Web.UI");
    var c = Telerik.Web.UI;
    var a = $telerik.$;
    var b = a(document), g = ".", f = ",", j = "px", l = true, i = false, e = "reflowUp", d = "reflowDown", k = 10;
    c.RibbonBarTab = function (m) {
        c.RibbonBarTab.initializeBase(this, [m]);
        if (m) {
            m._tab = this;
        } this._value = "";
        this._labelElement = null;
        this._textElement = null;
        this._pageView = null;
        this._groups = new c.RibbonBarGroupCollection(this);
        a(m).data("resizingMeta", { previousAction: null, previousGroupIndex: null, canReflowFurtherDown: null, canReflowFurtherUp: i });
    };
    c.RibbonBarTab.prototype = {
        get_ribbonBar: function () {
            if (this._parent) {
                return this._parent._owner;
            } return null;
        }, get_groups: function () {
            return this._groups;
        }, getGroup: function (m) {
            return this._groups.getGroup(m);
        }, get_textElement: function () {
            if (!this._textElement) {
                var m = this.get_element();
                if (m) {
                    this._textElement = a(m).find(">.rrbTabLabel>.rrbTabText").get(0);
                }
            } return this._textElement;
        }, get_labelElement: function () {
            if (!this._labelElement) {
                var m = this.get_element();
                if (m) {
                    this._labelElement = a(m).children(".rrbTabLabel").get(0);
                }
            } return this._labelElement;
        }, get_text: function () {
            if (!this._text) {
                var m = this.get_textElement();
                if (m) {
                    this._text = a(m).text();
                }
            } return this._text;
        }, get_hierarchicalIndex: function () {
            var m = "" + this.get_index();
            return m;
        }, set_text: function (m) {
            this._text = m;
            var n = this.get_textElement();
            if (n) {
                a(n).text(m);
            }
        }, _getCombinedGroupWidth: function (n) {
            var p = this, o = p._groups, n = !!n, m = p._combinedGroupWidth || 0;
            if (n) {
                m = 0;
            } if (m == 0) {
                o.forEach(function (q) {
                    var r = a(q._element).outerWidth(true);
                    if (q._groupVariant == c.RibbonBarGroupVariant.Collapsed) {
                        r = a(q._collapsedGroup).outerWidth(true) + 4;
                    } m += r;
                });
                p._combinedGroupWidth = m + 4;
            } return p._combinedGroupWidth;
        }, _reflowGroups: function (s) {
            var t = this, r = a(t._element).data("resizingMeta"), q = 0, p = 0, n, o, m;
            if (!s) {
                n = a(t.get_ribbonBar()._element).width(), o = t._getCombinedGroupWidth(true) + k;
            } else {
                if (s.width) {
                    n = s.width, o = t._getCombinedGroupWidth(true) + k;
                } else {
                    n = s.newSize.width, o = s.oldSize.width;
                }
            } if (n == o) {
                return;
            } else {
                if (n < o) {
                    m = t._getCombinedGroupWidth(true);
                    if (n >= m + k || r.canReflowFurtherDown == i) {
                        return;
                    } t._reflowGroupsDown();
                    m = t._getCombinedGroupWidth(true);
                    if (n >= m + k || r.canReflowFurtherDown == i) {
                        return;
                    } while (n < m + k) {
                        r = a(t._element).data("resizingMeta");
                        p++;
                        if (r.canReflowFurtherDown == i || p > 50) {
                            break;
                        } t._reflowGroupsDown();
                        m = t._getCombinedGroupWidth(true);
                    }
                } else {
                    if (n > o) {
                        m = t._getCombinedGroupWidth(true);
                        if (n <= m + k || r.canReflowFurtherUp == i) {
                            return;
                        } t._reflowGroupsUp();
                        m = t._getCombinedGroupWidth(true);
                        if (n < m + k) {
                            t._reflowGroupsDown();
                            return;
                        } if (n == m + k || r.canReflowFurtherUp == i) {
                            return;
                        } while (n > m + k) {
                            r = a(t._element).data("resizingMeta");
                            q++;
                            if (r.canReflowFurtherUp == i || q > 50) {
                                break;
                            } t._reflowGroupsUp();
                            m = t._getCombinedGroupWidth(true);
                        } if (n <= m + k) {
                            t._reflowGroupsDown();
                        }
                    }
                }
            }
        }, _reflowGroupsDown: function () {
            var r = this, o = r._groups._array, p = a(r._element).data("resizingMeta"), m, n, q = false;
            if (p.canReflowFurtherDown == i) {
                return;
            } if (p.previousGroupIndex == null) {
                p.previousGroupIndex = o.length;
            } if (p.previousAction == e) {
                m = p.previousGroupIndex;
            } else {
                m = --p.previousGroupIndex;
            } if (m == -1) {
                m = o.length - 1;
            } n = o[m];
            if (!n) {
                return;
            } a(n._element).parent().children().removeClass("resizing");
            a(n._element).addClass("resizing");
            n._reduceGroup();
            p.previousAction = d;
            p.previousGroupIndex = m;
            p.canReflowFurtherDown = i;
            p.canReflowFurtherUp = l;
            a.each(o, function (t, s) {
                if (s._groupVariant !== c.RibbonBarGroupVariant.Collapsed) {
                    p.canReflowFurtherDown = l;
                }
            });
            a(r._element).data("resizingMeta", p);
        }, _reflowGroupsUp: function () {
            var q = this, p = a(q._element).data("resizingMeta"), o = q._groups._array, m, n;
            if (p.canReflowFurtherUp == i) {
                return;
            } if (p.previousGroupIndex == null) {
                p.previousGroupIndex = -1;
            } if (p.previousAction == d) {
                m = p.previousGroupIndex;
            } else {
                m = ++p.previousGroupIndex;
            } if (m == o.length) {
                m = 0;
            } n = o[m];
            if (!n) {
                return;
            } a(n._element).parent().children().removeClass("resizing");
            a(n._element).addClass("resizing");
            n._enlargeGroup();
            p.previousAction = e;
            p.previousGroupIndex = m;
            p.canReflowFurtherUp = i;
            p.canReflowFurtherDown = l;
            a.each(o, function (s, r) {
                if (r._groupVariant !== c.RibbonBarGroupVariant.Full) {
                    p.canReflowFurtherUp = l;
                }
            });
            a(q._element).data("resizingMeta", p);
        }, _findItemByPropertyGeneric: function (s, t, m) {
            var o = this._groups;
            for (var p = 0, r = o.get_count() ;
            p < r;
            p++) {
                var n = o.getGroup(p), q = n._findItemByPropertyGeneric(s, t, m);
                if (q) {
                    return q;
                }
            } return null;
        }, findItemByText: function (m) {
            return this._findItemByPropertyGeneric("Text", m);
        }, findItemByCommandName: function (m) {
            return this._findItemByPropertyGeneric("CommandName", m);
        }, findItemByCommandArgument: function (m) {
            return this._findItemByPropertyGeneric("CommandArgument", m);
        }, findItemByAttribute: function (m, n) {
            return this._findItemByPropertyGeneric("Attribute", m, n);
        }, findGroupByValue: function (q) {
            var n = this._groups;
            var p = n.get_count();
            for (var o = 0;
            o < p;
            o++) {
                var m = n.getGroup(o);
                if (m.get_value() == q) {
                    return m;
                }
            } return null;
        }, _findByValueInGroupsGeneric: function (s, r) {
            var n = this._groups;
            var p = n.get_count();
            for (var o = 0;
            o < p;
            o++) {
                var m = n.getGroup(o);
                var q = m["find" + r + "ByValue"](s);
                if (q) {
                    return q;
                }
            } return null;
        }, findButtonByValue: function (m) {
            return this._findByValueInGroupsGeneric(m, "Button");
        }, findToggleButtonByValue: function (m) {
            return this._findByValueInGroupsGeneric(m, "ToggleButton");
        }, findMenuItemByValue: function (m) {
            return this._findByValueInGroupsGeneric(m, "MenuItem");
        }
    };
    a.registerControlProperties(c.RibbonBarTab, { pageView: null, value: "" });
    c.RibbonBarTab.registerClass("Telerik.Web.UI.RibbonBarTab", c.RibbonBarChild);
})(window, $telerik.$);
(function () {
    var a = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    a.RibbonBarTabCollection = function (b) {
        a.RibbonBarTabCollection.initializeBase(this, [b]);
    };
    a.RibbonBarTabCollection.prototype = {
        getTab: function (b) {
            return this.getItem(b);
        }
    };
    a.RibbonBarTabCollection.registerClass("Telerik.Web.UI.RibbonBarTabCollection", a.RibbonBarChildCollection);
})();
(function (a) {
    Type.registerNamespace("Telerik.Web.UI");
    var b = Telerik.Web.UI, m = ".", l = ",", G = " ", D = "px", K = true, B = false, t = "rrbButtonGroup", u = "rrbButtonGroupIn", w = "rrbGroupTitle", v = "rrbGroupLauncher", i = "rrbCollapsedGroup", y = "rrbHiddenGroup", g = "rrbButtonGuide", e = "rrbControlGroup", c = "rrbAbox", x = "rrbHbox", J = "rrbVbox", h = "rrbButtonStrip", f = "rrbButtonOut", F = "rrbButton", A = "rrbMediumButton", z = "rrbLargeButton", k = "rrbComboBox", n = "rrbDropDown", C = "rrbNumericTextBox", j = "rrbColorPicker", H = "rrbTemplateItem", I = "rrbTemplateItem";
    function d(M, L) {
        a(M).addClass(L);
    } function E(M, L) {
        a(M).removeClass(L);
    } a.registerEnum(b, "RibbonBarGroupVariant", { Full: 0, Large: 1, Medium: 2, Small: 3, Collapsed: 4 });
    function p(L, N) {
        if (!L || !a(L).is(":visible")) {
            return;
        } var M = parseFloat(L.style.width) || 0;
        N = !!N;
        if (a(L).hasClass(x)) {
            return r(L, N);
        } if (a(L).hasClass(J)) {
            return s(L, N);
        } if (a(L).hasClass(c)) {
            return o(L, N);
        } return M;
    } function r(O, N) {
        if (!O) {
            return;
        } var L = a(O).children(), P = L.not(m + e).get(), M = parseFloat(O.style.width) || 0;
        N = !!N;
        if (N) {
            M = 0;
        } L.filter(m + x).each(function () {
            M += r(this, N);
        });
        L.filter(m + J).each(function () {
            M += s(this, N);
        });
        L.filter(m + c).each(function () {
            M += o(this, N);
        });
        a(P).each(function () {
            M += a(this).outerWidth(true);
        });
        M += 2;
        return M;
    } function s(P, N) {
        if (!P) {
            return;
        } var L = a(P).children(), O = L.not(m + e).get(), M = parseFloat(P.style.width) || 0;
        N = !!N;
        if (N) {
            M = 0;
            P.style.width = "auto";
        } L.filter(m + x).each(function () {
            M = Math.max(r(this, N), a(this).outerWidth(true));
        });
        L.filter(m + J).each(function () {
            M = Math.max(s(this, N), a(this).outerWidth(true));
        });
        L.filter(m + c).each(function () {
            M = Math.max(o(this, N), a(this).outerWidth(true));
        });
        a(O).each(function () {
            M = Math.max(M, a(this).outerWidth(true) + 1);
        });
        M += 2;
        return M;
    } function o(M, O) {
        if (!M) {
            return;
        } var L = a(M).children(), P = L.not(m + e).get(), N = parseFloat(M.style.width) || 0;
        O = !!O;
        if (O) {
            N = 0;
            M.style.width = "auto";
        } if (a(P[0]).hasClass(z)) {
            a(P).each(function () {
                N += a(this).outerWidth(true);
            });
        } else {
            L.filter(m + x).each(function () {
                N = Math.max(r(this, O), a(this).outerWidth(true));
            });
            L.filter(m + J).each(function () {
                N = Math.max(s(this, O), a(this).outerWidth(true));
            });
            L.filter(m + c).each(function () {
                N = Math.max(o(this, O), a(this).outerWidth(true));
            });
            a(P).each(function () {
                N = Math.max(N, a(this).outerWidth(true) + 1);
            });
        } N += 2;
        return N;
    } function q(L, N) {
        if (!L || a(L).is(":hidden")) {
            return;
        } var M = parseFloat(L.style.width) || 0;
        if (!M || N) {
            M = 0;
            a(L).children(".rrbButtonStripPart ").each(function () {
                M += a(this).outerWidth();
            });
            M = M + 4;
        } return M;
    } b.RibbonBarGroup = function (L) {
        b.RibbonBarGroup.initializeBase(this);
        this._value = "";
        this._groupVariant = b.RibbonBarGroupVariant.Full;
        this._cachedSizes = {};
        this._launcherElement = null;
        this._collapsedGroup = null;
        this._smallButtons = [];
        this._mediumButtons = [];
        this._largeButtons = [];
        this._buttonGuides = [];
        this._buttonStrips = [];
        this._items = new b.RibbonBarChildCollection(this);
        this._element = L;
        this._$element = a(this._element);
        this._groupWidth = 0;
    };
    b.RibbonBarGroup.prototype = {
        initialize: function () {
            var O = this, L = O._$element, N, P, M, Q = O._getRibbonBar();
            N = L.find(m + w);
            if (N.length == 0) {
                N = a(document.createElement("DIV"));
                N.addClass(w);
                L.children(m + u).prepend(N);
            } O.set_text(N.text().trim());
            P = N.children(m + v).get(0);
            if (P) {
                M = a(P);
                O.set_launcherElement(P);
                P._group = O;
                if (!M.hasClass(".rrbDisabled")) {
                    M.bind("click", function (R) {
                        R.preventDefault();
                        R.stopImmediatePropagation();
                        Q._onLauncherClick(this);
                        Q._hideApplicationMenu();
                    });
                }
            }
        }, set_text: function (N) {
            var L = this._$element.find(m + w);
            var M = L.find(m + v).detach();
            L.text(N).prepend(M);
            b.RibbonBarGroup.callBaseMethod(this, "set_text", [N]);
        }, get_tab: function () {
            return this._parent._owner;
        }, get_items: function () {
            return this._items;
        }, getItem: function (L) {
            return this._items.getItem(L);
        }, get_hierarchicalIndex: function () {
            var L = this, M = this.get_index(), N = L.get_tab().get_index();
            return N + ":" + M;
        }, get_eventName: function (L) {
            if (L.get_toggleList) {
                var M = L.get_toggleList();
                if (M) {
                    return b.RadRibbonBar.get_eventName(Object.getTypeName(M));
                }
            } return b.RadRibbonBar.get_eventName(Object.getTypeName(L));
        }, _findItemByPropertyGeneric: function (M, N, L) {
            return this["findItemBy" + M](N, L);
        }, _findItemByPropertyRecursiveGeneric: function (P, R) {
            var N = this._items;
            for (var L = 0, O = N.get_count() ;
            L < O;
            L++) {
                var M = N.getItem(L);
                if (M._findItemByPropertyRecursiveGeneric) {
                    var Q = M._findItemByPropertyRecursiveGeneric(P, R);
                    if (Q) {
                        return Q;
                    }
                } else {
                    if (M["get_" + P] && M["get_" + P]() == R) {
                        return M;
                    }
                }
            } return null;
        }, findItemByCommandName: function (L) {
            return this._findItemByPropertyRecursiveGeneric("commandName", L);
        }, findItemByCommandArgument: function (L) {
            return this._findItemByPropertyRecursiveGeneric("commandArgument", L);
        }, findItemByText: function (N) {
            for (var L = 0;
            L < this._items.get_count() ;
            L++) {
                var M = this._items.getItem(L);
                if (M.get_text() == N) {
                    return M;
                }
            } return null;
        }, findItemByAttribute: function (M, N) {
            var Q = this._items;
            for (var O = 0, R = Q.get_count() ;
            O < R;
            O++) {
                var P = Q.getItem(O), L = P.get_element().getAttribute(M);
                if (L && L == N) {
                    return P;
                }
            } return null;
        }, findButtonByValue: function (P) {
            var N = this._items;
            for (var L = 0;
            L < N.get_count() ;
            L++) {
                var M = N.getItem(L);
                if (!M.toggle && M.get_value && M.get_value() == P) {
                    return M;
                } else {
                    if (M.findButtonByValue) {
                        var O = M.findButtonByValue(P);
                        if (O) {
                            return O;
                        }
                    }
                }
            } return null;
        }, findToggleButtonByValue: function (O) {
            var N = this._items;
            for (var L = 0;
            L < N.get_count() ;
            L++) {
                var M = N.getItem(L);
                if (M.toggle && M.get_value && M.get_value() == O) {
                    return M;
                }
            } return null;
        }, findMenuItemByValue: function (P) {
            var N = this._items;
            for (var L = 0;
            L < N.get_count() ;
            L++) {
                var M = N.getItem(L);
                if (M.findMenuItemByValue) {
                    var O = M.findMenuItemByValue(P);
                    if (O) {
                        return O;
                    }
                }
            } return null;
        }, _onChildAdded: function (L) {
            L.set_group(this);
        }, _getRibbonBar: function () {
            return this.get_tab().get_ribbonBar();
        }, get_width: function (M) {
            var N = this, O = N._groupWidth, M = !!M, L;
            if (M) {
                O = 0;
            } if (O != 0) {
                return O;
            } if (N._groupVariant == b.RibbonBarGroupVariant.Collapsed) { } else {
                L = N._getButtonGuidesWidth(true);
                O = L + 3;
            } N._cachedSizes[N._groupVariant] = O;
        }, _updateSize: function () {
            var N = this, R = N._getRibbonBar(), O = N._element, L = a(O), Q = 0, M = 0, P = null;
            if (a(O).is(":hidden")) {
                return;
            } if (Q) {
                O.style.width = Q + D;
                return;
            } O.style.width = "auto";
            M = N._getButtonGuidesWidth(true);
            P = a(O).find(".rrbGroupTitle").get(0);
            P.style.width = "auto";
            Q = Math.max(M + 3, a(O).width(), a(P).width() + 10);
            N._cachedSizes[N._groupVariant] = Q;
            a(O).data("width", Q);
            a(O).data("variant", N._groupVariant);
            if (P) {
                P.style.width = Q + D;
            }
        }, _autoArrangeItems: function () {
            var O = this, P = O._element, L = a(P), Q = L.children(m + u).get(0), M = a(Q), W = 3, X = M.children(m + F).get(), U = M.children(m + A).get(), S = M.children(m + z).get(), N = M.children(m + h).get(), Y = M.children(m + H).get(), V = M.children(m + k + l + m + n + l + m + C + l + m + j).get();
            function Z(ad, aa) {
                if (ad % W != 0) {
                    return;
                } var ac, ab = aa[ad], ae = aa[ad + 1], af = aa[ad + 2];
                ac = document.createElement("div");
                ac.className = e + " " + c;
                ac.appendChild(ab);
                if (ae) {
                    ac.appendChild(ae);
                } if (af) {
                    ac.appendChild(af);
                } Q.appendChild(ac);
            } for (var R = 0, T = S.length;
            R < T;
            R++) {
                Z(R, S);
            } for (var R = 0, T = U.length;
            R < T;
            R++) {
                Z(R, U);
            } for (var R = 0, T = X.length;
            R < T;
            R++) {
                Z(R, X);
            } for (var R = 0, T = N.length;
            R < T;
            R++) {
                Z(R, N);
            } for (var R = 0, T = Y.length;
            R < T;
            R++) {
                Z(R, Y);
            } for (var R = 0, T = V.length;
            R < T;
            R++) {
                Z(R, V);
            } M.find(m + h).each(function () {
                O._buttonStrips.push(this);
            });
            for (var R = 0, T = V.length;
            R < T;
            R++) {
                Z(R, V);
            } O._updateButtonGuidesInfo();
            if (L.is(":visible")) {
                O._updateSize();
            }
        }, _ensureIntegrity: function () {
            var M = this, N = M._element, L = a(N).find(m + c);
            L.each(function () {
                var P = this, O = a(P).children(m + z);
                O.each(function (R) {
                    if (R % 3 != 0) {
                        return;
                    } var Q = this, S = document.createElement("DIV");
                    S.className = e + G + c;
                    a(S).append(Q).append(O.get(R + 1)).append(O.get(R + 2));
                    a(P).before(S);
                });
            });
        }, _getButtonGuidesWidth: function (P) {
            var Q = this, M = a(Q._element).data("buttonGuides") || [], N = 0, P = !!P;
            for (var R = 0, S = M.length;
            R < S;
            R++) {
                var L = M[R], O = p(L, P);
                N += O;
            } return N;
        }, _updateButtonGuidesInfo: function () {
            var N = this, O = N._element, L = a(O), P = L.children(m + u).get(0), M = a(P);
            L.data("buttonGuides", M.children(m + e).get());
        }, _enlargeGroup: function () {
            var L = this;
            switch (L._groupVariant) {
                case b.RibbonBarGroupVariant.Collapsed: L._expandGroup();
                    break;
                case b.RibbonBarGroupVariant.Small: L._enlargeGroupToMedium();
                    break;
                case b.RibbonBarGroupVariant.Medium: L._enlargeGroupToLarge();
                    break;
                case b.RibbonBarGroupVariant.Large: L._enlargeGroupToFull();
                    break;
                case b.RibbonBarGroupVariant.Full: case Default: break;
            } L._updateSize();
        }, _enlargeGroupToMedium: function () {
            var L = this;
            if (L._groupVariant != b.RibbonBarGroupVariant.Small) {
                return;
            } a.each(L._largeButtons, function () {
                this._enlargeButton();
            });
            L._groupVariant = b.RibbonBarGroupVariant.Medium;
            return;
            if (L._largeButtons.length == 0 || L._largeButtons.length == 1) {
                L._enlargeGroup();
            }
        }, _enlargeGroupToLarge: function () {
            var L = this;
            if (L._groupVariant != b.RibbonBarGroupVariant.Medium) {
                return;
            } a.each(L._largeButtons, function () {
                this._enlargeButton();
            });
            L._groupVariant = b.RibbonBarGroupVariant.Large;
            return;
            if (L._largeButtons.length == 0 || L._largeButtons.length == 1) {
                L._enlargeGroup();
            }
        }, _enlargeGroupToFull: function () {
            var L = this;
            if (L._groupVariant != b.RibbonBarGroupVariant.Large) {
                return;
            } a.each(L._mediumButtons, function () {
                this._enlargeButton();
            });
            L._groupVariant = b.RibbonBarGroupVariant.Full;
            return;
            if (L._mediumButtons.length == 0) {
                L._enlargeGroup();
            }
        }, _reduceGroup: function () {
            var L = this;
            switch (L._groupVariant) {
                case b.RibbonBarGroupVariant.Full: L._reduceGroupToLarge();
                    break;
                case b.RibbonBarGroupVariant.Large: L._reduceGroupToMedium();
                    break;
                case b.RibbonBarGroupVariant.Medium: L._reduceGroupToSmall();
                    break;
                case b.RibbonBarGroupVariant.Small: L._collapseGroup();
                    break;
                case b.RibbonBarGroupVariant.Collapsed: case Default: break;
            } L._updateSize();
        }, _reduceGroupToLarge: function () {
            var L = this;
            if (L._groupVariant != b.RibbonBarGroupVariant.Full) {
                return;
            } a.each(L._mediumButtons, function () {
                this._reduceButton();
            });
            L._groupVariant = b.RibbonBarGroupVariant.Large;
            return;
            if (L._mediumButtons.length == 0) {
                L._reduceGroup();
            }
        }, _reduceGroupToMedium: function () {
            var L = this;
            if (L._groupVariant != b.RibbonBarGroupVariant.Large) {
                return;
            } if (L._largeButtons.length > 1) {
                a.each(L._largeButtons, function () {
                    this._reduceButton();
                });
            } this._groupVariant = b.RibbonBarGroupVariant.Medium;
            return;
            if (L._largeButtons.length == 0 || L._largeButtons.length == 1) {
                L._reduceGroup();
            }
        }, _reduceGroupToSmall: function () {
            var L = this;
            if (L._groupVariant != b.RibbonBarGroupVariant.Medium) {
                return;
            } if (L._largeButtons.length > 1) {
                a.each(L._largeButtons, function () {
                    this._reduceButton();
                });
            } this._groupVariant = b.RibbonBarGroupVariant.Small;
            return;
            if (L._largeButtons.length == 0 || L._largeButtons.length == 1) {
                L._reduceGroup();
            }
        }, _expandGroup: function () {
            var L = this;
            if (L._groupVariant != b.RibbonBarGroupVariant.Collapsed) {
                return;
            } a(L._element).removeClass(y);
            a(L._collapsedGroup).addClass(y);
            L._groupVariant = L._previousGroupVariant;
        }, _collapseGroup: function () {
            var L = this;
            if (L._groupVariant == b.RibbonBarGroupVariant.Collapsed) {
                return;
            } a(L._element).addClass(y);
            a(L._collapsedGroup).removeClass(y);
            L._previousGroupVariant = L._groupVariant;
            L._groupVariant = b.RibbonBarGroupVariant.Collapsed;
        }, _spawnCollapsedGroup: function () {
            var Q = this, R = Q._element, T = Q._getRibbonBar(), M, L, N, O;
            if (Q._collapsedGroup) {
                return;
            } M = document.createElement("div");
            M.className = "rrbCollapsedGroup rrbHiddenGroup";
            M.innerHTML = String.format("<span class='rrbGroupTitle'>{0}</span><span class='rrbGroupToggleIcon'></span>", Q._text);
            L = a(M);
            N = document.createElement("span");
            N.className = "rrbGroupIcon";
            O = Q._collapsedImageUrl;
            if (!O) {
                var S = Q.get_items();
                if (S.get_count()) {
                    var P = Q.get_items().getItem(0);
                    if (P.get_imageUrl) {
                        O = P.get_imageUrl();
                    }
                }
            } if (O) {
                N.style.backgroundImage = String.format("url('{0}')", O);
            } M.insertBefore(N, M.firstChild);
            M.innerHTML = String.format("<div class='rrbButtonGroupIn'>{0}</div>", M.innerHTML);
            R.parentNode.insertBefore(M, R);
            Q._collapsedGroup = M;
            L.data("group", R);
            L.on({
                click: function (U) {
                    U.preventDefault();
                    U.stopImmediatePropagation();
                    T._hideMenus();
                    if (T.get_quickAccessToolbar()) {
                        T.get_quickAccessToolbar().hideDropDown();
                    } if (T._detachedGroup) {
                        T._detachedGroup._attachGroup();
                    } Q._detachGroup();
                    T._detachedGroup = Q;
                }
            });
        }, _attachGroup: function () {
            var O = this, L = O._$element, M = O._collapsedGroup, N = L.parent().closest(".rrbDetachedContainer");
            L.removeClass("rrbDetachedGroup").insertAfter(M);
            L.find(".rrbButtonClicked").removeClass("rrbButtonClicked");
            N.remove();
        }, _detachGroup: function () {
            var O = this, R = O._getRibbonBar(), M = O._$element, L = a(O._collapsedGroup);
            M.addClass("rrbDetachedGroup");
            var N = a('<div class="rrbDetachedContainer"><div class="rrbContentWrapOut"><div class="rrbContentWrapMid"><div class="rrbContentWrapIn"></div></div></div></div>').appendTo(R._element);
            var Q = L.position(), P = N.find(".rrbContentWrapIn"), S = a(R._tabsContainerElement);
            N.css({ position: "absolute", left: Q.left + 1, top: S.outerHeight(true) + L.outerHeight(true) - 6 });
            if ($telerik.isIE6 || $telerik.quirksMode) {
                N.width(M.outerWidth(true) + 2);
            } P.append(M);
        }
    };
    a.registerControlProperties(b.RibbonBarGroup, { collapsedImageUrl: "", groupVariant: b.RibbonBarGroupVariant.Full, previousGroupVariant: b.RibbonBarGroupVariant.Full, launcherElement: null, value: "" });
    b.RibbonBarGroup.registerClass("Telerik.Web.UI.RibbonBarGroup", b.RibbonBarChild);
})($telerik.$);
(function () {
    var a = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    a.RibbonBarGroupCollection = function (b) {
        a.RibbonBarGroupCollection.initializeBase(this, [b]);
        this._combinedGroupWidth = 0;
    };
    a.RibbonBarGroupCollection.prototype = {
        getGroup: function (b) {
            return this.getItem(b);
        }, _getCombinedGroupWidth: function (c) {
            var d = this, c = !!c, b = d._combinedGroupWidth;
            if (c) {
                combinedWidth = 0;
            } if (b == 0) {
                d.forEach(function (e) {
                    var f = $(e._element).outerWidth(true);
                    if (e._groupVariant == a.RibbonBarGroupVariant.Collapsed) {
                        f = $(e._collapsedGroup).outerWidth(true) + 4;
                    } b += e.get_width(c);
                });
            } d._combinedGroupWidth = b;
            return d._combinedGroupWidth;
        }
    };
    a.RibbonBarGroupCollection.registerClass("Telerik.Web.UI.RibbonBarGroupCollection", a.RibbonBarChildCollection);
})();
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarItem = function (c) {
        b.RibbonBarItem.initializeBase(this, [c]);
        this._$element = a(this._element);
        this._owner = null;
        this._enabled = null;
        this._toolTip = null;
    };
    b.RibbonBarItem.prototype = {
        get_toolTip: function () {
            return this._toolTip;
        }, set_toolTip: function (c) {
            this._toolTip = c;
        }, get_owner: function () {
            if (!this._owner) {
                this._owner = this._parent._owner;
            } return this._owner;
        }, get_enabled: function () {
            if (this._enabled == null) {
                this._enabled = (this._$element.attr("disabled")) ? false : true;
            } return this._enabled;
        }, set_enabled: function (f) {
            if (this.get_enabled() == f) {
                return;
            } this._enabled = f;
            if (this._element) {
                var d = "rrbDisabled", e = this._getRibbonBar(), c = this._$element;
                if (f) {
                    if (c.hasClass(d)) {
                        c.removeClass(d);
                        c.removeAttr("disabled");
                    } e._updateEnabledItems(this);
                } else {
                    if (!c.hasClass(d)) {
                        c.addClass(d);
                        c.attr("disabled", "disabled");
                    } e._updateDisabledItems(this);
                } if (this._updateImageElement) {
                    this._updateImageElement();
                }
            }
        }, get_hierarchicalIndex: function () {
            var e = this.get_owner(), d = "";
            if (e.get_tab) {
                var f = this.get_owner().get_tab().get_index(), c = this.get_owner().get_index();
                d = f + ":" + c;
            } else {
                d = e.get_hierarchicalIndex();
            } return d + ":" + this.get_index();
        }
    };
    a.registerControlProperties(b.RibbonBarItem, { group: null, value: "" });
    b.RibbonBarItem.registerClass("Telerik.Web.UI.RibbonBarItem", b.RibbonBarChild);
})($telerik.$);
(function (b, a) {
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarGallery = function (c) {
        b.RibbonBarGallery.initializeBase(this, [c]);
        if (c) {
            c._button = this;
        } this._commandName = "";
        this._itemHeight = 32;
        this._itemWidth = 32;
        this._columns = 5;
        this._categories = new Telerik.Web.UI.RibbonBarGalleryCategoryCollection(this);
        this._popup = null;
        this._highlightedItem = null;
        this._itemPaddings = 6;
        this._actionButtonsWidth = 15;
        this._scrollbarWidth = 17;
        this._scrollTop = 0;
    };
    b.RibbonBarGallery.prototype = {
        initialize: function (c) {
            this._setItemProperties(c);
            this._updateGalleryWidth();
        }, get_eventName: function () {
            return b.RadRibbonBar.get_eventName(Object.getTypeName(this));
        }, _setItemProperties: function (c) {
            if (c.commandName) {
                this._commandName = c.commandName;
            } if (c.itemHeight) {
                this._itemHeight = c.itemHeight;
            } if (c.itemWidth) {
                this._itemWidth = c.itemWidth;
            } if (c.columns) {
                this._columns = c.columns;
            } if (c.expandedColumns) {
                this.set_expandedColumns(c.expandedColumns);
            } if (c.expandedHeight) {
                this.set_expandedHeight(c.expandedHeight);
            }
        }, _updateGalleryWidth: function () {
            var d = this._getItemFullWidth(), c = this.get_columns();
            this.get_element().style.width = ((c * d) + this._actionButtonsWidth) + "px";
        }, _getScrollableElement: function () {
            return a(this.get_element()).find(".rrbGalleryScrollWrap")[0];
        }, _getItemFullWidth: function () {
            return this._itemWidth + this._itemPaddings;
        }, _getItemFullHeight: function () {
            return this._itemHeight + this._itemPaddings;
        }, _onItemSelected: function (c, f) {
            var e = this._ribbonBar, d;
            if (!this._ribbonBar) {
                return;
            } if (f) {
                d = this.get_selectedItem();
                if (d) {
                    d._setSelected(false);
                    e._unregisterGallerySelectedIndex(d.get_hierarchicalIndex());
                } e._registerGallerySelectedIndex(c.get_hierarchicalIndex());
            } else {
                e._unregisterGallerySelectedIndex(c.get_hierarchicalIndex());
            }
        }, _createPopupElement: function () {
            var e = document.createElement("div"), d = document.createElement("div"), c = document.createElement("div");
            e.tabIndex = 1;
            e.className = "rrbSlide rrbSlide_" + this._getRibbonBar()._skin;
            d.className = "rrbPopup";
            c.className = this.get_element().className;
            e.appendChild(d);
            d.appendChild(c);
            a(document).find("form").prepend(e);
            e._gallery = this;
            return e;
        }, _positionPopupElement: function () {
            var c = a(this.get_element()), f = c.offset(), e = a(this._popup), d = e.find(".rrbGalleryScrollWrap"), h = (this.get_expandedColumns() * this._getItemFullWidth()) + this._scrollbarWidth, g = this.get_expandedHeight();
            e.css({ top: f.top + "px", left: f.left + "px" });
            d.css({ width: h + "px" });
            if (g != -1) {
                d.css({ height: g + "px" });
            }
        }, get_itemHeight: function () {
            return this._itemHeight;
        }, get_itemWidth: function () {
            return this._itemWidth;
        }, get_categories: function () {
            return this._categories;
        }, getCategory: function (c) {
            return this._categories.getCategory(c);
        }, get_commandName: function () {
            return this._commandName;
        }, get_columns: function () {
            return this._columns;
        }, set_columns: function (c) {
            this._columns = c;
            this._updateGalleryWidth();
            this._getRibbonBar().repaint();
        }, get_selectedItem: function () {
            var d = this.get_categories().get_count(), c, g, f;
            for (var e = 0;
            e < d;
            e++) {
                c = this.getCategory(e);
                g = c.get_items().get_count();
                for (var h = 0;
                h < g;
                h++) {
                    f = c.getItem(h);
                    if (f.get_selected()) {
                        return f;
                    }
                }
            } return null;
        }, scrollUp: function () {
            var d = this._scrollTop, c = d - this._getItemFullHeight(), e = this._getScrollableElement();
            if (d > 0) {
                if (c < 0) {
                    c = 0;
                } a(e).animate({ scrollTop: c }, 200);
                this._scrollTop = c;
            }
        }, scrollDown: function () {
            var d = this._scrollTop, c = d + this._getItemFullHeight(), e = this._getScrollableElement(), f = e.scrollHeight;
            if (c < f) {
                a(e).animate({ scrollTop: c }, 200);
                this._scrollTop = c;
            }
        }, expand: function () {
            if (this._popup !== null) {
                return;
            } this._popup = this._createPopupElement();
            a(this._popup).find(".rrbGallery").append(this._getScrollableElement());
            this._positionPopupElement();
            a(this._element).addClass("rrbGalleryExpanded");
            this._attachPopupEvents();
            a(this._popup).focus();
        }, collapse: function () {
            if (this._popup === null) {
                return;
            } var c = a(this._popup).find(".rrbGalleryScrollWrap");
            c.prependTo(this.get_element());
            c.css({ width: "", height: "" });
            this._detachPopupEvents();
            a(this._popup).remove();
            this._popup = null;
            if (this._highlightedItem) {
                this._highlightedItem._setHighlighted(false);
            } a(this._element).removeClass("rrbGalleryExpanded");
            if (this.get_selectedItem()) {
                this.get_selectedItem().scrollIntoView();
            }
        }, _attachPopupEvents: function () {
            var c = a(this._popup), d = this;
            c.on({
                keydown: function (f) {
                    d._onKeyDown(f);
                }
            });
        }, _detachPopupEvents: function () {
            var c = a(this._popup);
            c.off();
        }, _onKeyDown: function (d) {
            var j = Sys.UI.Key, k = d.keyCode, f = this._highlightedItem, o = this.get_selectedItem(), m, c = this.get_expandedColumns(), i = k == j.down || k == j.up || k == j.left || k == j.right;
            if (!f && i) {
                if (o) {
                    o._setHighlighted(true);
                } else {
                    this.getCategory(0).getItem(0)._setHighlighted(true);
                } d.preventDefault(d);
                d.stopPropagation(d);
                return;
            } if ((!f && k == j.enter) || k == j.esc) {
                this.collapse();
                return;
            } if (!i && k != j.enter && k != j.esc) {
                return;
            } d.preventDefault(d);
            d.stopPropagation(d);
            var n = f.get_category(), p = this.get_categories().get_count(), q = n.get_items().get_count(), h = f.get_index(), g = h % c;
            highlightedItemRowStartIndex = h - g;
            switch (k) {
                case j.down: m = h + c;
                    if (m >= q) {
                        do {
                            n = this.getCategory((n.get_index() + 1) % p);
                        } while (n.get_items().get_count() <= g);
                        m = g;
                    } n.getItem(m)._setHighlighted(true);
                    n.getItem(m).scrollIntoView(true);
                    break;
                case j.up: m = h - c;
                    if (m < 0) {
                        do {
                            var l = (n.get_index() - 1) % p;
                            if (l == -1) {
                                l = p - 1;
                            } n = this.getCategory(l);
                        } while (n.get_items().get_count() <= g);
                        q = n.get_items().get_count();
                        m = (q - (q % c)) + g;
                        if (m >= q) {
                            m -= c;
                        }
                    } n.getItem(m)._setHighlighted(true);
                    n.getItem(m).scrollIntoView();
                    break;
                case j.left: m = highlightedItemRowStartIndex + ((h - 1) % c);
                    if (m == -1) {
                        m = c - 1;
                    } if (m >= q) {
                        m = q - 1;
                    } n.getItem(m)._setHighlighted(true);
                    break;
                case j.right: m = highlightedItemRowStartIndex + ((h + 1) % c);
                    if (m >= q) {
                        m = highlightedItemRowStartIndex;
                    } n.getItem(m)._setHighlighted(true);
                    break;
                case j.enter: this.collapse();
                    if (f) {
                        f.select();
                    } break;
                case j.esc: this.collapse();
                    break;
            }
        }, _onItemHighlightChanged: function (c, d) {
            if (d && this._highlightedItem) {
                a(this._highlightedItem.get_element()).removeClass("rrbGalleryItemHovered");
            } this._highlightedItem = d ? c : null;
        }
    };
    a.registerControlProperties(b.RibbonBarGallery, { expandedHeight: -1, expandedColumns: 5 });
    b.RibbonBarGallery.registerClass("Telerik.Web.UI.RibbonBarGallery", b.RibbonBarItem);
})(Telerik.Web.UI, $telerik.$);
(function (b, a) {
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarGalleryCategory = function (c) {
        b.RibbonBarGalleryCategory.initializeBase(this, [c]);
        this._owner = null;
        this._items = new Telerik.Web.UI.RibbonBarChildCollection(this);
    };
    b.RibbonBarGalleryCategory.prototype = {
        _onChildAdded: function (c) {
            c.set_category(this);
            c.set_owner(this.get_owner());
        }, get_items: function () {
            return this._items;
        }, getItem: function (c) {
            return this._items.getItem(c);
        }, get_owner: function () {
            if (!this._owner && this._parent) {
                this._owner = this._parent._owner;
            } return this._owner;
        }, get_hierarchicalIndex: function () {
            return this.get_owner().get_hierarchicalIndex() + ":" + this.get_index();
        }
    };
    a.registerControlProperties(b.RibbonBarGalleryCategory, { title: "" });
    b.RibbonBarGalleryCategory.registerClass("Telerik.Web.UI.RibbonBarGalleryCategory", b.RibbonBarChild);
})(Telerik.Web.UI, $telerik.$);
(function (a) {
    Type.registerNamespace("Telerik.Web.UI");
    a.RibbonBarGalleryCategoryCollection = function (b) {
        a.RibbonBarGalleryCategoryCollection.initializeBase(this, [b]);
    };
    a.RibbonBarGalleryCategoryCollection.prototype = {
        getCategory: function (b) {
            return this.getItem(b);
        }
    };
    a.RibbonBarGalleryCategoryCollection.registerClass("Telerik.Web.UI.RibbonBarGalleryCategoryCollection", a.RibbonBarChildCollection);
})(Telerik.Web.UI);
(function (b, a) {
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarGalleryItem = function (c) {
        b.RibbonBarGalleryItem.initializeBase(this, [c]);
        if (c) {
            c._button = this;
        } this._commandArgument = "";
        this._selected = false;
    };
    b.RibbonBarGalleryItem.prototype = {
        _setSelected: function (c) {
            if (this._owner) {
                this._owner._onItemSelected(this, c);
            } this._selected = c;
            a(this.get_element()).toggleClass("rrbGalleryItemSelected", c);
            if (c) {
                this.scrollIntoView();
            }
        }, _isVisible: function () {
            var h = this._getScrollParent(), d = h.scrollTop, c = d + h.offsetHeight, e = this.get_element(), g = a(e).position().top + h.scrollTop - 1, f = g + e.offsetHeight;
            return (g >= d && f <= c);
        }, _setHighlighted: function (d) {
            var c = a(this.get_element());
            if (c.hasClass("rrbGalleryItemHovered") == d) {
                return;
            } c.toggleClass("rrbGalleryItemHovered", d);
            if (this._owner) {
                this._owner._onItemHighlightChanged(this, d);
            }
        }, _getScrollParent: function () {
            return a(this._element).parents(".rrbGalleryScrollWrap")[0];
        }, set_owner: function (c) {
            this._owner = c;
        }, get_commandArgument: function () {
            return this._commandArgument;
        }, set_image: function (d) {
            var c = this.get_imageElement();
            if (c) {
                c.src = d || $telerik._emptySrc();
            }
        }, get_imageElement: function () {
            return a(this.get_element()).find(".rrbGalleryItemImage").get(0);
        }, get_textElement: function () {
            return a(this.get_element()).find(".rrbGalleryItemText").get(0);
        }, get_text: function () {
            var c = this.get_textElement();
            if (!this._text && c) {
                this._text = a(c).text();
            } return this._text;
        }, set_text: function (c) {
            var d = this.get_textElement();
            this._text = c;
            if (d) {
                a(d).html(c);
            }
        }, get_selected: function () {
            return this._selected;
        }, set_selected: function (c) {
            if (this._selected === c) {
                return;
            } this._setSelected(c);
            if (this._owner && this._owner._ribbonBar) {
                this._owner._ribbonBar._onGalleryItemSelected(this);
            }
        }, select: function () {
            this.set_selected(true);
        }, unselect: function () {
            this.set_selected(false);
        }, toggle: function () {
            this.set_selected(!this.get_selected());
        }, get_hierarchicalIndex: function () {
            return this.get_category().get_hierarchicalIndex() + ":" + this.get_index();
        }, scrollIntoView: function (f) {
            var d = this._owner, c = this.get_element(), e = this._getScrollParent(), g = a(c).position().top + e.scrollTop - 1;
            if (!this._isVisible()) {
                if (f) {
                    g = g + c.offsetHeight - e.offsetHeight;
                } d._scrollTop = g;
                e.scrollTop = g;
            }
        }
    };
    a.registerControlProperties(b.RibbonBarGalleryItem, { imageUrl: "", category: null });
    b.RibbonBarGalleryItem.registerClass("Telerik.Web.UI.RibbonBarGalleryItem", b.RibbonBarItem);
})(Telerik.Web.UI, $telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarDropDownBase = function (c) {
        b.RibbonBarDropDownBase.initializeBase(this, [c]);
        if (c) {
            c._button = this;
        }
    };
    b.RibbonBarDropDownBase.prototype = {
        initialize: function (c) {
            this._setItemProperties(c);
        }, _setItemProperties: function (c) { }, get_eventName: function () {
            return b.RadRibbonBar.get_eventName(Object.getTypeName(this));
        }
    };
    a.registerControlProperties(b.RibbonBarDropDownBase, {});
    b.RibbonBarDropDownBase.registerClass("Telerik.Web.UI.RibbonBarDropDownBase", b.RibbonBarItem);
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI, c = ".", e = "rrbListItem", d = "rrbListItemHovered";
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarDropDown = function (f) {
        b.RibbonBarDropDown.initializeBase(this, [f]);
        this._selectedIndex = -1;
        this._items = new Telerik.Web.UI.RibbonBarChildCollection(this);
    };
    b.RibbonBarDropDown.prototype = {
        _setItemProperties: function (f) {
            if (f.toolTip) {
                this.set_toolTip(f.toolTip);
                this.get_element().removeAttribute("title");
            }
        }, get_items: function () {
            return this._items;
        }, get_selectedIndex: function () {
            return this._selectedIndex;
        }, set_selectedIndex: function (f) {
            if (this.get_selectedIndex() !== f) {
                this._ribbonBar._onDropDownSelectedIndexChange(this, f);
            }
        }, _setSelectedIndex: function (f) {
            var h = this._ribbonBar, g = a.proxy(h._registerDropDownSelectedIndex, h), i = a.proxy(h._unregisterDropDownSelectedIndex, h);
            this._setAndRegisterSelectedIndex(f, g, i);
        }, _setAndRegisterSelectedIndex: function (f, g, i) {
            var h = this.get_selectedItem();
            if (h) {
                h._selected = false;
                i(h.get_hierarchicalIndex());
            } this._selectedIndex = f;
            h = this.get_items().getItem(f);
            if (h) {
                h._selected = true;
                g(h.get_hierarchicalIndex());
            } this._updateInputElement();
        }, get_selectedItem: function () {
            return this.get_items().getItem(this.get_selectedIndex());
        }, _updateInputElement: function (h) {
            var g = this.get_selectedItem(), f;
            if (h) {
                f = h;
            } else {
                if (g) {
                    f = g.get_text();
                }
            } if (f) {
                this._setInputElementValue(f);
            }
        }, _getInputElement: function () {
            return a(this.get_element()).find(".rrbDDFakeInput")[0];
        }, _setInputElementValue: function (f) {
            a(this._getInputElement()).text(f);
        }, highlightNext: function () {
            var h = a(this._popup._element), f = h.find(c + d).last(), g = f[0] ? f.next() : h.find(c + e).first();
            f.removeClass(d);
            g.addClass(d);
        }, highlightPrev: function () {
            var h = a(this._popup._element), f = h.find(c + d).first(), g = f[0] ? f.prev() : h.find(c + e).last();
            f.removeClass(d);
            g.addClass(d);
        }, _selectHighlightedItem: function () {
            var f = a(this._popup._element).find(c + d).first().index();
            if (f != -1) {
                this.set_selectedIndex(f);
            }
        }
    };
    a.registerControlProperties(b.RibbonBarDropDown, {});
    b.RibbonBarDropDown.registerClass("Telerik.Web.UI.RibbonBarDropDown", b.RibbonBarDropDownBase);
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarComboBox = function (c) {
        b.RibbonBarComboBox.initializeBase(this, [c]);
    };
    b.RibbonBarComboBox.prototype = {
        _setItemProperties: function (c) {
            if (c.text) {
                this._setText(c.text);
            } if (c.toolTip) {
                this.set_toolTip(c.toolTip);
                this.get_element().removeAttribute("title");
            }
        }, set_text: function (c) {
            this._setText(c);
            this._setSelectedIndex(-1);
            this._ribbonBar._onComboBoxTextChange(this, c);
        }, _setText: function (c) {
            this._text = c;
            this._updateInputElement(c);
        }, get_text: function () {
            var d = "", c = this.get_selectedItem();
            if (c) {
                d = c.get_text();
            } else {
                d = this._text;
            } return d;
        }, set_selectedIndex: function (c) {
            if (this.get_selectedIndex() !== c) {
                this._ribbonBar._onComboBoxSelectedIndexChange(this, c);
            }
        }, _setSelectedIndex: function (c) {
            var e = this._ribbonBar, d = a.proxy(e._registerComboBoxSelectedIndex, e), f = a.proxy(e._unregisterComboBoxSelectedIndex, e);
            this._setAndRegisterSelectedIndex(c, d, f);
        }, _getInputElement: function () {
            return a(this.get_element()).find(".rrbCBInput")[0];
        }, _setInputElementValue: function (c) {
            this._getInputElement().value = c;
        }, set_enabled: function (d) {
            b.RibbonBarComboBox.callBaseMethod(this, "set_enabled", [d]);
            var c = a(this._getInputElement());
            if (d) {
                c.removeAttr("readonly");
            } else {
                c.attr("readonly", "readonly");
            }
        }
    };
    a.registerControlProperties(b.RibbonBarComboBox, {});
    b.RibbonBarComboBox.registerClass("Telerik.Web.UI.RibbonBarComboBox", b.RibbonBarDropDown);
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI, c = ".", e = "rrbCPColorBox", d = "rrbListItemHovered";
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarColorPicker = function (f) {
        b.RibbonBarColorPicker.initializeBase(this, [f]);
        this._selectedColor = "";
    };
    b.RibbonBarColorPicker.prototype = {
        _setItemProperties: function (f) {
            if (f.selectedColor) {
                this._setSelectedColor(f.selectedColor);
            } if (f.toolTip) {
                this.set_toolTip(f.toolTip);
                this.get_element().removeAttribute("title");
            }
        }, initialize: function (f) {
            this._setItemProperties(f);
        }, get_selectedColor: function () {
            return this._selectedColor;
        }, set_selectedColor: function (f) {
            this._ribbonBar._onColorPickerColorChange(this, f);
        }, _setSelectedColor: function (f) {
            this._selectedColor = f;
            this._setPreviewColor(f);
        }, _setPreviewColor: function (g) {
            var f = a(this.get_element()).find(".rrbCPColorPreview")[0];
            f.style.backgroundColor = g;
        }, highlightNext: function () {
            var h = a(this._popup._element), f = h.find(c + d).last(), g = f[0] ? f.parent().next().find(c + e) : h.find(c + e).first();
            f.removeClass(d);
            g.addClass(d);
        }, highlightPrev: function () {
            var h = a(this._popup._element), f = h.find(c + d).first(), g = f[0] ? f.parent().prev().find(c + e) : h.find(c + e).last();
            f.removeClass(d);
            g.addClass(d);
        }, highlightRight: function () {
            this.highlightNext();
        }, highlightLeft: function () {
            this.highlightPrev();
        }, _selectHighlightedItem: function () {
            var f = a(this._popup._element).find(c + d).first();
            if (f[0]) {
                newValue = f.find("span").text();
                this.set_selectedColor(newValue);
            }
        }
    };
    a.registerControlProperties(b.RibbonBarColorPicker, {});
    b.RibbonBarColorPicker.registerClass("Telerik.Web.UI.RibbonBarColorPicker", b.RibbonBarDropDownBase);
})($telerik.$);
(function (b, a) {
    var c = b.RadRibbonBar;
    c.DropDown = function (d) {
        this._element = d;
        if (d) {
            d._popup = this;
        }
    };
    c.DropDown.prototype = {
        show: function (f) {
            var d = a(this._element), e = d.height();
            d.stop(true, true).show();
            d.height(0);
            d.animate({ height: e }, "fast");
            this.position(f);
        }, hide: function () {
            var d = a(this._element);
            d.stop(true, true).slideUp("fast", function () {
                d.hide();
                d.css({ top: "", left: "" });
            });
        }, toggle: function (d) {
            if (a(this._element).is(":visible")) {
                this.hide();
            } else {
                this.show(d);
            }
        }, position: function (f) {
            var d = a(this._element), e = a(f), g = e.offset();
            d.css({ top: g.top + e.height() + "px", left: g.left + "px" });
        }
    };
    c.DropDown.registerClass("Telerik.Web.UI.RadRibbonBar.DropDown");
})(Telerik.Web.UI, $telerik.$);
(function (a, b) {
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarListItem = function (c) {
        b.RibbonBarListItem.initializeBase(this, [c]);
        if (c) {
            c._button = this;
        } this._text = "";
        this._selected = false;
    };
    b.RibbonBarListItem.prototype = {
        set_owner: function (c) {
            this._owner = c;
        }, set_text: function (d) {
            var c = this.get_element();
            this._text = d;
            if (c) {
                a(c).html(d);
            }
        }, get_text: function () {
            return this._text;
        }, get_selected: function () {
            return this._selected;
        }, set_selected: function (e) {
            var d = this.get_owner();
            if (d) {
                var c = e ? this.get_index() : -1;
                d.set_selectedIndex(c);
            } else {
                this._selected = e;
            }
        }, select: function () {
            this.set_selected(true);
        }, unselect: function () {
            this.set_selected(false);
        }, get_hierarchicalIndex: function () {
            var c = "";
            var d = this.get_owner();
            if (d) {
                c = d.get_hierarchicalIndex();
            } return c + ":" + this.get_index();
        }
    };
    a.registerControlProperties(b.RibbonBarListItem, {});
    b.RibbonBarListItem.registerClass("Telerik.Web.UI.RibbonBarListItem", b.RibbonBarItem);
})($telerik.$, Telerik.Web.UI);
(function (a, b) {
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarNumericTextBox = function (c) {
        b.RibbonBarNumericTextBox.initializeBase(this, [c]);
        if (c) {
            c._button = this;
        } this._precision = 1000;
    };
    b.RibbonBarNumericTextBox.prototype = {
        initialize: function (c) {
            this._setItemProperties(c);
        }, _setItemProperties: function (c) {
            if (c.value) {
                this._value = parseFloat(c.value);
            } if (c.step) {
                this.set_step(parseFloat(c.step));
            } if (c.prefix) {
                this.set_prefix(c.prefix);
            } if (c.suffix) {
                this.set_suffix(c.suffix);
            } if (c.toolTip) {
                this.set_toolTip(c.toolTip);
                this.get_element().removeAttribute("title");
            }
        }, get_eventName: function () {
            return b.RadRibbonBar.get_eventName(Object.getTypeName(this));
        }, set_value: function (d) {
            var e = parseFloat(d), c = this._ribbonBar;
            if (isNaN(e)) {
                this._updateInputElement();
                return;
            } if (c) {
                c._onNumericTextBoxValueChange(this, e);
            } else {
                this._setValue(e);
            }
        }, _setValue: function (c) {
            this._value = c;
            this._updateInputElement();
        }, _updateInputElement: function () {
            var d = this.get_prefix() + this.get_value() + this.get_suffix(), c = this.get_inputElement();
            if (c) {
                c.value = d;
            }
        }, get_inputElement: function () {
            return a(this.get_element()).find(".rrbNTBInput").get(0);
        }, increment: function () {
            this.set_value(this._getNextValue(true));
        }, decrement: function () {
            this.set_value(this._getNextValue(false));
        }, _getNextValue: function (e) {
            var g = this._precision, c = this.get_step() * g, d = this.get_value() * g, f;
            if (e) {
                f = (d + c) / g;
            } else {
                f = (d - c) / g;
            } return f;
        }, set_enabled: function (d) {
            b.RibbonBarNumericTextBox.callBaseMethod(this, "set_enabled", [d]);
            var c = a(this.get_inputElement());
            if (d) {
                c.removeAttr("readonly");
            } else {
                c.attr("readonly", "readonly");
            }
        }
    };
    a.registerControlProperties(b.RibbonBarNumericTextBox, { step: 1, prefix: "", suffix: "" });
    b.RibbonBarNumericTextBox.registerClass("Telerik.Web.UI.RibbonBarNumericTextBox", b.RibbonBarItem);
})($telerik.$, Telerik.Web.UI);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    a.registerEnum(b, "RibbonBarButtonSize", { Large: 0, Medium: 1, Small: 2 });
    b.RibbonBarImageButtonBase = function (c) {
        b.RibbonBarImageButtonBase.initializeBase(this, [c]);
        this._imageElement = null;
        this._textElement = null;
        this._renderingModeCssClass = (this._element && a(this._element).hasClass("rrbDualImage")) ? "rrbDualImage" : "";
        this._commandName = "";
        this._commandArgument = "";
    };
    b.RibbonBarImageButtonBase.prototype = {
        get_imageElement: function () {
            if (!this._imageElement) {
                if (this._element) {
                    var c = this._$element, e = c.find(".rrbButtonImage");
                    if (e.length == 0) {
                        var f = c.find(".rrbButtonIn"), g = c.find(".rrbButtonText"), h = $telerik._emptySrc(), d = a('<span class="rrbImagePlaceholder"><img src="' + h + '" class="rrbButtonImage" style="visibility: hidden;"></span>');
                        if (g.length > 0) {
                            d.insertBefore(g);
                        } else {
                            f.append(d);
                        } this._imageElement = c.find(".rrbButtonImage").get(0);
                    } else {
                        this._imageElement = e.get(0);
                    }
                }
            } return this._imageElement;
        }, set_image: function (e) {
            var d = this.get_imageElement();
            if (d) {
                var c = $telerik._emptySrc();
                if (e == "") {
                    e = c;
                } d.src = e;
                this._resolveImageVisibility();
            }
        }, _resolveImageVisibility: function () {
            var c = this.get_imageElement();
            if (c) {
                var d = c.src;
                if (d.lenght == 0 || (d == "about:blank")) {
                    c.style.visibility = "hidden";
                } else {
                    c.style.visibility = "visible";
                }
            }
        }, get_textElement: function () {
            if (!this._textElement && this._element) {
                this._textElement = a(this._element).find(".rrbTextContent");
            } return this._textElement;
        }, get_text: function () {
            if (this._text) {
                return this._text;
            } var c = this.get_textElement();
            if (c) {
                this._text = c.text();
            } return this._text;
        }, set_text: function (c) {
            var d = this.get_textElement();
            this._text = c;
            if (d) {
                d.html(this._text);
            }
        }, get_isLarge: function () {
            return this._$element.hasClass("rrbLargeButton");
        }, get_commandName: function () {
            return this._commandName;
        }, get_commandArgument: function () {
            return this._commandArgument;
        }, toggle_ImageRenderingMode: function () {
            var c = this.get_element();
            if (c) {
                if (a(c).hasClass("rrbDualImage")) {
                    a(c).removeClass("rrbDualImage");
                } else {
                    a(c).addClass("rrbDualImage");
                }
            }
        }, _updateParentGroupSize: function () {
            var c = this.get_owner();
            c._updateSize();
        }, _updateTextElement: function () {
            this.set_text(this.get_text());
            this._updateParentGroupSize();
        }, _updateImageElement: function () {
            var c = this._$element;
            if (this._renderingModeCssClass == "" && c.hasClass("rrbDualImage")) {
                this.toggle_ImageRenderingMode();
            } if (c.hasClass("rrbDualImage")) {
                this._updateDualImage();
            } else {
                this._updateClipImage();
            }
        }, _updateDualImage: function () {
            var c, d = this.get_isLarge();
            if (this.get_enabled()) {
                if (d) {
                    c = this.get_imageUrlLarge() ? this.get_imageUrlLarge() : this._getRibbonBar().get_defaultImageUrlLarge();
                } else {
                    c = this.get_imageUrl() ? this.get_imageUrl() : this._getRibbonBar().get_defaultImageUrl();
                }
            } else {
                if (d) {
                    c = this.get_disabledImageUrlLarge() ? this.get_disabledImageUrlLarge() : this._getRibbonBar().get_defaultDisabledImageUrlLarge();
                } else {
                    c = this.get_disabledImageUrl() ? this.get_disabledImageUrl() : this._getRibbonBar().get_defaultDisabledImageUrl();
                }
            } this.set_image(c);
        }, _updateClipImage: function () {
            var c = this.get_enabled(), e = (c && !this.get_imageUrl()) || (!c && !this.get_disabledImageUrl());
            if (e) {
                this.toggle_ImageRenderingMode();
                this._updateDualImage();
            } else {
                var d;
                if (c) {
                    d = this.get_imageUrl();
                } else {
                    d = this.get_disabledImageUrl();
                } this.set_image(d);
            }
        }, _setItemProperties: function (c) {
            if (c.text) {
                this.set_text(c.text);
            } if (c.toolTip) {
                this.set_toolTip(c.toolTip);
                this.get_element().removeAttribute("title");
            } if (c.value) {
                this.set_value(c.value);
            } if (c.imageUrl) {
                this.set_imageUrl(c.imageUrl);
            } if (c.imageUrlLarge) {
                this.set_imageUrlLarge(c.imageUrlLarge);
            } if (c.disabledImageUrl) {
                this.set_disabledImageUrl(c.disabledImageUrl);
            } if (c.disabledImageUrlLarge) {
                this.set_disabledImageUrlLarge(c.disabledImageUrlLarge);
            } if (c.enableButtonSelection) {
                this.set_enableButtonSelection(c.enableButtonSelection);
            } if (c.commandName) {
                this._commandName = c.commandName;
            } if (c.commandArgument) {
                this._commandArgument = c.commandArgument;
            }
        }, _ensureButtonSize: function () {
            var e = this._parent._owner, c = this._$element, d = b.RibbonBarButtonSize;
            if (c.hasClass("rrbLargeButton")) {
                this._buttonSize = d.Large;
                e._largeButtons.push(this);
            } else {
                if (c.hasClass("rrbMediumButton")) {
                    this._buttonSize = d.Medium;
                    e._mediumButtons.push(this);
                } else {
                    if (c.hasClass("rrbMediumButton")) {
                        this._buttonSize = d.Small;
                        e._smallButtons.push(this);
                    }
                }
            } this._initialButtonSize = this._buttonSize;
        }, _enlargeButton: function () {
            var c = this._$element, d = b.RibbonBarButtonSize;
            switch (this._buttonSize) {
                case d.Small: if (this._initialButtonSize == d.Small) {
                    return;
                } c.removeClass("rrbButton").addClass("rrbMediumButton");
                    this._buttonSize = d.Medium;
                    break;
                case d.Medium: if (this._initialButtonSize == d.Medium) {
                    return;
                } c.removeClass("rrbMediumButton").addClass("rrbLargeButton");
                    this._buttonSize = d.Large;
                    break;
                default: break;
            } this._updateImageElement();
        }, _reduceButton: function () {
            var c = this._$element, d = b.RibbonBarButtonSize;
            switch (this._buttonSize) {
                case d.Large: c.removeClass("rrbLargeButton").addClass("rrbMediumButton");
                    this._buttonSize = d.Medium;
                    break;
                case d.Medium: c.removeClass("rrbMediumButton").addClass("rrbButton");
                    this._buttonSize = d.Small;
                    break;
                default: break;
            } this._updateImageElement();
        }
    };
    a.registerControlProperties(b.RibbonBarImageButtonBase, { imageUrl: "", imageUrlLarge: "", disabledImageUrl: "", disabledImageUrlLarge: "" });
    b.RibbonBarImageButtonBase.registerClass("Telerik.Web.UI.RibbonBarImageButtonBase", b.RibbonBarItem);
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarButton = function (c) {
        b.RibbonBarButton.initializeBase(this, [c]);
        this._value = "";
        if (c) {
            c._button = this;
        } this._shouldDisplayDefaultImage = true;
    };
    b.RibbonBarButton.prototype = {
        initialize: function (c) {
            this._setItemProperties(c);
            this._ensureButtonSize();
        }, set_owner: function (c) {
            this._owner = c;
        }, _updateDualImage: function () {
            var d;
            var c = "";
            var e = this.get_isLarge();
            if (this.get_enabled()) {
                if (e) {
                    d = this.get_imageUrlLarge() ? this.get_imageUrlLarge() : this.get_shouldDisplayDefaultImage() ? this._getRibbonBar().get_defaultImageUrlLarge() : c;
                } else {
                    d = this.get_imageUrl() ? this.get_imageUrl() : this.get_shouldDisplayDefaultImage() ? this._getRibbonBar().get_defaultImageUrl() : c;
                }
            } else {
                if (e) {
                    d = this.get_disabledImageUrlLarge() ? this.get_disabledImageUrlLarge() : this.get_shouldDisplayDefaultImage() ? this._getRibbonBar().get_defaultDisabledImageUrlLarge() : c;
                } else {
                    d = this.get_disabledImageUrl() ? this.get_disabledImageUrl() : this.get_shouldDisplayDefaultImage() ? this._getRibbonBar().get_defaultDisabledImageUrl() : c;
                }
            } this.set_image(d);
        }
    };
    a.registerControlProperties(b.RibbonBarButton, { buttonSize: null, shouldDisplayDefaultImage: "", value: "" });
    b.RibbonBarButton.registerClass("Telerik.Web.UI.RibbonBarButton", b.RibbonBarImageButtonBase);
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarToggleButton = function (c) {
        b.RibbonBarToggleButton.initializeBase(this, [c]);
        if (c) {
            c._button = this;
        } this._toggled = false;
    };
    b.RibbonBarToggleButton.prototype = {
        initialize: function (d) {
            var c = this._$element, e = c.hasClass("rrbToggled");
            b.RibbonBarToggleButton.callBaseMethod(this, "initialize", [d]);
            this.set_toggled(e);
        }, set_owner: function (c) {
            this._owner = c;
        }, get_toggled: function () {
            if (this._element) {
                return a(this._element).hasClass("rrbToggled");
            } return this._toggled;
        }, set_toggled: function (d) {
            this._toggled = d;
            var c = a(this._element).add(this._qatItemElement);
            if (d) {
                c.addClass("rrbToggled");
            } else {
                c.removeClass("rrbToggled");
            }
        }, toggle: function () {
            this.set_toggled(!this.get_toggled());
        }, _setQuickAccessToolbarItemElement: function (c) {
            this._qatItemElement = c;
        }
    };
    a.registerControlProperties(b.RibbonBarToggleButton, { toggleList: null });
    b.RibbonBarToggleButton.registerClass("Telerik.Web.UI.RibbonBarToggleButton", b.RibbonBarButton);
})($telerik.$);
(function () {
    var a = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    a.RibbonBarButtonContainer = function (b) {
        a.RibbonBarButtonContainer.initializeBase(this, [b]);
        this._items = new Telerik.Web.UI.RibbonBarChildCollection(this);
    };
    a.RibbonBarButtonContainer.prototype = {
        get_items: function () {
            return this._items;
        }, _onChildAdded: function (b) {
            var c = this.get_owner();
            if (c && c._onChildAdded) {
                c._onChildAdded(b);
            }
        }
    };
    a.RibbonBarButtonContainer.registerClass("Telerik.Web.UI.RibbonBarButtonContainer", a.RibbonBarImageButtonBase);
})();
(function (a) {
    Type.registerNamespace("Telerik.Web.UI");
    var b = Telerik.Web.UI;
    b.RibbonBarMenu = function (c) {
        b.RibbonBarMenu.initializeBase(this, [c]);
        if (c) {
            c._menu = this;
        } this._items = new Telerik.Web.UI.RibbonBarChildCollection(this);
    };
    b.RibbonBarMenu.prototype = {
        initialize: function (e) {
            this._setItemProperties(e);
            this._ensureButtonSize();
            var d = a(this._element), c = d.find(".rrbButtonArrow");
            c.html("<span class='rrbIcon'></span>");
            d.find(".rrbButtonText").after(c);
        }, set_owner: function (c) {
            this._owner = c;
        }, get_eventName: function () {
            return b.RadRibbonBar.get_eventName(Object.getTypeName(this));
        }, get_items: function () {
            return this._items;
        }, _findItemByPropertyRecursiveGeneric: function (g, j) {
            var e = this.get_items();
            for (var c = 0, f = e.get_count() ;
            c < f;
            c++) {
                var d = e.getItem(c);
                if (d["get_" + g]() == j) {
                    return d;
                } var h = d._findItemByPropertyRecursiveGeneric(g, j);
                if (h) {
                    return h;
                }
            } return null;
        }, findMenuItemByValue: function (c) {
            return this._findItemByPropertyRecursiveGeneric("value", c);
        }, findItemByCommandName: function (c) {
            return this._findItemByPropertyRecursiveGeneric("commandName", c);
        }, findItemByCommandArgument: function (c) {
            return this._findItemByPropertyRecursiveGeneric("commandArgument", c);
        }, _onChildAdded: function (c) {
            c.set_group(this.get_group());
            if (c.set_owner) {
                c.set_owner(this);
            }
        }, _enlargeButton: function () {
            var c = this._$element;
            switch (this._buttonSize) {
                case b.RibbonBarButtonSize.Small: if (this._initialButtonSize == b.RibbonBarButtonSize.Small) {
                    return;
                } c.removeClass("rrbButton").addClass("rrbMediumButton");
                    this._buttonSize = b.RibbonBarButtonSize.Medium;
                    break;
                case b.RibbonBarButtonSize.Medium: if (this._initialButtonSize == b.RibbonBarButtonSize.Medium) {
                    return;
                } c.removeClass("rrbMediumButton").addClass("rrbLargeButton");
                    this._buttonSize = b.RibbonBarButtonSize.Large;
                    break;
                default: break;
            }
        }, _reduceButton: function () {
            var c = this._$element;
            switch (this._buttonSize) {
                case b.RibbonBarButtonSize.Large: c.removeClass("rrbLargeButton").addClass("rrbMediumButton");
                    this._buttonSize = b.RibbonBarButtonSize.Medium;
                    break;
                case b.RibbonBarButtonSize.Medium: c.removeClass("rrbMediumButton").addClass("rrbButton");
                    this._buttonSize = b.RibbonBarButtonSize.Small;
                    break;
                default: break;
            }
        }
    };
    a.registerControlProperties(b.RibbonBarMenu, { buttonSize: null });
    b.RibbonBarMenu.registerClass("Telerik.Web.UI.RibbonBarMenu", b.RibbonBarImageButtonBase);
})($telerik.$);
(function (a) {
    Type.registerNamespace("Telerik.Web.UI");
    var b = Telerik.Web.UI;
    b.RibbonBarMenuItem = function (d) {
        b.RibbonBarMenuItem.initializeBase(this, [d]);
        if (d) {
            d._button = this;
        } var e = this.get_imageElement();
        if (e) {
            var c = e.src;
            if (this.get_enabled()) {
                this.set_imageUrl(c);
            } else {
                this.set_disabledImageUrl(c);
            }
        } this._value = "";
        this._items = new Telerik.Web.UI.RibbonBarChildCollection(this);
        this._parentItem = null;
    };
    b.RibbonBarMenuItem.prototype = {
        set_owner: function (c) {
            this._owner = c;
        }, get_items: function () {
            return this._items;
        }, _findItemByPropertyRecursiveGeneric: function (g, j) {
            var e = this.get_items();
            for (var c = 0, f = e.get_count() ;
            c < f;
            c++) {
                var d = e.getItem(c);
                if (d["get_" + g]() == j) {
                    return d;
                } var h = d._findItemByPropertyRecursiveGeneric(g, j);
                if (h) {
                    return h;
                }
            } return null;
        }, findMenuItemByValue: function (c) {
            return this._findItemByPropertyRecursiveGeneric("value", c);
        }, findItemByCommandName: function (c) {
            return this._findItemByPropertyRecursiveGeneric("commandName", c);
        }, findItemByCommandArgument: function (c) {
            return this._findItemByPropertyRecursiveGeneric("commandArgument", c);
        }, get_hierarchicalIndex: function () {
            var c = "";
            var d = this.get_parentItem() || this.get_owner();
            if (d) {
                c = d.get_hierarchicalIndex();
            } return c + ":" + this.get_index();
        }, _updateImageElement: function () {
            var c = this.get_enabled();
            var d = "";
            if (c) {
                d = this.get_imageUrl();
            } else {
                d = this.get_disabledImageUrl();
            } this.set_image(d);
        }, _onChildAdded: function (c) {
            var d = this.get_owner();
            if (d && d._onChildAdded) {
                d._onChildAdded(c);
            } c.set_parentItem(this);
        }
    };
    a.registerControlProperties(b.RibbonBarMenuItem, { value: null, parentItem: null });
    b.RibbonBarMenuItem.registerClass("Telerik.Web.UI.RibbonBarMenuItem", b.RibbonBarImageButtonBase);
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarSplitButton = function (c) {
        b.RibbonBarSplitButton.initializeBase(this, [c]);
        if (c) {
            c._splitButton = this;
        } this._defaultButton = null;
        this._enableButtonSelection = false;
        this._initialSelectedButtonIndex = null;
        this._selectedButtonIndex = null;
        this._selectedButtonHierarchicalIndex = null;
    };
    b.RibbonBarSplitButton.prototype = {
        initialize: function (e) {
            this._setItemProperties(e);
            this._ensureButtonSize();
            var d = a(this._element), c = d.find(".rrbButtonArrow");
            c.html("<span class='rrbIcon'></span>");
            d.find(".rrbButtonText").after(c);
        }, _getFirstButton: function (e) {
            var g = [];
            for (var c = 0;
            c < e.get_count() ;
            c++) {
                var d = e.getItem(c);
                if (!d.get_items) {
                    return d;
                } else {
                    g[g.length] = d;
                }
            } for (var f = 0;
            f < g.length;
            f++) {
                d = this._getFirstButton(g[f].get_items());
                if (d) {
                    return d;
                }
            } return null;
        }, _isSubMenu: function (d) {
            var c = a(d.get_element()).find("span.rrbSubMenu").length > 0;
            return c;
        }, _onChildAdded: function (c) {
            c.set_group(this.get_group());
            c.set_shouldDisplayDefaultImage(false);
            if (c.set_owner) {
                c.set_owner(this);
            }
        }, _updateDualImage: function () {
            var d;
            var e = this.get_isLarge();
            var f = this.get_defaultButton();
            var c = this.get_enabled() && f && f.get_enabled();
            if (c) {
                if (e) {
                    if (this.get_imageUrlLarge()) {
                        d = this.get_imageUrlLarge();
                    } else {
                        d = (f && f.get_imageUrlLarge()) ? f.get_imageUrlLarge() : this._getRibbonBar().get_defaultImageUrlLarge();
                    }
                } else {
                    if (this.get_imageUrl()) {
                        d = this.get_imageUrl();
                    } else {
                        d = (f && f.get_imageUrl()) ? f.get_imageUrl() : this._getRibbonBar().get_defaultImageUrl();
                    }
                }
            } else {
                if (e) {
                    if (this.get_disabledImageUrlLarge()) {
                        d = this.get_disabledImageUrlLarge();
                    } else {
                        d = (f && f.get_disabledImageUrlLarge()) ? f.get_disabledImageUrlLarge() : this._getRibbonBar().get_defaultDisabledImageUrlLarge();
                    }
                } else {
                    if (this.get_disabledImageUrl()) {
                        d = this.get_disabledImageUrl();
                    } else {
                        d = (f && f.get_disabledImageUrl()) ? f.get_disabledImageUrl() : this._getRibbonBar().get_defaultDisabledImageUrl();
                    }
                }
            } this.set_image(d);
        }, _updateClipImage: function () {
            var e = this.get_defaultButton();
            var c = this.get_enabled() && e && e.get_enabled();
            var f = ((c && !this.get_imageUrl() && !(e && e.get_imageUrl())) || (!c && !this.get_disabledImageUrl() && !(e && e.get_disabledImageUrl())));
            if (f) {
                this.toggle_ImageRenderingMode();
                this._updateDualImage();
                return;
            } var d;
            if (c) {
                if (this.get_imageUrl()) {
                    d = this.get_imageUrl();
                } else {
                    d = e.get_imageUrl();
                }
            } else {
                if (this.get_disabledImageUrl()) {
                    d = this.get_disabledImageUrl();
                } else {
                    d = e.get_disabledImageUrl();
                }
            } this.set_image(d);
        }, _updateTextElement: function (d) {
            var c = false;
            if (this.get_text(c)) {
                return;
            } var e = this.get_textElement();
            if (e) {
                e.text(d);
                this._updateParentGroupSize();
            }
        }, get_text: function (c) {
            if (!c) {
                return this._text;
            } var e = this.get_textElement();
            var d;
            if (e) {
                d = e.text();
            } return d;
        }, set_owner: function (c) {
            this._owner = c;
        }, get_eventName: function () {
            return b.RadRibbonBar.get_eventName(Object.getTypeName(this));
        }, set_defaultButton: function (c) {
            this._defaultButton = c;
        }, get_defaultButton: function () {
            var c = (this._defaultButton) ? this._defaultButton : this._getFirstButton(this.get_items());
            return c;
        }, _findItemByPropertyRecursiveGeneric: function (g, h) {
            var e = this.get_items();
            for (var c = 0, f = e.get_count() ;
            c < f;
            c++) {
                var d = e.getItem(c);
                if (d["get_" + g]() == h) {
                    return d;
                }
            } return null;
        }, findButtonByValue: function (c) {
            return this._findItemByPropertyRecursiveGeneric("value", c);
        }, findItemByCommandName: function (c) {
            return this._findItemByPropertyRecursiveGeneric("commandName", c);
        }, findItemByCommandArgument: function (c) {
            return this._findItemByPropertyRecursiveGeneric("commandArgument", c);
        }, set_selectedButtonIndex: function (d, g) {
            var e = (g) ? parseInt(d.split(":")[3]) : d;
            if (this._initialSelectedButtonIndex == null) {
                this._initialSelectedButtonIndex = e;
            } this._selectedButtonIndex = e;
            var f = this.get_items().getItem(e);
            if ((this._initialSelectedButtonIndex != this._selectedButtonIndex)) {
                if (g) {
                    this._selectedButtonHierarchicalIndex = d;
                } else {
                    this._selectedButtonHierarchicalIndex = f.get_hierarchicalIndex();
                }
            } this.set_defaultButton(f);
            var c = this.get_element();
            if (c) {
                c._defaultButton = this._defaultButton;
                this._updateTextElement(this.get_defaultButton().get_text());
                this._updateImageElement();
            }
        }, get_selectedButtonIndex: function () {
            return this._selectedButtonIndex;
        }, get_selectedButtonHierarchicalIndex: function () {
            return this._selectedButtonHierarchicalIndex;
        }, get_selectedIndexDifferentFromInitial: function () {
            return (this._selectedButtonIndex != this._initialSelectedButtonIndex);
        }, set_enableButtonSelection: function (c) {
            this._enableButtonSelection = c;
        }, get_enableButtonSelection: function () {
            return this._enableButtonSelection;
        }
    };
    a.registerControlProperties(b.RibbonBarSplitButton, { buttonSize: null });
    b.RibbonBarSplitButton.registerClass("Telerik.Web.UI.RibbonBarSplitButton", b.RibbonBarButtonContainer);
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarToggleList = function () {
        this._parent = null;
        this._owner = null;
        this._buttons = [];
    };
    b.RibbonBarToggleList.prototype = {
        get_owner: function () {
            if (!this._owner) {
                this._owner = this._parent._owner;
            } return this._owner;
        }, get_buttons: function () {
            return this._buttons;
        }, addButton: function (c) {
            this._buttons[this._buttons.length] = c;
            c.set_toggleList(this);
        }
    };
    a.registerControlProperties(b.RibbonBarToggleList, { group: null, toggledButton: null });
    b.RibbonBarToggleList.registerClass("Telerik.Web.UI.RibbonBarToggleList");
})($telerik.$);
(function (a) {
    var e = Telerik.Web.UI;
    var c = Sys.Serialization.JavaScriptSerializer;
    var f = e.RadRibbonBar, d = f.prototype;
    var b = a(document), i = ".", h = ",", l = "px", t = true, k = false, o = "RadRibbonBar", r = "rrbTabs", q = "rrbTab", s = "rrbTabLabel", g = "rrbButtonGuide", m = false, p = false;
    function j(u, w) {
        for (var v in w) {
            u[v] = w[v];
        } return u;
    } var n = {
        init: function (u) {
            u.initializeResizing();
        }
    };
    j(d, {
        _initializeResizing: function () {
            var y = this, v = y._$element, x = v.find(".rrbResizeHandle").get(0), u = a(x), w;
            y._hasResizeHandle = u.length > 0;
            if (y._hasResizeHandle) {
                y._updateWidthInClientState();
            } v.data("width", v.width());
            u.bind({
                mousedown: function () {
                    v.data("width", v.width());
                    b.bind({ mousemove: a.proxy(y._resizeRibbon, y), mouseup: a.proxy(y._resizeStop, y), mouseleave: a.proxy(y._resizeStop, y) });
                }, selectstart: function () {
                    return false;
                }
            });
            if ($telerik.isIE) {
                u.attr("unselectable", "on");
            } if (!y._hasResizeHandle) {
                w = Function.createDelegate(y, y._resizeRibbon);
                a(window).bind({ resize: w });
                y.add_disposing(function () {
                    a(window).unbind("resize", w);
                });
            }
        }, _onResize: function (u) {
            this._resizeHandler(u);
        }, _resizeHandler: function (u) {
            var v = this, w = v._element, x = v._tabs.getTab(v._selectedTabIndex), y = { width: a(w).width() };
            x._reflowGroups(y, "handler");
        }, _resizeRibbon: function (u) {
            var w = this, x = w._element, y, v;
            p = true;
            if (u.currentTarget == window) {
                v = a(x.parentNode).width();
            } else {
                v = u.clientX - a(x).offset().left + 7;
            } y = { newSize: { width: v }, oldSize: { width: a(x).data("width") } };
            w._setRibbonSize(y);
        }, _resizeStop: function (u) {
            var v = this;
            b.unbind("mousemove", v._resizeRibbon);
            b.unbind("mouseup", v._resizeStop);
            if (!p) {
                return;
            } a(v._element).data("width", a(v._element).width());
            p = false;
        }, _setRibbonSize: function (z) {
            if (!z || !a(this._element).is(":visible")) {
                return;
            } var w = this, x = w._element, v = z.width || z.newSize.width || null, u = w._minWidth, y = w._tabs.getTab(w._selectedTabIndex);
            if (w._detachedGroup) {
                w._detachedGroup._attachGroup();
                w._detachedGroup = null;
            } if (v === null) {
                return;
            } if (v < u) {
                v = u;
                if (z.width) {
                    z.width = v;
                } else {
                    z.newSize.width = v;
                }
            } x.style.width = v + "px";
            if (p) {
                if (m !== false) {
                    clearTimeout(m);
                } m = window.setTimeout(function () {
                    y._reflowGroups(z);
                    a(x).data("width", v);
                    if (w._hasResizeHandle) {
                        w._updateWidthInClientState();
                    }
                }, 50);
            } else {
                y._reflowGroups(z);
                a(x).data("width", v);
                if (w._hasResizeHandle) {
                    w._updateWidthInClientState();
                }
            }
        }
    });
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarContextualTabGroup = function (c) {
        this._element = c;
        this._textElement = a(c).find(".rrbContextualTabLabel").get(0);
        this._text = a(this._textElement).text();
    };
    b.RibbonBarContextualTabGroup.prototype = {
        get_element: function () {
            return this._element;
        }, get_text: function () {
            return this._text;
        }, get_isActive: function () {
            return a(this._element).hasClass("rrbContextualTabActive");
        }, activate: function () {
            a(this._element).addClass("rrbContextualTabActive");
        }, deactivate: function () {
            a(this._element).removeClass("rrbContextualTabActive");
            if (this._onDeactivate) {
                this._onDeactivate(this);
            }
        }, get_tabs: function () {
            if (typeof (this._tabs) == "undefined") {
                this._tabs = [];
            } return this._tabs;
        }
    };
    b.RibbonBarContextualTabGroup.registerClass("Telerik.Web.UI.RibbonBarContextualTabGroup");
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    b.RadRibbonBar.prototype.get_contextualTabGroups = function () {
        if (typeof (this._contextualTabGroups) == "undefined") {
            this._contextualTabGroups = [];
        } return this._contextualTabGroups;
    };
    b.RadRibbonBar.prototype.findContextualTabGroupByText = function (f) {
        var d = this.get_contextualTabGroups();
        for (var e = 0;
        e < d.length;
        e++) {
            var c = d[e];
            if (c.get_text() === f) {
                return c;
            }
        } return null;
    };
    b.RadRibbonBar.prototype._initializeContextualTabGroups = function () {
        var e = a(this._tabsContainerElement).find(".rrbContextualTab");
        if (e.length) {
            var f = this.get_contextualTabGroups();
            for (var g = 0;
            g < e.length;
            g++) {
                var d = e[g];
                var c = new b.RibbonBarContextualTabGroup(d);
                var h = this;
                c._onDeactivate = function (i) {
                    h._onContextualTabGroupDeactivate(i);
                };
                f[f.length] = c;
                this._initializeContextualTabs(c);
            }
        }
    };
    b.RadRibbonBar.prototype._onContextualTabGroupDeactivate = function (c) {
        var g = c.get_tabs();
        var e = this.get_selectedTab();
        var f = null;
        for (var d = 0;
        d < g.length;
        d++) {
            if (f = (e == g[d] ? g[d] : null)) {
                break;
            }
        } if (f) {
            this.set_selectedTabIndex(0);
        }
    };
    b.RadRibbonBar.prototype._initializeContextualTabs = function (e) {
        var d = a(e.get_element()).find(".rrbTab");
        var g = e.get_tabs();
        for (var f = 0;
        f < d.length;
        f++) {
            var c = d[f]._tab;
            c.set_contextualTabGroup(e);
            g[g.length] = c;
        }
    };
    b.RibbonBarTab.prototype.set_contextualTabGroup = function (c) {
        this._contextualTabGroup = c;
    };
    b.RibbonBarTab.prototype.get_contextualTabGroup = function () {
        return this._contextualTabGroup;
    };
})($telerik.$);
(function (a) {
    var c = Telerik.Web.UI;
    var b = Sys.Serialization.JavaScriptSerializer;
    c.RadRibbonBar.prototype._initializeQuickAccessToolbar = function () {
        var f = [];
        var g = this;
        a.each(this._qatItemsHierarchicalIndices, function (i, m) {
            var j = (m || "").split(":");
            var l = g.get_tabs().getTab(j[0]);
            var h = l.get_groups().getGroup(j[1]);
            var k = h.get_items().getItem(j[2]);
            f[f.length] = k;
        });
        var e = this._$element.find(".rrbQuickAccessToolbar");
        var d = true;
        this._quickAccessToolbar = new c.RibbonBarQuickAccessToolbar(e);
        this._qatActiveItemIndices = [];
        this._qatActiveItemIndicesJson = "[]";
        this._quickAccessToolbar._onItemActivated = function (h) {
            g._onQatItemActivated(h);
            if (!d) {
                g._updateShortcuts();
            }
        };
        this._quickAccessToolbar._onItemDeactivated = function (h) {
            g._onQatItemDeactivated(h);
            if (!d) {
                g._updateShortcuts();
            }
        };
        this._quickAccessToolbar.initialize(f);
        d = false;
    };
    c.RadRibbonBar.prototype._updateShortcuts = function () {
        if (this._quickAccessToolbar && this._getNavigator()) {
            c.RadRibbonBar.prototype._setKeyboardShortcut(this._quickAccessToolbar._getVisibleElements(), 0);
            this._getNavigator().rebuild();
        }
    };
    c.RadRibbonBar.prototype._setKeyboardShortcut = function (e, d) {
        if (!e[d]) {
            return;
        } a(e[d]).find(".rrbKeyBox").html(d).parent("a").attr("accessKey", d);
        c.RadRibbonBar.prototype._setKeyboardShortcut(e, ++d);
    };
    c.RadRibbonBar.prototype._registerQatActiveItemIndex = function (d) {
        if (Array.indexOf(this._qatActiveItemIndices, d) == -1) {
            Array.add(this._qatActiveItemIndices, d);
            this._updateQatActiveItemIndicesJson();
        }
    };
    c.RadRibbonBar.prototype._unregisterQatActiveIndex = function (d) {
        Array.remove(this._qatActiveItemIndices, d);
        this._updateQatActiveItemIndicesJson();
    };
    c.RadRibbonBar.prototype._updateQatActiveItemIndicesJson = function () {
        this._qatActiveItemIndicesJson = b.serialize(this._qatActiveItemIndices);
        this.updateClientState();
    };
    c.RadRibbonBar.prototype._onQatItemActivated = function (d) {
        this._registerQatActiveItemIndex(d.get_hierarchicalIndex());
    };
    c.RadRibbonBar.prototype._onQatItemDeactivated = function (d) {
        this._unregisterQatActiveIndex(d.get_hierarchicalIndex());
    };
    c.RadRibbonBar.prototype.get_quickAccessToolbar = function () {
        return this._quickAccessToolbar;
    };
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarQuickAccessToolbar = function (c) {
        this._jElement = c;
        this._jDropDownElement = this._jElement.find(".rrbQatDropDown");
        this._jDropDownArrowElement = this._jDropDownElement.find(".rrbQatButton");
        this._jDropDownListElement = this._jDropDownElement.find(".rrbSlide");
        this._items = [];
    };
    b.RibbonBarQuickAccessToolbar.prototype = {
        initialize: function (f) {
            var e = this._jElement.find(".rrbQatItem:not(.rrbQatDropDown)");
            var c = this._jDropDownListElement.find("li");
            var d = this;
            c.each(function (h, g) {
                var m = f[h];
                var l = e[h];
                var k = new b.RibbonBarQuickAccessToolbarItem(l, g, m);
                k.initialize();
                d._items[d._items.length] = k;
                var j = a(g).hasClass("rrbMenuItemCheckboxChecked");
                if (j && d._onItemActivated) {
                    d._onItemActivated(k._ribbonBarItem);
                }
            });
            this._jDropDownArrowElement.click(function (g) {
                d._jDropDownListElement.toggle();
                g.preventDefault();
            });
            this._jDropDownListElement.delegate("[type=checkbox]", "change", function (g) {
                var h = a(g.target).parents("li").get(0)._item;
                if (g.target.checked) {
                    h.showQatElement();
                    a(h._dropDownItemElement).addClass("rrbMenuItemCheckboxChecked");
                    if (d._onItemActivated) {
                        d._onItemActivated(h._ribbonBarItem);
                    }
                } else {
                    h.hideQatElement();
                    a(h._dropDownItemElement).removeClass("rrbMenuItemCheckboxChecked");
                    if (d._onItemDeactivated) {
                        d._onItemDeactivated(h._ribbonBarItem);
                    }
                } d._jDropDownListElement.toggle();
            });
            this._jDropDownArrowElement.html("<span class='rrbIcon' />");
            this._jElement.find(".rrbButtonOut").each(function () {
                var h = a(this), g = h.find(".rrbButtonArrow");
                if (!(h.find(".rrbMenuButton").length || h.find(".rrbSplitButton").length)) {
                    return;
                } g.html("<span class='rrbIcon'></span>");
                h.find(".rrbButtonText").after(g);
            });
            b.RadRibbonBar.prototype._setKeyboardShortcut(this._getVisibleElements(), 0);
        }, _getVisibleElements: function () {
            return this._jElement.find(".rrbQatItem:not(.rrbQatDropDown)").filter(":visible");
        }, dispose: function () {
            this._jDropDownListElement.undelegate("[type=checkbox]", "change");
        }, hideDropDown: function () {
            this._jDropDownListElement.hide();
        }, get_items: function () {
            return this._items;
        }, _putQatItemElementLastInQatItemList: function (c) {
            a(c).insertBefore(this._jDropDownElement);
        }
    };
    b.RibbonBarQuickAccessToolbar.registerClass("Telerik.Web.UI.RibbonBarQuickAccessToolbar");
})($telerik.$);
(function (a) {
    var b = Telerik.Web.UI;
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarQuickAccessToolbarItem = function (d, c, e) {
        this._qatItemElement = d;
        this._dropDownItemElement = c;
        this._ribbonBarItem = e;
    };
    b.RibbonBarQuickAccessToolbarItem.prototype = {
        _createQatItemElementContainer: function () {
            this._qatItemElement = document.createElement("LI");
            this._qatItemElement.className = "rrbQatItem";
        }, _cloneRibbonBarItemElement: function () {
            var c = a(this._ribbonBarItem.get_element()).clone();
            return c;
        }, _setSmallCssClassToRibbonBarItemElement: function (d) {
            var c = d.attr("class");
            c = c.replace("rrbLargeButton", "rrbButton");
            c = c.replace("rrbMediumButton", "rrbButton");
            c = c.replace("rrbButtonStripPart", "rrbButtonOut rrbButton");
            d.attr("class", c);
        }, _createQatItemElement: function () {
            this._createQatItemElementContainer();
            if (this._ribbonBarItem) {
                var c = this._cloneRibbonBarItemElement();
                this._setSmallCssClassToRibbonBarItemElement(c);
                c.appendTo(this._qatItemElement);
            }
        }, _transferButtonExpandosFromSplitButtonElement: function (d) {
            this._qatItemElement.firstChild._defaultButton = d._defaultButton;
            var e = a(d._dropDown).find("a");
            var c = a(this._qatItemElement.firstChild._dropDown).find("a");
            e.each(function (f) {
                c.get(f)._button = this._button;
            });
        }, _transferButtonExpandosFromMenuItemElements: function (e, c) {
            var f = a(e._dropDown).find("a");
            var d = a(c._dropDown).find("a");
            var g = this;
            f.each(function (j) {
                var h = d.get(j);
                h._button = this._button;
                if (this._dropDown) {
                    g._transferButtonExpandosFromMenuItemElements(this, h);
                }
            });
        }, initialize: function () {
            if (this._qatItemElement) {
                var c = this._ribbonBarItem.get_element();
                if (c._button) {
                    this._qatItemElement.firstChild._button = c._button;
                } if (a(c).find("span.rrbSplitButton").length > 0) {
                    this._transferButtonExpandosFromSplitButtonElement(c);
                } if (a(c).find("span.rrbMenuButton").length > 0) {
                    this._transferButtonExpandosFromMenuItemElements(c, this._qatItemElement.firstChild);
                } if (a(c).find("span.rrbToggleButton").length > 0) {
                    c._button._setQuickAccessToolbarItemElement(this._qatItemElement.firstChild);
                }
            } if (this._dropDownItemElement) {
                this._dropDownItemElement._item = this;
            }
        }, get_qatItemElement: function () {
            if (!this._qatItemElement) {
                this._createQatItemElement();
            } return this._qatItemElement;
        }, get_element: function () {
            return this.get_qatItemElement();
        }, hideQatElement: function () {
            a(this._qatItemElement).hide();
        }, showQatElement: function () {
            a(this._qatItemElement).show();
        }
    };
    b.RibbonBarQuickAccessToolbarItem.registerClass("Telerik.Web.UI.RibbonBarQuickAccessToolbarItem");
})($telerik.$);
Type.registerNamespace("Telerik.Web.UI");
(function (b, a) {
    function c(f, e) {
        var d = a(f), g = e || d.width();
        d.width("auto");
        g = Math.max(g, d.width());
        d.width(g);
    } b.RibbonBarApplicationMenu = function (d) {
        this._items = new Telerik.Web.UI.RibbonBarChildCollection(this);
        this._textElement = null;
        this._element = d || null;
        this._$element = a(d);
        this._text = null;
        if (d) {
            d._applicationMenu = this;
        }
    };
    b.RibbonBarApplicationMenu.prototype = {
        initialize: function (d) {
            this._ribbonBar = d;
            this._dropDownElement = a(this._element).find(".rrbSlide")[0];
            this._popupElement = a(this._dropDownElement).children(".rrbPopup").get(0);
            this._headerBarElement = a(this._popupElement).children(".rrbHeaderBar").get(0);
            this._menuPaneElement = a(this._popupElement).children(".rrbApplicationMenu").get(0);
            this._auxiliaryPaneElement = a(this._popupElement).children(".rrbAuxiliaryPane").get(0) || null;
            this._footerPaneElement = a(this._popupElement).children(".rrbFooterPane").get(0) || null;
            a(document.body).find("form").prepend(this._dropDownElement);
            this._adjustPopupDimensions();
        }, dispose: function () {
            this._element._applicationMenu = null;
            this._element._button = null;
            this._element = null;
            this._textElement = null;
            this._popupElement = null;
            this._headerBarElement = null;
            this._menuPaneElement = null;
            this._auxiliaryPaneElement = null;
            this._footerPaneElement = null;
            a(this._dropDownElement).remove();
            this._dropDownElement = null;
            this.disposeChildren();
        }, disposeChildren: function () {
            for (var d = 0, e = this.get_items().get_count() ;
            d < e;
            d++) {
                this.getItem(d).dispose();
            }
        }, _onChildAdded: function (d) {
            if (d.set_owner) {
                d.set_owner(this);
            } d.set_level(0);
        }, _position: function () {
            var e = this._dropDownElement.style, d = a(this.get_element()), g = d.offset(), f = d.outerHeight();
            e.top = g.top + f + "px";
            e.left = g.left + "px";
        }, _hideSplitMenuItems: function () {
            var d = a(this.get_dropDownElement()).find(".rrbMIExpanded")[0];
            if (d) {
                d._button.close();
            }
        }, _adjustPopupDimensions: function () {
            var k = this, i = k._dropDownElement, j = i.style, n = 0, h = a(k._popupElement), r, q, g = a(k._menuPaneElement), p, o, d = a(k._auxiliaryPaneElement), m, l, e = a(k._footerPaneElement), f = a(k._headerBarElement);
            j.visibility = "hidden";
            j.display = "block";
            animationContainerWidth = j.width || null;
            animationContainerHeight = j.height || null;
            r = h.width();
            q = h.height();
            c(k._menuPaneElement);
            p = g.width();
            o = g.height();
            d.width(r - p - 1);
            m = d.width();
            l = d.height();
            g.find(".rrbSplitMenuItem").each(function () {
                var t = a(this), s = t.children(".rrbPopup");
                t.addClass(".rrbMIExpanded");
                s.height("auto");
                s.width(m);
                o = Math.max(o, s.height());
                s.height("100%");
                t.removeClass(".rrbMIExpanded");
            });
            n = Math.max(o, l);
            if (k._popupElement.style.height) {
                n = q - e.outerHeight();
            } g.height(n);
            d.height(n);
            f.width(r);
            j.visibility = "visible";
            j.display = "none";
        }, get_items: function () {
            return this._items;
        }, getItem: function (d) {
            return this._items.getItem(d);
        }, show: function () {
            var e = this, d = a(e._element);
            d.before("<li class='rrbHeaderBarTab'></li>");
            d.prev("li.rrbHeaderBarTab").append(e._headerBarElement);
            d.addClass("rrbSelectedApplicationTab");
            e._position();
            a(e._dropDownElement).show();
        }, hide: function () {
            var e = this, d = a(e._element);
            a(e._popupElement).prepend(e._headerBarElement);
            d.prev("li.rrbHeaderBarTab").remove();
            d.removeClass("rrbSelectedApplicationTab");
            e._hideSplitMenuItems();
            a(e._dropDownElement).hide();
        }, toggle: function () {
            var d = a(this._element).hasClass("rrbSelectedApplicationTab");
            if (d) {
                this.hide();
            } else {
                this.show();
            }
        }, get_textElement: function () {
            if (this._textElement === null) {
                this._textElement = a(this._element).find(".rrbTabText")[0];
            } return this._textElement;
        }, get_text: function () {
            if (this._text === null) {
                this._text = a(this.get_textElement()).text();
            } return this._text;
        }, set_text: function (d) {
            this._text = d;
            a(this.get_textElement()).text(d);
        }
    };
    a.registerControlProperties(b.RibbonBarApplicationMenu, { element: null, ribbonBar: null, dropDownElement: null });
    b.RibbonBarApplicationMenu.registerClass("Telerik.Web.UI.RibbonBarApplicationMenu");
})(Telerik.Web.UI, $telerik.$);
(function (b, a) {
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarApplicationMenuItemBase = function (c) {
        b.RibbonBarApplicationMenuItemBase.initializeBase(this, [c]);
        this._enabled = true;
        this._text = null;
        if (c) {
            c._button = this;
        }
    };
    b.RibbonBarApplicationMenuItemBase.prototype = {
        initialize: function (c) {
            this._setItemProperties(c);
        }, dispose: function () {
            this._element._button = null;
            this._element = null;
        }, _setItemProperties: function (c) {
            if (c.enabled !== undefined) {
                this._enabled = c.enabled;
            } if (c.imageUrl) {
                this._imageUrl = c.imageUrl;
            } if (c.commandName) {
                this._commandName = c.commandName;
            } if (c.commandArgument) {
                this._commandArgument = c.commandArgument;
            }
        }, set_enabled: function (c) {
            this._enabled = c;
            a(this.get_element()).toggleClass("rrbDisabled", !c);
        }, get_enabled: function () {
            return this._enabled;
        }, get_hierarchicalIndex: function () {
            return this.get_index() + "";
        }, get_textElement: function () {
            return a(this._element).find(">.rrbMIInner>.rrbMIText")[0];
        }, get_text: function () {
            if (this._text === null) {
                this._text = a(this.get_textElement()).text();
            } return this._text;
        }, set_text: function (c) {
            this._text = c;
            a(this.get_textElement()).text(c);
        }, get_imageElement: function () {
            return a(this._element).find(">.rrbMIInner>.rrbMIImage")[0];
        }, get_imageUrl: function () {
            return this._imageUrl;
        }, set_imageUrl: function (d) {
            var c = this.get_imageElement();
            this._imageUrl = d;
            if (c.src !== d) {
                c.src = d;
            }
        }
    };
    a.registerControlProperties(b.RibbonBarApplicationMenuItemBase, { commandName: "", commandArgument: "", owner: null, level: -1 });
    b.RibbonBarApplicationMenuItemBase.registerClass("Telerik.Web.UI.RibbonBarApplicationMenuItemBase", b.RibbonBarChild);
})(Telerik.Web.UI, $telerik.$);
(function (b, a) {
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarApplicationMenuItem = function (c) {
        b.RibbonBarApplicationMenuItem.initializeBase(this, [c]);
        this._description = null;
    };
    b.RibbonBarApplicationMenuItem.prototype = {
        _createDescriptionElement: function () {
            var c = document.createElement("div"), d = this.get_textElement();
            c.className = "rrbMIDesc";
            a(c).insertAfter(d);
            return c;
        }, get_hierarchicalIndex: function () {
            var c = this.get_index();
            if (this.get_level() == 1) {
                return this.get_splitMenuItem().get_index() + ":" + c;
            } return c + "";
        }, get_descriptionElement: function () {
            return a(this._element).find(">.rrbMIInner>.rrbMIDesc")[0];
        }, get_description: function () {
            if (this._description === null) {
                this._description = a(this.get_descriptionElement()).text();
            } return this._description;
        }, set_description: function (c) {
            this._description = c;
            if (!this.get_descriptionElement()) {
                this._createDescriptionElement();
            } a(this.get_descriptionElement()).text(c);
        }
    };
    a.registerControlProperties(b.RibbonBarApplicationMenuItem, { splitMenuItem: null });
    b.RibbonBarApplicationMenuItem.registerClass("Telerik.Web.UI.RibbonBarApplicationMenuItem", b.RibbonBarApplicationMenuItemBase);
})(Telerik.Web.UI, $telerik.$);
(function (b, a) {
    Type.registerNamespace("Telerik.Web.UI");
    b.RibbonBarApplicationSplitMenuItem = function (c) {
        b.RibbonBarApplicationSplitMenuItem.initializeBase(this, [c]);
        this._items = new Telerik.Web.UI.RibbonBarChildCollection(this);
        this._header = null;
    };
    b.RibbonBarApplicationSplitMenuItem.prototype = {
        _onChildAdded: function (c) {
            if (c.set_owner) {
                c.set_owner(this.get_owner());
            } c.set_splitMenuItem(this);
            c.set_level(1);
        }, _createHeaderElement: function () {
            var c = document.createElement("strong");
            c.className = "rrbHeader";
            a(this._element).find(".rrbPopup ").prepend(c);
            return c;
        }, set_owner: function (e) {
            this._owner = e;
            for (var c = 0, d = this.get_items().get_count() ;
            c < d;
            c++) {
                this.getItem(c).set_owner(e);
            }
        }, get_headerElement: function () {
            return a(this._element).find(".rrbHeader")[0];
        }, dispose: function () {
            b.RibbonBarApplicationSplitMenuItem.callBaseMethod(this, "dispose");
            for (var c = 0, d = this.get_items().get_count() ;
            c < d;
            c++) {
                this.getItem(c).dispose();
            }
        }, get_header: function () {
            if (this._header === null) {
                this._header = a(this.get_headerElement()).text();
            } return this._header;
        }, set_header: function (c) {
            this._header = c;
            if (!this.get_headerElement()) {
                this._createHeaderElement();
            } a(this.get_headerElement()).text(c);
        }, get_items: function () {
            return this._items;
        }, getItem: function (c) {
            return this._items.getItem(c);
        }, open: function () {
            this.get_owner()._hideSplitMenuItems();
            a(this.get_element()).addClass("rrbMIExpanded");
        }, close: function () {
            a(this.get_element()).removeClass("rrbMIExpanded");
        }
    };
    a.registerControlProperties(b.RibbonBarApplicationSplitMenuItem, {});
    b.RibbonBarApplicationSplitMenuItem.registerClass("Telerik.Web.UI.RibbonBarApplicationSplitMenuItem", b.RibbonBarApplicationMenuItemBase);
})(Telerik.Web.UI, $telerik.$);
(function (a, e) {
    var d = Sys.UI.Key;
    var b = "activeItemChanging";
    var c = {
        1: function (g) {
            return g.altKey;
        }, 2: function (g) {
            return g.ctrlKey;
        }, 3: function (g) {
            return g.shiftKey;
        }, 4: function (g) {
            return g.altKey && g.ctrlKey;
        }, 5: function (g) {
            return g.altKey && g.shiftKey;
        }, 6: function (g) {
            return g.ctrlKey && g.shiftKey;
        }
    };
    var f = { ribbon: 1, tab: 2, applicationMenuItem: 3, menu: 4, menuItem: 5, button: 6, comboBox: 7, dropDown: 8, numericTextBox: 9, colorPicker: 10, gallery: 11 };
    e.Navigator = function (n) {
        var j = null, i = e.Navigator, p = n._navigationSettings;
        this._tree = new i.NavigationTree(n);
        this._navigator = new i.KeyNavigator(n);
        this._arrowsNavigator = new i.ArrowsNavigator();
        var q = this._tree._innerTree, o = q, h = a(this._navigator), g = a(this._arrowsNavigator), k = false, m = this, l = null;
        a.extend(this, {
            rebuild: function () {
                j = o;
                m._tree._rebuildQuickAccessSubTree(n);
            }, initialize: function () {
                m.initializeHandlers();
                m.initializeRootItem();
            }, initializeRootItem: function () {
                var r = n.get_selectedTab();
                if (p.Activated) {
                    a.each(q.children, function (t, s) {
                        if (s.type == f.tab) {
                            if (s.domElement === a(r.get_element()).children(".rrbTabLabel")[0]) {
                                m.handleToggle(a.Event("keydown"));
                                h.trigger(b, [s]);
                                return false;
                            }
                        }
                    });
                }
            }, initializeHandlers: function () {
                h.bind(b, function (s, t) {
                    if (j) {
                        m.hide(j);
                    } if (k) {
                        m.show(j = t);
                    }
                });
                var r = n.get_element();
                a(r).bind("blur.key", function (s) {
                    m._setIsVisible(false);
                    h.trigger(b, [null]);
                    h.get(0).reset();
                    m._updateState(false);
                });
                a(document).bind("keydown.key", function (s) {
                    if (!l) {
                        l = s.target;
                    } m.handle(s);
                });
            }, handle: function (r) {
                if (m.isToggleCommand(r)) {
                    m.handleToggle(r);
                } else {
                    if (k) {
                        m.handleNavigation(r);
                    }
                }
            }, handleToggle: function (r) {
                r.preventDefault();
                a(n.get_element()).focus();
                m._setIsVisible(!k);
                h.trigger(b, [o]);
            }, handleNavigation: function (r) {
                r.preventDefault();
                if (r.keyCode == d.up || r.keyCode == d.down) {
                    g.get(0).handle(r, j);
                } else {
                    m._updateState(true);
                    h.get(0).handle(r, j, function () {
                        a(n.get_element()).blur();
                        a(l).focus();
                        l = null;
                        k = false;
                    });
                }
            }, isToggleCommand: function (s) {
                var r = c[p.CommandKey](s);
                if (r) {
                    return s.keyCode == p.FocusKey;
                } else {
                    return false;
                }
            }, dispose: function () {
                a(document).unbind("keydown.key");
                a(n).unbind("blur.key");
                h.unbind(b);
            }, hide: function (r) {
                m._toggle(r, "hide");
            }, show: function (r) {
                m._toggle(r, "show");
            }, _updateState: function (r) {
                n._navigationSettings.activated = r;
                n.updateClientState();
            }, _getActiveitem: function () {
                return j;
            }, _getIsVisible: function () {
                return k;
            }, _setIsVisible: function (r) {
                k = r;
            }, _toggle: function (r, s) {
                if (r) {
                    a(r.children).each(function (t, u) {
                        if (u.type == f.applicationMenuItem) {
                            a(u.domElement).find(">.rrbMIInner .rrbKeyBox")[s]();
                        } else {
                            a(u.domElement).find(".rrbKeyBox")[s]();
                        }
                    });
                }
            }
        });
    };
    e.Navigator.KeyNavigator = function (i) {
        var g = "", j = { children: [], parent: null }, h = this;
        a.extend(this, {
            reset: function () {
                j.children = [];
                j.parent = null;
                g = "";
            }, backwards: function (k, l) {
                a.each(k.children, function (n, m) {
                    if (a(m.domElement).parents().is(i._menuGroupOutCssClass)) {
                        i._hideMenus();
                        return false;
                    }
                });
                if (k.parent) {
                    k = k.parent;
                } else {
                    l();
                } h.reset();
                a(h).trigger(b, [k]);
            }, upwards: function (l, k, n) {
                g += String.fromCharCode(l.keyCode);
                j.parent = k;
                var o = j.children.length == 0 ? k.children : j.children, m = false;
                a.each(o, function (t, r) {
                    var p = r.accessKey == g, s = r.expandAccessKey && r.expandAccessKey == g, q;
                    if (p || s) {
                        q = p ? r.domElement : a(r.domElement).find(".rrbMIToggle")[0];
                        h.triggerEventByType(q);
                        k = r;
                        a(h).trigger(b, [k]);
                        if (r.children.length == 0) {
                            n();
                        } h.reset();
                        return false;
                    } else {
                        if (r.accessKey.indexOf(g) == 0) {
                            j.children.push(r);
                            m = true;
                        }
                    }
                });
                if (m) {
                    a(h).trigger(b, [j]);
                } else {
                    h.reset();
                }
            }, handle: function (l, k, m) {
                if (l.keyCode == d.esc) {
                    h.backwards(k, m);
                } else {
                    h.upwards(l, k, m);
                }
            }, triggerEventByType: function (k) {
                $el = a(k);
                if ($el.children().is(".rrbSubMenu")) {
                    $el.mouseover();
                } else {
                    if ($el.children().is(".rrbSplitButton")) {
                        $el.find(".rrbButtonText:first").click();
                    } else {
                        if ($el.is(".rrbComboBox")) {
                            $el.find(".rrbCBInput").focus();
                        } else {
                            if ($el.is(".rrbDropDown, .rrbColorPicker")) {
                                $el.find(".rrbActionButton").click();
                            } else {
                                if ($el.is(".rrbNumericTextBox")) {
                                    setTimeout(function () {
                                        $el.find(".rrbNTBInput").focus();
                                    }, 1);
                                } else {
                                    if ($el.is(".rrbGallery")) {
                                        setTimeout(function () {
                                            $el.find(".rrbGalleryActionExpand").click();
                                        }, 1);
                                    } else {
                                        $el.click();
                                    }
                                }
                            }
                        }
                    }
                }
            }, resetMask: function () {
                g = "";
            }
        });
    };
    e.Navigator.ArrowsNavigator = function () { };
    e.Navigator.ArrowsNavigator.prototype = { handle: function () { } };
    e.Navigator.NavigationTree = function (g) {
        this._innerTree = this.buildTree(g);
    };
    e.Navigator.NavigationTree.prototype = {
        get_tree: function () {
            return this._innerTree;
        }, buildTree: function (h) {
            var g = this, i = this._buildNode(h, function (k) {
                var j = [g._buildTabs(k), g._buildApplicationMenu(k), g._buildQuickAccessToolbar(k)];
                return g._flatten(j);
            });
            this._setParent(i);
            return i;
        }, _flatten: function (g) {
            var h = [];
            for (var k = 0;
            k < g.length;
            k++) {
                for (var l = 0;
                l < g[k].length;
                l++) {
                    h[h.length] = g[k][l];
                }
            } return h;
        }, _determineElementType: function (h) {
            var g = a(h), j = g.is("a") || g.is(".RadRibbonBar") || g.is(".rrbComboBox, .rrbDropDown, .rrbNumericTextBox, .rrbColorPicker, .rrbGallery"), i = g.parents().is(".rrbApplicationMenuPopup");
            if (j) {
                if (g.is(".RadRibbonBar")) {
                    return f.ribbon;
                } else {
                    if (g.parents().is(".rrbMenuGroupIn")) {
                        return f.menu;
                    } else {
                        if (g.parents().is(".rrbButtonOut")) {
                            return f.menuItem;
                        } else {
                            if (g.is(".rrbButtonOut")) {
                                return f.button;
                            } else {
                                if (g.is(".rrbTabLabel")) {
                                    return f.tab;
                                } else {
                                    if (g.is(".rrbComboBox")) {
                                        return f.comboBox;
                                    } else {
                                        if (g.is(".rrbDropDown")) {
                                            return f.dropDown;
                                        } else {
                                            if (g.is(".rrbNumericTextBox")) {
                                                return f.numericTextBox;
                                            } else {
                                                if (g.is(".rrbColorPicker")) {
                                                    return f.colorPicker;
                                                } else {
                                                    if (g.is(".rrbGallery")) {
                                                        return f.gallery;
                                                    } else {
                                                        return -1;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            } else {
                if (i) {
                    return f.applicationMenuItem;
                }
            }
        }, _determineAccessKeyElementFromSourceElement: function (h) {
            var g = a(h), j = g.is("a") || g.is(".RadRibbonBar") || g.is(".rrbComboBox, .rrbDropDown, .rrbNumericTextBox, .rrbColorPicker, .rrbGallery"), i = g.parents().is(".rrbApplicationMenuPopup");
            if (j) {
                return h;
            } else {
                if (i) {
                    return g.get(0);
                } else {
                    return g.find("a:first").get(0);
                }
            }
        }, _rebuildQuickAccessSubTree: function (i) {
            var g = [];
            var h = this._buildQuickAccessToolbar(i);
            a(this.get_tree().children).each(function (j, k) {
                if (!a(k.domElement).parent().is(".rrbQatItem")) {
                    g.push(k);
                }
            });
            this._innerTree.children = this._flatten([g, h]);
            this._setParent(this._innerTree);
        }, _buildNode: function (j, l) {
            var h = j.get_element(), i = this._determineAccessKeyElementFromSourceElement(h), k = "accessKey", g = a(i).attr(k) || "", n = this._determineElementType(i);
            var m = { accessKey: g, domElement: i, parent: null, children: l(j), type: n };
            if (n == f.applicationMenuItem && a(h).hasClass("rrbSplitMenuItem")) {
                m.expandAccessKey = a(h).find(".rrbMIToggle").attr(k) || "";
            } this._cleanAccessKey(i);
            return m;
        }, _buildTabs: function (i) {
            var g = [], h = this;
            i.get_tabs().forEach(function (j) {
                g[g.length] = h._buildNode(j, function (k) {
                    return h._buildGroupItems(k);
                });
            });
            return g;
        }, _buildApplicationMenu: function (i) {
            var g = this, h = i.get_applicationMenuDropDown();
            if (h) {
                return [this._buildNode(h, function (j) {
                    return g._buildItems(j);
                })];
            } else {
                return [];
            }
        }, _buildQuickAccessToolbar: function (n) {
            var l = this, m = [], o = n.get_quickAccessToolbar();
            if (o) {
                var k = o.get_items();
                for (var h = 0;
                h < k.length;
                h++) {
                    var j = k[h];
                    var g = a(j.get_element());
                    if (g.is(":visible")) {
                        m.push(this._buildNode(j, function (q) {
                            var i = [];
                            var p = g.find("a").get(0)._dropDown;
                            a(p).find("a").each(function (s, r) {
                                var t = {
                                    get_element: function () {
                                        return r;
                                    }
                                };
                                i[i.length] = l._buildNode(t, function () {
                                    return [];
                                });
                            });
                            return i;
                        }));
                    }
                } return m;
            } else {
                return [];
            }
        }, _buildGroupItems: function (i) {
            var g = [], h = this;
            i.get_groups().forEach(function (j) {
                j.get_items().forEach(function (k) {
                    g[g.length] = h._buildNode(k, function (l) {
                        return h._buildItems(l);
                    });
                });
            });
            return g;
        }, _buildItems: function (i) {
            if (!i.get_items || i.get_items().get_count() == 0) {
                return [];
            } var g = [], h = this;
            i.get_items().forEach(function (j) {
                g[g.length] = h._buildNode(j, function (k) {
                    return h._buildItems(k);
                });
            });
            return g;
        }, _setParent: function (h) {
            function g(i) {
                if (i.children.length == 0) {
                    return;
                } a(i.children).each(function (j, k) {
                    k.parent = i;
                    g(k);
                });
            } a(h.children).each(function (i, j) {
                g(h);
            });
        }, _cleanAccessKey: function (g) {
            a(g).attr("accessKey", "");
        }
    };
})($telerik.$, Telerik.Web.UI.RadRibbonBar);
(function (a) {
    var b = Telerik.Web.UI;
    b.RibbonBarToolTip = function (c) {
        this._element = c;
    };
    b.RibbonBarToolTip.prototype = {
        get_element: function () {
            return this._element;
        }, _setTitle: function (c) {
            a(this._element).find(".rrbToolTipTitle").text(c);
        }, _setText: function (c) {
            a(this._element).find(".rrbToolTipDescription p").html(c);
        }, _show: function (c) {
            a(this._element).show();
        }, _hide: function () {
            this._clear();
            a(this._element).hide();
        }, _clear: function () {
            a(this._element).find(".rrbToolTipTitle, .rrbToolTipDescription p").html("");
            this._element.style.top = "";
            this._element.style.left = "";
        }
    };
})($telerik.$);

/* END Telerik.Web.UI.RibbonBar.RadRibbonBarScripts.js */
if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();
(function () {
    function loadHandler() {
        var hf = $get('RadScriptManager_TSM');
        if (!hf) return;
        if (!hf._RSM_init) { hf._RSM_init = true; hf.value = ''; }
        hf.value += ';;System.Web.Extensions, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35:ru-RU:f319b152-218f-4c14-829d-050a68bb1a61:ea597d4b:b25378d2;Telerik.Web.UI, Version=2013.3.1015.40, Culture=neutral, PublicKeyToken=121fae78165ba3d4:ru-RU:ac331549-681c-4402-9fb7-09ec3c579ee8:16e4e7cd:f7645509:24ee1bba:a675b4ab';
        Sys.Application.remove_load(loadHandler);
    };
    Sys.Application.add_load(loadHandler);
})();
